/*****************************************************
This program was produced by the
CodeWizardAVR V1.24.6 Professional
Automatic Program Generator
 Copyright 1998-2005 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com
e-mail:office@hpinfotech.com

Project : Coder
Version : 2.0
Date    : 01.06.2006
Author  : F4CG                            
Company : F4CG                            
Comments: 


Chip type           : ATmega128
Program type        : Application
Clock frequency     : 12,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 1024
*****************************************************/

#include <mega128.h>
#include <delay.h>
#include <stdio.h>
#include <def.c>
//
#define trim_0up   PINA.3
#define trim_0down PINA.0
#define trim_1up   PINA.1
#define trim_1down PINA.2
#define trim_2up   PINA.5
#define trim_2down PINA.4
#define trim_3up   PINA.7
#define trim_3down PINA.6     

//   
#define UP    PIND.4
#define DOWN  PIND.5          
#define LEFT  PIND.6
#define RIGHT PIND.7

//

#define BUZ   PORTG.2
//
#define LED1 PORTC.6
#define LED2 PORTC.7

//
#define MODE_KEY1       PINE.6
#define MODE_KEY2       PINE.7    
#define SW1             PINE.4  
#define SW2_1           PINE.3
#define SW2_2           PINE.2
#define SW3             PINE.5

#define Tcut_KEY        PINC.3     
#define DUAL_ail        PINC.1     
#define DUAL_elev       PINC.0  
#define DUAL_rud        PINC.2     

//  
#define Ailerons        5
#define Elevator        4
#define Throttle        6
#define Rudder          3
#define Rpop_contr      2
#define Batt            7

        


// Model types
#define TYPE_HELI		0
#define TYPE_PLANE		1
#define TYPE_GLIDER		2

// Fly modes
#define	M_NORMAL		0
#define	M_IDLEUP1		1
#define	M_IDLEUP2		2
#define	M_THOLD			3
#define	MAX_MODES		4

//Channels
#define CHAN_AIL		0
#define CHAN_ELE		1
#define CHAN_THR		2
#define CHAN_RUD		3
#define CHAN_GYRO		4
#define CHAN_PITCH		5
#define CHAN_GOV		6
#define CHAN_AUX1		7
#define CHAN_AUX2		8
#define MAX_CHANS		9
#define MAX_CONTR		10
#define CHAN_MIN                9
#define CHAN_MID		10
#define CHAN_MAX		11
#define CHAN_SW_L		12
#define CHAN_SW_R		13
#define CHAN_NONE		14

// TX Modulation types
#define MODUL_PPM               0
#define MODUL_IPPM              1
#define MODUL_PCM               2
#define MAX_MODULS		3

#define CURVE_NODES		7
#define MAX_MODELS              4



#include <Variables.c>

signed int input[10];
signed int out_cur[10];
signed int output[10];
signed int AD[5];
       int U_bat;

signed int ADmin[5];
signed int ADmax[5];  
signed int ADmid[5];

unsigned char buf[12];

char FLY_MODE;

signed long Kmin[5];
signed long Kmax[5];

char Cut_enable;
int temp_time;
int time;
char enable_counting;   


char S_trim[4];
char timersound;
char counter;
char precounter;

char  sound;
char cur_model_num;
  
unsigned char deep; 
unsigned char en;
unsigned char pen;
unsigned char pos[4];
unsigned char edit;
unsigned char curve_ed_enable;
unsigned char edit_cur;
unsigned char T[2];
unsigned char trim_sound_en;
unsigned char Clip;
unsigned char PreClip;
bit Pre_Trim;

unsigned char screen_name[9];
//Channel
typedef struct {
	signed int		CH[11][MAX_MODES];
       	
} CHAN_SETTINGS;


typedef struct {
	char		        reverse[MAX_MODES];
	unsigned char		maxRates[MAX_MODES];						// EPA val in 2% unit
	unsigned char		minRates[MAX_MODES];						// EPA val in 2% unit
	unsigned char		maxDRates[MAX_MODES];						// EPA val in 2% unit 
	unsigned char		minDRates[MAX_MODES];                                           //T-Cut for throttle channel
	char                    from[MAX_MODES];
	char		        nodes[CURVE_NODES][MAX_MODES];
} CONTR_SETTINGS;




//Model
typedef struct {
	char			version[2];			// Major and Minor version of data structure
	char			name[9];			// name of model (max 8 chars)
	char			type;				// heli, plane, etc.
	char			modulation;			// PPM, IPPM, PCM
        char			trimmer[MAX_MODES][4];
	int                     timer;
	char                    timer_mode;
         char                    num_ch;
}MODEL_SETTINGS;


CONTR_SETTINGS	        contr[MAX_CONTR];
CHAN_SETTINGS           chans[MAX_CHANS];


MODEL_SETTINGS          curmodel;



//    EEPROM'

        eeprom char		        reverse[MAX_MODELS][MAX_CONTR][MAX_MODES];
        eeprom unsigned char		maxRates[MAX_MODELS][MAX_CONTR][MAX_MODES];
        eeprom unsigned char		minRates[MAX_MODELS][MAX_CONTR][MAX_MODES];						// EPA val in 2% unit
	eeprom unsigned char		maxDRates[MAX_MODELS][MAX_CONTR][MAX_MODES];						// EPA val in 2% unit
	eeprom unsigned char		minDRates[MAX_MODELS][MAX_CONTR][MAX_MODES];
		        					// T-Cut for throttle channel
	eeprom char                     from[MAX_MODELS][MAX_CONTR][MAX_MODES];
	eeprom char		        nodes[MAX_MODELS][MAX_CONTR][CURVE_NODES][MAX_MODES];
	
	eeprom char		        CH[MAX_MODELS][MAX_CHANS][11][MAX_MODES];
	
	
	
	eeprom char			name[MAX_MODELS][8];			// name of model (max 8 chars)
	eeprom char			type[MAX_MODELS];				// heli, plane, etc.
	
	eeprom char			modulation[MAX_MODELS];			// PPM, IPPM, PCM
        
	eeprom char			trimmer[MAX_MODELS][MAX_MODES][4];            
	
	
	
	eeprom char                     EEPRsound;	
	eeprom int                      timer[MAX_MODELS];
	eeprom char                     timer_mode[MAX_MODELS];
	eeprom char                     start_model;
	eeprom int                      EEPR_ADmid[5];   
	eeprom char                     EEPR_Kmin[5],EEPR_Kmax[5];  
	eeprom char                     num_ch[MAX_MODELS];
	eeprom char                     FirstON;

	
#include <math.h>
#include <graph_new.h>




#define ADC_VREF_TYPE 0x00

unsigned char i;
   
  


unsigned int read_adc(unsigned char adc_input)
{
ADMUX=adc_input|ADC_VREF_TYPE;
// Start the AD conversion
ADCSRA|=0x40;
// Wait for the AD conversion to complete
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCW;
}



#include <Menu.c>


 #define MAXST 5;

typedef unsigned char byte;
 

 __flash const char __flash *modeNames[2][3] = 
   {
        {
	"Landing ",
	"Normal  ",
	"Pilotage"
	
        },
    
        {
	"Normal  ",
	"IddleUp ",
	"T Hold  "
	
        }
    }; 

__flash const char __flash modeNamesL=3;

__flash const char __flash *modulNames[] = {
	"PPM ",
	"IPPM",
        "PCM"
};
__flash const char __flash modulNamesL =3;


__flash const char __flash *menuT0[] = {
	"Model    >",
	"Controls >",
	"Channels >",
	"Timer    >",
	"Options  >"
};
__flash const char __flash menuT0L = 5;

__flash const char __flash *menuT1[] ={
	"Select   >",
	"Reset     ",
	"Copy     >",
	"Name     >",
	"Type     >",
	"Mods Copy>",
	"Modu Type>",
        "MAX CH   >"
};

__flash const char __flash menuT1L =8; 


__flash const char __flash *menuT2[] = {
	"Ailerons >",
	"Elevator >",
	"Throttle >",
	"Rudder   >",
	"SW 1     >",
	"SW 2     >",
	"SW 3     >",
	"Prop     >",
	"User's 1 >",
	"User's 2 >",
        "Trim      >"

};
__flash const char __flash menuT2L =10; 


__flash const char __flash *menuT3[] = {
	"Set     ",
	"Mode    ",
	"Control "
};
__flash const char __flash menuT3L =2; 

__flash const char __flash *menuT4[] = {
	"Sound    >",
	"Bcklight >",
	"Contrast >",
	"Sleep    >"
};
__flash const char __flash menuT4L =1;


__flash const char __flash *menuT5[] = {
	"CH 1     >",
	"CH 2     >",
	"CH 3     >",
	"CH 4     >",
	"CH 5     >",
	"CH 6     >",
	"CH 7     >",
	"CH 8     >"	
};

__flash const char __flash menuT5L =8; 

__flash const char __flash *menuT6[] = {
	"Plane",
	"Heli "
	
};

__flash const char __flash menuT6L =2; 



__flash const char __flash NM[] ={37,42,20,22,36,0,0,0};




__flash const char __flash *Timer_modes1[] = {
	"UP  ",
	"DOWN"
	
};

__flash const char __flash *Timer_modes2[] = {
	"Sound ON ",
	"Sound OFF"
	
};

__flash const char __flash Name_table[65] = {
' ','_','-','0','1','2','3','4','5','6','7','8','9','A','a','B','b','C','c','D',
'd','E','e','F','f','G','g','H','h','I','i','J','j','K','k','L','l','M','m','N',	
'n','O','o','P','p','Q','q','R','r','S','s','T','t','U','u','V','v','W','w','X',
'x','Y','y','Z','z'};


void name_init(void)
{
  screen_name[8]='\0';
      
   for (i=0; i<8; i++)  screen_name[i]=Name_table[curmodel.name[i]];

}

void trim_sound (void)
{
if (trim_sound_en&&sound)
        {
        trim_sound_en=0;
        PORTG|=0x4;
        delay_ms(30);
        PORTG&=0xFB;
        delay_ms(30);
        }
}
        
        
void BEEP (void)
{   
if (sound)
        {
        PORTG|=0x4;
        delay_ms(50);
        PORTG&=0xFB;
        delay_ms(50);
        }
else delay_ms(100);
}
void BEEP1 (void)
{   
if (sound)
        {
        PORTG|=0x4;
        delay_ms(20);
        PORTG&=0xFB;
        delay_ms(20);
        }
else delay_ms(40);
}
  

void MODEL_reset (void)
{char MOD, con,i;

#asm("cli")
 for (con=0; con<10; con++)
        for (MOD=0; MOD<4; MOD++)
                { 
 
                reverse[cur_model_num][con][MOD]=1;
      
                maxRates[cur_model_num][con][MOD]=100;
                minRates[cur_model_num][con][MOD]=100;						// EPA val in 2% unit
        
                maxDRates[cur_model_num][con][MOD]=100;					// EPA val in 2% unit
                minDRates[cur_model_num][con][MOD]=100;
                

//	eeprom char		        exponent[MAX_MODELS][MAX_CONTR][MAX_MODES];					// T-Cut for throttle channel
	        
	        nodes[cur_model_num][con][0][MOD]=-100;
                nodes[cur_model_num][con][1][MOD]=-66;
                nodes[cur_model_num][con][2][MOD]=-34;
                nodes[cur_model_num][con][3][MOD]=0;
                nodes[cur_model_num][con][4][MOD]=34;
                nodes[cur_model_num][con][5][MOD]=66;
                nodes[cur_model_num][con][6][MOD]=100;

                
                
                
                
                
                }	
for (con=0; con<8; con++)
        for (MOD=0; MOD<4; MOD++)
                for (i=0; i<11; i++)                
                        CH[cur_model_num][con][i][MOD]=0;
for (MOD=0; MOD<4; MOD++)
        {				
        for (i=0; i<8; i++)
                CH[cur_model_num][i][i][MOD]=100;	
 
 num_ch[cur_model_num]=6;  		
	}
	
	
	
for (i=0; i<8; i++)name[cur_model_num][i]=NM[i];
	
modulation[cur_model_num]=0;

for (i=0; i<4; i++)
        for (MOD=0; MOD<4; MOD++)     trimmer[cur_model_num][MOD][i]=0;


	type[cur_model_num]=0;				// heli, plane, etc.

timer[cur_model_num]=0;
 timer_mode[cur_model_num]=0;
 
 #asm("sei")
}

void MODEL_init (void)
{char MOD, con,node_num,i;
  BEEP();

#asm("cli")
 for (con=0; con<10; con++)
        for (MOD=0; MOD<4; MOD++)
                {   
 
                contr[con].reverse[MOD]=reverse[cur_model_num][con][MOD];
      
                contr[con].maxRates[MOD]=maxRates[cur_model_num][con][MOD];
                contr[con].minRates[MOD]=minRates[cur_model_num][con][MOD];						// EPA val in 2% unit
        
                contr[con].maxDRates[MOD]=maxDRates[cur_model_num][con][MOD];					// EPA val in 2% unit
                contr[con].minDRates[MOD]=minDRates[cur_model_num][con][MOD];
                contr[con].from[MOD]=from[cur_model_num][con][MOD];


	        
	        for (node_num=0; node_num<7; node_num++)
                contr[con].nodes[node_num][MOD]=nodes[cur_model_num][con][node_num][MOD];
                }	
        
        

for (con=0; con<8; con++)
        for (MOD=0; MOD<4; MOD++)
                for (i=0; i<11; i++)                
                        chans[con].CH[i][MOD]=CH[cur_model_num][con][i][MOD];
	
	
  for (i=0; i<8; i++)curmodel.name[i]=name[cur_model_num][i];	

	curmodel.type=type[cur_model_num];				// heli, plane, etc.


for (i=0; i<4; i++)
        for (MOD=0; MOD<4; MOD++)     curmodel.trimmer[MOD][i]=trimmer[cur_model_num][MOD][i];

curmodel.modulation= modulation[cur_model_num];


curmodel.timer=timer[cur_model_num];
curmodel.timer_mode=timer_mode[cur_model_num];

curmodel.num_ch=num_ch[cur_model_num];   

 name_init();
 #asm("sei")
 }
 
 void MODEL_copy (char f, char to)
        {char MOD, con,node_num,i;
  BEEP();
 
#asm("cli")
 for (con=0; con<10; con++)
        for (MOD=0; MOD<4; MOD++)
                {   
 
                reverse[to][con][MOD]=reverse[f][con][MOD];
      
                maxRates[to][con][MOD]=maxRates[f][con][MOD];
                minRates[to][con][MOD]=minRates[f][con][MOD];						// EPA val in 2% unit
        
                maxDRates[to][con][MOD]=maxDRates[f][con][MOD];					// EPA val in 2% unit
                minDRates[to][con][MOD]=minDRates[f][con][MOD];
                from[to][con][MOD]=from[f][con][MOD];

//	eeprom char		        exponent[MAX_MODELS][MAX_CONTR][MAX_MODES];					// T-Cut for throttle channel
	        
	        for (node_num=0; node_num<7; node_num++)
                nodes[to][con][node_num][MOD]=nodes[f][con][node_num][MOD];
                }	
                
                
for (con=0; con<8; con++)
        for (MOD=0; MOD<4; MOD++)
                for (i=0; i<11; i++)                
                        CH[to][con][i][MOD]=CH[f][con][i][MOD];
	
	
        for (i=0; i<8; i++)name[to][i]=name[f][i];	

	
	
	type[to]=type[f];				// heli, plane, etc.

for (i=0; i<4; i++)
        for (MOD=0; MOD<4; MOD++)     trimmer[to][MOD][i]=trimmer[f][MOD][i];


modulation[to]=modulation[f];


timer[to]=timer[f];
timer_mode[to]=timer_mode[f];

num_ch[to]=num_ch[f];  
        
        #asm("sei")
 }
 
void MODE_copy (char f, char to)
        {char MOD, con,node_num,i;
  BEEP();

#asm("cli")
 for (con=0; con<10; con++)
       
                {   
 
                reverse[cur_model_num][con][to]=reverse[cur_model_num][con][f];
      
                maxRates[cur_model_num][con][to]=maxRates[cur_model_num][con][f];
                minRates[cur_model_num][con][to]=minRates[cur_model_num][con][f];						// EPA val in 2% unit
        
                maxDRates[cur_model_num][con][to]=maxDRates[cur_model_num][con][f];					// EPA val in 2% unit
                minDRates[cur_model_num][con][to]=minDRates[cur_model_num][con][f];
                
                from[cur_model_num][con][to]=from[cur_model_num][con][f];

				
	        
	        for (node_num=0; node_num<7; node_num++)
                nodes[cur_model_num][con][node_num][to]=nodes[cur_model_num][con][node_num][f];
                }
                
                
                	
for (con=0; con<8; con++)
                for (i=0; i<11; i++)                
                        CH[cur_model_num][con][i][to]=CH[cur_model_num][con][i][f];
	
   for (i=0; i<4; i++)
        for (MOD=0; MOD<4; MOD++)     trimmer[cur_model_num][to][i]=trimmer[cur_model_num][f][i];	
        
        
        } 
 
 
 scroll (byte p,byte L)
 { if (!UP&&p<L-1)
                { p++;
                  BEEP();              }
        if (!DOWN&&p>0)
                {     
                p--;
                          
                 BEEP();         }
  return (p);
  #asm("sei")
  }
 
       
  void SAVE_CH (char NMOD,char N,char sel)
   {
        BEEP();
   
        
        if (sel==0) reverse[NMOD][N][FLY_MODE]=  contr[N].reverse[FLY_MODE] ;
        if (sel==2) minRates[NMOD][N][FLY_MODE]=  contr[N].minRates[FLY_MODE] ;
        if (sel==3) maxRates[NMOD][N][FLY_MODE]=  contr[N].maxRates[FLY_MODE] ;
        if (N<4)
                {
                if (sel==4) minDRates[NMOD][N][FLY_MODE]=  contr[N].minDRates[FLY_MODE] ;
                if (sel==5) maxDRates[NMOD][N][FLY_MODE]=  contr[N].maxDRates[FLY_MODE] ;
                }
        if (N>7&&sel==4) from[NMOD][N][FLY_MODE]=  contr[N].from[FLY_MODE] ;
  
       BEEP();
  
   }   
   
void edit_curve (char sel)
{ char Y[7];

lcd_line(5,16,89,16,1);
lcd_line(5,56,5,16,1);
lcd_line(89,56,89,16,1);
lcd_line(5,56,89,56,1);
lcd_dashline(5,36,89,36);
lcd_dashline(47,16,47,56);  
lcd_dashline(19,16,19,56);   
lcd_dashline(33,16,33,56);  
lcd_dashline(61,16,61,56);
lcd_dashline(75,16,75,56) ;
  
        Y[0]=contr[pos[1]].nodes[0][FLY_MODE]/-5+36;
        Y[1]=contr[pos[1]].nodes[1][FLY_MODE]/-5+36;
        Y[2]=contr[pos[1]].nodes[2][FLY_MODE]/-5+36;
        Y[3]=contr[pos[1]].nodes[3][FLY_MODE]/-5+36;
        Y[4]=contr[pos[1]].nodes[4][FLY_MODE]/-5+36;
        Y[5]=contr[pos[1]].nodes[5][FLY_MODE]/-5+36;
        Y[6]=contr[pos[1]].nodes[6][FLY_MODE]/-5+36;


lcd_line(5,Y[0],19,Y[1],1);
lcd_line(19,Y[1],33,Y[2],1);
lcd_line(33,Y[2],47,Y[3],1);
lcd_line(47,Y[3],61,Y[4],1);
lcd_line(61,Y[4],75,Y[5],1);
lcd_line(75,Y[5],89,Y[6],1);

lcd_rectangle(3+sel*14,Y[sel]+2,7+sel*14,Y[sel]-2,1);


sprintf(buf,"%-i",contr[pos[1]].nodes[sel][FLY_MODE]);
lcd_setxy(2,57);
if (!edit_cur)lcd_wrs(buf,255);
else  lcd_wrs(buf,Clip);
}   
      

void SAVE_NODE (void)
{ BEEP();
 nodes[cur_model_num][pos[1]][pos[3]][FLY_MODE]=contr[pos[1]].nodes[pos[3]][FLY_MODE];      
BEEP();
}









   void menu_item (__flash const char __flash **name, byte leng, byte sel)
        {   byte i, f,l,c;
        if (leng>5) {
                lcd_line(92,18,92,64,1);
                lcd_line(95,18,95,64,1);
        
                if (sel>=5)
                        {
                        lcd_line(93,41,93,64,1);
                        lcd_line(94,41,94,64,1);
                        lcd_line(93,18,94,18,1);
                        f=5; 
                        l=leng;
                        }      
        
                else
                        {
                        lcd_line(93,18,93,41,1);
                        lcd_line(94,18,94,41,1);
                        lcd_line(93,64,94,64,1);
                        f=0; 
                        l=5;
                        }      
        
                      }
        else
        {f=0;
         l=leng;
         }
        
        
        c=0;
        for (i=f; i<l; i++)
                {
                            lcd_setxy(10,c*9+18);
                            lcd_wrsf(name[i],255);
                            if (i==sel)
                                {
                                
                                lcd_setxy(10,c*9+18);
                                lcd_wrsf(name[i],0);
                                }
                               c++;
                }
        
        }  
     
     
void edit_CH (char N,char sel)
{
 if (sel==0)
        {
        lcd_setxy(0,20);
        if (edit==0) lcd_wrsf("Rev  ",0);   
        else lcd_wrsf("Rev  ",Clip);
        if (contr[N].reverse[FLY_MODE]==-1)
                {
              lcd_setxy(31,20);
                lcd_char(124,0);
                }
        else
                {
              lcd_setxy(31,20);
                
                lcd_char(123,0);
                }
        }
 else   {
        lcd_setxy(0,20);
        lcd_wrsf("Rev  ",255);                      
        if (contr[N].reverse[FLY_MODE]==-1)
                {
              lcd_setxy(31,20);
                lcd_char(124,255);
                }
        else
                {
              lcd_setxy(31,20);
                lcd_char(123,255);
                }
        
        
        }
if (N<4||N>6) 
        {       
        if (sel==1)
                {
                lcd_setxy(46,20);
                lcd_wrsf("Curve>",0);         
                }       
        else
                {
                lcd_setxy(46,20);
                lcd_wrsf("Curve>",255);         
                }
        }
        
 lcd_setxy(8,30);
        lcd_wrsf("Rate ",255);  
sprintf(buf,"%-i",contr[N].minRates[FLY_MODE]);
if (sel==2)
        {
        lcd_setxy(44,30);
        if (!edit)lcd_wrs(buf,0);
        else  lcd_wrs(buf,Clip);        
        }
else
        {
        lcd_setxy(44,30);
        lcd_wrs(buf,255);         
        }
sprintf(buf,"%-i",contr[N].maxRates[FLY_MODE]);        
 if (sel==3)
        {
        lcd_setxy(72,30);
         if (!edit)lcd_wrs(buf,0);
        else  lcd_wrs(buf,Clip);         
        }
else
        {
        lcd_setxy(72,30);
        lcd_wrs(buf,255);         
        }




  
if (N<4&&N!=2)
        {
         lcd_setxy(0,40);
         lcd_wrsf("DRate ",255); 
        sprintf(buf,"%-i",contr[N].minDRates[FLY_MODE]);   
        if (sel==4)
                {
                lcd_setxy(44,40);
                if (!edit)lcd_wrs(buf,0);
                else  lcd_wrs(buf,Clip);   
                         
                }
        else
                {
                lcd_setxy(44,40);
                lcd_wrs(buf,255);      
                }             
       sprintf(buf,"%-i",contr[N].maxDRates[FLY_MODE]);   
        if (sel==5)
                {
                lcd_setxy(72,40);
                if (!edit)lcd_wrs(buf,0);
                else  lcd_wrs(buf,Clip);   
                         
                }
        else
                {
                lcd_setxy(72,40);
                lcd_wrs(buf,255);      
                }             
       
       
       
       
        }
   
if (N==2)
        {
         lcd_setxy(2,40);
                lcd_wrsf("Tcut ",255);
       sprintf(buf,"%-i",contr[N].minDRates[FLY_MODE]);
        if (sel==4)
                {
                lcd_setxy(44,40);
              if (!edit) lcd_wrs(buf,0);
                else  lcd_wrs(buf,Clip);
                       
                }
        else
                {
                 lcd_setxy(44,40);
                lcd_wrs(buf,255);        
                }             
        } 
 if (N>7)
        {lcd_setxy(2,42);
                lcd_wrsf("From: ",255);    
        if (sel==4)
                {
        
                lcd_setxy(8,50);
                if (!edit)lcd_wrsf(menuT2[contr[pos[1]].from[FLY_MODE]] ,0);
                else  lcd_wrsf(menuT2[contr[pos[1]].from[FLY_MODE]] ,Clip);        
                }
        else
                {
                lcd_setxy(8,50);
                lcd_wrsf(menuT2[contr[pos[1]].from[FLY_MODE]] ,255);      
                }             
        } 
 
 }

void wr_trimmer (void)
{  char tr[4];


tr[2]=curmodel.trimmer[FLY_MODE][2]/-5+40;

lcd_line(6,24,6,56,1); 

lcd_pixel(7,24,1);
lcd_pixel(8,24,1);
lcd_pixel(7,28,1);
lcd_pixel(7,32,1);
lcd_pixel(7,36,1);
lcd_pixel(7,40,1);
lcd_pixel(8,40,1);
lcd_pixel(7,44,1);
lcd_pixel(7,48,1);
lcd_pixel(7,52,1);
lcd_pixel(7,56,1);
lcd_pixel(8,56,1);

lcd_pixel(9,tr[2],1); 
lcd_line(10,tr[2]-1,10,tr[2]+1,1);
lcd_line(11,tr[2]-2,11,tr[2]+2,1);


tr[1]=curmodel.trimmer[FLY_MODE][1]/-5+40; 
lcd_line(89,24,89,56,1); 

lcd_pixel(88,24,1);
lcd_pixel(87,24,1);
lcd_pixel(88,28,1);
lcd_pixel(88,32,1);
lcd_pixel(88,36,1);
lcd_pixel(88,40,1);
lcd_pixel(87,40,1);
lcd_pixel(88,44,1);
lcd_pixel(88,48,1);
lcd_pixel(88,52,1);
lcd_pixel(88,56,1);
lcd_pixel(87,56,1);

lcd_pixel(86,tr[1],1); 
lcd_line(85,tr[1]-1,85,tr[1]+1,1);
lcd_line(84,tr[1]-2,84,tr[1]+2,1); 


tr[3]=curmodel.trimmer[FLY_MODE][3]/5+26; 
lcd_line(10,63,42,63,1);
lcd_pixel(10,61,1);
lcd_pixel(10,62,1);
lcd_pixel(14,62,1);
lcd_pixel(18,62,1);
lcd_pixel(22,62,1);
lcd_pixel(26,62,1);
lcd_pixel(26,61,1);
lcd_pixel(30,62,1);
lcd_pixel(34,62,1);
lcd_pixel(38,62,1);
lcd_pixel(42,62,1);
lcd_pixel(42,61,1); 

lcd_pixel(tr[3],60,1); 
lcd_line(tr[3]-1,59,tr[3]+1,59,1);
lcd_line(tr[3]-2,58,tr[3]+2,58,1);


tr[0]=curmodel.trimmer[FLY_MODE][0]/5+68; 
lcd_line(52,63,84,63,1);
lcd_pixel(52,62,1);
lcd_pixel(52,61,1);
lcd_pixel(56,62,1);
lcd_pixel(60,62,1);
lcd_pixel(64,62,1);
lcd_pixel(68,62,1);
lcd_pixel(68,61,1);
lcd_pixel(72,62,1);
lcd_pixel(76,62,1);
lcd_pixel(80,62,1);
lcd_pixel(84,62,1);
lcd_pixel(84,61,1); 

lcd_pixel(tr[0],60,1); 
lcd_line(tr[0]-1,59,tr[0]+1,59,1);
lcd_line(tr[0]-2,58,tr[0]+2,58,1); 


}


void main_scr (void)
        {char min[2],sec[2];
        
        
        lcd_setxy(0,0);
        sprintf(buf,"0%-i",cur_model_num+1);
        lcd_wrs(buf,255);
        lcd_setxy(16,0);
        if (curmodel.type==1)            // 
                {
                lcd_char(125,255); 
                lcd_char(126,255); 
                }                                                                ///***************************
        if (curmodel.type==0)            // 
                {
                lcd_char(127,255); 
                lcd_char(128,255); 
                }  
   
   
   
   if (Cut_enable)
        {
        lcd_setxy(65,15);
        lcd_char(129,255);
        lcd_char(130,255);
        lcd_setxy(65,23);
        lcd_char(131,255);
        lcd_char(132,255);
        }
   
   
   lcd_setxy(25,20); 
     sprintf(buf,"%-i.%-iV",U_bat/100,U_bat/10%10);
      lcd_wrs(buf,255);
      
   
      lcd_setxy(33,0);
      lcd_wrs(screen_name,255);
                        
       
    
    lcd_setxy(0,9);  
    lcd_wrsf(modeNames[curmodel.type][FLY_MODE],255);  
     
     //lcd_fillrect(24,18,68,30,1);
     //lcd_fillrect(68,22,71,26,1);
     
    min[0]=time/600;
    min[1]=time/60%10;
    sec[0]=time%60/10;
    sec[1]=time%10;
    
    lcd_setxy(42,35);
    lcd_deg12x16(10,255);
    
    lcd_setxy(19,36);
    lcd_deg12x16(min[0],255);
    lcd_setxy(32,36);
    lcd_deg12x16(min[1],255);
    
     
    lcd_setxy(50,36);
    lcd_deg12x16(sec[0],255);
    lcd_setxy(63,36);
    lcd_deg12x16(sec[1],255);
   
    
    wr_trimmer();
    
        }
      
    /*  
      void main_scr (void)
        {
      lcd_setxy(1,10);
      sprintf(buf,"%-i  %-i",output[0], out_cur[4]);
      lcd_wrs(buf,255); 
       
     
     lcd_setxy(1,20);
     
      
     sprintf(buf,"%-i  %-i",output[1], out_cur[5]);
      lcd_wrs(buf,255);
       
 
     lcd_setxy(1,30);
     
     sprintf(buf,"%-i  %-i",output[2], out_cur[6]);
      lcd_wrs(buf,255);
     
     lcd_setxy(1,40);
     
     sprintf(buf,"%-i  %-i",output[3],input[3]);
      lcd_wrs(buf,255);
     
    lcd_setxy(1,50);
     
     sprintf(buf,"%-i  %-i,%-i",output[7],U_bat/10000,U_bat/1000%10);
      lcd_wrs(buf,255);    
        
        }
      */
void menu (void)
{ byte i,j,max,temp[9],f,l,c; 

if (LEFT&&RIGHT&&UP&&DOWN) pen=1;
 
lcd_clear();
if (!en) {
        main_scr();
        if (!RIGHT&&pen)
                        {
                        en=1;
                        deep=0;
                        pen=0;
                        pos[0]=0;
                        BEEP();
                        }
          }                
         
        else  
        {
        
        lcd_setxy(0,0);
        sprintf(buf,"0%-i",cur_model_num+1);
        lcd_wrs(buf,255);
        lcd_setxy(16,0);
        if (curmodel.type==1)            //  
                {
                lcd_char(125,255); 
                lcd_char(126,255); 
                }
        
           if (curmodel.type==0)            // 
                {
                lcd_char(127,255); 
                lcd_char(128,255); 
                }  
        
        lcd_setxy(33,0);
   lcd_wrsf(modeNames[curmodel.type][FLY_MODE],255);
   if (!curve_ed_enable )   
        {
        lcd_dashline(0,16,95,16);
        lcd_line(0,17,95,17,1);
        }
        
        if (deep==0) {                                                          // 
                
    pos[0]= scroll (pos[0],menuT0L);
                
       
             if (!LEFT&&pen) {en=0;pen=0;BEEP();}
             if (!RIGHT&&pen) 
                        {
                        deep=1;
                        pos[1]=0;
                        pen=0;
                        BEEP();
                        }
                
                
                
                lcd_setxy(0,8);
                lcd_wrsf("Main menu",255);
        
                menu_item( menuT0 ,menuT0L,pos[0]);
        
        
                        }
 
 
        if (deep>0) 
        {
        if (pos[0]==0)
        { if (deep==1)
                {                                                    //                
                pos[1]= scroll (pos[1],menuT1L) ;
                if (!LEFT&&pen) {deep=0; pen=0;BEEP();}
                if (!RIGHT&&pen) 
                        {
                        deep=2;
                        pos[2]=0;
                        pen=0;
                        BEEP();
                        if (pos[1]==0) pos[2]=cur_model_num;
                        }
                
                
                
                lcd_setxy(0,8);
                lcd_wrsf("Model",255);
        
                menu_item( menuT1 ,menuT1L,pos[1]);
        
                }
        if (deep==2&&pos[1]==0)                      //
                {
                lcd_setxy(0,8);
                lcd_wrsf("Select",255);  
                for (j=0; j<MAX_MODELS; j++)
                        {
                        for (i=0; i<8; i++)temp[i]=Name_table[name[j][i]];	
                        temp[8]='\0';
                        lcd_setxy(10,9*j+18);
                        if (pos[2]==j) lcd_wrs(temp,0);
                        else lcd_wrs(temp,255);
                        }
                        if (!UP&&pos[2]<MAX_MODELS-1)
                                {
                                pos[2]++;
                                BEEP();
                                }
                
                        if (!DOWN&&pos[2]>0)
                                {
                                pos[2]--;   
                                BEEP();
                                }
                        if (!LEFT&&pen){BEEP(); pen=0; deep=1; cur_model_num=pos[2]; start_model=cur_model_num; MODEL_init(); BEEP();}        
                        
                        
                }
                
        if (deep==2&&pos[1]==1)                      //
                {
                lcd_setxy(0,8);
                lcd_wrsf("Reset",255);
                lcd_setxy(10,24);
                lcd_wrsf("Are you",255);                
                lcd_setxy(15,35);
                lcd_wrsf("sure?",255);          
                if (!RIGHT&&pen)
                        {
                        BEEP();
                        lcd_clear();
                        lcd_setxy(10,24);
                        lcd_wrsf("Please",255);                
                        lcd_setxy(15,35);
                        lcd_wrsf("wait...",255); 
                        lcd_refresh();
                        MODEL_reset();
                        MODEL_init(); 
                        pen=0; 
                        deep=1;
                        BEEP();
                        } 
                 if (!LEFT&&pen) {deep=1; pen=0;BEEP();}
                }
        if (deep==2&&pos[1]==2)                      //  
                {
                lcd_setxy(0,8);
                lcd_wrsf("Copy",255);  
                
                lcd_setxy(2,18);
                lcd_wrsf("From:",255);
                
                lcd_setxy(2,36);
                lcd_wrsf("To:",255);
                
                for (i=0; i<8; i++)temp[i]=Name_table[name[T[0]][i]];	
                
                temp[8]='\0';
                
                lcd_setxy(15,27);
                
                if (pos[2]==0)
                        {  
                        if (!edit)lcd_wrs(temp,0);
                        else lcd_wrs(temp,Clip);  
                        }
                else    lcd_wrs(temp,255);
                
                for (i=0; i<8; i++)temp[i]=Name_table[name[T[1]][i]];	
                
                lcd_setxy(15,45);
                
                temp[8]='\0';
                
                if (pos[2]==1)  
                        {  
                        if (!edit)lcd_wrs(temp,0);
                        else lcd_wrs(temp,Clip);  
                        }
                else    lcd_wrs(temp,255);
                
                lcd_setxy(40,54);
                if (pos[2]==2)
                        lcd_wrsf("OK",0);
                else    lcd_wrsf("OK",255);
                
                if (!UP&&!edit&&pos[2]<2)
                                {
                                pos[2]++;
                                BEEP();
                                }
                
                if (!DOWN&&!edit&&pos[2]>0)
                                {
                                pos[2]--;   
                                BEEP();
                                }
                
                if (!LEFT&&pen&&!edit) {pen=0; deep=1; BEEP();}
                if (!LEFT&&pen&&edit) {pen=0; edit=0; BEEP();}
               
                if (!RIGHT&&pen&&!edit&&pos[2]<2) {pen=0; edit=1;BEEP();}
                                
                if (!UP&&edit&&T[pos[2]]<MAX_MODELS-1)
                                {
                                T[pos[2]]++;
                                BEEP();
                                }
                
                if (!DOWN&&edit&&T[pos[2]]>0)
                                {
                                T[pos[2]]--;   
                                BEEP();
                                }
                
                if (!RIGHT&&pen&&!edit&&pos[2]==2) {pen=0;MODEL_copy(T[0],T[1]); BEEP();deep=1;}
                
                }
        
        if (deep==2&&pos[1]==3)                      // 
                {
                lcd_setxy(0,8);
                lcd_wrsf("Name",255);  
                
                for (i=0; i<8; i++) 
                        {
                        lcd_setxy(i*11+5,25);
                        if (edit&&pos[2]==i)lcd_char(Name_table[curmodel.name[i]],Clip);
                        else lcd_char(Name_table[curmodel.name[i]],255);
                        }
                
                lcd_rectangle(pos[2]*11+3,23,pos[2]*11+14,34,1);
                
                if (!LEFT&&pen&&!edit) {pen=0; deep=1; BEEP();}
                
                if (!RIGHT&&pen&&!edit) {pen=0; edit=1;BEEP();name_init();}
                
                if (!LEFT&&pen&&edit) {pen=0; edit=0; BEEP(); name[cur_model_num][pos[2]]=curmodel.name[pos[2]];}
                
                
                if (!DOWN&&!edit&&pos[2]<7)
                                {
                                pos[2]++;
                                BEEP();
                                }
                
                if (!UP&&!edit&&pos[2]>0)
                                {
                                pos[2]--;   
                                BEEP();
                                }
                
                if (!DOWN&&edit&&curmodel.name[pos[2]]<64)
                                {
                                curmodel.name[pos[2]]++;
                                BEEP1();
                                }
                
                if (!UP&&edit&&curmodel.name[pos[2]]>0)
                                {
                                curmodel.name[pos[2]]--;   
                                BEEP1();
                                }
                
                
                
                }
        
                 if (deep==2&&pos[1]==4)                      //  
                {
                
                lcd_setxy(0,8);
                lcd_wrsf("Type",255);
                
                lcd_setxy(5,25);
                lcd_wrsf(menuT6[curmodel.type],255);
                               
                if (!UP&&curmodel.type<1)
                                {
                                curmodel.type++;
                                 BEEP1();
                                }
                
                if (!DOWN&&curmodel.type>0)
                                {
                                curmodel.type--;   
                                 BEEP1();
                                }
                
                
                if (!LEFT&&pen) {pen=0; deep=1; BEEP(); type[cur_model_num]=curmodel.type; BEEP();}
                
                }
                
                if (deep==2&&pos[1]==5)                      //  
                {
                lcd_setxy(0,8);
                lcd_wrsf("Copy MODE",255);  
                
                lcd_setxy(2,18);
                lcd_wrsf("From:",255);
                
                lcd_setxy(2,36);
                lcd_wrsf("To:",255);
                
                for (i=0; i<8; i++)temp[i]=modeNames[curmodel.type][T[0]][i];	
                
                temp[8]='\0';
                
                lcd_setxy(15,27);
                
                if (pos[2]==0)  
                        {
                        if (!edit)lcd_wrs(temp,0);
                        else lcd_wrs(temp,Clip);
                        }
                else    lcd_wrs(temp,255);
                
                for (i=0; i<8; i++)temp[i]=modeNames[curmodel.type][T[1]][i];	
                
                lcd_setxy(15,45);
                
                temp[8]='\0';
                
                if (pos[2]==1)  
                        {
                        if (!edit)lcd_wrs(temp,0);
                        else lcd_wrs(temp,Clip);
                        }
                else    lcd_wrs(temp,255);
                
                lcd_setxy(40,54);
                if (pos[2]==2)
                        lcd_wrsf("OK",0);
                else    lcd_wrsf("OK",255);
                
                if (!UP&&!edit&&pos[2]<2)
                                {
                                pos[2]++;
                                BEEP();
                                }
                
                if (!DOWN&&!edit&&pos[2]>0)
                                {
                                pos[2]--;   
                                BEEP();
                                }
                
                if (!LEFT&&pen&&!edit) {pen=0; deep=1; BEEP();}
                if (!LEFT&&pen&&edit) {pen=0; edit=0; BEEP();}
               
                if (!RIGHT&&pen&&!edit&&pos[2]<2) {pen=0; edit=1;BEEP();}
                                
                if (!UP&&edit&&T[pos[2]]<2)
                                {
                                T[pos[2]]++;
                                BEEP();
                                }
                
                if (!DOWN&&edit&&T[pos[2]]>0)
                                {
                                T[pos[2]]--;   
                                BEEP();
                                }
                
                if (!RIGHT&&pen&&!edit&&pos[2]==2) {pen=0;MODE_copy(T[0],T[1]);MODEL_init(); BEEP();deep=1;}
                
                }
                
                
              if (deep==2&&pos[1]==6)                      // 
                {  
                 lcd_setxy(0,8);
                lcd_wrsf("Modulation",255);  
        
                if (!UP&&curmodel.modulation<1)
                                {
                                curmodel.modulation++;
                                BEEP();
                                
                                if (curmodel.modulation==0) TCCR1A=0x82;
                                if (curmodel.modulation==1) TCCR1A=0xC2;
                                }
                
                if (!DOWN&&curmodel.modulation>0)
                                {
                                curmodel.modulation--;   
                                BEEP();
                                if (curmodel.modulation==0) TCCR1A=0x82;
                                if (curmodel.modulation==1) TCCR1A=0xC2;
                                }
                 
                 
                 if (!LEFT&&pen) {deep=1; modulation[cur_model_num]=curmodel.modulation; BEEP();}
                 
                 
                lcd_setxy(15,25);
                lcd_wrsf(modulNames[curmodel.modulation],255); 
                 
                 
                 
                 
                 }
       
       
         if (deep==2&&pos[1]==7)                      //      ===========================================================
                { 
                lcd_setxy(0,8);
                lcd_wrsf("MAX CH",255); 
                
                if (!DOWN&&curmodel.num_ch<8)
                                {
                                curmodel.num_ch++;
                                BEEP();
                                
                                
                                }
                
                if (!UP&&curmodel.num_ch>2)
                                {
                                curmodel.num_ch--;   
                                BEEP();
                                
                                }
                 
                 
                 if (!LEFT&&pen) {deep=1; num_ch[cur_model_num]=curmodel.num_ch; BEEP(); pen=0;}
                 
                 
                lcd_setxy(15,25);
                lcd_deg12x16(curmodel.num_ch,255);
                
                
                
                
                }
       
       
       
       
       
       
        }
        
        if (pos[0]==1)
        {       if (deep==1){                                                         //      CONTROLS          
                        if (!UP&&pos[1]<menuT2L-1)
                                {pos[1]++;
                                BEEP();
                                } 
                                
                        if (!DOWN&&pos[1]>0)
                                {pos[1]--;
                                 BEEP();
                                 }
                        if (!LEFT&&pen) {deep=0; pen=0;BEEP();}
                        if (!RIGHT&&pen) 
                                {
                                deep=2;
                                pos[2]=0;
                                edit=0;
                                pen=0;
                                
                                BEEP();
                                }
                  
                
                
                        lcd_setxy(0,8);
                        lcd_wrsf("Controls",255);
        
                        menu_item( menuT2 ,menuT2L,pos[1]);
                
               } 
                if (deep==2)                                       // CONtrols
                        {
                        if (pos[1]<2||pos[1]==3) max=6;
                        if (pos[1]>4&&pos[1]<8) max=4;
                        if (pos[1]>7||pos[1]==2) max=5;
                        
                        if (!UP&&(pos[2]<max-1)&&!edit)
                                {
                                pos[2]++;
                                if  (pos[1]>3&&pos[1]<7&&pos[2]==1) pos[2]++;               
                                BEEP();
                                }
                
                        if (!DOWN&&(pos[2]>0)&&!edit)
                                {pos[2]--;   
                                if  (pos[1]>3&&pos[1]<7&&pos[2]==1) pos[2]--; 
                                BEEP();
                                }
                        
                        if (!LEFT&&pen&&!edit) {deep=1; pen=0;BEEP();}
                        if (!LEFT&&pen&&edit&&!curve_ed_enable) {edit=0; pen=0;SAVE_CH(cur_model_num,pos[1],pos[2]);     } 
                        
                        if (!RIGHT&&pen&&!edit&&pos[2]!=1) {edit=1; pen=0;BEEP(); }
                        
                      
                        
                        if (pos[2]==0&&!UP&&edit) contr[pos[1]].reverse[FLY_MODE]=-1;
                         if (pos[2]==0&&!DOWN&&edit) contr[pos[1]].reverse[FLY_MODE]=1;
                        
                           if (pos[2]==2&&!DOWN&&edit&&contr[pos[1]].minRates[FLY_MODE]<150)    {contr[pos[1]].minRates[FLY_MODE]+=2;  BEEP1();}
                         if (pos[2]==2&&!UP&&edit&&contr[pos[1]].minRates[FLY_MODE]>0)          {contr[pos[1]].minRates[FLY_MODE]-=2;  BEEP1();}
                                                                                                                                       
                          if (pos[2]==3&&!DOWN&&edit&&contr[pos[1]].maxRates[FLY_MODE]<150)     {contr[pos[1]].maxRates[FLY_MODE]+=2;  BEEP1();}
                         if (pos[2]==3&&!UP&&edit&&contr[pos[1]].maxRates[FLY_MODE]>0)          {contr[pos[1]].maxRates[FLY_MODE]-=2;  BEEP1();}
                        
                        
                        if (pos[1]<4&&pos[1]!=2)
                                {
                                if (pos[2]==4&&!DOWN&&edit&&contr[pos[1]].minDRates[FLY_MODE]<150)     { contr[pos[1]].minDRates[FLY_MODE]+=2; BEEP1();}
                                if (pos[2]==4&&!UP&&edit&&contr[pos[1]].minDRates[FLY_MODE]>0)         { contr[pos[1]].minDRates[FLY_MODE]-=2; BEEP1();}
                               
                                if (pos[2]==5&&!DOWN&&edit&&contr[pos[1]].maxDRates[FLY_MODE]<150)     { contr[pos[1]].maxDRates[FLY_MODE]+=2; BEEP1();}
                                if (pos[2]==5&&!UP&&edit&&contr[pos[1]].maxDRates[FLY_MODE]>0)         { contr[pos[1]].maxDRates[FLY_MODE]-=2; BEEP1();}
                                
                                }
                        if (pos[1]==2)// Throttle cut
                                { 
                                if (pos[2]==4&&!DOWN&&edit&&contr[pos[1]].minDRates[FLY_MODE]<150)     { contr[pos[1]].minDRates[FLY_MODE]+=2; BEEP1();}
                                if (pos[2]==4&&!UP&&edit&&contr[pos[1]].minDRates[FLY_MODE]>0)          {contr[pos[1]].minDRates[FLY_MODE]-=2;  BEEP1();}
                                }
                        if (pos[2]==1&&!RIGHT&&pen&&!edit) {curve_ed_enable=1; edit=1;pen=0;pos[3]=0;edit_cur=0;BEEP();}
                        if (pos[2]==1&&!LEFT&&pen&&edit&&curve_ed_enable&&!edit_cur) {curve_ed_enable=0; edit=0;pen=0;BEEP();}
                        
                        if(curve_ed_enable)                                             //
                                {
                                 
                                if (!DOWN&&!edit_cur&&pen&&pos[3]<6) {pos[3]++;pen=0;BEEP();}
                                if (!UP&&!edit_cur&&pen&&pos[3]>0) {pos[3]--;pen=0;BEEP();}
                                
                                if (!RIGHT&&pen) {edit_cur=1; pen=0;BEEP();} 
                                
                                if (!DOWN&&edit_cur&&contr[pos[1]].nodes[pos[3]][FLY_MODE]<100) {contr[pos[1]].nodes[pos[3]][FLY_MODE]+=2; BEEP1();}
                                if (!UP&&edit_cur&&contr[pos[1]].nodes[pos[3]][FLY_MODE]>-100){ contr[pos[1]].nodes[pos[3]][FLY_MODE]-=2;  BEEP1();}
                               
                                if (!LEFT&&pen) {edit_cur=0; pen=0;SAVE_NODE();} 
                                
                                edit_curve(pos[3]);
                                
                                }
                       
                        
                        lcd_setxy(0,7);
                        lcd_wrsf(menuT2[pos[1]],255);        
                        lcd_setxy(70,7);
                        lcd_wrsf("   ",255);          
                        
                        if (!curve_ed_enable) edit_CH (pos[1],pos[2])    ;
                        
                        
                                if (pos[1]>7)                         ////     
                                        {
                                        if (pos[2]==4&&!UP&&edit&&contr[pos[1]].from[FLY_MODE]>0){ contr[pos[1]].from[FLY_MODE]--;   BEEP1();}
                                        if (pos[2]==4&&!DOWN&&edit&&contr[pos[1]].from[FLY_MODE]<7) {contr[pos[1]].from[FLY_MODE]++;   BEEP1();}      
                                        
                                        
                                        }
                        
                        
                        
                        
                        
                        
                        
                        
                        
                        
                        
                        
                        
                        }
              
              }
              
              
              
              if (pos[0]==2)
                {
                if (deep==1)
                        {                                                          //CHANNELS          
                        if (!UP&&pos[1]<menuT5L-1)
                                {
                                pos[1]++;
                                BEEP();
                                }
                        if (!DOWN&&pos[1]>0)
                                {
                                pos[1]--;
                                BEEP();
                                }
                        if (!LEFT&&pen) {deep=0; pen=0; BEEP();}
                        if (!RIGHT&&pen) 
                                {
                                deep=2;
                                pos[2]=0;
                                pen=0;
                                BEEP();
                                }
                        
                
                
                        lcd_setxy(0,8);
                        lcd_wrsf("Channels",255);
        
                        menu_item( menuT5 ,menuT5L,pos[1]);
                        }
                if (deep==2)
                        {
                        lcd_setxy(0,8);
                        lcd_wrsf(menuT5[pos[1]],255);
                        lcd_setxy(70,8);
                        lcd_wrsf("   ",255);  
                        if (!LEFT&&!edit&&pen) {deep=1; pen=0; BEEP();}
                        if (!LEFT&&edit&&pen) {edit=0; pen=0;CH[cur_model_num][pos[1]][pos[2]][FLY_MODE]=chans[pos[1]].CH[pos[2]][FLY_MODE]; BEEP();}
                        if (!RIGHT&&pen) {edit=1; pen=0; BEEP();}
                        
                        if (!UP&&!edit&&pos[2]<10)
                                {
                                pos[2]++;
                                BEEP();
                                }
                        if (!DOWN&&!edit&&pos[2]>0)
                                {
                                pos[2]--;
                                BEEP();
                                }
                        if (!DOWN&&edit&&chans[pos[1]].CH[pos[2]][FLY_MODE]<100)
                                {
                                chans[pos[1]].CH[pos[2]][FLY_MODE]+=2;
                                 BEEP1();
                                }
                        if (!UP&&edit&&chans[pos[1]].CH[pos[2]][FLY_MODE]>-100)
                                {
                                chans[pos[1]].CH[pos[2]][FLY_MODE]-=2;
                                 BEEP1();
                                }
                        
                        lcd_line(92,18,92,64,1);
                        lcd_line(95,18,95,64,1);
        
                        if (pos[2]>=5&&pos[2]<10)
                                {
                                lcd_line(93,33,93,48,1);
                                lcd_line(94,33,94,48,1);
                                lcd_line(93,18,94,18,1);
                                f=5; 
                                l=10;
                                }      
                        if (pos[2]>=10)
                                {
                                lcd_line(93,48,93,64,1);
                                lcd_line(94,48,94,64,1);
                                lcd_line(93,18,94,18,1);
                                f=10; 
                                l=11;
                                }      
                        
                         if (pos[2]<5)        
                                {
                                lcd_line(93,18,93,33,1);
                                lcd_line(94,18,94,33,1);
                                lcd_line(93,64,94,64,1);
                                f=0; 
                                l=5;
                                }  
                        
                        c=0;
                        for (i=f; i<l; i++)
                                {
                                
                                if (i==pos[2])
                                        {
                                        lcd_setxy(0,c*9+18);
                                        if (!edit)lcd_wrsf(menuT2[i],0);
                                        else lcd_wrsf(menuT2[i],Clip);
                                        
                                        lcd_setxy(56,c*9+18);
                                         if (!edit)lcd_wrsf("    ",0);
                                        else lcd_wrsf("    ",Clip);
                                        
                                        lcd_setxy(60,c*9+18);
                                        sprintf(buf,"%-i",chans[pos[1]].CH[i][FLY_MODE]);
                                        if (!edit)lcd_wrs(buf,0);
                                        else lcd_wrs(buf,Clip);
                                        
                                        }
                                else
                                        {
                                        lcd_setxy(0,c*9+18);
                                        lcd_wrsf(menuT2[i],255);
                                        lcd_setxy(56,c*9+18);
                                        lcd_wrsf("   ",255);
                                        lcd_setxy(60,c*9+18);
                                        sprintf(buf,"%-i",chans[pos[1]].CH[i][FLY_MODE]);
                                        lcd_wrs(buf,255);
                                        }
                                c++;
                                
                                }
                          
                        
                        
                        }
                
                
                }
      
      
         if (pos[0]==3)
        {
        if (deep==1)
                {                                                          //    TIMER            
                if (!UP&&pos[1]<menuT3L-1)
                        { 
                        pos[1]++;
                        BEEP();
                        }
                if (!DOWN&&pos[1]>0)
                        {
                        pos[1]--;
                        BEEP();
                        }
                if (!LEFT&&pen) {deep=0; pen=0;BEEP();}
                if (!RIGHT&&pen) 
                        {
                        deep=2;
                        pos[2]=0;
                        pen=0;
                        BEEP();
                        }
                  
                
                
                lcd_setxy(0,8);
                lcd_wrsf("Timer",255);
        
                menu_item( menuT3 ,menuT3L,pos[1]);
        
        
                }
       
       if (deep==2&&pos[1]==0)    // 
                {  
                if (!LEFT&&pen) {deep=1; pen=0; timer[cur_model_num]=curmodel.timer;BEEP();}
               
                if (!DOWN&&curmodel.timer<3599)
                        { 
                        curmodel.timer+=10;
                        BEEP1();
                        }
                if (!UP&&curmodel.timer>0)
                        {
                       curmodel.timer-=10;
                        BEEP1();
                        }
                
              
                
                
               
                        sprintf(buf,"%-i:%-i",curmodel.timer/60,curmodel.timer%60);
                 
                lcd_setxy(25,25);
                lcd_wrs(buf,255);
                }
       
       if (deep==2&&pos[1]==1)      // 
                {
                if (!LEFT&&pen) {deep=1;timer_mode[cur_model_num]=curmodel.timer_mode; pen=0;BEEP();}  
                
                
                
                if (!UP&&curmodel.timer_mode<3)
                        { 
                        curmodel.timer_mode++;
                        BEEP();
                        }
                if (!DOWN&&curmodel.timer_mode>0)
                        {
                       curmodel.timer_mode--;
                        BEEP();
                        }
                
                lcd_setxy(15,20);
                lcd_wrsf(Timer_modes1[curmodel.timer_mode/2],255);
                lcd_setxy(15,30);
                lcd_wrsf(Timer_modes2[curmodel.timer_mode%2],255);
                
                }
       
       
       
       }
       
       if (pos[0]==4)
                { 
                if (deep==1)
                        {                                                         //OPTIONS         
                        if (!UP&&pos[1]<menuT4L-1)
                                {
                                pos[1]++;
                                BEEP();
                                }
                        if (!DOWN&&pos[1]>0)
                                {
                                pos[1]--;
                                BEEP(); 
                                }
                        if (!LEFT&&pen) {deep=0; pen=0;BEEP();}
                        if (!RIGHT&&pen) 
                                {
                                deep=2;
                                pos[2]=0;
                                pen=0;
                                BEEP();
                                }
                  
                
                
                lcd_setxy(0,8);
                lcd_wrsf("Options",255);
        
                menu_item( menuT4 ,menuT4L,pos[1]);
                        }
                if (deep==2&&pos[1]==0)
                        {
                        lcd_setxy(0,8);
                        lcd_wrsf("Sound",255);
                        lcd_setxy(10,25);
                        if (sound)lcd_wrsf("ON",255); 
                        else lcd_wrsf("OFF",255);
                        if (!DOWN&&pen) {sound=1; BEEP();pen=0;}
                        if (!UP&&pen) {sound=0; BEEP();pen=0;}
                        if (!LEFT&&pen) {deep=1; pen=0; EEPRsound=sound; BEEP();}
                        }
                        
                
                
                
                
                
                
                }
       
       
       
       
       
        }
  }      
 lcd_refresh();
 }










void calibr (void)
{
unsigned char i,x2,y2;
int t1,t2;   
    read_adc(Ailerons);
        AD[0]=ADCW-ADmid[0];
        read_adc(Throttle);
        AD[2]=ADCW-ADmid[2];
        read_adc(Rudder);
        AD[3]=ADCW-ADmid[3];
        read_adc(Elevator);
        AD[1]=ADCW-ADmid[1];
        read_adc(Rpop_contr);
        AD[4]=ADCW-ADmid[4];
        read_adc(Batt);
        U_bat=ADCW;
        U_bat=U_bat*2;
   
   
    
 for (i=0; i<5; i++)
        {
        ADmin[i]=AD[i];
        ADmax[i]=AD[i];
        }
  
 sound=1;
 
 lcd_clear();
 lcd_setxy(4,5);
 lcd_wrsf("Calibrating",255);
 lcd_refresh();
 delay_ms(1000);
  
  BEEP();
   BEEP();
    BEEP();
      BEEP();
        BEEP();
while (RIGHT){
lcd_clear();

        read_adc(Ailerons);
        AD[0]=ADCW-ADmid[0];
        read_adc(Throttle);
        AD[2]=ADCW-ADmid[2];
        read_adc(Rudder);
        AD[3]=ADCW-ADmid[3];
        read_adc(Elevator);
        AD[1]=ADCW-ADmid[1];
        read_adc(Rpop_contr);
        AD[4]=ADCW-ADmid[4];
        read_adc(Batt);
        U_bat=ADCW;
        U_bat=U_bat*2;
    
lcd_line(8,10,8,40,1);
lcd_line(8,10,38,10,1);
lcd_line(38,10,38,40,1);
lcd_line(8,40,38,40,1);
lcd_line(7,9,7,41,1);
lcd_line(7,9,39,9,1);
lcd_line(39,9,39,41,1);
lcd_line(7,41,39,41,1);


lcd_line(58,10,58,40,1);
lcd_line(58,10,88,10,1);
lcd_line(88,10,88,40,1);
lcd_line(58,40,88,40,1);
lcd_line(57,9,57,41,1);
lcd_line(57,9,89,9,1);
lcd_line(89,9,89,41,1);
lcd_line(57,41,89,41,1);

for (i=0; i<5; i++){
      if (ADmin[i]>AD[i]) ADmin[i]=AD[i];
    if (ADmax[i]<AD[i]) ADmax[i]=AD[i];}


x2=(AD[0]-ADmin[0])*28/(ADmax[0]-ADmin[0])+59;
y2=30-(AD[2]-ADmin[2])*28/(ADmax[2]-ADmin[2])+9;  

lcd_pixel(x2,y2-2,1);        
lcd_line(x2-1,y2-1,x2+1,y2-1,1); 
lcd_line(x2-2,y2,x2+2,y2,1); 
lcd_line(x2-1,y2+1,x2+1,y2+1,1); 
lcd_pixel(x2,y2+2,1); 

x2=(AD[3]-ADmin[3])*28/(ADmax[3]-ADmin[3])+9            ;
y2=30-(AD[1]-ADmin[1])*28/(ADmax[1]-ADmin[1])+9; 

lcd_pixel(x2,y2-2,1);        
lcd_line(x2-1,y2-1,x2+1,y2-1,1); 
lcd_line(x2-2,y2,x2+2,y2,1); 
lcd_line(x2-1,y2+1,x2+1,y2+1,1); 
lcd_pixel(x2,y2+2,1); 


x2=(AD[4]-ADmin[4])*50/(ADmax[4]-ADmin[4])+23 ;
lcd_rectangle(23,50,73,52,1);
lcd_fillrect(x2-1,48,x2+1,54,1);

lcd_refresh();       
}
    read_adc(Ailerons);
        AD[0]=ADCW-ADmid[0];
        read_adc(Throttle);
        AD[2]=ADCW-ADmid[2];
        read_adc(Rudder);
        AD[3]=ADCW-ADmid[3];
        read_adc(Elevator);
        AD[1]=ADCW-ADmid[1];
        read_adc(Rpop_contr);
        AD[4]=ADCW-ADmid[4];
        read_adc(Batt);
        U_bat=ADCW;
        U_bat=U_bat*2;
        
for (i=0; i<5; i++)
        {
        EEPR_ADmid[i]=AD[i];
        t1=7500/(ADmax[i]-AD[i]);
        t2=7500/(AD[i]-ADmin[i]);
        EEPR_Kmin[i]=t2;
        EEPR_Kmax[i]=t1;
       
         BEEP();
          BEEP();
        }
}       







void TX_init (void)
{ char i;
cur_model_num=start_model;

for (i=0; i<5; i++)
        {
        
        
        ADmid[i]=EEPR_ADmid[i];
        Kmin[i]=EEPR_Kmin[i];
        Kmax[i]=EEPR_Kmax[i];
                
        }

sound=EEPRsound;
MODEL_init();

if (curmodel.modulation==0) TCCR1A=0x82;
if (curmodel.modulation==1) TCCR1A=0xC2;

if  (curmodel.timer_mode<2)    time=0;
                else    time=curmodel.timer;



}

void TX_reset (void)
{#asm("cli")
lcd_setxy(15,8);
lcd_wrsf("Please",255);
lcd_setxy(25,16);
lcd_wrsf("wait...",255);

lcd_rectangle(18,35,78,45,1);
lcd_refresh();
cur_model_num=0;
MODEL_reset();
lcd_fillrect(18,35,33,45,1);
lcd_refresh();

cur_model_num=1;
MODEL_reset();
lcd_fillrect(18,35,48,45,1);
lcd_refresh();

cur_model_num=2;
MODEL_reset();
lcd_fillrect(18,35,63,45,1);
lcd_refresh();

cur_model_num=3;
MODEL_reset();
lcd_fillrect(18,35,78,45,1);
lcd_refresh();

start_model=0;
EEPRsound=1;
calibr();

FirstON=1;
#asm("sei")
}


#include <math.c>


void CHcalc (char i)
{ signed long Y0; 
char j;


output[i]=0;
           for (j=0; j<10; j++) 
                {
                if (chans[i].CH[j][FLY_MODE]!=0)
                        {
                        Y0=chans[i].CH[j][FLY_MODE];
                        output[i]=output[i]+out_cur[j]*Y0/100;
                        }
                }
           
           Y0=chans[i].CH[10][FLY_MODE];
           output[i]=output[i]+750*Y0/100+2250;           
           
}


void Calc (void)
        {  char j,DUAL[4];
        int Y2;
        signed  long k,Y0,Y1;
        
        //  ;
        
        
        
        if (timersound&&pen&&(!LEFT||!RIGHT||!UP||!DOWN))
                {
                pen=0;
                timersound=0;
                PORTG&=0xFB;
                trim_sound_en=1; 
                }
        
        if (!en&&!LEFT&&pen&&!timersound)
        
                { 
                if  (curmodel.timer_mode<2)    time=0;
                else    time=curmodel.timer;
                enable_counting=0;
                pen=0;
                 trim_sound_en=1; 
                }
        
        if (!en&&!UP&&!timersound&&pen) {enable_counting=0; trim_sound_en=1; pen=0;   }
        if (!en&&!DOWN&&!timersound&&pen) {enable_counting=1; trim_sound_en=1; pen=0;}
        
        
        if (enable_counting)
                {
                temp_time++;
                if (temp_time==50)
                        {
                        temp_time=0;
                        if (curmodel.timer_mode<2) time++;
                        else time--;
                        }
                if (curmodel.timer_mode==0&&time==curmodel.timer&&enable_counting&&time!=0)
                        {
                        counter=0;
                        precounter=0;
                        timersound=1;
                        }        
                
                if (curmodel.timer_mode==2&&time==0&&enable_counting)
                        {
                        enable_counting=0;
                        counter=0;
                        precounter=0;
                        timersound=1;
                        time=curmodel.timer ;
                        }         
                        
                        
                }        
        
        if (timersound)
                {
                
                 if (precounter==20||precounter==0)
                        {
                        precounter=0;
                        counter++;
                        if (counter%2==0) PORTG|=0x4;
                        else PORTG&=0xFB;
                        }
                 if (counter==25) timersound=0;
                
                precounter++;
                }
        
        
        
        
        //   
       if (!MODE_KEY2) FLY_MODE=0;
         if (MODE_KEY1&&MODE_KEY2) FLY_MODE=1;
         if (!MODE_KEY1) FLY_MODE=2;
        //  
        if (Pre_Trim)
        {
        if (!trim_0up&&curmodel.trimmer[FLY_MODE][0]<80) {curmodel.trimmer[FLY_MODE][0]++;  S_trim[0]=1; trim_sound_en=1;  }
        if (!trim_0down&&curmodel.trimmer[FLY_MODE][0]>-80){ curmodel.trimmer[FLY_MODE][0]--;  S_trim[0]=1; trim_sound_en=1; }
        
        if (!trim_1up&&curmodel.trimmer[FLY_MODE][1]<80) {curmodel.trimmer[FLY_MODE][1]++;  S_trim[1]=1; trim_sound_en=1; }
        if (!trim_1down&&curmodel.trimmer[FLY_MODE][1]>-80){ curmodel.trimmer[FLY_MODE][1]--;  S_trim[1]=1; trim_sound_en=1; }
        
        if (!trim_2up&&curmodel.trimmer[FLY_MODE][2]<80) {curmodel.trimmer[FLY_MODE][2]++;  S_trim[2]=1; trim_sound_en=1; }
        if (!trim_2down&&curmodel.trimmer[FLY_MODE][2]>-80){ curmodel.trimmer[FLY_MODE][2]--;  S_trim[2]=1; trim_sound_en=1; }
        
        if (!trim_3up&&curmodel.trimmer[FLY_MODE][3]<80){ curmodel.trimmer[FLY_MODE][3]++;  S_trim[3]=1; trim_sound_en=1; }
        if (!trim_3down&&curmodel.trimmer[FLY_MODE][3]>-80) {curmodel.trimmer[FLY_MODE][3]--;  S_trim[3]=1; trim_sound_en=1; }
        }
        Pre_Trim=!Pre_Trim;
        //   
        
        if (!Tcut_KEY&&input[2]+500<0) Cut_enable=1;
        
        if (input[2]+500>0) Cut_enable=0;
        
        read_adc(Ailerons);
        AD[0]=ADCW-ADmid[0];
        read_adc(Throttle);
        AD[2]=ADCW-ADmid[2];
        read_adc(Rudder);
        AD[3]=ADCW-ADmid[3];
        read_adc(Elevator);
        AD[1]=ADCW-ADmid[1];
        read_adc(Rpop_contr);
        AD[4]=ADCW-ADmid[4];
        read_adc(Batt);
        U_bat=ADCW;
        U_bat=U_bat*2;
        
        if(!SW1)input[4]=-750; 
        else input[4]=750;
        
        if(!SW2_1)input[5]=750; 
        if(SW2_1&&SW2_2)input[5]=0; 
        if(!SW2_2)input[5]=-750;
        
        if(!SW3)input[6]=-750; 
        else input[6]=750;
       
        
        
        for (i=0; i<4; i++)
        {
          if (AD[i]>0) input[i]=AD[i]*Kmax[i]/10;
          else input[i]=AD[i]*Kmin[i]/10;
        }
        
        
        
        
        
        input[8]=input[contr[8].from[FLY_MODE]];
        input[9]=input[contr[9].from[FLY_MODE]];
          
        
        
        
        
        
        if (AD[4]>0) input[7]=AD[4]*Kmax[4]/10;
        else input[7]=AD[7]*Kmin[4]/10;
        
        
        
        
        for (i=0; i<4; i++)
        {if (input[i]<=-500)
                {
                 Y1=contr[i].nodes[1][FLY_MODE];
                 Y0=contr[i].nodes[0][FLY_MODE];
                 k=(Y1-Y0)*3;
                 out_cur[i]=(input[i]+750)*k/100+Y0*75/10;
                }
        
        if (input[i]<=-250&&input[i]>-500)
                {
                 Y1=contr[i].nodes[2][FLY_MODE];
                 Y0=contr[i].nodes[1][FLY_MODE];
                 k=(Y1-Y0)*3;
                 out_cur[i]=(input[i]+500)*k/100+Y0*75/10;
                }
        
        if (input[i]<=0&&input[i]>-250)
                {
                 Y1=contr[i].nodes[3][FLY_MODE];
                 Y0=contr[i].nodes[2][FLY_MODE];
                 k=(Y1-Y0)*3;
                 out_cur[i]=(input[i]+250)*k/100+Y0*75/10;
                }
         if (input[i]<=250&&input[i]>0)
                {
                 Y1=contr[i].nodes[4][FLY_MODE];
                 Y0=contr[i].nodes[3][FLY_MODE];
                 k=(Y1-Y0)*3;
                 out_cur[i]=input[i]*k/100+Y0*75/10;
                }
          if (input[i]<=500&&input[i]>250)
                {
                 Y1=contr[i].nodes[5][FLY_MODE];
                 Y0=contr[i].nodes[4][FLY_MODE];
                 k=(Y1-Y0)*3;
                 out_cur[i]=(input[i]-250)*k/100+Y0*75/10;
                }
        
        if (input[i]>500)
                {
                 Y1=contr[i].nodes[6][FLY_MODE];
                 Y0=contr[i].nodes[5][FLY_MODE];
                 k=(Y1-Y0)*3;
                 out_cur[i]=(input[i]-500)*k/100+Y0*75/10;
                }
         
         
        }
        for (i=7; i<10; i++)
        {
        
        if (input[i]<=-500)
                {
                 Y1=contr[i].nodes[1][FLY_MODE];
                 Y0=contr[i].nodes[0][FLY_MODE];
                 k=(Y1-Y0)*3;
                 out_cur[i]=(input[i]+750)*k/100+Y0*75/10;
                }
        
        if (input[i]<=-250&&input[i]>-500)
                {
                 Y1=contr[i].nodes[2][FLY_MODE];
                 Y0=contr[i].nodes[1][FLY_MODE];
                 k=(Y1-Y0)*3;
                 out_cur[i]=(input[i]+500)*k/100+Y0*75/10;
                }
        
        if (input[i]<=0&&input[i]>-250)
                {
                 Y1=contr[i].nodes[3][FLY_MODE];
                 Y0=contr[i].nodes[2][FLY_MODE];
                 k=(Y1-Y0)*3;
                 out_cur[i]=(input[i]+250)*k/100+Y0*75/10;
                }
         if (input[i]<=250&&input[i]>0)
                {
                 Y1=contr[i].nodes[4][FLY_MODE];
                 Y0=contr[i].nodes[3][FLY_MODE];
                 k=(Y1-Y0)*3;
                 out_cur[i]=input[i]*k/100+Y0*75/10;
                }
          if (input[i]<=500&&input[i]>250)
                {
                 Y1=contr[i].nodes[5][FLY_MODE];
                 Y0=contr[i].nodes[4][FLY_MODE];
                 k=(Y1-Y0)*3;
                 out_cur[i]=(input[i]-250)*k/100+Y0*75/10;
                }
        
        if (input[i]>500)
                {
                 Y1=contr[i].nodes[6][FLY_MODE];
                 Y0=contr[i].nodes[5][FLY_MODE];
                 k=(Y1-Y0)*3;
                 out_cur[i]=(input[i]-500)*k/100+Y0*75/10;
                }
        
       
          
                
        }     
//  
DUAL[0]=DUAL_ail;
DUAL[1]=DUAL_elev;
DUAL[3]=DUAL_rud;

for (i=0; i<10; i++)
        {
        Y0=contr[i].reverse[FLY_MODE]; 
        
        if (i<4&&i!=2)
                {
                if (DUAL[i])
                        {
                        if (input[i]<0)
                                Y1=contr[i].minRates[FLY_MODE];
                
                        else
                                Y1=contr[i].maxRates[FLY_MODE];
                        }
                else
                        {
                        if (input[i]<0)
                                Y1=contr[i].minDRates[FLY_MODE];
                
                        else
                                Y1=contr[i].maxDRates[FLY_MODE];
                        }
                        
                        
                        
                }
                
                
                
        else
                {                
                if (input[i]<0)
                        Y1=contr[i].minRates[FLY_MODE];
                
                else
                        Y1=contr[i].maxRates[FLY_MODE];
                }
                
                 
        
        
        if (i>=4&&i<=6)  out_cur[i]=input[i]*Y1/100;      
        else out_cur[i]=out_cur[i]*Y1/100;
        
        if (i==2&&Cut_enable)
                {
                Y1=contr[i].minDRates[FLY_MODE];
                out_cur[i]=-75*Y1/10; 
                }
                
        if (i<4)  
                {
                Y2=curmodel.trimmer[FLY_MODE][i];
                out_cur[i]+=Y2*5;
                }
        out_cur[i]=out_cur[i]*Y0;
        
        }
        
     
        if (trim_0up && trim_0down && S_trim[0]){ trimmer[cur_model_num][FLY_MODE][0]=curmodel.trimmer[FLY_MODE][0]; S_trim[0]=0;}
        if (trim_1up && trim_1down && S_trim[1]){ trimmer[cur_model_num][FLY_MODE][1]=curmodel.trimmer[FLY_MODE][1]; S_trim[1]=0;}
        if (trim_2up && trim_2down && S_trim[2]){ trimmer[cur_model_num][FLY_MODE][2]=curmodel.trimmer[FLY_MODE][2]; S_trim[2]=0;}
        if (trim_3up && trim_3down && S_trim[3]){ trimmer[cur_model_num][FLY_MODE][3]=curmodel.trimmer[FLY_MODE][3]; S_trim[3]=0;}
 
 
           }  
        
        
             
// SPI functions
#include <spi.h>

int nb,del;

interrupt [TIM1_COMPA] void timer1_compa_isr(void)       // ,         :)
{char i;

LED2=1; 
if (nb<curmodel.num_ch)
        {       
        if (nb<curmodel.num_ch-1) 
        
        CHcalc(nb+1);
        
        ICR1H=output[nb]>>8;        //  
        ICR1L=output[nb]&0b11111111;
        
        nb++;
        }

 else
        {
        del=0;
        nb=0;
        for(i=0; i<curmodel.num_ch; i++) del+=output[i];       
        
        
        
        del=30000-del;
        
        ICR1H=del>>8; 
        ICR1L=del&0b11111111;     //  

        PreClip++;
        
        if (PreClip>=30) 
                {
                PreClip=0;
                if (Clip==255) Clip=0;
                else Clip=255;
                }
        
        Calc(); 
        
        CHcalc(0);
        
        LED2=0;
        }

}






// Declare your global variables here
  unsigned char x,y;



void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=P State6=P State5=P State4=P State3=P State2=P State1=P State0=P 
PORTA=0xFF;
DDRA=0x00;

// Port B initialization
// Func7=In Func6=In Func5=Out Func4=In Func3=In Func2=Out Func1=Out Func0=IN 
// State7=T State6=T State5=0 State4=T State3=T State2=0 State1=0 State0=1 
PORTB=0x01;
DDRB=0x26;

// Port C initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=In 
// State7=0 State6=0 State5=0 State4=0 State3=T State2=T State1=T State0=T 
PORTC=0x0F;
DDRC=0xF0;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=P State6=P State5=P State4=P State3=T State2=T State1=T State0=T 
PORTD=0xF0;
DDRD=0x00;

// Port E initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=P State6=P State5=P State4=P State3=P State2=P State1=T State0=T 
PORTE=0xFC;
DDRE=0x00;

// Port F initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTF=0x00;
DDRF=0x00;

// Port G initialization
// Func4=In Func3=In Func2=Out Func1=In Func0=In 
// State4=T State3=T State2=0 State1=T State0=T 
PORTG=0x00;
DDRG=0x04;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0 output: Disconnected
ASSR=0x00;
TCCR0=0x00;
TCNT0=0x00;
OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Fast PWM top=ICR1
// OC1A output: Non-Inv.
// OC1B output: Discon.
// OC1C output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
// Compare C Match Interrupt: Off
TCCR1A=0x82;

TCCR1B=0x1A;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x17;
ICR1L=0x70;
OCR1AH=0x02;
OCR1AL=0x68;
OCR1BH=0x00;
OCR1BL=0x00;
OCR1CH=0x00;
OCR1CL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// Timer/Counter 3 initialization
// Clock source: System Clock
// Clock value: Timer 3 Stopped
// Mode: Normal top=FFFFh
// Noise Canceler: Off
// Input Capture on Falling Edge
// OC3A output: Discon.
// OC3B output: Discon.
// OC3C output: Discon.
// Timer 3 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
// Compare C Match Interrupt: Off
TCCR3A=0x00;
TCCR3B=0x00;
TCNT3H=0x00;
TCNT3L=0x00;
ICR3H=0x00;
ICR3L=0x00;
OCR3AH=0x00;
OCR3AL=0x00;
OCR3BH=0x00;
OCR3BL=0x00;
OCR3CH=0x00;
OCR3CL=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
// INT3: Off
// INT4: Off
// INT5: Off
// INT6: Off
// INT7: Off
EICRA=0x00;
EICRB=0x00;
EIMSK=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;
ETIMSK=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// ADC initialization
// ADC Clock frequency: 187,500 kHz
// ADC Voltage Reference: AREF pin
ADMUX=ADC_VREF_TYPE;
ADCSRA=0x86;
/*
// SPI initialization
// SPI Type: Master
// SPI Clock Rate: 3000,000 kHz
// SPI Clock Phase: Cycle Half
// SPI Clock Polarity: Low
// SPI Data Order: MSB First
SPCR=0x50;
SPSR=0x00;
 */


// SPI initialization
// SPI Type: Master
// SPI Clock Rate: 2*3000,000 kHz
// SPI Clock Phase: Cycle Half
// SPI Clock Polarity: Low
// SPI Data Order: MSB First
SPCR=0x50;
SPSR=0x01;







LED1=1;

grafinit();

if (FirstON!=1)TX_reset();
if (!LEFT&&!UP&&!DOWN)calibr();

#asm("cli")


TX_init();

Calc();  // c; 
CHcalc(0);
TIMSK=0x10;
#asm("sei")

LED1=0;

 




while (1)
      {
   
    
   

 trim_sound(); 
   
  menu();
     
    
      };
}
