
;CodeVisionAVR C Compiler V2.03.4 Standard
;(C) Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega128
;Program type           : Application
;Clock frequency        : 12,000000 MHz
;Memory model           : Small
;Optimize for           : Speed
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 1024 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : No
;global const stored in FLASH  : Yes
;8 bit enums            : Yes
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega128
	#pragma AVRPART MEMORY PROG_FLASH 131072
	#pragma AVRPART MEMORY EEPROM 4096
	#pragma AVRPART MEMORY INT_SRAM SIZE 4096
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU XMCRA=0x6D
	.EQU XMCRB=0x6C

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _U_bat=R4
	.DEF _FLY_MODE=R7
	.DEF _Cut_enable=R6
	.DEF _temp_time=R8
	.DEF _time=R10
	.DEF _enable_counting=R13
	.DEF _timersound=R12

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _timer1_compa_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

_menuT0L:
	.DB  0x5
_menuT1L:
	.DB  0x8
_menuT2L:
	.DB  0xA
_menuT3L:
	.DB  0x2
_menuT4L:
	.DB  0x1
_menuT5L:
	.DB  0x8
_NM:
	.DB  0x25,0x2A,0x14,0x16,0x24,0x0,0x0,0x0
_Name_table:
	.DB  0x20,0x5F,0x2D,0x30,0x31,0x32,0x33,0x34
	.DB  0x35,0x36,0x37,0x38,0x39,0x41,0x61,0x42
	.DB  0x62,0x43,0x63,0x44,0x64,0x45,0x65,0x46
	.DB  0x66,0x47,0x67,0x48,0x68,0x49,0x69,0x4A
	.DB  0x6A,0x4B,0x6B,0x4C,0x6C,0x4D,0x6D,0x4E
	.DB  0x6E,0x4F,0x6F,0x50,0x70,0x51,0x71,0x52
	.DB  0x72,0x53,0x73,0x54,0x74,0x55,0x75,0x56
	.DB  0x76,0x57,0x77,0x58,0x78,0x59,0x79,0x5A
	.DB  0x7A
_tbl10_G100:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G100:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0
_font8x8:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x6,0x5F,0x5F,0x6,0x0,0x0,0x0
	.DB  0x0,0x7,0x7,0x0,0x7,0x7,0x0,0x0
	.DB  0x14,0x7F,0x7F,0x14,0x7F,0x7F,0x14,0x0
	.DB  0x24,0x2E,0x6B,0x6B,0x3A,0x12,0x0,0x0
	.DB  0x46,0x66,0x30,0x18,0xC,0x66,0x62,0x2
	.DB  0x30,0x7A,0x4F,0x5D,0x37,0x7A,0x48,0x0
	.DB  0x4,0x7,0x3,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x1C,0x3E,0x63,0x41,0x0,0x0,0x0
	.DB  0x0,0x41,0x63,0x3E,0x1C,0x0,0x1,0x0
	.DB  0x8,0x2A,0x3E,0x1C,0x1C,0x3E,0x2A,0x8
	.DB  0x8,0x8,0x3E,0x3E,0x8,0x8,0x8,0x0
	.DB  0x0,0x80,0xE0,0x60,0x0,0x0,0x0,0x0
	.DB  0x10,0x10,0x10,0x10,0x10,0x10,0x0,0x0
	.DB  0x0,0x0,0x60,0x60,0x0,0x0,0x0,0x0
	.DB  0x60,0x30,0x18,0xC,0x6,0x3,0x1,0x0
	.DB  0x3E,0x7F,0x41,0x41,0x41,0x7F,0x3E,0x0
	.DB  0x40,0x42,0x7F,0x7F,0x40,0x40,0x0,0x0
	.DB  0x62,0x73,0x5B,0x49,0x6F,0x66,0x0,0x0
	.DB  0x22,0x63,0x49,0x49,0x7F,0x36,0x0,0x0
	.DB  0x18,0x1C,0x16,0x53,0x7F,0x7F,0x50,0x0
	.DB  0x27,0x67,0x45,0x45,0x7D,0x39,0x0,0x0
	.DB  0x3C,0x7E,0x4B,0x49,0x79,0x30,0x0,0x0
	.DB  0x3,0x3,0x71,0x79,0xF,0x7,0x0,0x0
	.DB  0x36,0x7F,0x49,0x49,0x7F,0x36,0x0,0x0
	.DB  0x6,0x4F,0x49,0x69,0x3F,0x1E,0x0,0x0
	.DB  0x0,0x0,0x66,0x66,0x0,0x0,0x0,0x0
	.DB  0x0,0x80,0xE6,0x66,0x0,0x0,0x0,0x0
	.DB  0x8,0x1C,0x36,0x63,0x41,0x0,0x0,0x0
	.DB  0x14,0x14,0x14,0x14,0x14,0x14,0x0,0x0
	.DB  0x0,0x41,0x63,0x36,0x1C,0x8,0x0,0x0
	.DB  0x2,0x3,0x51,0x59,0xF,0x6,0x0,0x0
	.DB  0x3E,0x7F,0x41,0x5D,0x5D,0x1F,0x1E,0x0
	.DB  0x7C,0x7E,0x13,0x13,0x7E,0x7C,0x0,0x0
	.DB  0x41,0x7F,0x7F,0x49,0x49,0x7F,0x36,0x0
	.DB  0x1C,0x3E,0x63,0x41,0x41,0x63,0x22,0x0
	.DB  0x41,0x7F,0x7F,0x41,0x63,0x3E,0x1C,0x0
	.DB  0x41,0x7F,0x7F,0x49,0x5D,0x41,0x63,0x0
	.DB  0x41,0x7F,0x7F,0x49,0x1D,0x1,0x3,0x0
	.DB  0x1E,0x3E,0x63,0x41,0x51,0x73,0x72,0x0
	.DB  0x7F,0x7F,0x8,0x8,0x7F,0x7F,0x0,0x0
	.DB  0x41,0x7F,0x7F,0x41,0x0,0x0,0x0,0x0
	.DB  0x30,0x70,0x40,0x41,0x7F,0x3F,0x1,0x0
	.DB  0x41,0x7F,0x7F,0x8,0x1C,0x77,0x63,0x0
	.DB  0x41,0x7F,0x7F,0x41,0x40,0x60,0x70,0x0
	.DB  0x7F,0x7F,0xE,0x1C,0xE,0x7F,0x7F,0x0
	.DB  0x7F,0x7F,0x6,0xC,0x18,0x7F,0x7F,0x0
	.DB  0x1C,0x3E,0x63,0x41,0x63,0x3E,0x1C,0x0
	.DB  0x41,0x7F,0x7F,0x49,0x9,0xF,0x6,0x0
	.DB  0x1E,0x3F,0x21,0x71,0x7F,0x5E,0x0,0x0
	.DB  0x41,0x7F,0x7F,0x9,0x19,0x7F,0x66,0x0
	.DB  0x22,0x67,0x4D,0x59,0x73,0x22,0x0,0x0
	.DB  0x3,0x41,0x7F,0x7F,0x41,0x3,0x0,0x0
	.DB  0x3F,0x7F,0x40,0x40,0x7F,0x3F,0x0,0x0
	.DB  0x1F,0x3F,0x60,0x60,0x3F,0x1F,0x0,0x0
	.DB  0x7F,0x7F,0x30,0x18,0x30,0x7F,0x7F,0x0
	.DB  0x43,0x67,0x3C,0x18,0x3C,0x67,0x43,0x0
	.DB  0x7,0x4F,0x78,0x78,0x4F,0x7,0x0,0x0
	.DB  0x47,0x63,0x71,0x59,0x4D,0x67,0x73,0x0
	.DB  0x0,0x7F,0x7F,0x41,0x41,0x0,0x0,0x0
	.DB  0x1,0x3,0x6,0xC,0x18,0x30,0x60,0x0
	.DB  0x0,0x41,0x41,0x7F,0x7F,0x0,0x0,0x0
	.DB  0x8,0xC,0x6,0x3,0x6,0xC,0x8,0x0
	.DB  0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80
	.DB  0x0,0x0,0x3,0x7,0x4,0x0,0x0,0x0
	.DB  0x20,0x74,0x54,0x54,0x3C,0x78,0x40,0x0
	.DB  0x41,0x7F,0x3F,0x48,0x48,0x78,0x30,0x0
	.DB  0x38,0x7C,0x44,0x44,0x6C,0x28,0x0,0x0
	.DB  0x30,0x78,0x48,0x49,0x3F,0x7F,0x40,0x0
	.DB  0x38,0x7C,0x54,0x54,0x5C,0x18,0x0,0x0
	.DB  0x48,0x7E,0x7F,0x49,0x1,0x3,0x2,0x0
	.DB  0x4C,0x5E,0x52,0x52,0x7C,0x3E,0x2,0x0
	.DB  0x41,0x7F,0x7F,0x8,0x4,0x7C,0x78,0x0
	.DB  0x0,0x44,0x7D,0x7D,0x40,0x0,0x0,0x0
	.DB  0x60,0xE0,0x80,0x80,0xFD,0x7D,0x0,0x0
	.DB  0x41,0x7F,0x7F,0x10,0x38,0x6C,0x44,0x0
	.DB  0x0,0x41,0x7F,0x7F,0x40,0x0,0x0,0x0
	.DB  0x7C,0x7C,0x18,0x38,0x1C,0x7C,0x78,0x0
	.DB  0x7C,0x7C,0x4,0x4,0x7C,0x78,0x0,0x0
	.DB  0x38,0x7C,0x44,0x44,0x7C,0x38,0x0,0x0
	.DB  0x84,0xFC,0xF8,0xA4,0x24,0x3C,0x18,0x0
	.DB  0x18,0x3C,0x24,0xA4,0xF8,0xFC,0x84,0x0
	.DB  0x44,0x7C,0x78,0x4C,0x4,0x1C,0x18,0x0
	.DB  0x48,0x5C,0x54,0x54,0x74,0x24,0x0,0x0
	.DB  0x0,0x4,0x3E,0x7F,0x44,0x24,0x0,0x0
	.DB  0x3C,0x7C,0x40,0x40,0x3C,0x7C,0x40,0x0
	.DB  0x1C,0x3C,0x60,0x60,0x3C,0x1C,0x0,0x0
	.DB  0x3C,0x7C,0x70,0x38,0x70,0x7C,0x3C,0x0
	.DB  0x44,0x6C,0x38,0x10,0x38,0x6C,0x44,0x0
	.DB  0x9C,0xBC,0xA0,0xA0,0xFC,0x7C,0x0,0x0
	.DB  0x4C,0x64,0x74,0x5C,0x4C,0x64,0x0,0x0
	.DB  0xFF,0x81,0x81,0x81,0x81,0x81,0x81,0xFF
	.DB  0xFF,0x81,0xBD,0xBD,0xBD,0xBD,0x81,0xFF
	.DB  0x1,0x31,0x79,0x79,0x7D,0x7F,0x7D,0x31
	.DB  0x11,0x11,0x11,0x10,0x10,0x10,0x38,0x10
	.DB  0x3E,0x8,0x1C,0x1C,0x7C,0x3E,0x1E,0x1E
	.DB  0x1E,0x1C,0x18,0x18,0x18,0x1C,0xE,0xE
	.DB  0xF0,0x8,0x4,0x2,0x1,0x51,0xF1,0xF1
	.DB  0xFD,0xF1,0xF1,0x71,0x1A,0xC,0x8,0xF0
	.DB  0xF,0x10,0x24,0x74,0x9C,0x8E,0x9F,0x9F
	.DB  0x9F,0x9F,0x9F,0x9E,0x40,0x20,0x10,0xF
_deg12x16:
	.DB  0x0,0xF8,0xFE,0x6,0x3,0x3,0x3,0x3
	.DB  0x3,0x6,0xFE,0xF8,0x0,0x7,0x1F,0x18
	.DB  0x30,0x30,0x30,0x30,0x30,0x18,0x1F,0x7
	.DB  0x0,0x0,0x0,0xC,0xC,0xE,0xFF,0xFF
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x30
	.DB  0x30,0x30,0x3F,0x3F,0x30,0x30,0x30,0x0
	.DB  0x0,0x1C,0x1E,0x7,0x3,0x3,0x83,0xC3
	.DB  0xE3,0x77,0x3E,0x1C,0x0,0x30,0x38,0x3C
	.DB  0x3E,0x37,0x33,0x31,0x30,0x30,0x30,0x30
	.DB  0x0,0xC,0xE,0x7,0xC3,0xC3,0xC3,0xC3
	.DB  0xC3,0xE7,0x7E,0x3C,0x0,0xC,0x1C,0x38
	.DB  0x30,0x30,0x30,0x30,0x30,0x39,0x1F,0xE
	.DB  0x0,0xC0,0xE0,0x70,0x38,0x1C,0xE,0x7
	.DB  0xFF,0xFF,0x0,0x0,0x0,0x3,0x3,0x3
	.DB  0x3,0x3,0x3,0x3,0x3F,0x3F,0x3,0x3
	.DB  0x0,0x3F,0x7F,0x63,0x63,0x63,0x63,0x63
	.DB  0x63,0xE3,0xC3,0x83,0x0,0xC,0x1C,0x38
	.DB  0x30,0x30,0x30,0x30,0x30,0x38,0x1F,0xF
	.DB  0x0,0xC0,0xF0,0xF8,0xDC,0xCE,0xC7,0xC3
	.DB  0xC3,0xC3,0x80,0x0,0x0,0xF,0x1F,0x39
	.DB  0x30,0x30,0x30,0x30,0x30,0x39,0x1F,0xF
	.DB  0x0,0x3,0x3,0x3,0x3,0x3,0x3,0xC3
	.DB  0xF3,0x3F,0xF,0x3,0x0,0x0,0x0,0x0
	.DB  0x30,0x3C,0xF,0x3,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0xBC,0xFE,0xE7,0xC3,0xC3,0xC3
	.DB  0xE7,0xFE,0xBC,0x0,0x0,0xF,0x1F,0x39
	.DB  0x30,0x30,0x30,0x30,0x30,0x39,0x1F,0xF
	.DB  0x0,0x3C,0x7E,0xE7,0xC3,0xC3,0xC3,0xC3
	.DB  0xC3,0xE7,0xFE,0xFC,0x0,0x0,0x0,0x30
	.DB  0x30,0x30,0x38,0x1C,0xE,0x7,0x3,0x0
	.DB  0x0,0x0,0x0,0x0,0x70,0x70,0x70,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x1C,0x1C,0x1C,0x0,0x0,0x0,0x0,0x0

_0x6:
	.DB  LOW(_0x0*2),HIGH(_0x0*2),LOW(_0x0*2+9),HIGH(_0x0*2+9),LOW(_0x0*2+18),HIGH(_0x0*2+18),LOW(_0x0*2+9),HIGH(_0x0*2+9)
	.DB  LOW(_0x0*2+27),HIGH(_0x0*2+27),LOW(_0x0*2+36),HIGH(_0x0*2+36)
_0x7:
	.DB  LOW(_0x0*2+45),HIGH(_0x0*2+45),LOW(_0x0*2+50),HIGH(_0x0*2+50),LOW(_0x0*2+55),HIGH(_0x0*2+55)
_0x8:
	.DB  LOW(_0x0*2+59),HIGH(_0x0*2+59),LOW(_0x0*2+70),HIGH(_0x0*2+70),LOW(_0x0*2+81),HIGH(_0x0*2+81),LOW(_0x0*2+92),HIGH(_0x0*2+92)
	.DB  LOW(_0x0*2+103),HIGH(_0x0*2+103)
_0x9:
	.DB  LOW(_0x0*2+114),HIGH(_0x0*2+114),LOW(_0x0*2+125),HIGH(_0x0*2+125),LOW(_0x0*2+136),HIGH(_0x0*2+136),LOW(_0x0*2+147),HIGH(_0x0*2+147)
	.DB  LOW(_0x0*2+158),HIGH(_0x0*2+158),LOW(_0x0*2+169),HIGH(_0x0*2+169),LOW(_0x0*2+180),HIGH(_0x0*2+180),LOW(_0x0*2+191),HIGH(_0x0*2+191)
_0xA:
	.DB  LOW(_0x0*2+202),HIGH(_0x0*2+202),LOW(_0x0*2+213),HIGH(_0x0*2+213),LOW(_0x0*2+224),HIGH(_0x0*2+224),LOW(_0x0*2+235),HIGH(_0x0*2+235)
	.DB  LOW(_0x0*2+246),HIGH(_0x0*2+246),LOW(_0x0*2+257),HIGH(_0x0*2+257),LOW(_0x0*2+268),HIGH(_0x0*2+268),LOW(_0x0*2+279),HIGH(_0x0*2+279)
	.DB  LOW(_0x0*2+290),HIGH(_0x0*2+290),LOW(_0x0*2+301),HIGH(_0x0*2+301),LOW(_0x0*2+312),HIGH(_0x0*2+312)
_0xB:
	.DB  LOW(_0x0*2+324),HIGH(_0x0*2+324),LOW(_0x0*2+333),HIGH(_0x0*2+333),LOW(_0x0*2+342),HIGH(_0x0*2+342)
_0xC:
	.DB  LOW(_0x0*2+351),HIGH(_0x0*2+351),LOW(_0x0*2+362),HIGH(_0x0*2+362),LOW(_0x0*2+373),HIGH(_0x0*2+373),LOW(_0x0*2+384),HIGH(_0x0*2+384)
_0xD:
	.DB  LOW(_0x0*2+395),HIGH(_0x0*2+395),LOW(_0x0*2+406),HIGH(_0x0*2+406),LOW(_0x0*2+417),HIGH(_0x0*2+417),LOW(_0x0*2+428),HIGH(_0x0*2+428)
	.DB  LOW(_0x0*2+439),HIGH(_0x0*2+439),LOW(_0x0*2+450),HIGH(_0x0*2+450),LOW(_0x0*2+461),HIGH(_0x0*2+461),LOW(_0x0*2+472),HIGH(_0x0*2+472)
_0xE:
	.DB  LOW(_0x0*2+483),HIGH(_0x0*2+483),LOW(_0x0*2+489),HIGH(_0x0*2+489)
_0xF:
	.DB  LOW(_0x0*2+495),HIGH(_0x0*2+495),LOW(_0x0*2+500),HIGH(_0x0*2+500)
_0x10:
	.DB  LOW(_0x0*2+505),HIGH(_0x0*2+505),LOW(_0x0*2+515),HIGH(_0x0*2+515)
_0x0:
	.DB  0x4C,0x61,0x6E,0x64,0x69,0x6E,0x67,0x20
	.DB  0x0,0x4E,0x6F,0x72,0x6D,0x61,0x6C,0x20
	.DB  0x20,0x0,0x50,0x69,0x6C,0x6F,0x74,0x61
	.DB  0x67,0x65,0x0,0x49,0x64,0x64,0x6C,0x65
	.DB  0x55,0x70,0x20,0x0,0x54,0x20,0x48,0x6F
	.DB  0x6C,0x64,0x20,0x20,0x0,0x50,0x50,0x4D
	.DB  0x20,0x0,0x49,0x50,0x50,0x4D,0x0,0x50
	.DB  0x43,0x4D,0x0,0x4D,0x6F,0x64,0x65,0x6C
	.DB  0x20,0x20,0x20,0x20,0x3E,0x0,0x43,0x6F
	.DB  0x6E,0x74,0x72,0x6F,0x6C,0x73,0x20,0x3E
	.DB  0x0,0x43,0x68,0x61,0x6E,0x6E,0x65,0x6C
	.DB  0x73,0x20,0x3E,0x0,0x54,0x69,0x6D,0x65
	.DB  0x72,0x20,0x20,0x20,0x20,0x3E,0x0,0x4F
	.DB  0x70,0x74,0x69,0x6F,0x6E,0x73,0x20,0x20
	.DB  0x3E,0x0,0x53,0x65,0x6C,0x65,0x63,0x74
	.DB  0x20,0x20,0x20,0x3E,0x0,0x52,0x65,0x73
	.DB  0x65,0x74,0x20,0x20,0x20,0x20,0x20,0x0
	.DB  0x43,0x6F,0x70,0x79,0x20,0x20,0x20,0x20
	.DB  0x20,0x3E,0x0,0x4E,0x61,0x6D,0x65,0x20
	.DB  0x20,0x20,0x20,0x20,0x3E,0x0,0x54,0x79
	.DB  0x70,0x65,0x20,0x20,0x20,0x20,0x20,0x3E
	.DB  0x0,0x4D,0x6F,0x64,0x73,0x20,0x43,0x6F
	.DB  0x70,0x79,0x3E,0x0,0x4D,0x6F,0x64,0x75
	.DB  0x20,0x54,0x79,0x70,0x65,0x3E,0x0,0x4D
	.DB  0x41,0x58,0x20,0x43,0x48,0x20,0x20,0x20
	.DB  0x3E,0x0,0x41,0x69,0x6C,0x65,0x72,0x6F
	.DB  0x6E,0x73,0x20,0x3E,0x0,0x45,0x6C,0x65
	.DB  0x76,0x61,0x74,0x6F,0x72,0x20,0x3E,0x0
	.DB  0x54,0x68,0x72,0x6F,0x74,0x74,0x6C,0x65
	.DB  0x20,0x3E,0x0,0x52,0x75,0x64,0x64,0x65
	.DB  0x72,0x20,0x20,0x20,0x3E,0x0,0x53,0x57
	.DB  0x20,0x31,0x20,0x20,0x20,0x20,0x20,0x3E
	.DB  0x0,0x53,0x57,0x20,0x32,0x20,0x20,0x20
	.DB  0x20,0x20,0x3E,0x0,0x53,0x57,0x20,0x33
	.DB  0x20,0x20,0x20,0x20,0x20,0x3E,0x0,0x50
	.DB  0x72,0x6F,0x70,0x20,0x20,0x20,0x20,0x20
	.DB  0x3E,0x0,0x55,0x73,0x65,0x72,0x27,0x73
	.DB  0x20,0x31,0x20,0x3E,0x0,0x55,0x73,0x65
	.DB  0x72,0x27,0x73,0x20,0x32,0x20,0x3E,0x0
	.DB  0x54,0x72,0x69,0x6D,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x3E,0x0,0x53,0x65,0x74,0x20
	.DB  0x20,0x20,0x20,0x20,0x0,0x4D,0x6F,0x64
	.DB  0x65,0x20,0x20,0x20,0x20,0x0,0x43,0x6F
	.DB  0x6E,0x74,0x72,0x6F,0x6C,0x20,0x0,0x53
	.DB  0x6F,0x75,0x6E,0x64,0x20,0x20,0x20,0x20
	.DB  0x3E,0x0,0x42,0x63,0x6B,0x6C,0x69,0x67
	.DB  0x68,0x74,0x20,0x3E,0x0,0x43,0x6F,0x6E
	.DB  0x74,0x72,0x61,0x73,0x74,0x20,0x3E,0x0
	.DB  0x53,0x6C,0x65,0x65,0x70,0x20,0x20,0x20
	.DB  0x20,0x3E,0x0,0x43,0x48,0x20,0x31,0x20
	.DB  0x20,0x20,0x20,0x20,0x3E,0x0,0x43,0x48
	.DB  0x20,0x32,0x20,0x20,0x20,0x20,0x20,0x3E
	.DB  0x0,0x43,0x48,0x20,0x33,0x20,0x20,0x20
	.DB  0x20,0x20,0x3E,0x0,0x43,0x48,0x20,0x34
	.DB  0x20,0x20,0x20,0x20,0x20,0x3E,0x0,0x43
	.DB  0x48,0x20,0x35,0x20,0x20,0x20,0x20,0x20
	.DB  0x3E,0x0,0x43,0x48,0x20,0x36,0x20,0x20
	.DB  0x20,0x20,0x20,0x3E,0x0,0x43,0x48,0x20
	.DB  0x37,0x20,0x20,0x20,0x20,0x20,0x3E,0x0
	.DB  0x43,0x48,0x20,0x38,0x20,0x20,0x20,0x20
	.DB  0x20,0x3E,0x0,0x50,0x6C,0x61,0x6E,0x65
	.DB  0x0,0x48,0x65,0x6C,0x69,0x20,0x0,0x55
	.DB  0x50,0x20,0x20,0x0,0x44,0x4F,0x57,0x4E
	.DB  0x0,0x53,0x6F,0x75,0x6E,0x64,0x20,0x4F
	.DB  0x4E,0x20,0x0,0x53,0x6F,0x75,0x6E,0x64
	.DB  0x20,0x4F,0x46,0x46,0x0,0x25,0x2D,0x69
	.DB  0x0,0x52,0x65,0x76,0x20,0x20,0x0,0x43
	.DB  0x75,0x72,0x76,0x65,0x3E,0x0,0x52,0x61
	.DB  0x74,0x65,0x20,0x0,0x44,0x52,0x61,0x74
	.DB  0x65,0x20,0x0,0x54,0x63,0x75,0x74,0x20
	.DB  0x0,0x46,0x72,0x6F,0x6D,0x3A,0x20,0x0
	.DB  0x30,0x25,0x2D,0x69,0x0,0x25,0x2D,0x69
	.DB  0x2E,0x25,0x2D,0x69,0x56,0x0,0x4D,0x61
	.DB  0x69,0x6E,0x20,0x6D,0x65,0x6E,0x75,0x0
	.DB  0x4D,0x6F,0x64,0x65,0x6C,0x0,0x53,0x65
	.DB  0x6C,0x65,0x63,0x74,0x0,0x52,0x65,0x73
	.DB  0x65,0x74,0x0,0x41,0x72,0x65,0x20,0x79
	.DB  0x6F,0x75,0x0,0x73,0x75,0x72,0x65,0x3F
	.DB  0x0,0x50,0x6C,0x65,0x61,0x73,0x65,0x0
	.DB  0x77,0x61,0x69,0x74,0x2E,0x2E,0x2E,0x0
	.DB  0x43,0x6F,0x70,0x79,0x0,0x46,0x72,0x6F
	.DB  0x6D,0x3A,0x0,0x54,0x6F,0x3A,0x0,0x4F
	.DB  0x4B,0x0,0x4E,0x61,0x6D,0x65,0x0,0x54
	.DB  0x79,0x70,0x65,0x0,0x43,0x6F,0x70,0x79
	.DB  0x20,0x4D,0x4F,0x44,0x45,0x0,0x4D,0x6F
	.DB  0x64,0x75,0x6C,0x61,0x74,0x69,0x6F,0x6E
	.DB  0x0,0x4D,0x41,0x58,0x20,0x43,0x48,0x0
	.DB  0x43,0x6F,0x6E,0x74,0x72,0x6F,0x6C,0x73
	.DB  0x0,0x43,0x68,0x61,0x6E,0x6E,0x65,0x6C
	.DB  0x73,0x0,0x54,0x69,0x6D,0x65,0x72,0x0
	.DB  0x25,0x2D,0x69,0x3A,0x25,0x2D,0x69,0x0
	.DB  0x4F,0x70,0x74,0x69,0x6F,0x6E,0x73,0x0
	.DB  0x53,0x6F,0x75,0x6E,0x64,0x0,0x4F,0x4E
	.DB  0x0,0x43,0x61,0x6C,0x69,0x62,0x72,0x61
	.DB  0x74,0x69,0x6E,0x67,0x0
_0x20C005F:
	.DB  0x1
_0x20C0000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0

__GLOBAL_INI_TBL:
	.DW  0x0C
	.DW  _modeNames
	.DW  _0x6*2

	.DW  0x06
	.DW  _modulNames
	.DW  _0x7*2

	.DW  0x0A
	.DW  _menuT0
	.DW  _0x8*2

	.DW  0x10
	.DW  _menuT1
	.DW  _0x9*2

	.DW  0x16
	.DW  _menuT2
	.DW  _0xA*2

	.DW  0x06
	.DW  _menuT3
	.DW  _0xB*2

	.DW  0x08
	.DW  _menuT4
	.DW  _0xC*2

	.DW  0x10
	.DW  _menuT5
	.DW  _0xD*2

	.DW  0x04
	.DW  _menuT6
	.DW  _0xE*2

	.DW  0x04
	.DW  _Timer_modes1
	.DW  _0xF*2

	.DW  0x04
	.DW  _Timer_modes2
	.DW  _0x10*2

	.DW  0x01
	.DW  __seed_G106
	.DW  _0x20C005F*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30
	STS  XMCRB,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x1000)
	LDI  R25,HIGH(0x1000)
	LDI  R26,LOW(0x100)
	LDI  R27,HIGH(0x100)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x10FF)
	OUT  SPL,R30
	LDI  R30,HIGH(0x10FF)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x500)
	LDI  R29,HIGH(0x500)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x500

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V1.24.6 Professional
;Automatic Program Generator
; Copyright 1998-2005 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;e-mail:office@hpinfotech.com
;
;Project : Coder
;Version : 2.0
;Date    : 01.06.2006
;Author  : F4CG
;Company : F4CG
;Comments:
;
;
;Chip type           : ATmega128
;Program type        : Application
;Clock frequency     : 12,000000 MHz
;Memory model        : Small
;External SRAM size  : 0
;Data Stack size     : 1024
;*****************************************************/
;
;#include <mega128.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;#include <stdio.h>
;#include <def.c>
;//
;#define trim_0up   PINA.3
;#define trim_0down PINA.0
;#define trim_1up   PINA.1
;#define trim_1down PINA.2
;#define trim_2up   PINA.5
;#define trim_2down PINA.4
;#define trim_3up   PINA.7
;#define trim_3down PINA.6
;
;// 
;#define UP    PIND.4
;#define DOWN  PIND.5
;#define LEFT  PIND.6
;#define RIGHT PIND.7
;
;//
;
;#define BUZ   PORTG.2
;//
;#define LED1 PORTC.6
;#define LED2 PORTC.7
;
;//
;#define MODE_KEY1       PINE.6
;#define MODE_KEY2       PINE.7
;#define SW1             PINE.4
;#define SW2_1           PINE.3
;#define SW2_2           PINE.2
;#define SW3             PINE.5
;
;#define Tcut_KEY        PINC.3
;#define DUAL_ail        PINC.1
;#define DUAL_elev       PINC.0
;#define DUAL_rud        PINC.2
;
;//  
;#define Ailerons        5
;#define Elevator        4
;#define Throttle        6
;#define Rudder          3
;#define Rpop_contr      2
;#define Batt            7
;
;
;
;
;// Model types
;#define TYPE_HELI		0
;#define TYPE_PLANE		1
;#define TYPE_GLIDER		2
;
;// Fly modes
;#define	M_NORMAL		0
;#define	M_IDLEUP1		1
;#define	M_IDLEUP2		2
;#define	M_THOLD			3
;#define	MAX_MODES		4
;
;//Channels
;#define CHAN_AIL		0
;#define CHAN_ELE		1
;#define CHAN_THR		2
;#define CHAN_RUD		3
;#define CHAN_GYRO		4
;#define CHAN_PITCH		5
;#define CHAN_GOV		6
;#define CHAN_AUX1		7
;#define CHAN_AUX2		8
;#define MAX_CHANS		9
;#define MAX_CONTR		10
;#define CHAN_MIN                9
;#define CHAN_MID		10
;#define CHAN_MAX		11
;#define CHAN_SW_L		12
;#define CHAN_SW_R		13
;#define CHAN_NONE		14
;
;// TX Modulation types
;#define MODUL_PPM               0
;#define MODUL_IPPM              1
;#define MODUL_PCM               2
;#define MAX_MODULS		3
;
;#define CURVE_NODES		7
;#define MAX_MODELS              4
;
;// 
;#define reset PORTC.4
;#define DC PORTC.5
;
;
;
;#include <Variables.c>
;
;signed int input[10];
;signed int out_cur[10];
;signed int output[10];
;signed int AD[5];
;       int U_bat;
;
;signed int ADmin[5];
;signed int ADmax[5];
;signed int ADmid[5];
;
;unsigned char buf[12];
;
;char FLY_MODE;
;
;signed long Kmin[5];
;signed long Kmax[5];
;
;char Cut_enable;
;int temp_time;
;int time;
;char enable_counting;
;
;
;char S_trim[4];
;char timersound;
;char counter;
;char precounter;
;
;char  sound;
;char cur_model_num;
;
;unsigned char deep;
;unsigned char en;
;unsigned char pen;
;unsigned char pos[4];
;unsigned char edit;
;unsigned char curve_ed_enable;
;unsigned char edit_cur;
;unsigned char T[2];
;unsigned char trim_sound_en;
;unsigned char Clip;
;unsigned char PreClip;
;bit Pre_Trim;
;
;unsigned char screen_name[9];
;//Channel
;typedef struct {
;	signed int		CH[11][MAX_MODES];
;
;} CHAN_SETTINGS;
;
;
;typedef struct {
;	char		        reverse[MAX_MODES];
;	unsigned char		maxRates[MAX_MODES];						// EPA val in 2% unit
;	unsigned char		minRates[MAX_MODES];						// EPA val in 2% unit
;	unsigned char		maxDRates[MAX_MODES];						// EPA val in 2% unit
;	unsigned char		minDRates[MAX_MODES];                                           //T-Cut for throttle channel
;	char                    from[MAX_MODES];
;	char		        nodes[CURVE_NODES][MAX_MODES];
;} CONTR_SETTINGS;
;
;
;
;
;//Model
;typedef struct {
;	char			version[2];			// Major and Minor version of data structure
;	char			name[9];			// name of model (max 8 chars)
;	char			type;				// heli, plane, etc.
;	char			modulation;			// PPM, IPPM, PCM
;        char			trimmer[MAX_MODES][4];
;	int                     timer;
;	char                    timer_mode;
;         char                    num_ch;
;}MODEL_SETTINGS;
;
;
;CONTR_SETTINGS	        contr[MAX_CONTR];
;CHAN_SETTINGS           chans[MAX_CHANS];
;
;
;MODEL_SETTINGS          curmodel;
;
;
;
;//    EEPROM'
;
;        eeprom char		        reverse[MAX_MODELS][MAX_CONTR][MAX_MODES];
;        eeprom unsigned char		maxRates[MAX_MODELS][MAX_CONTR][MAX_MODES];
;        eeprom unsigned char		minRates[MAX_MODELS][MAX_CONTR][MAX_MODES];						// EPA val in 2% unit
;	eeprom unsigned char		maxDRates[MAX_MODELS][MAX_CONTR][MAX_MODES];						// EPA val in 2% unit
;	eeprom unsigned char		minDRates[MAX_MODELS][MAX_CONTR][MAX_MODES];
;		        					// T-Cut for throttle channel
;	eeprom char                     from[MAX_MODELS][MAX_CONTR][MAX_MODES];
;	eeprom char		        nodes[MAX_MODELS][MAX_CONTR][CURVE_NODES][MAX_MODES];
;
;	eeprom char		        CH[MAX_MODELS][MAX_CHANS][11][MAX_MODES];
;
;
;
;	eeprom char			name[MAX_MODELS][8];			// name of model (max 8 chars)
;	eeprom char			type[MAX_MODELS];				// heli, plane, etc.
;
;	eeprom char			modulation[MAX_MODELS];			// PPM, IPPM, PCM
;
;	eeprom char			trimmer[MAX_MODELS][MAX_MODES][4];
;
;
;
;	eeprom char                     EEPRsound;
;	eeprom int                      timer[MAX_MODELS];
;	eeprom char                     timer_mode[MAX_MODELS];
;	eeprom char                     start_model;
;	eeprom int                      EEPR_ADmid[5];
;	eeprom char                     EEPR_Kmin[5],EEPR_Kmax[5];
;	eeprom char                     num_ch[MAX_MODELS];
;	eeprom char                     FirstON;
;
;
;#include <math.h>
;#include <graph_new.h>
;
;
;
;
;#define ADC_VREF_TYPE 0x00
;
;unsigned char i;
;
;
;
;
;unsigned int read_adc(unsigned char adc_input)
; 0000 002C {

	.CSEG
_read_adc:
; 0000 002D ADMUX=adc_input|ADC_VREF_TYPE;
;	adc_input -> Y+0
	LD   R30,Y
	OUT  0x7,R30
; 0000 002E // Start the AD conversion
; 0000 002F ADCSRA|=0x40;
	SBI  0x6,6
; 0000 0030 // Wait for the AD conversion to complete
; 0000 0031 while ((ADCSRA & 0x10)==0);
_0x3:
	SBIS 0x6,4
	RJMP _0x3
; 0000 0032 ADCSRA|=0x10;
	SBI  0x6,4
; 0000 0033 return ADCW;
	IN   R30,0x4
	IN   R31,0x4+1
	ADIW R28,1
	RET
; 0000 0034 }
;
;
;
;#include <Menu.c>
;
;
; #define MAXST 5;
;
;typedef unsigned char byte;
;
;
; __flash const char  *modeNames[2][3] =
;   {
;        {
;	"Landing ",
;	"Normal  ",
;	"Pilotage"
;
;        },
;
;        {
;	"Normal  ",
;	"IddleUp ",
;	"T Hold  "
;
;        }
;    };

	.DSEG
;
;
;__flash const char  *modulNames[] = {
;	"PPM ",
;	"IPPM",
;        "PCM"
;};
;
;
;__flash const char  *menuT0[] = {
;	"Model    >",
;	"Controls >",
;	"Channels >",
;	"Timer    >",
;	"Options  >"
;};
;__flash const char  menuT0L = 5;
;
;__flash const char  *menuT1[] ={
;	"Select   >",
;	"Reset     ",
;	"Copy     >",
;	"Name     >",
;	"Type     >",
;	"Mods Copy>",
;	"Modu Type>",
;        "MAX CH   >"
;};
;
;__flash const char  menuT1L =8;
;
;
;__flash const char  *menuT2[] = {
;	"Ailerons >",
;	"Elevator >",
;	"Throttle >",
;	"Rudder   >",
;	"SW 1     >",
;	"SW 2     >",
;	"SW 3     >",
;	"Prop     >",
;	"User's 1 >",
;	"User's 2 >",
;        "Trim      >"
;
;};
;__flash const char  menuT2L =10;
;
;
;__flash const char  *menuT3[] = {
;	"Set     ",
;	"Mode    ",
;	"Control "
;};
;__flash const char  menuT3L =2;
;
;__flash const char  *menuT4[] = {
;	"Sound    >",
;	"Bcklight >",
;	"Contrast >",
;	"Sleep    >"
;};
;__flash const char  menuT4L =1;
;
;
;__flash const char  *menuT5[] = {
;	"CH 1     >",
;	"CH 2     >",
;	"CH 3     >",
;	"CH 4     >",
;	"CH 5     >",
;	"CH 6     >",
;	"CH 7     >",
;	"CH 8     >"
;};
;
;__flash const char  menuT5L =8;
;
;__flash const char  *menuT6[] = {
;	"Plane",
;	"Heli "
;
;};
;
;
;
;
;
;__flash const char  NM[] ={37,42,20,22,36,0,0,0};
;
;
;
;
;__flash const char  *Timer_modes1[] = {
;	"UP  ",
;	"DOWN"
;
;};
;
;__flash const char  *Timer_modes2[] = {
;	"Sound ON ",
;	"Sound OFF"
;
;};
;
;__flash const char  Name_table[65] = {
;' ','_','-','0','1','2','3','4','5','6','7','8','9','A','a','B','b','C','c','D',
;'d','E','e','F','f','G','g','H','h','I','i','J','j','K','k','L','l','M','m','N',
;'n','O','o','P','p','Q','q','R','r','S','s','T','t','U','u','V','v','W','w','X',
;'x','Y','y','Z','z'};
;
;
;void name_init(void)
; 0000 0038 {

	.CSEG
_name_init:
;  screen_name[8]='\0';
	LDI  R30,LOW(0)
	__PUTB1MN _screen_name,8
;
;   for (i=0; i<8; i++)  screen_name[i]=Name_table[curmodel.name[i]];
	STS  _i,R30
_0x12:
	LDS  R26,_i
	CPI  R26,LOW(0x8)
	BRSH _0x13
	LDS  R30,_i
	LDI  R31,0
	MOVW R22,R30
	SUBI R30,LOW(-_screen_name)
	SBCI R31,HIGH(-_screen_name)
	MOVW R0,R30
	__POINTW2MN _curmodel,2
	ADD  R26,R22
	ADC  R27,R23
	LD   R30,X
	LDI  R31,0
	SUBI R30,LOW(-_Name_table*2)
	SBCI R31,HIGH(-_Name_table*2)
	LPM  R30,Z
	MOVW R26,R0
	ST   X,R30
	LDS  R30,_i
	SUBI R30,-LOW(1)
	STS  _i,R30
	RJMP _0x12
_0x13:
	RET
;
;void trim_sound (void)
;{
_trim_sound:
;if (trim_sound_en&&sound)
	LDS  R30,_trim_sound_en
	CPI  R30,0
	BREQ _0x15
	LDS  R30,_sound
	CPI  R30,0
	BRNE _0x16
_0x15:
	RJMP _0x14
_0x16:
;        {
;        trim_sound_en=0;
	LDI  R30,LOW(0)
	STS  _trim_sound_en,R30
;        PORTG|=0x4;
	LDS  R30,101
	ORI  R30,4
	STS  101,R30
;        delay_ms(30);
	LDI  R30,LOW(30)
	LDI  R31,HIGH(30)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;        PORTG&=0xFB;
	LDS  R30,101
	ANDI R30,0xFB
	STS  101,R30
;        delay_ms(30);
	LDI  R30,LOW(30)
	LDI  R31,HIGH(30)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;        }
;}
_0x14:
	RET
;
;
;void BEEP (void)
;{
_BEEP:
;if (sound)
	LDS  R30,_sound
	CPI  R30,0
	BREQ _0x17
;        {
;        PORTG|=0x4;
	LDS  R30,101
	ORI  R30,4
	STS  101,R30
;        delay_ms(50);
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;        PORTG&=0xFB;
	LDS  R30,101
	ANDI R30,0xFB
	STS  101,R30
;        delay_ms(50);
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	RJMP _0x353
;        }
;else delay_ms(100);
_0x17:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
_0x353:
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;}
	RET
;void BEEP1 (void)
;{
_BEEP1:
;if (sound)
	LDS  R30,_sound
	CPI  R30,0
	BREQ _0x19
;        {
;        PORTG|=0x4;
	LDS  R30,101
	ORI  R30,4
	STS  101,R30
;        delay_ms(20);
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;        PORTG&=0xFB;
	LDS  R30,101
	ANDI R30,0xFB
	STS  101,R30
;        delay_ms(20);
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	RJMP _0x354
;        }
;else delay_ms(40);
_0x19:
	LDI  R30,LOW(40)
	LDI  R31,HIGH(40)
_0x354:
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;}
	RET
;
;
;void MODEL_reset (void)
;{char MOD, con,i;
_MODEL_reset:
;
;#asm("cli")
	CALL __SAVELOCR4
;	MOD -> R17
;	con -> R16
;	i -> R19
	cli
; for (con=0; con<10; con++)
	LDI  R16,LOW(0)
_0x1C:
	CPI  R16,10
	BRLT PC+3
	JMP _0x1D
;        for (MOD=0; MOD<4; MOD++)
	LDI  R17,LOW(0)
_0x1F:
	CPI  R17,4
	BRLT PC+3
	JMP _0x20
;                {
;
;                reverse[cur_model_num][con][MOD]=1;
	LDS  R30,_cur_model_num
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_reverse)
	SBCI R31,HIGH(-_reverse)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LDI  R30,LOW(1)
	CALL __EEPROMWRB
;
;                maxRates[cur_model_num][con][MOD]=100;
	LDS  R30,_cur_model_num
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_maxRates)
	SBCI R31,HIGH(-_maxRates)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LDI  R30,LOW(100)
	CALL __EEPROMWRB
;                minRates[cur_model_num][con][MOD]=100;						// EPA val in 2% unit
	LDS  R30,_cur_model_num
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_minRates)
	SBCI R31,HIGH(-_minRates)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LDI  R30,LOW(100)
	CALL __EEPROMWRB
;
;                maxDRates[cur_model_num][con][MOD]=100;					// EPA val in 2% unit
	LDS  R30,_cur_model_num
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_maxDRates)
	SBCI R31,HIGH(-_maxDRates)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LDI  R30,LOW(100)
	CALL __EEPROMWRB
;                minDRates[cur_model_num][con][MOD]=100;
	LDS  R30,_cur_model_num
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_minDRates)
	SBCI R31,HIGH(-_minDRates)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LDI  R30,LOW(100)
	CALL __EEPROMWRB
;
;
;//	eeprom char		        exponent[MAX_MODELS][MAX_CONTR][MAX_MODES];					// T-Cut for throttle channel
;
;	        nodes[cur_model_num][con][0][MOD]=-100;
	LDS  R30,_cur_model_num
	LDI  R31,0
	LDI  R26,LOW(280)
	LDI  R27,HIGH(280)
	CALL __MULW12U
	SUBI R30,LOW(-_nodes)
	SBCI R31,HIGH(-_nodes)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(28)
	LDI  R27,HIGH(28)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LDI  R30,LOW(156)
	CALL __EEPROMWRB
;                nodes[cur_model_num][con][1][MOD]=-66;
	LDS  R30,_cur_model_num
	LDI  R31,0
	LDI  R26,LOW(280)
	LDI  R27,HIGH(280)
	CALL __MULW12U
	SUBI R30,LOW(-_nodes)
	SBCI R31,HIGH(-_nodes)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(28)
	LDI  R27,HIGH(28)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,4
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LDI  R30,LOW(190)
	CALL __EEPROMWRB
;                nodes[cur_model_num][con][2][MOD]=-34;
	LDS  R30,_cur_model_num
	LDI  R31,0
	LDI  R26,LOW(280)
	LDI  R27,HIGH(280)
	CALL __MULW12U
	SUBI R30,LOW(-_nodes)
	SBCI R31,HIGH(-_nodes)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(28)
	LDI  R27,HIGH(28)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,8
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LDI  R30,LOW(222)
	CALL __EEPROMWRB
;                nodes[cur_model_num][con][3][MOD]=0;
	LDS  R30,_cur_model_num
	LDI  R31,0
	LDI  R26,LOW(280)
	LDI  R27,HIGH(280)
	CALL __MULW12U
	SUBI R30,LOW(-_nodes)
	SBCI R31,HIGH(-_nodes)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(28)
	LDI  R27,HIGH(28)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,12
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	CALL __EEPROMWRB
;                nodes[cur_model_num][con][4][MOD]=34;
	LDS  R30,_cur_model_num
	LDI  R31,0
	LDI  R26,LOW(280)
	LDI  R27,HIGH(280)
	CALL __MULW12U
	SUBI R30,LOW(-_nodes)
	SBCI R31,HIGH(-_nodes)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(28)
	LDI  R27,HIGH(28)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,16
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LDI  R30,LOW(34)
	CALL __EEPROMWRB
;                nodes[cur_model_num][con][5][MOD]=66;
	LDS  R30,_cur_model_num
	LDI  R31,0
	LDI  R26,LOW(280)
	LDI  R27,HIGH(280)
	CALL __MULW12U
	SUBI R30,LOW(-_nodes)
	SBCI R31,HIGH(-_nodes)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(28)
	LDI  R27,HIGH(28)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,20
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LDI  R30,LOW(66)
	CALL __EEPROMWRB
;                nodes[cur_model_num][con][6][MOD]=100;
	LDS  R30,_cur_model_num
	LDI  R31,0
	LDI  R26,LOW(280)
	LDI  R27,HIGH(280)
	CALL __MULW12U
	SUBI R30,LOW(-_nodes)
	SBCI R31,HIGH(-_nodes)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(28)
	LDI  R27,HIGH(28)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,24
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LDI  R30,LOW(100)
	CALL __EEPROMWRB
;
;
;
;
;
;
;                }
	SUBI R17,-1
	RJMP _0x1F
_0x20:
	SUBI R16,-1
	RJMP _0x1C
_0x1D:
;for (con=0; con<8; con++)
	LDI  R16,LOW(0)
_0x22:
	CPI  R16,8
	BRGE _0x23
;        for (MOD=0; MOD<4; MOD++)
	LDI  R17,LOW(0)
_0x25:
	CPI  R17,4
	BRGE _0x26
;                for (i=0; i<11; i++)
	LDI  R19,LOW(0)
_0x28:
	CPI  R19,11
	BRGE _0x29
;                        CH[cur_model_num][con][i][MOD]=0;
	LDS  R30,_cur_model_num
	LDI  R31,0
	LDI  R26,LOW(396)
	LDI  R27,HIGH(396)
	CALL __MULW12U
	SUBI R30,LOW(-_CH)
	SBCI R31,HIGH(-_CH)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(44)
	LDI  R27,HIGH(44)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R19
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	CALL __EEPROMWRB
	SUBI R19,-1
	RJMP _0x28
_0x29:
	SUBI R17,-1
	RJMP _0x25
_0x26:
	SUBI R16,-1
	RJMP _0x22
_0x23:
	LDI  R17,LOW(0)
_0x2B:
	CPI  R17,4
	BRGE _0x2C
;        {
;        for (i=0; i<8; i++)
	LDI  R19,LOW(0)
_0x2E:
	CPI  R19,8
	BRGE _0x2F
;                CH[cur_model_num][i][i][MOD]=100;
	LDS  R30,_cur_model_num
	LDI  R31,0
	LDI  R26,LOW(396)
	LDI  R27,HIGH(396)
	CALL __MULW12U
	SUBI R30,LOW(-_CH)
	SBCI R31,HIGH(-_CH)
	MOVW R26,R30
	MOV  R30,R19
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(44)
	LDI  R27,HIGH(44)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R19
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LDI  R30,LOW(100)
	CALL __EEPROMWRB
	SUBI R19,-1
	RJMP _0x2E
_0x2F:
	LDS  R26,_cur_model_num
	LDI  R27,0
	SUBI R26,LOW(-_num_ch)
	SBCI R27,HIGH(-_num_ch)
	LDI  R30,LOW(6)
	CALL __EEPROMWRB
;	}
	SUBI R17,-1
	RJMP _0x2B
_0x2C:
;
;
;
;for (i=0; i<8; i++)name[cur_model_num][i]=NM[i];
	LDI  R19,LOW(0)
_0x31:
	CPI  R19,8
	BRGE _0x32
	LDS  R30,_cur_model_num
	LDI  R31,0
	CALL __LSLW3
	SUBI R30,LOW(-_name)
	SBCI R31,HIGH(-_name)
	MOVW R26,R30
	CLR  R30
	ADD  R26,R19
	ADC  R27,R30
	MOV  R30,R19
	LDI  R31,0
	SUBI R30,LOW(-_NM*2)
	SBCI R31,HIGH(-_NM*2)
	LPM  R30,Z
	CALL __EEPROMWRB
	SUBI R19,-1
	RJMP _0x31
_0x32:
	LDS  R26,_cur_model_num
	LDI  R27,0
	SUBI R26,LOW(-_modulation)
	SBCI R27,HIGH(-_modulation)
	LDI  R30,LOW(0)
	CALL __EEPROMWRB
;
;for (i=0; i<4; i++)
	LDI  R19,LOW(0)
_0x34:
	CPI  R19,4
	BRGE _0x35
;        for (MOD=0; MOD<4; MOD++)     trimmer[cur_model_num][MOD][i]=0;
	LDI  R17,LOW(0)
_0x37:
	CPI  R17,4
	BRGE _0x38
	LDS  R30,_cur_model_num
	LDI  R31,0
	CALL __LSLW4
	SUBI R30,LOW(-_trimmer)
	SBCI R31,HIGH(-_trimmer)
	MOVW R26,R30
	MOV  R30,R17
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CLR  R30
	ADD  R26,R19
	ADC  R27,R30
	CALL __EEPROMWRB
	SUBI R17,-1
	RJMP _0x37
_0x38:
	SUBI R19,-1
	RJMP _0x34
_0x35:
	LDS  R26,_cur_model_num
	LDI  R27,0
	SUBI R26,LOW(-_type)
	SBCI R27,HIGH(-_type)
	LDI  R30,LOW(0)
	CALL __EEPROMWRB
;
;timer[cur_model_num]=0;
	LDS  R30,_cur_model_num
	LDI  R26,LOW(_timer)
	LDI  R27,HIGH(_timer)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	CALL __EEPROMWRW
; timer_mode[cur_model_num]=0;
	LDS  R26,_cur_model_num
	LDI  R27,0
	SUBI R26,LOW(-_timer_mode)
	SBCI R27,HIGH(-_timer_mode)
	CALL __EEPROMWRB
;
; #asm("sei")
	sei
	RJMP _0x20E000B
;}
;
;void MODEL_init (void)
;{char MOD, con,node_num,i;
_MODEL_init:
;  BEEP();
	CALL __SAVELOCR4
;	MOD -> R17
;	con -> R16
;	node_num -> R19
;	i -> R18
	RCALL _BEEP
;
;#asm("cli")
	cli
; for (con=0; con<10; con++)
	LDI  R16,LOW(0)
_0x3A:
	CPI  R16,10
	BRLT PC+3
	JMP _0x3B
;        for (MOD=0; MOD<4; MOD++)
	LDI  R17,LOW(0)
_0x3D:
	CPI  R17,4
	BRLT PC+3
	JMP _0x3E
;                {
;
;                contr[con].reverse[MOD]=reverse[cur_model_num][con][MOD];
	LDI  R26,LOW(52)
	MUL  R16,R26
	MOVW R30,R0
	SUBI R30,LOW(-_contr)
	SBCI R31,HIGH(-_contr)
	MOVW R26,R30
	MOV  R30,R17
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	LDS  R30,_cur_model_num
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_reverse)
	SBCI R31,HIGH(-_reverse)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	CALL __EEPROMRDB
	MOVW R26,R22
	ST   X,R30
;
;                contr[con].maxRates[MOD]=maxRates[cur_model_num][con][MOD];
	LDI  R26,LOW(52)
	MUL  R16,R26
	MOVW R30,R0
	__ADDW1MN _contr,4
	MOVW R26,R30
	MOV  R30,R17
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	LDS  R30,_cur_model_num
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_maxRates)
	SBCI R31,HIGH(-_maxRates)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	CALL __EEPROMRDB
	MOVW R26,R22
	ST   X,R30
;                contr[con].minRates[MOD]=minRates[cur_model_num][con][MOD];						// EPA val in 2% unit
	LDI  R26,LOW(52)
	MUL  R16,R26
	MOVW R30,R0
	__ADDW1MN _contr,8
	MOVW R26,R30
	MOV  R30,R17
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	LDS  R30,_cur_model_num
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_minRates)
	SBCI R31,HIGH(-_minRates)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	CALL __EEPROMRDB
	MOVW R26,R22
	ST   X,R30
;
;                contr[con].maxDRates[MOD]=maxDRates[cur_model_num][con][MOD];					// EPA val in 2% unit
	LDI  R26,LOW(52)
	MUL  R16,R26
	MOVW R30,R0
	__ADDW1MN _contr,12
	MOVW R26,R30
	MOV  R30,R17
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	LDS  R30,_cur_model_num
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_maxDRates)
	SBCI R31,HIGH(-_maxDRates)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	CALL __EEPROMRDB
	MOVW R26,R22
	ST   X,R30
;                contr[con].minDRates[MOD]=minDRates[cur_model_num][con][MOD];
	LDI  R26,LOW(52)
	MUL  R16,R26
	MOVW R30,R0
	__ADDW1MN _contr,16
	MOVW R26,R30
	MOV  R30,R17
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	LDS  R30,_cur_model_num
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_minDRates)
	SBCI R31,HIGH(-_minDRates)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	CALL __EEPROMRDB
	MOVW R26,R22
	ST   X,R30
;                contr[con].from[MOD]=from[cur_model_num][con][MOD];
	LDI  R26,LOW(52)
	MUL  R16,R26
	MOVW R30,R0
	__ADDW1MN _contr,20
	MOVW R26,R30
	MOV  R30,R17
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	LDS  R30,_cur_model_num
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_from)
	SBCI R31,HIGH(-_from)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	CALL __EEPROMRDB
	MOVW R26,R22
	ST   X,R30
;
;
;
;	        for (node_num=0; node_num<7; node_num++)
	LDI  R19,LOW(0)
_0x40:
	CPI  R19,7
	BRLT PC+3
	JMP _0x41
;                contr[con].nodes[node_num][MOD]=nodes[cur_model_num][con][node_num][MOD];
	LDI  R26,LOW(52)
	MUL  R16,R26
	MOVW R30,R0
	__ADDW1MN _contr,24
	MOVW R26,R30
	MOV  R30,R19
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R17
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDS  R30,_cur_model_num
	LDI  R31,0
	LDI  R26,LOW(280)
	LDI  R27,HIGH(280)
	CALL __MULW12U
	SUBI R30,LOW(-_nodes)
	SBCI R31,HIGH(-_nodes)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(28)
	LDI  R27,HIGH(28)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R19
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	CALL __EEPROMRDB
	POP  R26
	POP  R27
	ST   X,R30
	SUBI R19,-1
	RJMP _0x40
_0x41:
	SUBI R17,-1
	RJMP _0x3D
_0x3E:
	SUBI R16,-1
	RJMP _0x3A
_0x3B:
;
;
;
;for (con=0; con<8; con++)
	LDI  R16,LOW(0)
_0x43:
	CPI  R16,8
	BRLT PC+3
	JMP _0x44
;        for (MOD=0; MOD<4; MOD++)
	LDI  R17,LOW(0)
_0x46:
	CPI  R17,4
	BRLT PC+3
	JMP _0x47
;                for (i=0; i<11; i++)
	LDI  R18,LOW(0)
_0x49:
	CPI  R18,11
	BRLT PC+3
	JMP _0x4A
;                        chans[con].CH[i][MOD]=CH[cur_model_num][con][i][MOD];
	LDI  R26,LOW(88)
	MUL  R16,R26
	MOVW R30,R0
	SUBI R30,LOW(-_chans)
	SBCI R31,HIGH(-_chans)
	MOVW R26,R30
	MOV  R30,R18
	LDI  R31,0
	CALL __LSLW3
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R17
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDS  R30,_cur_model_num
	LDI  R31,0
	LDI  R26,LOW(396)
	LDI  R27,HIGH(396)
	CALL __MULW12U
	SUBI R30,LOW(-_CH)
	SBCI R31,HIGH(-_CH)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(44)
	LDI  R27,HIGH(44)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R18
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	CALL __EEPROMRDB
	POP  R26
	POP  R27
	LDI  R31,0
	SBRC R30,7
	SER  R31
	ST   X+,R30
	ST   X,R31
	SUBI R18,-1
	RJMP _0x49
_0x4A:
	SUBI R17,-1
	RJMP _0x46
_0x47:
	SUBI R16,-1
	RJMP _0x43
_0x44:
	LDI  R18,LOW(0)
_0x4C:
	CPI  R18,8
	BRGE _0x4D
	__POINTW2MN _curmodel,2
	MOV  R30,R18
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	LDS  R30,_cur_model_num
	LDI  R31,0
	CALL __LSLW3
	SUBI R30,LOW(-_name)
	SBCI R31,HIGH(-_name)
	MOVW R26,R30
	CLR  R30
	ADD  R26,R18
	ADC  R27,R30
	CALL __EEPROMRDB
	MOVW R26,R0
	ST   X,R30
	SUBI R18,-1
	RJMP _0x4C
_0x4D:
	LDS  R26,_cur_model_num
	LDI  R27,0
	SUBI R26,LOW(-_type)
	SBCI R27,HIGH(-_type)
	CALL __EEPROMRDB
	__PUTB1MN _curmodel,11
;
;
;for (i=0; i<4; i++)
	LDI  R18,LOW(0)
_0x4F:
	CPI  R18,4
	BRGE _0x50
;        for (MOD=0; MOD<4; MOD++)     curmodel.trimmer[MOD][i]=trimmer[cur_model_num][MOD][i];
	LDI  R17,LOW(0)
_0x52:
	CPI  R17,4
	BRGE _0x53
	__POINTW2MN _curmodel,13
	MOV  R30,R17
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R18
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	LDS  R30,_cur_model_num
	LDI  R31,0
	CALL __LSLW4
	SUBI R30,LOW(-_trimmer)
	SBCI R31,HIGH(-_trimmer)
	MOVW R26,R30
	MOV  R30,R17
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CLR  R30
	ADD  R26,R18
	ADC  R27,R30
	CALL __EEPROMRDB
	MOVW R26,R0
	ST   X,R30
	SUBI R17,-1
	RJMP _0x52
_0x53:
	SUBI R18,-1
	RJMP _0x4F
_0x50:
	LDS  R26,_cur_model_num
	LDI  R27,0
	SUBI R26,LOW(-_modulation)
	SBCI R27,HIGH(-_modulation)
	CALL __EEPROMRDB
	__PUTB1MN _curmodel,12
;
;
;curmodel.timer=timer[cur_model_num];
	LDS  R30,_cur_model_num
	LDI  R26,LOW(_timer)
	LDI  R27,HIGH(_timer)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __EEPROMRDW
	__PUTW1MN _curmodel,29
;curmodel.timer_mode=timer_mode[cur_model_num];
	LDS  R26,_cur_model_num
	LDI  R27,0
	SUBI R26,LOW(-_timer_mode)
	SBCI R27,HIGH(-_timer_mode)
	CALL __EEPROMRDB
	__PUTB1MN _curmodel,31
;
;curmodel.num_ch=num_ch[cur_model_num];
	LDS  R26,_cur_model_num
	LDI  R27,0
	SUBI R26,LOW(-_num_ch)
	SBCI R27,HIGH(-_num_ch)
	CALL __EEPROMRDB
	__PUTB1MN _curmodel,32
;
; name_init();
	RCALL _name_init
; #asm("sei")
	sei
_0x20E000B:
; }
	CALL __LOADLOCR4
	ADIW R28,4
	RET
;
; void MODEL_copy (char f, char to)
;        {char MOD, con,node_num,i;
_MODEL_copy:
;  BEEP();
	CALL __SAVELOCR4
;	f -> Y+5
;	to -> Y+4
;	MOD -> R17
;	con -> R16
;	node_num -> R19
;	i -> R18
	RCALL _BEEP
;
;#asm("cli")
	cli
; for (con=0; con<10; con++)
	LDI  R16,LOW(0)
_0x55:
	CPI  R16,10
	BRLT PC+3
	JMP _0x56
;        for (MOD=0; MOD<4; MOD++)
	LDI  R17,LOW(0)
_0x58:
	CPI  R17,4
	BRLT PC+3
	JMP _0x59
;                {
;
;                reverse[to][con][MOD]=reverse[f][con][MOD];
	LDD  R30,Y+4
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_reverse)
	SBCI R31,HIGH(-_reverse)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R17
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	LDD  R30,Y+5
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_reverse)
	SBCI R31,HIGH(-_reverse)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	CALL __EEPROMRDB
	MOVW R26,R22
	CALL __EEPROMWRB
;
;                maxRates[to][con][MOD]=maxRates[f][con][MOD];
	LDD  R30,Y+4
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_maxRates)
	SBCI R31,HIGH(-_maxRates)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R17
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	LDD  R30,Y+5
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_maxRates)
	SBCI R31,HIGH(-_maxRates)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	CALL __EEPROMRDB
	MOVW R26,R22
	CALL __EEPROMWRB
;                minRates[to][con][MOD]=minRates[f][con][MOD];						// EPA val in 2% unit
	LDD  R30,Y+4
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_minRates)
	SBCI R31,HIGH(-_minRates)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R17
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	LDD  R30,Y+5
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_minRates)
	SBCI R31,HIGH(-_minRates)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	CALL __EEPROMRDB
	MOVW R26,R22
	CALL __EEPROMWRB
;
;                maxDRates[to][con][MOD]=maxDRates[f][con][MOD];					// EPA val in 2% unit
	LDD  R30,Y+4
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_maxDRates)
	SBCI R31,HIGH(-_maxDRates)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R17
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	LDD  R30,Y+5
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_maxDRates)
	SBCI R31,HIGH(-_maxDRates)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	CALL __EEPROMRDB
	MOVW R26,R22
	CALL __EEPROMWRB
;                minDRates[to][con][MOD]=minDRates[f][con][MOD];
	LDD  R30,Y+4
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_minDRates)
	SBCI R31,HIGH(-_minDRates)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R17
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	LDD  R30,Y+5
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_minDRates)
	SBCI R31,HIGH(-_minDRates)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	CALL __EEPROMRDB
	MOVW R26,R22
	CALL __EEPROMWRB
;                from[to][con][MOD]=from[f][con][MOD];
	LDD  R30,Y+4
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_from)
	SBCI R31,HIGH(-_from)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R17
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	LDD  R30,Y+5
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_from)
	SBCI R31,HIGH(-_from)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	CALL __EEPROMRDB
	MOVW R26,R22
	CALL __EEPROMWRB
;
;//	eeprom char		        exponent[MAX_MODELS][MAX_CONTR][MAX_MODES];					// T-Cut for throttle channel
;
;	        for (node_num=0; node_num<7; node_num++)
	LDI  R19,LOW(0)
_0x5B:
	CPI  R19,7
	BRLT PC+3
	JMP _0x5C
;                nodes[to][con][node_num][MOD]=nodes[f][con][node_num][MOD];
	LDD  R30,Y+4
	LDI  R31,0
	LDI  R26,LOW(280)
	LDI  R27,HIGH(280)
	CALL __MULW12U
	SUBI R30,LOW(-_nodes)
	SBCI R31,HIGH(-_nodes)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(28)
	LDI  R27,HIGH(28)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R19
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R17
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDD  R30,Y+5
	LDI  R31,0
	LDI  R26,LOW(280)
	LDI  R27,HIGH(280)
	CALL __MULW12U
	SUBI R30,LOW(-_nodes)
	SBCI R31,HIGH(-_nodes)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(28)
	LDI  R27,HIGH(28)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R19
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	CALL __EEPROMRDB
	POP  R26
	POP  R27
	CALL __EEPROMWRB
	SUBI R19,-1
	RJMP _0x5B
_0x5C:
	SUBI R17,-1
	RJMP _0x58
_0x59:
	SUBI R16,-1
	RJMP _0x55
_0x56:
;
;
;for (con=0; con<8; con++)
	LDI  R16,LOW(0)
_0x5E:
	CPI  R16,8
	BRLT PC+3
	JMP _0x5F
;        for (MOD=0; MOD<4; MOD++)
	LDI  R17,LOW(0)
_0x61:
	CPI  R17,4
	BRLT PC+3
	JMP _0x62
;                for (i=0; i<11; i++)
	LDI  R18,LOW(0)
_0x64:
	CPI  R18,11
	BRLT PC+3
	JMP _0x65
;                        CH[to][con][i][MOD]=CH[f][con][i][MOD];
	LDD  R30,Y+4
	LDI  R31,0
	LDI  R26,LOW(396)
	LDI  R27,HIGH(396)
	CALL __MULW12U
	SUBI R30,LOW(-_CH)
	SBCI R31,HIGH(-_CH)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(44)
	LDI  R27,HIGH(44)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R18
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R17
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDD  R30,Y+5
	LDI  R31,0
	LDI  R26,LOW(396)
	LDI  R27,HIGH(396)
	CALL __MULW12U
	SUBI R30,LOW(-_CH)
	SBCI R31,HIGH(-_CH)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(44)
	LDI  R27,HIGH(44)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R18
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	CALL __EEPROMRDB
	POP  R26
	POP  R27
	CALL __EEPROMWRB
	SUBI R18,-1
	RJMP _0x64
_0x65:
	SUBI R17,-1
	RJMP _0x61
_0x62:
	SUBI R16,-1
	RJMP _0x5E
_0x5F:
	LDI  R18,LOW(0)
_0x67:
	CPI  R18,8
	BRGE _0x68
	LDD  R30,Y+4
	LDI  R31,0
	CALL __LSLW3
	SUBI R30,LOW(-_name)
	SBCI R31,HIGH(-_name)
	MOVW R26,R30
	MOV  R30,R18
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	LDD  R30,Y+5
	LDI  R31,0
	CALL __LSLW3
	SUBI R30,LOW(-_name)
	SBCI R31,HIGH(-_name)
	MOVW R26,R30
	CLR  R30
	ADD  R26,R18
	ADC  R27,R30
	CALL __EEPROMRDB
	MOVW R26,R0
	CALL __EEPROMWRB
	SUBI R18,-1
	RJMP _0x67
_0x68:
	LDD  R30,Y+4
	LDI  R31,0
	SUBI R30,LOW(-_type)
	SBCI R31,HIGH(-_type)
	MOVW R0,R30
	LDD  R26,Y+5
	LDI  R27,0
	SUBI R26,LOW(-_type)
	SBCI R27,HIGH(-_type)
	CALL __EEPROMRDB
	MOVW R26,R0
	CALL __EEPROMWRB
;
;for (i=0; i<4; i++)
	LDI  R18,LOW(0)
_0x6A:
	CPI  R18,4
	BRGE _0x6B
;        for (MOD=0; MOD<4; MOD++)     trimmer[to][MOD][i]=trimmer[f][MOD][i];
	LDI  R17,LOW(0)
_0x6D:
	CPI  R17,4
	BRGE _0x6E
	LDD  R30,Y+4
	LDI  R31,0
	CALL __LSLW4
	SUBI R30,LOW(-_trimmer)
	SBCI R31,HIGH(-_trimmer)
	MOVW R26,R30
	MOV  R30,R17
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R18
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	LDD  R30,Y+5
	LDI  R31,0
	CALL __LSLW4
	SUBI R30,LOW(-_trimmer)
	SBCI R31,HIGH(-_trimmer)
	MOVW R26,R30
	MOV  R30,R17
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CLR  R30
	ADD  R26,R18
	ADC  R27,R30
	CALL __EEPROMRDB
	MOVW R26,R0
	CALL __EEPROMWRB
	SUBI R17,-1
	RJMP _0x6D
_0x6E:
	SUBI R18,-1
	RJMP _0x6A
_0x6B:
	LDD  R30,Y+4
	LDI  R31,0
	SUBI R30,LOW(-_modulation)
	SBCI R31,HIGH(-_modulation)
	MOVW R0,R30
	LDD  R26,Y+5
	LDI  R27,0
	SUBI R26,LOW(-_modulation)
	SBCI R27,HIGH(-_modulation)
	CALL __EEPROMRDB
	MOVW R26,R0
	CALL __EEPROMWRB
;
;
;timer[to]=timer[f];
	LDD  R30,Y+4
	LDI  R26,LOW(_timer)
	LDI  R27,HIGH(_timer)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	LDD  R30,Y+5
	LDI  R26,LOW(_timer)
	LDI  R27,HIGH(_timer)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __EEPROMRDW
	MOVW R26,R0
	CALL __EEPROMWRW
;timer_mode[to]=timer_mode[f];
	LDD  R30,Y+4
	LDI  R31,0
	SUBI R30,LOW(-_timer_mode)
	SBCI R31,HIGH(-_timer_mode)
	MOVW R0,R30
	LDD  R26,Y+5
	LDI  R27,0
	SUBI R26,LOW(-_timer_mode)
	SBCI R27,HIGH(-_timer_mode)
	CALL __EEPROMRDB
	MOVW R26,R0
	CALL __EEPROMWRB
;
;num_ch[to]=num_ch[f];
	LDD  R30,Y+4
	LDI  R31,0
	SUBI R30,LOW(-_num_ch)
	SBCI R31,HIGH(-_num_ch)
	MOVW R0,R30
	LDD  R26,Y+5
	LDI  R27,0
	SUBI R26,LOW(-_num_ch)
	SBCI R27,HIGH(-_num_ch)
	CALL __EEPROMRDB
	MOVW R26,R0
	CALL __EEPROMWRB
;
;        #asm("sei")
	sei
; }
	RJMP _0x20E000A
;
;void MODE_copy (char f, char to)
;        {char MOD, con,node_num,i;
_MODE_copy:
;  BEEP();
	CALL __SAVELOCR4
;	f -> Y+5
;	to -> Y+4
;	MOD -> R17
;	con -> R16
;	node_num -> R19
;	i -> R18
	CALL _BEEP
;
;#asm("cli")
	cli
; for (con=0; con<10; con++)
	LDI  R16,LOW(0)
_0x70:
	CPI  R16,10
	BRLT PC+3
	JMP _0x71
;
;                {
;
;                reverse[cur_model_num][con][to]=reverse[cur_model_num][con][f];
	LDS  R30,_cur_model_num
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_reverse)
	SBCI R31,HIGH(-_reverse)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	LDD  R30,Y+4
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	LDS  R30,_cur_model_num
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_reverse)
	SBCI R31,HIGH(-_reverse)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	LDD  R30,Y+5
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	CALL __EEPROMRDB
	MOVW R26,R22
	CALL __EEPROMWRB
;
;                maxRates[cur_model_num][con][to]=maxRates[cur_model_num][con][f];
	LDS  R30,_cur_model_num
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_maxRates)
	SBCI R31,HIGH(-_maxRates)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	LDD  R30,Y+4
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	LDS  R30,_cur_model_num
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_maxRates)
	SBCI R31,HIGH(-_maxRates)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	LDD  R30,Y+5
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	CALL __EEPROMRDB
	MOVW R26,R22
	CALL __EEPROMWRB
;                minRates[cur_model_num][con][to]=minRates[cur_model_num][con][f];						// EPA val in 2% unit
	LDS  R30,_cur_model_num
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_minRates)
	SBCI R31,HIGH(-_minRates)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	LDD  R30,Y+4
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	LDS  R30,_cur_model_num
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_minRates)
	SBCI R31,HIGH(-_minRates)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	LDD  R30,Y+5
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	CALL __EEPROMRDB
	MOVW R26,R22
	CALL __EEPROMWRB
;
;                maxDRates[cur_model_num][con][to]=maxDRates[cur_model_num][con][f];					// EPA val in 2% unit
	LDS  R30,_cur_model_num
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_maxDRates)
	SBCI R31,HIGH(-_maxDRates)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	LDD  R30,Y+4
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	LDS  R30,_cur_model_num
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_maxDRates)
	SBCI R31,HIGH(-_maxDRates)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	LDD  R30,Y+5
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	CALL __EEPROMRDB
	MOVW R26,R22
	CALL __EEPROMWRB
;                minDRates[cur_model_num][con][to]=minDRates[cur_model_num][con][f];
	LDS  R30,_cur_model_num
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_minDRates)
	SBCI R31,HIGH(-_minDRates)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	LDD  R30,Y+4
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	LDS  R30,_cur_model_num
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_minDRates)
	SBCI R31,HIGH(-_minDRates)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	LDD  R30,Y+5
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	CALL __EEPROMRDB
	MOVW R26,R22
	CALL __EEPROMWRB
;
;                from[cur_model_num][con][to]=from[cur_model_num][con][f];
	LDS  R30,_cur_model_num
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_from)
	SBCI R31,HIGH(-_from)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	LDD  R30,Y+4
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	LDS  R30,_cur_model_num
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_from)
	SBCI R31,HIGH(-_from)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	LDD  R30,Y+5
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	CALL __EEPROMRDB
	MOVW R26,R22
	CALL __EEPROMWRB
;
;
;
;	        for (node_num=0; node_num<7; node_num++)
	LDI  R19,LOW(0)
_0x73:
	CPI  R19,7
	BRLT PC+3
	JMP _0x74
;                nodes[cur_model_num][con][node_num][to]=nodes[cur_model_num][con][node_num][f];
	LDS  R30,_cur_model_num
	LDI  R31,0
	LDI  R26,LOW(280)
	LDI  R27,HIGH(280)
	CALL __MULW12U
	SUBI R30,LOW(-_nodes)
	SBCI R31,HIGH(-_nodes)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(28)
	LDI  R27,HIGH(28)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R19
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	LDD  R30,Y+4
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDS  R30,_cur_model_num
	LDI  R31,0
	LDI  R26,LOW(280)
	LDI  R27,HIGH(280)
	CALL __MULW12U
	SUBI R30,LOW(-_nodes)
	SBCI R31,HIGH(-_nodes)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(28)
	LDI  R27,HIGH(28)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R19
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	LDD  R30,Y+5
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	CALL __EEPROMRDB
	POP  R26
	POP  R27
	CALL __EEPROMWRB
	SUBI R19,-1
	RJMP _0x73
_0x74:
	SUBI R16,-1
	RJMP _0x70
_0x71:
;
;
;
;for (con=0; con<8; con++)
	LDI  R16,LOW(0)
_0x76:
	CPI  R16,8
	BRLT PC+3
	JMP _0x77
;                for (i=0; i<11; i++)
	LDI  R18,LOW(0)
_0x79:
	CPI  R18,11
	BRLT PC+3
	JMP _0x7A
;                        CH[cur_model_num][con][i][to]=CH[cur_model_num][con][i][f];
	LDS  R30,_cur_model_num
	LDI  R31,0
	LDI  R26,LOW(396)
	LDI  R27,HIGH(396)
	CALL __MULW12U
	SUBI R30,LOW(-_CH)
	SBCI R31,HIGH(-_CH)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(44)
	LDI  R27,HIGH(44)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R18
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	LDD  R30,Y+4
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDS  R30,_cur_model_num
	LDI  R31,0
	LDI  R26,LOW(396)
	LDI  R27,HIGH(396)
	CALL __MULW12U
	SUBI R30,LOW(-_CH)
	SBCI R31,HIGH(-_CH)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(44)
	LDI  R27,HIGH(44)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R18
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	LDD  R30,Y+5
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	CALL __EEPROMRDB
	POP  R26
	POP  R27
	CALL __EEPROMWRB
	SUBI R18,-1
	RJMP _0x79
_0x7A:
	SUBI R16,-1
	RJMP _0x76
_0x77:
	LDI  R18,LOW(0)
_0x7C:
	CPI  R18,4
	BRGE _0x7D
;        for (MOD=0; MOD<4; MOD++)     trimmer[cur_model_num][to][i]=trimmer[cur_model_num][f][i];
	LDI  R17,LOW(0)
_0x7F:
	CPI  R17,4
	BRGE _0x80
	LDS  R30,_cur_model_num
	LDI  R31,0
	CALL __LSLW4
	SUBI R30,LOW(-_trimmer)
	SBCI R31,HIGH(-_trimmer)
	MOVW R22,R30
	MOVW R26,R30
	LDD  R30,Y+4
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R18
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOVW R26,R22
	LDD  R30,Y+5
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CLR  R30
	ADD  R26,R18
	ADC  R27,R30
	CALL __EEPROMRDB
	MOVW R26,R0
	CALL __EEPROMWRB
	SUBI R17,-1
	RJMP _0x7F
_0x80:
	SUBI R18,-1
	RJMP _0x7C
_0x7D:
_0x20E000A:
	CALL __LOADLOCR4
	ADIW R28,6
	RET
;
;
;int scroll (byte p,byte L)
; { if (!UP&&p<L-1)
_scroll:
;	p -> Y+1
;	L -> Y+0
	SBIC 0x10,4
	RJMP _0x82
	LD   R30,Y
	SUBI R30,LOW(1)
	LDD  R26,Y+1
	CP   R26,R30
	BRLO _0x83
_0x82:
	RJMP _0x81
_0x83:
;                { p++;
	LDD  R30,Y+1
	SUBI R30,-LOW(1)
	STD  Y+1,R30
;                  BEEP();              }
	CALL _BEEP
;        if (!DOWN&&p>0)
_0x81:
	SBIC 0x10,5
	RJMP _0x85
	LDD  R26,Y+1
	CPI  R26,LOW(0x1)
	BRSH _0x86
_0x85:
	RJMP _0x84
_0x86:
;                {
;                p--;
	LDD  R30,Y+1
	SUBI R30,LOW(1)
	STD  Y+1,R30
;
;                 BEEP();         }
	CALL _BEEP
;  return (p);
_0x84:
	LDD  R30,Y+1
	LDI  R31,0
	RJMP _0x20E0008
;  #asm("sei")
	sei
;  }
	RJMP _0x20E0008
;
;
;  void SAVE_CH (char NMOD,char N,char sel)
;   {
_SAVE_CH:
;        BEEP();
;	NMOD -> Y+2
;	N -> Y+1
;	sel -> Y+0
	CALL _BEEP
;
;
;        if (sel==0) reverse[NMOD][N][FLY_MODE]=  contr[N].reverse[FLY_MODE] ;
	LD   R30,Y
	CPI  R30,0
	BRNE _0x87
	LDD  R30,Y+2
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_reverse)
	SBCI R31,HIGH(-_reverse)
	MOVW R26,R30
	LDD  R30,Y+1
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R7
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	LDD  R30,Y+1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_contr)
	SBCI R31,HIGH(-_contr)
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	MOVW R26,R22
	CALL __EEPROMWRB
;        if (sel==2) minRates[NMOD][N][FLY_MODE]=  contr[N].minRates[FLY_MODE] ;
_0x87:
	LD   R26,Y
	CPI  R26,LOW(0x2)
	BRNE _0x88
	LDD  R30,Y+2
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_minRates)
	SBCI R31,HIGH(-_minRates)
	MOVW R26,R30
	LDD  R30,Y+1
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R7
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	LDD  R30,Y+1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,8
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	MOVW R26,R22
	CALL __EEPROMWRB
;        if (sel==3) maxRates[NMOD][N][FLY_MODE]=  contr[N].maxRates[FLY_MODE] ;
_0x88:
	LD   R26,Y
	CPI  R26,LOW(0x3)
	BRNE _0x89
	LDD  R30,Y+2
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_maxRates)
	SBCI R31,HIGH(-_maxRates)
	MOVW R26,R30
	LDD  R30,Y+1
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R7
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	LDD  R30,Y+1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,4
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	MOVW R26,R22
	CALL __EEPROMWRB
;        if (N<4)
_0x89:
	LDD  R26,Y+1
	CPI  R26,LOW(0x4)
	BRLT PC+3
	JMP _0x8A
;                {
;                if (sel==4) minDRates[NMOD][N][FLY_MODE]=  contr[N].minDRates[FLY_MODE] ;
	LD   R26,Y
	CPI  R26,LOW(0x4)
	BRNE _0x8B
	LDD  R30,Y+2
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_minDRates)
	SBCI R31,HIGH(-_minDRates)
	MOVW R26,R30
	LDD  R30,Y+1
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R7
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	LDD  R30,Y+1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,16
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	MOVW R26,R22
	CALL __EEPROMWRB
;                if (sel==5) maxDRates[NMOD][N][FLY_MODE]=  contr[N].maxDRates[FLY_MODE] ;
_0x8B:
	LD   R26,Y
	CPI  R26,LOW(0x5)
	BRNE _0x8C
	LDD  R30,Y+2
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_maxDRates)
	SBCI R31,HIGH(-_maxDRates)
	MOVW R26,R30
	LDD  R30,Y+1
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R7
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	LDD  R30,Y+1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,12
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	MOVW R26,R22
	CALL __EEPROMWRB
;                }
_0x8C:
;        if (N>7&&sel==4) from[NMOD][N][FLY_MODE]=  contr[N].from[FLY_MODE] ;
_0x8A:
	LDD  R26,Y+1
	CPI  R26,LOW(0x8)
	BRLT _0x8E
	LD   R26,Y
	CPI  R26,LOW(0x4)
	BREQ _0x8F
_0x8E:
	RJMP _0x8D
_0x8F:
	LDD  R30,Y+2
	LDI  R26,LOW(40)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_from)
	SBCI R31,HIGH(-_from)
	MOVW R26,R30
	LDD  R30,Y+1
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R7
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	LDD  R30,Y+1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,20
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	MOVW R26,R22
	CALL __EEPROMWRB
;
;       BEEP();
_0x8D:
	CALL _BEEP
;
;   }
	ADIW R28,3
	RET
;
;void edit_curve (char sel)
;{ char Y[7];
_edit_curve:
;
;lcd_line(5,16,89,16,1);
	SBIW R28,7
;	sel -> Y+7
;	Y -> Y+0
	LDI  R30,LOW(5)
	ST   -Y,R30
	LDI  R30,LOW(16)
	ST   -Y,R30
	LDI  R30,LOW(89)
	ST   -Y,R30
	LDI  R30,LOW(16)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;lcd_line(5,56,5,16,1);
	LDI  R30,LOW(5)
	ST   -Y,R30
	LDI  R30,LOW(56)
	ST   -Y,R30
	LDI  R30,LOW(5)
	ST   -Y,R30
	LDI  R30,LOW(16)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;lcd_line(89,56,89,16,1);
	LDI  R30,LOW(89)
	ST   -Y,R30
	LDI  R30,LOW(56)
	ST   -Y,R30
	LDI  R30,LOW(89)
	ST   -Y,R30
	LDI  R30,LOW(16)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;lcd_line(5,56,89,56,1);
	LDI  R30,LOW(5)
	ST   -Y,R30
	LDI  R30,LOW(56)
	ST   -Y,R30
	LDI  R30,LOW(89)
	ST   -Y,R30
	LDI  R30,LOW(56)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;lcd_dashline(5,36,89,36);
	LDI  R30,LOW(5)
	ST   -Y,R30
	LDI  R30,LOW(36)
	ST   -Y,R30
	LDI  R30,LOW(89)
	ST   -Y,R30
	LDI  R30,LOW(36)
	ST   -Y,R30
	CALL _lcd_dashline
;lcd_dashline(47,16,47,56);
	LDI  R30,LOW(47)
	ST   -Y,R30
	LDI  R30,LOW(16)
	ST   -Y,R30
	LDI  R30,LOW(47)
	ST   -Y,R30
	LDI  R30,LOW(56)
	ST   -Y,R30
	CALL _lcd_dashline
;lcd_dashline(19,16,19,56);
	LDI  R30,LOW(19)
	ST   -Y,R30
	LDI  R30,LOW(16)
	ST   -Y,R30
	LDI  R30,LOW(19)
	ST   -Y,R30
	LDI  R30,LOW(56)
	ST   -Y,R30
	CALL _lcd_dashline
;lcd_dashline(33,16,33,56);
	LDI  R30,LOW(33)
	ST   -Y,R30
	LDI  R30,LOW(16)
	ST   -Y,R30
	LDI  R30,LOW(33)
	ST   -Y,R30
	LDI  R30,LOW(56)
	ST   -Y,R30
	CALL _lcd_dashline
;lcd_dashline(61,16,61,56);
	LDI  R30,LOW(61)
	ST   -Y,R30
	LDI  R30,LOW(16)
	ST   -Y,R30
	LDI  R30,LOW(61)
	ST   -Y,R30
	LDI  R30,LOW(56)
	ST   -Y,R30
	CALL _lcd_dashline
;lcd_dashline(75,16,75,56) ;
	LDI  R30,LOW(75)
	ST   -Y,R30
	LDI  R30,LOW(16)
	ST   -Y,R30
	LDI  R30,LOW(75)
	ST   -Y,R30
	LDI  R30,LOW(56)
	ST   -Y,R30
	CALL _lcd_dashline
;
;        Y[0]=contr[pos[1]].nodes[0][FLY_MODE]/-5+36;
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,24
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R26,X
	LDI  R30,LOW(251)
	CALL __DIVB21
	SUBI R30,-LOW(36)
	ST   Y,R30
;        Y[1]=contr[pos[1]].nodes[1][FLY_MODE]/-5+36;
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,24
	ADIW R30,4
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R26,X
	LDI  R30,LOW(251)
	CALL __DIVB21
	SUBI R30,-LOW(36)
	STD  Y+1,R30
;        Y[2]=contr[pos[1]].nodes[2][FLY_MODE]/-5+36;
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,24
	ADIW R30,8
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R26,X
	LDI  R30,LOW(251)
	CALL __DIVB21
	SUBI R30,-LOW(36)
	STD  Y+2,R30
;        Y[3]=contr[pos[1]].nodes[3][FLY_MODE]/-5+36;
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,24
	ADIW R30,12
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R26,X
	LDI  R30,LOW(251)
	CALL __DIVB21
	SUBI R30,-LOW(36)
	STD  Y+3,R30
;        Y[4]=contr[pos[1]].nodes[4][FLY_MODE]/-5+36;
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,24
	ADIW R30,16
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R26,X
	LDI  R30,LOW(251)
	CALL __DIVB21
	SUBI R30,-LOW(36)
	STD  Y+4,R30
;        Y[5]=contr[pos[1]].nodes[5][FLY_MODE]/-5+36;
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,24
	ADIW R30,20
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R26,X
	LDI  R30,LOW(251)
	CALL __DIVB21
	SUBI R30,-LOW(36)
	STD  Y+5,R30
;        Y[6]=contr[pos[1]].nodes[6][FLY_MODE]/-5+36;
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,24
	ADIW R30,24
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R26,X
	LDI  R30,LOW(251)
	CALL __DIVB21
	SUBI R30,-LOW(36)
	STD  Y+6,R30
;
;
;lcd_line(5,Y[0],19,Y[1],1);
	LDI  R30,LOW(5)
	ST   -Y,R30
	LDD  R30,Y+1
	ST   -Y,R30
	LDI  R30,LOW(19)
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;lcd_line(19,Y[1],33,Y[2],1);
	LDI  R30,LOW(19)
	ST   -Y,R30
	LDD  R30,Y+2
	ST   -Y,R30
	LDI  R30,LOW(33)
	ST   -Y,R30
	LDD  R30,Y+5
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;lcd_line(33,Y[2],47,Y[3],1);
	LDI  R30,LOW(33)
	ST   -Y,R30
	LDD  R30,Y+3
	ST   -Y,R30
	LDI  R30,LOW(47)
	ST   -Y,R30
	LDD  R30,Y+6
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;lcd_line(47,Y[3],61,Y[4],1);
	LDI  R30,LOW(47)
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	LDI  R30,LOW(61)
	ST   -Y,R30
	LDD  R30,Y+7
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;lcd_line(61,Y[4],75,Y[5],1);
	LDI  R30,LOW(61)
	ST   -Y,R30
	LDD  R30,Y+5
	ST   -Y,R30
	LDI  R30,LOW(75)
	ST   -Y,R30
	LDD  R30,Y+8
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;lcd_line(75,Y[5],89,Y[6],1);
	LDI  R30,LOW(75)
	ST   -Y,R30
	LDD  R30,Y+6
	ST   -Y,R30
	LDI  R30,LOW(89)
	ST   -Y,R30
	LDD  R30,Y+9
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;
;lcd_rectangle(3+sel*14,Y[sel]+2,7+sel*14,Y[sel]-2,1);
	LDD  R26,Y+7
	LDI  R30,LOW(14)
	MULS R30,R26
	MOVW R30,R0
	SUBI R30,-LOW(3)
	ST   -Y,R30
	LDD  R30,Y+8
	LDI  R31,0
	MOVW R26,R28
	ADIW R26,1
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	SUBI R30,-LOW(2)
	ST   -Y,R30
	LDD  R26,Y+9
	LDI  R30,LOW(14)
	MULS R30,R26
	MOVW R30,R0
	SUBI R30,-LOW(7)
	ST   -Y,R30
	LDD  R30,Y+10
	LDI  R31,0
	MOVW R26,R28
	ADIW R26,3
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	SUBI R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_rectangle
;
;
;sprintf(buf,"%-i",contr[pos[1]].nodes[sel][FLY_MODE]);
	LDI  R30,LOW(_buf)
	LDI  R31,HIGH(_buf)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,525
	ST   -Y,R31
	ST   -Y,R30
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,24
	MOVW R26,R30
	LDD  R30,Y+11
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	CALL __CBD1
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
;lcd_setxy(2,57);
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(57)
	ST   -Y,R30
	CALL _lcd_setxy
;if (!edit_cur)lcd_wrs(buf,255);
	LDS  R30,_edit_cur
	CPI  R30,0
	BRNE _0x90
	LDI  R30,LOW(_buf)
	LDI  R31,HIGH(_buf)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	RJMP _0x355
;else  lcd_wrs(buf,Clip);
_0x90:
	LDI  R30,LOW(_buf)
	LDI  R31,HIGH(_buf)
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Clip
_0x355:
	ST   -Y,R30
	CALL _lcd_wrs
;}
	RJMP _0x20E0009
;
;
;void SAVE_NODE (void)
;{ BEEP();
_SAVE_NODE:
	CALL _BEEP
; nodes[cur_model_num][pos[1]][pos[3]][FLY_MODE]=contr[pos[1]].nodes[pos[3]][FLY_MODE];
	LDS  R30,_cur_model_num
	LDI  R31,0
	LDI  R26,LOW(280)
	LDI  R27,HIGH(280)
	CALL __MULW12U
	SUBI R30,LOW(-_nodes)
	SBCI R31,HIGH(-_nodes)
	MOVW R26,R30
	__GETB1MN _pos,1
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(28)
	LDI  R27,HIGH(28)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	__GETB1MN _pos,3
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R7
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,24
	MOVW R26,R30
	__GETB1MN _pos,3
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	MOVW R26,R22
	CALL __EEPROMWRB
;BEEP();
	CALL _BEEP
;}
	RET
;
;
;
;
;
;
;
;
;
;   void menu_item (__flash const char  **name, byte leng, byte sel)
;        {   byte i, f,l,c;
_menu_item:
;        if (leng>5) {
	CALL __SAVELOCR4
;	*name -> Y+6
;	leng -> Y+5
;	sel -> Y+4
;	i -> R17
;	f -> R16
;	l -> R19
;	c -> R18
	LDD  R26,Y+5
	CPI  R26,LOW(0x6)
	BRSH PC+3
	JMP _0x92
;                lcd_line(92,18,92,64,1);
	LDI  R30,LOW(92)
	ST   -Y,R30
	LDI  R30,LOW(18)
	ST   -Y,R30
	LDI  R30,LOW(92)
	ST   -Y,R30
	LDI  R30,LOW(64)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;                lcd_line(95,18,95,64,1);
	LDI  R30,LOW(95)
	ST   -Y,R30
	LDI  R30,LOW(18)
	ST   -Y,R30
	LDI  R30,LOW(95)
	ST   -Y,R30
	LDI  R30,LOW(64)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;
;                if (sel>=5)
	LDD  R26,Y+4
	CPI  R26,LOW(0x5)
	BRLO _0x93
;                        {
;                        lcd_line(93,41,93,64,1);
	LDI  R30,LOW(93)
	ST   -Y,R30
	LDI  R30,LOW(41)
	ST   -Y,R30
	LDI  R30,LOW(93)
	ST   -Y,R30
	LDI  R30,LOW(64)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;                        lcd_line(94,41,94,64,1);
	LDI  R30,LOW(94)
	ST   -Y,R30
	LDI  R30,LOW(41)
	ST   -Y,R30
	LDI  R30,LOW(94)
	ST   -Y,R30
	LDI  R30,LOW(64)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;                        lcd_line(93,18,94,18,1);
	LDI  R30,LOW(93)
	ST   -Y,R30
	LDI  R30,LOW(18)
	ST   -Y,R30
	LDI  R30,LOW(94)
	ST   -Y,R30
	LDI  R30,LOW(18)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;                        f=5;
	LDI  R16,LOW(5)
;                        l=leng;
	LDD  R19,Y+5
;                        }
;
;                else
	RJMP _0x94
_0x93:
;                        {
;                        lcd_line(93,18,93,41,1);
	LDI  R30,LOW(93)
	ST   -Y,R30
	LDI  R30,LOW(18)
	ST   -Y,R30
	LDI  R30,LOW(93)
	ST   -Y,R30
	LDI  R30,LOW(41)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;                        lcd_line(94,18,94,41,1);
	LDI  R30,LOW(94)
	ST   -Y,R30
	LDI  R30,LOW(18)
	ST   -Y,R30
	LDI  R30,LOW(94)
	ST   -Y,R30
	LDI  R30,LOW(41)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;                        lcd_line(93,64,94,64,1);
	LDI  R30,LOW(93)
	ST   -Y,R30
	LDI  R30,LOW(64)
	ST   -Y,R30
	LDI  R30,LOW(94)
	ST   -Y,R30
	LDI  R30,LOW(64)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;                        f=0;
	LDI  R16,LOW(0)
;                        l=5;
	LDI  R19,LOW(5)
;                        }
_0x94:
;
;                      }
;        else
	RJMP _0x95
_0x92:
;        {f=0;
	LDI  R16,LOW(0)
;         l=leng;
	LDD  R19,Y+5
;         }
_0x95:
;
;
;        c=0;
	LDI  R18,LOW(0)
;        for (i=f; i<l; i++)
	MOV  R17,R16
_0x97:
	CP   R17,R19
	BRSH _0x98
;                {
;                            lcd_setxy(10,c*9+18);
	LDI  R30,LOW(10)
	ST   -Y,R30
	MOV  R26,R18
	LDI  R30,LOW(9)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,-LOW(18)
	ST   -Y,R30
	CALL _lcd_setxy
;                            lcd_wrsf(name[i],255);
	MOV  R30,R17
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;                            if (i==sel)
	LDD  R30,Y+4
	CP   R30,R17
	BRNE _0x99
;                                {
;
;                                lcd_setxy(10,c*9+18);
	LDI  R30,LOW(10)
	ST   -Y,R30
	MOV  R26,R18
	LDI  R30,LOW(9)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,-LOW(18)
	ST   -Y,R30
	CALL _lcd_setxy
;                                lcd_wrsf(name[i],0);
	MOV  R30,R17
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _lcd_wrsf
;                                }
;                               c++;
_0x99:
	SUBI R18,-1
;                }
	SUBI R17,-1
	RJMP _0x97
_0x98:
;
;        }
	CALL __LOADLOCR4
_0x20E0009:
	ADIW R28,8
	RET
;
;
;void edit_CH (char N,char sel)
;{
_edit_CH:
; if (sel==0)
;	N -> Y+1
;	sel -> Y+0
	LD   R30,Y
	CPI  R30,0
	BRNE _0x9A
;        {
;        lcd_setxy(0,20);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _lcd_setxy
;        if (edit==0) lcd_wrsf("Rev  ",0);
	LDS  R30,_edit
	CPI  R30,0
	BRNE _0x9B
	__POINTW1FN _0x0,529
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	RJMP _0x356
;        else lcd_wrsf("Rev  ",Clip);
_0x9B:
	__POINTW1FN _0x0,529
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Clip
_0x356:
	ST   -Y,R30
	CALL _lcd_wrsf
;        if (contr[N].reverse[FLY_MODE]==-1)
	LDD  R30,Y+1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_contr)
	SBCI R31,HIGH(-_contr)
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R26,X
	CPI  R26,LOW(0xFF)
	BRNE _0x9D
;                {
;              lcd_setxy(31,20);
	LDI  R30,LOW(31)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _lcd_setxy
;                lcd_char(124,0);
	LDI  R30,LOW(124)
	RJMP _0x357
;                }
;        else
_0x9D:
;                {
;              lcd_setxy(31,20);
	LDI  R30,LOW(31)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _lcd_setxy
;
;                lcd_char(123,0);
	LDI  R30,LOW(123)
_0x357:
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _lcd_char
;                }
;        }
; else   {
	RJMP _0x9F
_0x9A:
;        lcd_setxy(0,20);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _lcd_setxy
;        lcd_wrsf("Rev  ",255);
	__POINTW1FN _0x0,529
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;        if (contr[N].reverse[FLY_MODE]==-1)
	LDD  R30,Y+1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_contr)
	SBCI R31,HIGH(-_contr)
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R26,X
	CPI  R26,LOW(0xFF)
	BRNE _0xA0
;                {
;              lcd_setxy(31,20);
	LDI  R30,LOW(31)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _lcd_setxy
;                lcd_char(124,255);
	LDI  R30,LOW(124)
	RJMP _0x358
;                }
;        else
_0xA0:
;                {
;              lcd_setxy(31,20);
	LDI  R30,LOW(31)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _lcd_setxy
;                lcd_char(123,255);
	LDI  R30,LOW(123)
_0x358:
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_char
;                }
;
;
;        }
_0x9F:
;if (N<4||N>6)
	LDD  R26,Y+1
	CPI  R26,LOW(0x4)
	BRLT _0xA3
	CPI  R26,LOW(0x7)
	BRLT _0xA2
_0xA3:
;        {
;        if (sel==1)
	LD   R26,Y
	CPI  R26,LOW(0x1)
	BRNE _0xA5
;                {
;                lcd_setxy(46,20);
	LDI  R30,LOW(46)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _lcd_setxy
;                lcd_wrsf("Curve>",0);
	__POINTW1FN _0x0,535
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	RJMP _0x359
;                }
;        else
_0xA5:
;                {
;                lcd_setxy(46,20);
	LDI  R30,LOW(46)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _lcd_setxy
;                lcd_wrsf("Curve>",255);
	__POINTW1FN _0x0,535
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
_0x359:
	ST   -Y,R30
	CALL _lcd_wrsf
;                }
;        }
;
; lcd_setxy(8,30);
_0xA2:
	LDI  R30,LOW(8)
	ST   -Y,R30
	LDI  R30,LOW(30)
	ST   -Y,R30
	CALL _lcd_setxy
;        lcd_wrsf("Rate ",255);
	__POINTW1FN _0x0,542
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;sprintf(buf,"%-i",contr[N].minRates[FLY_MODE]);
	LDI  R30,LOW(_buf)
	LDI  R31,HIGH(_buf)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,525
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+5
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,8
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
;if (sel==2)
	LD   R26,Y
	CPI  R26,LOW(0x2)
	BRNE _0xA7
;        {
;        lcd_setxy(44,30);
	LDI  R30,LOW(44)
	ST   -Y,R30
	LDI  R30,LOW(30)
	ST   -Y,R30
	CALL _lcd_setxy
;        if (!edit)lcd_wrs(buf,0);
	LDS  R30,_edit
	CPI  R30,0
	BRNE _0xA8
	LDI  R30,LOW(_buf)
	LDI  R31,HIGH(_buf)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	RJMP _0x35A
;        else  lcd_wrs(buf,Clip);
_0xA8:
	LDI  R30,LOW(_buf)
	LDI  R31,HIGH(_buf)
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Clip
_0x35A:
	ST   -Y,R30
	CALL _lcd_wrs
;        }
;else
	RJMP _0xAA
_0xA7:
;        {
;        lcd_setxy(44,30);
	LDI  R30,LOW(44)
	ST   -Y,R30
	LDI  R30,LOW(30)
	ST   -Y,R30
	CALL _lcd_setxy
;        lcd_wrs(buf,255);
	LDI  R30,LOW(_buf)
	LDI  R31,HIGH(_buf)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrs
;        }
_0xAA:
;sprintf(buf,"%-i",contr[N].maxRates[FLY_MODE]);
	LDI  R30,LOW(_buf)
	LDI  R31,HIGH(_buf)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,525
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+5
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,4
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; if (sel==3)
	LD   R26,Y
	CPI  R26,LOW(0x3)
	BRNE _0xAB
;        {
;        lcd_setxy(72,30);
	LDI  R30,LOW(72)
	ST   -Y,R30
	LDI  R30,LOW(30)
	ST   -Y,R30
	CALL _lcd_setxy
;         if (!edit)lcd_wrs(buf,0);
	LDS  R30,_edit
	CPI  R30,0
	BRNE _0xAC
	LDI  R30,LOW(_buf)
	LDI  R31,HIGH(_buf)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	RJMP _0x35B
;        else  lcd_wrs(buf,Clip);
_0xAC:
	LDI  R30,LOW(_buf)
	LDI  R31,HIGH(_buf)
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Clip
_0x35B:
	ST   -Y,R30
	CALL _lcd_wrs
;        }
;else
	RJMP _0xAE
_0xAB:
;        {
;        lcd_setxy(72,30);
	LDI  R30,LOW(72)
	ST   -Y,R30
	LDI  R30,LOW(30)
	ST   -Y,R30
	CALL _lcd_setxy
;        lcd_wrs(buf,255);
	LDI  R30,LOW(_buf)
	LDI  R31,HIGH(_buf)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrs
;        }
_0xAE:
;
;
;
;
;
;if (N<4&&N!=2)
	LDD  R26,Y+1
	CPI  R26,LOW(0x4)
	BRGE _0xB0
	CPI  R26,LOW(0x2)
	BRNE _0xB1
_0xB0:
	RJMP _0xAF
_0xB1:
;        {
;         lcd_setxy(0,40);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	CALL _lcd_setxy
;         lcd_wrsf("DRate ",255);
	__POINTW1FN _0x0,548
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;        sprintf(buf,"%-i",contr[N].minDRates[FLY_MODE]);
	LDI  R30,LOW(_buf)
	LDI  R31,HIGH(_buf)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,525
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+5
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,16
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
;        if (sel==4)
	LD   R26,Y
	CPI  R26,LOW(0x4)
	BRNE _0xB2
;                {
;                lcd_setxy(44,40);
	LDI  R30,LOW(44)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	CALL _lcd_setxy
;                if (!edit)lcd_wrs(buf,0);
	LDS  R30,_edit
	CPI  R30,0
	BRNE _0xB3
	LDI  R30,LOW(_buf)
	LDI  R31,HIGH(_buf)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	RJMP _0x35C
;                else  lcd_wrs(buf,Clip);
_0xB3:
	LDI  R30,LOW(_buf)
	LDI  R31,HIGH(_buf)
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Clip
_0x35C:
	ST   -Y,R30
	CALL _lcd_wrs
;
;                }
;        else
	RJMP _0xB5
_0xB2:
;                {
;                lcd_setxy(44,40);
	LDI  R30,LOW(44)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	CALL _lcd_setxy
;                lcd_wrs(buf,255);
	LDI  R30,LOW(_buf)
	LDI  R31,HIGH(_buf)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrs
;                }
_0xB5:
;       sprintf(buf,"%-i",contr[N].maxDRates[FLY_MODE]);
	LDI  R30,LOW(_buf)
	LDI  R31,HIGH(_buf)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,525
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+5
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,12
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
;        if (sel==5)
	LD   R26,Y
	CPI  R26,LOW(0x5)
	BRNE _0xB6
;                {
;                lcd_setxy(72,40);
	LDI  R30,LOW(72)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	CALL _lcd_setxy
;                if (!edit)lcd_wrs(buf,0);
	LDS  R30,_edit
	CPI  R30,0
	BRNE _0xB7
	LDI  R30,LOW(_buf)
	LDI  R31,HIGH(_buf)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	RJMP _0x35D
;                else  lcd_wrs(buf,Clip);
_0xB7:
	LDI  R30,LOW(_buf)
	LDI  R31,HIGH(_buf)
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Clip
_0x35D:
	ST   -Y,R30
	CALL _lcd_wrs
;
;                }
;        else
	RJMP _0xB9
_0xB6:
;                {
;                lcd_setxy(72,40);
	LDI  R30,LOW(72)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	CALL _lcd_setxy
;                lcd_wrs(buf,255);
	LDI  R30,LOW(_buf)
	LDI  R31,HIGH(_buf)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrs
;                }
_0xB9:
;
;
;
;
;        }
;
;if (N==2)
_0xAF:
	LDD  R26,Y+1
	CPI  R26,LOW(0x2)
	BREQ PC+3
	JMP _0xBA
;        {
;         lcd_setxy(2,40);
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	CALL _lcd_setxy
;                lcd_wrsf("Tcut ",255);
	__POINTW1FN _0x0,555
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;       sprintf(buf,"%-i",contr[N].minDRates[FLY_MODE]);
	LDI  R30,LOW(_buf)
	LDI  R31,HIGH(_buf)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,525
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+5
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,16
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
;        if (sel==4)
	LD   R26,Y
	CPI  R26,LOW(0x4)
	BRNE _0xBB
;                {
;                lcd_setxy(44,40);
	LDI  R30,LOW(44)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	CALL _lcd_setxy
;              if (!edit) lcd_wrs(buf,0);
	LDS  R30,_edit
	CPI  R30,0
	BRNE _0xBC
	LDI  R30,LOW(_buf)
	LDI  R31,HIGH(_buf)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	RJMP _0x35E
;                else  lcd_wrs(buf,Clip);
_0xBC:
	LDI  R30,LOW(_buf)
	LDI  R31,HIGH(_buf)
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Clip
_0x35E:
	ST   -Y,R30
	CALL _lcd_wrs
;
;                }
;        else
	RJMP _0xBE
_0xBB:
;                {
;                 lcd_setxy(44,40);
	LDI  R30,LOW(44)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	CALL _lcd_setxy
;                lcd_wrs(buf,255);
	LDI  R30,LOW(_buf)
	LDI  R31,HIGH(_buf)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrs
;                }
_0xBE:
;        }
; if (N>7)
_0xBA:
	LDD  R26,Y+1
	CPI  R26,LOW(0x8)
	BRGE PC+3
	JMP _0xBF
;        {lcd_setxy(2,42);
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(42)
	ST   -Y,R30
	CALL _lcd_setxy
;                lcd_wrsf("From: ",255);
	__POINTW1FN _0x0,561
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;        if (sel==4)
	LD   R26,Y
	CPI  R26,LOW(0x4)
	BREQ PC+3
	JMP _0xC0
;                {
;
;                lcd_setxy(8,50);
	LDI  R30,LOW(8)
	ST   -Y,R30
	LDI  R30,LOW(50)
	ST   -Y,R30
	CALL _lcd_setxy
;                if (!edit)lcd_wrsf(menuT2[contr[pos[1]].from[FLY_MODE]] ,0);
	LDS  R30,_edit
	CPI  R30,0
	BRNE _0xC1
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,20
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	LDI  R26,LOW(_menuT2)
	LDI  R27,HIGH(_menuT2)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	RJMP _0x35F
;                else  lcd_wrsf(menuT2[contr[pos[1]].from[FLY_MODE]] ,Clip);
_0xC1:
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,20
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	LDI  R26,LOW(_menuT2)
	LDI  R27,HIGH(_menuT2)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Clip
_0x35F:
	ST   -Y,R30
	CALL _lcd_wrsf
;                }
;        else
	RJMP _0xC3
_0xC0:
;                {
;                lcd_setxy(8,50);
	LDI  R30,LOW(8)
	ST   -Y,R30
	LDI  R30,LOW(50)
	ST   -Y,R30
	CALL _lcd_setxy
;                lcd_wrsf(menuT2[contr[pos[1]].from[FLY_MODE]] ,255);
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,20
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	LDI  R26,LOW(_menuT2)
	LDI  R27,HIGH(_menuT2)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;                }
_0xC3:
;        }
;
; }
_0xBF:
_0x20E0008:
	ADIW R28,2
	RET
;
;void wr_trimmer (void)
;{  char tr[4];
_wr_trimmer:
;
;
;tr[2]=curmodel.trimmer[FLY_MODE][2]/-5+40;
	SBIW R28,4
;	tr -> Y+0
	__POINTW2MN _curmodel,13
	MOV  R30,R7
	LDI  R31,0
	CALL __LSLW2
	ADD  R30,R26
	ADC  R31,R27
	LDD  R30,Z+2
	MOV  R26,R30
	LDI  R30,LOW(251)
	CALL __DIVB21
	SUBI R30,-LOW(40)
	STD  Y+2,R30
;
;lcd_line(6,24,6,56,1);
	LDI  R30,LOW(6)
	ST   -Y,R30
	LDI  R30,LOW(24)
	ST   -Y,R30
	LDI  R30,LOW(6)
	ST   -Y,R30
	LDI  R30,LOW(56)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;
;lcd_pixel(7,24,1);
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(24)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(8,24,1);
	LDI  R30,LOW(8)
	ST   -Y,R30
	LDI  R30,LOW(24)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(7,28,1);
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(28)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(7,32,1);
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(32)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(7,36,1);
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(36)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(7,40,1);
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(8,40,1);
	LDI  R30,LOW(8)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(7,44,1);
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(44)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(7,48,1);
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(7,52,1);
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(52)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(7,56,1);
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(56)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(8,56,1);
	LDI  R30,LOW(8)
	ST   -Y,R30
	LDI  R30,LOW(56)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;
;lcd_pixel(9,tr[2],1);
	LDI  R30,LOW(9)
	ST   -Y,R30
	LDD  R30,Y+3
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_line(10,tr[2]-1,10,tr[2]+1,1);
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDD  R30,Y+3
	SUBI R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDD  R30,Y+5
	SUBI R30,-LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;lcd_line(11,tr[2]-2,11,tr[2]+2,1);
	LDI  R30,LOW(11)
	ST   -Y,R30
	LDD  R30,Y+3
	SUBI R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(11)
	ST   -Y,R30
	LDD  R30,Y+5
	SUBI R30,-LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;
;
;tr[1]=curmodel.trimmer[FLY_MODE][1]/-5+40;
	__POINTW2MN _curmodel,13
	MOV  R30,R7
	LDI  R31,0
	CALL __LSLW2
	ADD  R30,R26
	ADC  R31,R27
	LDD  R30,Z+1
	MOV  R26,R30
	LDI  R30,LOW(251)
	CALL __DIVB21
	SUBI R30,-LOW(40)
	STD  Y+1,R30
;lcd_line(89,24,89,56,1);
	LDI  R30,LOW(89)
	ST   -Y,R30
	LDI  R30,LOW(24)
	ST   -Y,R30
	LDI  R30,LOW(89)
	ST   -Y,R30
	LDI  R30,LOW(56)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;
;lcd_pixel(88,24,1);
	LDI  R30,LOW(88)
	ST   -Y,R30
	LDI  R30,LOW(24)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(87,24,1);
	LDI  R30,LOW(87)
	ST   -Y,R30
	LDI  R30,LOW(24)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(88,28,1);
	LDI  R30,LOW(88)
	ST   -Y,R30
	LDI  R30,LOW(28)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(88,32,1);
	LDI  R30,LOW(88)
	ST   -Y,R30
	LDI  R30,LOW(32)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(88,36,1);
	LDI  R30,LOW(88)
	ST   -Y,R30
	LDI  R30,LOW(36)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(88,40,1);
	LDI  R30,LOW(88)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(87,40,1);
	LDI  R30,LOW(87)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(88,44,1);
	LDI  R30,LOW(88)
	ST   -Y,R30
	LDI  R30,LOW(44)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(88,48,1);
	LDI  R30,LOW(88)
	ST   -Y,R30
	LDI  R30,LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(88,52,1);
	LDI  R30,LOW(88)
	ST   -Y,R30
	LDI  R30,LOW(52)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(88,56,1);
	LDI  R30,LOW(88)
	ST   -Y,R30
	LDI  R30,LOW(56)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(87,56,1);
	LDI  R30,LOW(87)
	ST   -Y,R30
	LDI  R30,LOW(56)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;
;lcd_pixel(86,tr[1],1);
	LDI  R30,LOW(86)
	ST   -Y,R30
	LDD  R30,Y+2
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_line(85,tr[1]-1,85,tr[1]+1,1);
	LDI  R30,LOW(85)
	ST   -Y,R30
	LDD  R30,Y+2
	SUBI R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(85)
	ST   -Y,R30
	LDD  R30,Y+4
	SUBI R30,-LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;lcd_line(84,tr[1]-2,84,tr[1]+2,1);
	LDI  R30,LOW(84)
	ST   -Y,R30
	LDD  R30,Y+2
	SUBI R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(84)
	ST   -Y,R30
	LDD  R30,Y+4
	SUBI R30,-LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;
;
;tr[3]=curmodel.trimmer[FLY_MODE][3]/5+26;
	__POINTW2MN _curmodel,13
	MOV  R30,R7
	LDI  R31,0
	CALL __LSLW2
	ADD  R30,R26
	ADC  R31,R27
	LDD  R30,Z+3
	MOV  R26,R30
	LDI  R30,LOW(5)
	CALL __DIVB21
	SUBI R30,-LOW(26)
	STD  Y+3,R30
;lcd_line(10,63,42,63,1);
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(63)
	ST   -Y,R30
	LDI  R30,LOW(42)
	ST   -Y,R30
	LDI  R30,LOW(63)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;lcd_pixel(10,61,1);
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(61)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(10,62,1);
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(62)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(14,62,1);
	LDI  R30,LOW(14)
	ST   -Y,R30
	LDI  R30,LOW(62)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(18,62,1);
	LDI  R30,LOW(18)
	ST   -Y,R30
	LDI  R30,LOW(62)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(22,62,1);
	LDI  R30,LOW(22)
	ST   -Y,R30
	LDI  R30,LOW(62)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(26,62,1);
	LDI  R30,LOW(26)
	ST   -Y,R30
	LDI  R30,LOW(62)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(26,61,1);
	LDI  R30,LOW(26)
	ST   -Y,R30
	LDI  R30,LOW(61)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(30,62,1);
	LDI  R30,LOW(30)
	ST   -Y,R30
	LDI  R30,LOW(62)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(34,62,1);
	LDI  R30,LOW(34)
	ST   -Y,R30
	LDI  R30,LOW(62)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(38,62,1);
	LDI  R30,LOW(38)
	ST   -Y,R30
	LDI  R30,LOW(62)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(42,62,1);
	LDI  R30,LOW(42)
	ST   -Y,R30
	LDI  R30,LOW(62)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(42,61,1);
	LDI  R30,LOW(42)
	ST   -Y,R30
	LDI  R30,LOW(61)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;
;lcd_pixel(tr[3],60,1);
	LDD  R30,Y+3
	ST   -Y,R30
	LDI  R30,LOW(60)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_line(tr[3]-1,59,tr[3]+1,59,1);
	LDD  R30,Y+3
	SUBI R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(59)
	ST   -Y,R30
	LDD  R30,Y+5
	SUBI R30,-LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(59)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;lcd_line(tr[3]-2,58,tr[3]+2,58,1);
	LDD  R30,Y+3
	SUBI R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(58)
	ST   -Y,R30
	LDD  R30,Y+5
	SUBI R30,-LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(58)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;
;
;tr[0]=curmodel.trimmer[FLY_MODE][0]/5+68;
	__POINTW2MN _curmodel,13
	MOV  R30,R7
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	LD   R26,X
	LDI  R30,LOW(5)
	CALL __DIVB21
	SUBI R30,-LOW(68)
	ST   Y,R30
;lcd_line(52,63,84,63,1);
	LDI  R30,LOW(52)
	ST   -Y,R30
	LDI  R30,LOW(63)
	ST   -Y,R30
	LDI  R30,LOW(84)
	ST   -Y,R30
	LDI  R30,LOW(63)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;lcd_pixel(52,62,1);
	LDI  R30,LOW(52)
	ST   -Y,R30
	LDI  R30,LOW(62)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(52,61,1);
	LDI  R30,LOW(52)
	ST   -Y,R30
	LDI  R30,LOW(61)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(56,62,1);
	LDI  R30,LOW(56)
	ST   -Y,R30
	LDI  R30,LOW(62)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(60,62,1);
	LDI  R30,LOW(60)
	ST   -Y,R30
	LDI  R30,LOW(62)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(64,62,1);
	LDI  R30,LOW(64)
	ST   -Y,R30
	LDI  R30,LOW(62)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(68,62,1);
	LDI  R30,LOW(68)
	ST   -Y,R30
	LDI  R30,LOW(62)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(68,61,1);
	LDI  R30,LOW(68)
	ST   -Y,R30
	LDI  R30,LOW(61)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(72,62,1);
	LDI  R30,LOW(72)
	ST   -Y,R30
	LDI  R30,LOW(62)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(76,62,1);
	LDI  R30,LOW(76)
	ST   -Y,R30
	LDI  R30,LOW(62)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(80,62,1);
	LDI  R30,LOW(80)
	ST   -Y,R30
	LDI  R30,LOW(62)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(84,62,1);
	LDI  R30,LOW(84)
	ST   -Y,R30
	LDI  R30,LOW(62)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_pixel(84,61,1);
	LDI  R30,LOW(84)
	ST   -Y,R30
	LDI  R30,LOW(61)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;
;lcd_pixel(tr[0],60,1);
	LD   R30,Y
	ST   -Y,R30
	LDI  R30,LOW(60)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_line(tr[0]-1,59,tr[0]+1,59,1);
	LD   R30,Y
	SUBI R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(59)
	ST   -Y,R30
	LDD  R30,Y+2
	SUBI R30,-LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(59)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;lcd_line(tr[0]-2,58,tr[0]+2,58,1);
	LD   R30,Y
	SUBI R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(58)
	ST   -Y,R30
	LDD  R30,Y+2
	SUBI R30,-LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(58)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;
;
;}
	RJMP _0x20E0007
;
;
;void main_scr (void)
;        {char min[2],sec[2];
_main_scr:
;
;
;        lcd_setxy(0,0);
	SBIW R28,4
;	min -> Y+2
;	sec -> Y+0
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	CALL _lcd_setxy
;        sprintf(buf,"0%-i",cur_model_num+1);
	LDI  R30,LOW(_buf)
	LDI  R31,HIGH(_buf)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,568
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_cur_model_num
	SUBI R30,-LOW(1)
	CALL __CBD1
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
;        lcd_wrs(buf,255);
	LDI  R30,LOW(_buf)
	LDI  R31,HIGH(_buf)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrs
;        lcd_setxy(16,0);
	LDI  R30,LOW(16)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _lcd_setxy
;        if (curmodel.type==1)            // 
	__GETB2MN _curmodel,11
	CPI  R26,LOW(0x1)
	BRNE _0xC4
;                {
;                lcd_char(125,255);
	LDI  R30,LOW(125)
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_char
;                lcd_char(126,255);
	LDI  R30,LOW(126)
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_char
;                }                                                                ///***************************
;        if (curmodel.type==0)            // 
_0xC4:
	__GETB1MN _curmodel,11
	CPI  R30,0
	BRNE _0xC5
;                {
;                lcd_char(127,255);
	LDI  R30,LOW(127)
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_char
;                lcd_char(128,255);
	LDI  R30,LOW(128)
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_char
;                }
;
;
;
;   if (Cut_enable)
_0xC5:
	TST  R6
	BREQ _0xC6
;        {
;        lcd_setxy(65,15);
	LDI  R30,LOW(65)
	ST   -Y,R30
	LDI  R30,LOW(15)
	ST   -Y,R30
	CALL _lcd_setxy
;        lcd_char(129,255);
	LDI  R30,LOW(129)
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_char
;        lcd_char(130,255);
	LDI  R30,LOW(130)
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_char
;        lcd_setxy(65,23);
	LDI  R30,LOW(65)
	ST   -Y,R30
	LDI  R30,LOW(23)
	ST   -Y,R30
	CALL _lcd_setxy
;        lcd_char(131,255);
	LDI  R30,LOW(131)
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_char
;        lcd_char(132,255);
	LDI  R30,LOW(132)
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_char
;        }
;
;
;   lcd_setxy(25,20);
_0xC6:
	LDI  R30,LOW(25)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _lcd_setxy
;     sprintf(buf,"%-i.%-iV",U_bat/100,U_bat/10%10);
	LDI  R30,LOW(_buf)
	LDI  R31,HIGH(_buf)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,573
	ST   -Y,R31
	ST   -Y,R30
	MOVW R26,R4
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CALL __DIVW21
	CALL __CWD1
	CALL __PUTPARD1
	MOVW R26,R4
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21
	CALL __CWD1
	CALL __PUTPARD1
	LDI  R24,8
	CALL _sprintf
	ADIW R28,12
;      lcd_wrs(buf,255);
	LDI  R30,LOW(_buf)
	LDI  R31,HIGH(_buf)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrs
;
;
;      lcd_setxy(33,0);
	LDI  R30,LOW(33)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _lcd_setxy
;      lcd_wrs(screen_name,255);
	LDI  R30,LOW(_screen_name)
	LDI  R31,HIGH(_screen_name)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrs
;
;
;
;    lcd_setxy(0,9);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(9)
	ST   -Y,R30
	CALL _lcd_setxy
;    lcd_wrsf(modeNames[curmodel.type][FLY_MODE],255);
	__GETB1MN _curmodel,11
	LDI  R26,LOW(6)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_modeNames)
	SBCI R31,HIGH(-_modeNames)
	MOVW R26,R30
	MOV  R30,R7
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;
;     //lcd_fillrect(24,18,68,30,1);
;     //lcd_fillrect(68,22,71,26,1);
;
;    min[0]=time/600;
	MOVW R26,R10
	LDI  R30,LOW(600)
	LDI  R31,HIGH(600)
	CALL __DIVW21
	STD  Y+2,R30
;    min[1]=time/60%10;
	MOVW R26,R10
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	CALL __DIVW21
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21
	STD  Y+3,R30
;    sec[0]=time%60/10;
	MOVW R26,R10
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	CALL __MODW21
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	ST   Y,R30
;    sec[1]=time%10;
	MOVW R26,R10
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21
	STD  Y+1,R30
;
;    lcd_setxy(42,35);
	LDI  R30,LOW(42)
	ST   -Y,R30
	LDI  R30,LOW(35)
	ST   -Y,R30
	CALL _lcd_setxy
;    lcd_deg12x16(10,255);
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_deg12x16
;
;    lcd_setxy(19,36);
	LDI  R30,LOW(19)
	ST   -Y,R30
	LDI  R30,LOW(36)
	ST   -Y,R30
	CALL _lcd_setxy
;    lcd_deg12x16(min[0],255);
	LDD  R30,Y+2
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_deg12x16
;    lcd_setxy(32,36);
	LDI  R30,LOW(32)
	ST   -Y,R30
	LDI  R30,LOW(36)
	ST   -Y,R30
	CALL _lcd_setxy
;    lcd_deg12x16(min[1],255);
	LDD  R30,Y+3
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_deg12x16
;
;
;    lcd_setxy(50,36);
	LDI  R30,LOW(50)
	ST   -Y,R30
	LDI  R30,LOW(36)
	ST   -Y,R30
	CALL _lcd_setxy
;    lcd_deg12x16(sec[0],255);
	LD   R30,Y
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_deg12x16
;    lcd_setxy(63,36);
	LDI  R30,LOW(63)
	ST   -Y,R30
	LDI  R30,LOW(36)
	ST   -Y,R30
	CALL _lcd_setxy
;    lcd_deg12x16(sec[1],255);
	LDD  R30,Y+1
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_deg12x16
;
;
;    wr_trimmer();
	RCALL _wr_trimmer
;
;        }
_0x20E0007:
	ADIW R28,4
	RET
;
;    /*
;      void main_scr (void)
;        {
;      lcd_setxy(1,10);
;      sprintf(buf,"%-i  %-i",output[0], out_cur[4]);
;      lcd_wrs(buf,255);
;
;
;     lcd_setxy(1,20);
;
;
;     sprintf(buf,"%-i  %-i",output[1], out_cur[5]);
;      lcd_wrs(buf,255);
;
;
;     lcd_setxy(1,30);
;
;     sprintf(buf,"%-i  %-i",output[2], out_cur[6]);
;      lcd_wrs(buf,255);
;
;     lcd_setxy(1,40);
;
;     sprintf(buf,"%-i  %-i",output[3],input[3]);
;      lcd_wrs(buf,255);
;
;    lcd_setxy(1,50);
;
;     sprintf(buf,"%-i  %-i,%-i",output[7],U_bat/10000,U_bat/1000%10);
;      lcd_wrs(buf,255);
;
;        }
;      */
;void menu (void)
;{ byte i,j,max,temp[9],f,l,c;
_menu:
;
;if (LEFT&&RIGHT&&UP&&DOWN) pen=1;
	SBIW R28,9
	CALL __SAVELOCR6
;	i -> R17
;	j -> R16
;	max -> R19
;	temp -> Y+6
;	f -> R18
;	l -> R21
;	c -> R20
	SBIS 0x10,6
	RJMP _0xC8
	SBIS 0x10,7
	RJMP _0xC8
	SBIS 0x10,4
	RJMP _0xC8
	SBIC 0x10,5
	RJMP _0xC9
_0xC8:
	RJMP _0xC7
_0xC9:
	LDI  R30,LOW(1)
	STS  _pen,R30
;
;lcd_clear();
_0xC7:
	CALL _lcd_clear
;if (!en) {
	LDS  R30,_en
	CPI  R30,0
	BRNE _0xCA
;        main_scr();
	RCALL _main_scr
;        if (!RIGHT&&pen)
	SBIC 0x10,7
	RJMP _0xCC
	LDS  R30,_pen
	CPI  R30,0
	BRNE _0xCD
_0xCC:
	RJMP _0xCB
_0xCD:
;                        {
;                        en=1;
	LDI  R30,LOW(1)
	STS  _en,R30
;                        deep=0;
	LDI  R30,LOW(0)
	STS  _deep,R30
;                        pen=0;
	STS  _pen,R30
;                        pos[0]=0;
	STS  _pos,R30
;                        BEEP();
	CALL _BEEP
;                        }
;          }
_0xCB:
;
;        else
	JMP  _0xCE
_0xCA:
;        {
;
;        lcd_setxy(0,0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	CALL _lcd_setxy
;        sprintf(buf,"0%-i",cur_model_num+1);
	LDI  R30,LOW(_buf)
	LDI  R31,HIGH(_buf)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,568
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_cur_model_num
	SUBI R30,-LOW(1)
	CALL __CBD1
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
;        lcd_wrs(buf,255);
	LDI  R30,LOW(_buf)
	LDI  R31,HIGH(_buf)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrs
;        lcd_setxy(16,0);
	LDI  R30,LOW(16)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _lcd_setxy
;        if (curmodel.type==1)            // 
	__GETB2MN _curmodel,11
	CPI  R26,LOW(0x1)
	BRNE _0xCF
;                {
;                lcd_char(125,255);
	LDI  R30,LOW(125)
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_char
;                lcd_char(126,255);
	LDI  R30,LOW(126)
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_char
;                }
;
;           if (curmodel.type==0)            // 
_0xCF:
	__GETB1MN _curmodel,11
	CPI  R30,0
	BRNE _0xD0
;                {
;                lcd_char(127,255);
	LDI  R30,LOW(127)
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_char
;                lcd_char(128,255);
	LDI  R30,LOW(128)
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_char
;                }
;
;        lcd_setxy(33,0);
_0xD0:
	LDI  R30,LOW(33)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _lcd_setxy
;   lcd_wrsf(modeNames[curmodel.type][FLY_MODE],255);
	__GETB1MN _curmodel,11
	LDI  R26,LOW(6)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_modeNames)
	SBCI R31,HIGH(-_modeNames)
	MOVW R26,R30
	MOV  R30,R7
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;   if (!curve_ed_enable )
	LDS  R30,_curve_ed_enable
	CPI  R30,0
	BRNE _0xD1
;        {
;        lcd_dashline(0,16,95,16);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(16)
	ST   -Y,R30
	LDI  R30,LOW(95)
	ST   -Y,R30
	LDI  R30,LOW(16)
	ST   -Y,R30
	CALL _lcd_dashline
;        lcd_line(0,17,95,17,1);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(17)
	ST   -Y,R30
	LDI  R30,LOW(95)
	ST   -Y,R30
	LDI  R30,LOW(17)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;        }
;
;        if (deep==0) {                                                          // 
_0xD1:
	LDS  R30,_deep
	CPI  R30,0
	BREQ PC+3
	JMP _0xD2
;
;    pos[0]= scroll (pos[0],menuT0L);
	LDS  R30,_pos
	ST   -Y,R30
	LDI  R30,LOW(_menuT0L*2)
	LDI  R31,HIGH(_menuT0L*2)
	LPM  R30,Z
	ST   -Y,R30
	CALL _scroll
	STS  _pos,R30
;
;
;             if (!LEFT&&pen) {en=0;pen=0;BEEP();}
	SBIC 0x10,6
	RJMP _0xD4
	LDS  R30,_pen
	CPI  R30,0
	BRNE _0xD5
_0xD4:
	RJMP _0xD3
_0xD5:
	LDI  R30,LOW(0)
	STS  _en,R30
	STS  _pen,R30
	CALL _BEEP
;             if (!RIGHT&&pen)
_0xD3:
	SBIC 0x10,7
	RJMP _0xD7
	LDS  R30,_pen
	CPI  R30,0
	BRNE _0xD8
_0xD7:
	RJMP _0xD6
_0xD8:
;                        {
;                        deep=1;
	LDI  R30,LOW(1)
	STS  _deep,R30
;                        pos[1]=0;
	LDI  R30,LOW(0)
	__PUTB1MN _pos,1
;                        pen=0;
	STS  _pen,R30
;                        BEEP();
	CALL _BEEP
;                        }
;
;
;
;                lcd_setxy(0,8);
_0xD6:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(8)
	ST   -Y,R30
	CALL _lcd_setxy
;                lcd_wrsf("Main menu",255);
	__POINTW1FN _0x0,582
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;
;                menu_item( menuT0 ,menuT0L,pos[0]);
	LDI  R30,LOW(_menuT0)
	LDI  R31,HIGH(_menuT0)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_menuT0L*2)
	LDI  R31,HIGH(_menuT0L*2)
	LPM  R30,Z
	ST   -Y,R30
	LDS  R30,_pos
	ST   -Y,R30
	CALL _menu_item
;
;
;                        }
;
;
;        if (deep>0)
_0xD2:
	LDS  R26,_deep
	CPI  R26,LOW(0x1)
	BRSH PC+3
	JMP _0xD9
;        {
;        if (pos[0]==0)
	LDS  R30,_pos
	CPI  R30,0
	BREQ PC+3
	JMP _0xDA
;        { if (deep==1)
	CPI  R26,LOW(0x1)
	BREQ PC+3
	JMP _0xDB
;                {                                                    //     
;                pos[1]= scroll (pos[1],menuT1L) ;
	__GETB1MN _pos,1
	ST   -Y,R30
	LDI  R30,LOW(_menuT1L*2)
	LDI  R31,HIGH(_menuT1L*2)
	LPM  R30,Z
	ST   -Y,R30
	CALL _scroll
	__PUTB1MN _pos,1
;                if (!LEFT&&pen) {deep=0; pen=0;BEEP();}
	SBIC 0x10,6
	RJMP _0xDD
	LDS  R30,_pen
	CPI  R30,0
	BRNE _0xDE
_0xDD:
	RJMP _0xDC
_0xDE:
	LDI  R30,LOW(0)
	STS  _deep,R30
	STS  _pen,R30
	CALL _BEEP
;                if (!RIGHT&&pen)
_0xDC:
	SBIC 0x10,7
	RJMP _0xE0
	LDS  R30,_pen
	CPI  R30,0
	BRNE _0xE1
_0xE0:
	RJMP _0xDF
_0xE1:
;                        {
;                        deep=2;
	LDI  R30,LOW(2)
	STS  _deep,R30
;                        pos[2]=0;
	LDI  R30,LOW(0)
	__PUTB1MN _pos,2
;                        pen=0;
	STS  _pen,R30
;                        BEEP();
	CALL _BEEP
;                        if (pos[1]==0) pos[2]=cur_model_num;
	__GETB1MN _pos,1
	CPI  R30,0
	BRNE _0xE2
	LDS  R30,_cur_model_num
	__PUTB1MN _pos,2
;                        }
_0xE2:
;
;
;
;                lcd_setxy(0,8);
_0xDF:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(8)
	ST   -Y,R30
	CALL _lcd_setxy
;                lcd_wrsf("Model",255);
	__POINTW1FN _0x0,592
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;
;                menu_item( menuT1 ,menuT1L,pos[1]);
	LDI  R30,LOW(_menuT1)
	LDI  R31,HIGH(_menuT1)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_menuT1L*2)
	LDI  R31,HIGH(_menuT1L*2)
	LPM  R30,Z
	ST   -Y,R30
	__GETB1MN _pos,1
	ST   -Y,R30
	CALL _menu_item
;
;                }
;        if (deep==2&&pos[1]==0)                      //
_0xDB:
	LDS  R26,_deep
	CPI  R26,LOW(0x2)
	BRNE _0xE4
	__GETB1MN _pos,1
	CPI  R30,0
	BREQ _0xE5
_0xE4:
	RJMP _0xE3
_0xE5:
;                {
;                lcd_setxy(0,8);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(8)
	ST   -Y,R30
	CALL _lcd_setxy
;                lcd_wrsf("Select",255);
	__POINTW1FN _0x0,598
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;                for (j=0; j<MAX_MODELS; j++)
	LDI  R16,LOW(0)
_0xE7:
	CPI  R16,4
	BRLO PC+3
	JMP _0xE8
;                        {
;                        for (i=0; i<8; i++)temp[i]=Name_table[name[j][i]];
	LDI  R17,LOW(0)
_0xEA:
	CPI  R17,8
	BRSH _0xEB
	MOV  R30,R17
	LDI  R31,0
	MOVW R26,R28
	ADIW R26,6
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOV  R30,R16
	LDI  R31,0
	CALL __LSLW3
	SUBI R30,LOW(-_name)
	SBCI R31,HIGH(-_name)
	MOVW R26,R30
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	CALL __EEPROMRDB
	LDI  R31,0
	SUBI R30,LOW(-_Name_table*2)
	SBCI R31,HIGH(-_Name_table*2)
	LPM  R30,Z
	MOVW R26,R0
	ST   X,R30
	SUBI R17,-1
	RJMP _0xEA
_0xEB:
	LDI  R30,LOW(0)
	STD  Y+14,R30
;                        lcd_setxy(10,9*j+18);
	LDI  R30,LOW(10)
	ST   -Y,R30
	MOV  R30,R16
	LDI  R26,LOW(9)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,-LOW(18)
	ST   -Y,R30
	CALL _lcd_setxy
;                        if (pos[2]==j) lcd_wrs(temp,0);
	__GETB2MN _pos,2
	CP   R16,R26
	BRNE _0xEC
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	RJMP _0x360
;                        else lcd_wrs(temp,255);
_0xEC:
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
_0x360:
	ST   -Y,R30
	CALL _lcd_wrs
;                        }
	SUBI R16,-1
	RJMP _0xE7
_0xE8:
;                        if (!UP&&pos[2]<MAX_MODELS-1)
	SBIC 0x10,4
	RJMP _0xEF
	__GETB2MN _pos,2
	CPI  R26,LOW(0x3)
	BRLO _0xF0
_0xEF:
	RJMP _0xEE
_0xF0:
;                                {
;                                pos[2]++;
	__GETB1MN _pos,2
	SUBI R30,-LOW(1)
	__PUTB1MN _pos,2
;                                BEEP();
	CALL _BEEP
;                                }
;
;                        if (!DOWN&&pos[2]>0)
_0xEE:
	SBIC 0x10,5
	RJMP _0xF2
	__GETB2MN _pos,2
	CPI  R26,LOW(0x1)
	BRSH _0xF3
_0xF2:
	RJMP _0xF1
_0xF3:
;                                {
;                                pos[2]--;
	__GETB1MN _pos,2
	SUBI R30,LOW(1)
	__PUTB1MN _pos,2
;                                BEEP();
	CALL _BEEP
;                                }
;                        if (!LEFT&&pen){BEEP(); pen=0; deep=1; cur_model_num=pos[2]; start_model=cur_model_num; MODEL_init(); BEEP();}
_0xF1:
	SBIC 0x10,6
	RJMP _0xF5
	LDS  R30,_pen
	CPI  R30,0
	BRNE _0xF6
_0xF5:
	RJMP _0xF4
_0xF6:
	CALL _BEEP
	LDI  R30,LOW(0)
	STS  _pen,R30
	LDI  R30,LOW(1)
	STS  _deep,R30
	__GETB1MN _pos,2
	STS  _cur_model_num,R30
	LDI  R26,LOW(_start_model)
	LDI  R27,HIGH(_start_model)
	CALL __EEPROMWRB
	CALL _MODEL_init
	CALL _BEEP
;
;
;                }
_0xF4:
;
;        if (deep==2&&pos[1]==1)                      //
_0xE3:
	LDS  R26,_deep
	CPI  R26,LOW(0x2)
	BRNE _0xF8
	__GETB1MN _pos,1
	CPI  R30,LOW(0x1)
	BREQ _0xF9
_0xF8:
	RJMP _0xF7
_0xF9:
;                {
;                lcd_setxy(0,8);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(8)
	ST   -Y,R30
	CALL _lcd_setxy
;                lcd_wrsf("Reset",255);
	__POINTW1FN _0x0,605
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;                lcd_setxy(10,24);
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(24)
	ST   -Y,R30
	CALL _lcd_setxy
;                lcd_wrsf("Are you",255);
	__POINTW1FN _0x0,611
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;                lcd_setxy(15,35);
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(35)
	ST   -Y,R30
	CALL _lcd_setxy
;                lcd_wrsf("sure?",255);
	__POINTW1FN _0x0,619
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;                if (!RIGHT&&pen)
	SBIC 0x10,7
	RJMP _0xFB
	LDS  R30,_pen
	CPI  R30,0
	BRNE _0xFC
_0xFB:
	RJMP _0xFA
_0xFC:
;                        {
;                        BEEP();
	CALL _BEEP
;                        lcd_clear();
	CALL _lcd_clear
;                        lcd_setxy(10,24);
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(24)
	ST   -Y,R30
	CALL _lcd_setxy
;                        lcd_wrsf("Please",255);
	__POINTW1FN _0x0,625
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;                        lcd_setxy(15,35);
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(35)
	ST   -Y,R30
	CALL _lcd_setxy
;                        lcd_wrsf("wait...",255);
	__POINTW1FN _0x0,632
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;                        lcd_refresh();
	CALL _lcd_refresh
;                        MODEL_reset();
	CALL _MODEL_reset
;                        MODEL_init();
	CALL _MODEL_init
;                        pen=0;
	LDI  R30,LOW(0)
	STS  _pen,R30
;                        deep=1;
	LDI  R30,LOW(1)
	STS  _deep,R30
;                        BEEP();
	CALL _BEEP
;                        }
;                 if (!LEFT&&pen) {deep=1; pen=0;BEEP();}
_0xFA:
	SBIC 0x10,6
	RJMP _0xFE
	LDS  R30,_pen
	CPI  R30,0
	BRNE _0xFF
_0xFE:
	RJMP _0xFD
_0xFF:
	LDI  R30,LOW(1)
	STS  _deep,R30
	LDI  R30,LOW(0)
	STS  _pen,R30
	CALL _BEEP
;                }
_0xFD:
;        if (deep==2&&pos[1]==2)                      //  
_0xF7:
	LDS  R26,_deep
	CPI  R26,LOW(0x2)
	BRNE _0x101
	__GETB1MN _pos,1
	CPI  R30,LOW(0x2)
	BREQ _0x102
_0x101:
	RJMP _0x100
_0x102:
;                {
;                lcd_setxy(0,8);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(8)
	ST   -Y,R30
	CALL _lcd_setxy
;                lcd_wrsf("Copy",255);
	__POINTW1FN _0x0,640
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;
;                lcd_setxy(2,18);
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(18)
	ST   -Y,R30
	CALL _lcd_setxy
;                lcd_wrsf("From:",255);
	__POINTW1FN _0x0,645
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;
;                lcd_setxy(2,36);
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(36)
	ST   -Y,R30
	CALL _lcd_setxy
;                lcd_wrsf("To:",255);
	__POINTW1FN _0x0,651
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;
;                for (i=0; i<8; i++)temp[i]=Name_table[name[T[0]][i]];
	LDI  R17,LOW(0)
_0x104:
	CPI  R17,8
	BRSH _0x105
	MOV  R30,R17
	LDI  R31,0
	MOVW R26,R28
	ADIW R26,6
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	LDS  R30,_T
	LDI  R31,0
	CALL __LSLW3
	SUBI R30,LOW(-_name)
	SBCI R31,HIGH(-_name)
	MOVW R26,R30
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	CALL __EEPROMRDB
	LDI  R31,0
	SUBI R30,LOW(-_Name_table*2)
	SBCI R31,HIGH(-_Name_table*2)
	LPM  R30,Z
	MOVW R26,R0
	ST   X,R30
	SUBI R17,-1
	RJMP _0x104
_0x105:
	LDI  R30,LOW(0)
	STD  Y+14,R30
;
;                lcd_setxy(15,27);
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(27)
	ST   -Y,R30
	CALL _lcd_setxy
;
;                if (pos[2]==0)
	__GETB1MN _pos,2
	CPI  R30,0
	BRNE _0x106
;                        {
;                        if (!edit)lcd_wrs(temp,0);
	LDS  R30,_edit
	CPI  R30,0
	BRNE _0x107
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	RJMP _0x361
;                        else lcd_wrs(temp,Clip);
_0x107:
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Clip
_0x361:
	ST   -Y,R30
	CALL _lcd_wrs
;                        }
;                else    lcd_wrs(temp,255);
	RJMP _0x109
_0x106:
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrs
;
;                for (i=0; i<8; i++)temp[i]=Name_table[name[T[1]][i]];
_0x109:
	LDI  R17,LOW(0)
_0x10B:
	CPI  R17,8
	BRSH _0x10C
	MOV  R30,R17
	LDI  R31,0
	MOVW R26,R28
	ADIW R26,6
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	__GETB1MN _T,1
	LDI  R31,0
	CALL __LSLW3
	SUBI R30,LOW(-_name)
	SBCI R31,HIGH(-_name)
	MOVW R26,R30
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	CALL __EEPROMRDB
	LDI  R31,0
	SUBI R30,LOW(-_Name_table*2)
	SBCI R31,HIGH(-_Name_table*2)
	LPM  R30,Z
	MOVW R26,R0
	ST   X,R30
	SUBI R17,-1
	RJMP _0x10B
_0x10C:
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(45)
	ST   -Y,R30
	CALL _lcd_setxy
;
;                temp[8]='\0';
	LDI  R30,LOW(0)
	STD  Y+14,R30
;
;                if (pos[2]==1)
	__GETB1MN _pos,2
	CPI  R30,LOW(0x1)
	BRNE _0x10D
;                        {
;                        if (!edit)lcd_wrs(temp,0);
	LDS  R30,_edit
	CPI  R30,0
	BRNE _0x10E
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	RJMP _0x362
;                        else lcd_wrs(temp,Clip);
_0x10E:
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Clip
_0x362:
	ST   -Y,R30
	CALL _lcd_wrs
;                        }
;                else    lcd_wrs(temp,255);
	RJMP _0x110
_0x10D:
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrs
;
;                lcd_setxy(40,54);
_0x110:
	LDI  R30,LOW(40)
	ST   -Y,R30
	LDI  R30,LOW(54)
	ST   -Y,R30
	CALL _lcd_setxy
;                if (pos[2]==2)
	__GETB1MN _pos,2
	CPI  R30,LOW(0x2)
	BRNE _0x111
;                        lcd_wrsf("OK",0);
	__POINTW1FN _0x0,655
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	RJMP _0x363
;                else    lcd_wrsf("OK",255);
_0x111:
	__POINTW1FN _0x0,655
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
_0x363:
	ST   -Y,R30
	CALL _lcd_wrsf
;
;                if (!UP&&!edit&&pos[2]<2)
	SBIC 0x10,4
	RJMP _0x114
	LDS  R30,_edit
	CPI  R30,0
	BRNE _0x114
	__GETB2MN _pos,2
	CPI  R26,LOW(0x2)
	BRLO _0x115
_0x114:
	RJMP _0x113
_0x115:
;                                {
;                                pos[2]++;
	__GETB1MN _pos,2
	SUBI R30,-LOW(1)
	__PUTB1MN _pos,2
;                                BEEP();
	CALL _BEEP
;                                }
;
;                if (!DOWN&&!edit&&pos[2]>0)
_0x113:
	SBIC 0x10,5
	RJMP _0x117
	LDS  R30,_edit
	CPI  R30,0
	BRNE _0x117
	__GETB2MN _pos,2
	CPI  R26,LOW(0x1)
	BRSH _0x118
_0x117:
	RJMP _0x116
_0x118:
;                                {
;                                pos[2]--;
	__GETB1MN _pos,2
	SUBI R30,LOW(1)
	__PUTB1MN _pos,2
;                                BEEP();
	CALL _BEEP
;                                }
;
;                if (!LEFT&&pen&&!edit) {pen=0; deep=1; BEEP();}
_0x116:
	SBIC 0x10,6
	RJMP _0x11A
	LDS  R30,_pen
	CPI  R30,0
	BREQ _0x11A
	LDS  R30,_edit
	CPI  R30,0
	BREQ _0x11B
_0x11A:
	RJMP _0x119
_0x11B:
	LDI  R30,LOW(0)
	STS  _pen,R30
	LDI  R30,LOW(1)
	STS  _deep,R30
	CALL _BEEP
;                if (!LEFT&&pen&&edit) {pen=0; edit=0; BEEP();}
_0x119:
	SBIC 0x10,6
	RJMP _0x11D
	LDS  R30,_pen
	CPI  R30,0
	BREQ _0x11D
	LDS  R30,_edit
	CPI  R30,0
	BRNE _0x11E
_0x11D:
	RJMP _0x11C
_0x11E:
	LDI  R30,LOW(0)
	STS  _pen,R30
	STS  _edit,R30
	CALL _BEEP
;
;                if (!RIGHT&&pen&&!edit&&pos[2]<2) {pen=0; edit=1;BEEP();}
_0x11C:
	SBIC 0x10,7
	RJMP _0x120
	LDS  R30,_pen
	CPI  R30,0
	BREQ _0x120
	LDS  R30,_edit
	CPI  R30,0
	BRNE _0x120
	__GETB2MN _pos,2
	CPI  R26,LOW(0x2)
	BRLO _0x121
_0x120:
	RJMP _0x11F
_0x121:
	LDI  R30,LOW(0)
	STS  _pen,R30
	LDI  R30,LOW(1)
	STS  _edit,R30
	CALL _BEEP
;
;                if (!UP&&edit&&T[pos[2]]<MAX_MODELS-1)
_0x11F:
	SBIC 0x10,4
	RJMP _0x123
	LDS  R30,_edit
	CPI  R30,0
	BREQ _0x123
	__GETB1MN _pos,2
	LDI  R31,0
	SUBI R30,LOW(-_T)
	SBCI R31,HIGH(-_T)
	LD   R30,Z
	CPI  R30,LOW(0x3)
	BRLO _0x124
_0x123:
	RJMP _0x122
_0x124:
;                                {
;                                T[pos[2]]++;
	__GETB1MN _pos,2
	LDI  R31,0
	SUBI R30,LOW(-_T)
	SBCI R31,HIGH(-_T)
	MOVW R26,R30
	LD   R30,X
	SUBI R30,-LOW(1)
	ST   X,R30
;                                BEEP();
	CALL _BEEP
;                                }
;
;                if (!DOWN&&edit&&T[pos[2]]>0)
_0x122:
	SBIC 0x10,5
	RJMP _0x126
	LDS  R30,_edit
	CPI  R30,0
	BREQ _0x126
	__GETB1MN _pos,2
	LDI  R31,0
	SUBI R30,LOW(-_T)
	SBCI R31,HIGH(-_T)
	LD   R30,Z
	CPI  R30,LOW(0x1)
	BRSH _0x127
_0x126:
	RJMP _0x125
_0x127:
;                                {
;                                T[pos[2]]--;
	__GETB1MN _pos,2
	LDI  R31,0
	SUBI R30,LOW(-_T)
	SBCI R31,HIGH(-_T)
	MOVW R26,R30
	LD   R30,X
	SUBI R30,LOW(1)
	ST   X,R30
;                                BEEP();
	CALL _BEEP
;                                }
;
;                if (!RIGHT&&pen&&!edit&&pos[2]==2) {pen=0;MODEL_copy(T[0],T[1]); BEEP();deep=1;}
_0x125:
	SBIC 0x10,7
	RJMP _0x129
	LDS  R30,_pen
	CPI  R30,0
	BREQ _0x129
	LDS  R30,_edit
	CPI  R30,0
	BRNE _0x129
	__GETB1MN _pos,2
	CPI  R30,LOW(0x2)
	BREQ _0x12A
_0x129:
	RJMP _0x128
_0x12A:
	LDI  R30,LOW(0)
	STS  _pen,R30
	LDS  R30,_T
	ST   -Y,R30
	__GETB1MN _T,1
	ST   -Y,R30
	CALL _MODEL_copy
	CALL _BEEP
	LDI  R30,LOW(1)
	STS  _deep,R30
;
;                }
_0x128:
;
;        if (deep==2&&pos[1]==3)                      // 
_0x100:
	LDS  R26,_deep
	CPI  R26,LOW(0x2)
	BRNE _0x12C
	__GETB1MN _pos,1
	CPI  R30,LOW(0x3)
	BREQ _0x12D
_0x12C:
	RJMP _0x12B
_0x12D:
;                {
;                lcd_setxy(0,8);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(8)
	ST   -Y,R30
	CALL _lcd_setxy
;                lcd_wrsf("Name",255);
	__POINTW1FN _0x0,658
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;
;                for (i=0; i<8; i++)
	LDI  R17,LOW(0)
_0x12F:
	CPI  R17,8
	BRSH _0x130
;                        {
;                        lcd_setxy(i*11+5,25);
	MOV  R26,R17
	LDI  R30,LOW(11)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,-LOW(5)
	ST   -Y,R30
	LDI  R30,LOW(25)
	ST   -Y,R30
	CALL _lcd_setxy
;                        if (edit&&pos[2]==i)lcd_char(Name_table[curmodel.name[i]],Clip);
	LDS  R30,_edit
	CPI  R30,0
	BREQ _0x132
	__GETB2MN _pos,2
	CP   R17,R26
	BREQ _0x133
_0x132:
	RJMP _0x131
_0x133:
	__POINTW2MN _curmodel,2
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LD   R30,X
	LDI  R31,0
	SUBI R30,LOW(-_Name_table*2)
	SBCI R31,HIGH(-_Name_table*2)
	LPM  R30,Z
	ST   -Y,R30
	LDS  R30,_Clip
	RJMP _0x364
;                        else lcd_char(Name_table[curmodel.name[i]],255);
_0x131:
	__POINTW2MN _curmodel,2
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LD   R30,X
	LDI  R31,0
	SUBI R30,LOW(-_Name_table*2)
	SBCI R31,HIGH(-_Name_table*2)
	LPM  R30,Z
	ST   -Y,R30
	LDI  R30,LOW(255)
_0x364:
	ST   -Y,R30
	CALL _lcd_char
;                        }
	SUBI R17,-1
	RJMP _0x12F
_0x130:
;
;                lcd_rectangle(pos[2]*11+3,23,pos[2]*11+14,34,1);
	__GETB1MN _pos,2
	LDI  R26,LOW(11)
	MUL  R30,R26
	MOVW R30,R0
	MOVW R26,R30
	SUBI R30,-LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(23)
	ST   -Y,R30
	MOVW R30,R26
	SUBI R30,-LOW(14)
	ST   -Y,R30
	LDI  R30,LOW(34)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_rectangle
;
;                if (!LEFT&&pen&&!edit) {pen=0; deep=1; BEEP();}
	SBIC 0x10,6
	RJMP _0x136
	LDS  R30,_pen
	CPI  R30,0
	BREQ _0x136
	LDS  R30,_edit
	CPI  R30,0
	BREQ _0x137
_0x136:
	RJMP _0x135
_0x137:
	LDI  R30,LOW(0)
	STS  _pen,R30
	LDI  R30,LOW(1)
	STS  _deep,R30
	CALL _BEEP
;
;                if (!RIGHT&&pen&&!edit) {pen=0; edit=1;BEEP();name_init();}
_0x135:
	SBIC 0x10,7
	RJMP _0x139
	LDS  R30,_pen
	CPI  R30,0
	BREQ _0x139
	LDS  R30,_edit
	CPI  R30,0
	BREQ _0x13A
_0x139:
	RJMP _0x138
_0x13A:
	LDI  R30,LOW(0)
	STS  _pen,R30
	LDI  R30,LOW(1)
	STS  _edit,R30
	CALL _BEEP
	CALL _name_init
;
;                if (!LEFT&&pen&&edit) {pen=0; edit=0; BEEP(); name[cur_model_num][pos[2]]=curmodel.name[pos[2]];}
_0x138:
	SBIC 0x10,6
	RJMP _0x13C
	LDS  R30,_pen
	CPI  R30,0
	BREQ _0x13C
	LDS  R30,_edit
	CPI  R30,0
	BRNE _0x13D
_0x13C:
	RJMP _0x13B
_0x13D:
	LDI  R30,LOW(0)
	STS  _pen,R30
	STS  _edit,R30
	CALL _BEEP
	LDS  R30,_cur_model_num
	LDI  R31,0
	CALL __LSLW3
	SUBI R30,LOW(-_name)
	SBCI R31,HIGH(-_name)
	MOVW R26,R30
	__GETB1MN _pos,2
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	__POINTW2MN _curmodel,2
	__GETB1MN _pos,2
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	MOVW R26,R0
	CALL __EEPROMWRB
;
;
;                if (!DOWN&&!edit&&pos[2]<7)
_0x13B:
	SBIC 0x10,5
	RJMP _0x13F
	LDS  R30,_edit
	CPI  R30,0
	BRNE _0x13F
	__GETB2MN _pos,2
	CPI  R26,LOW(0x7)
	BRLO _0x140
_0x13F:
	RJMP _0x13E
_0x140:
;                                {
;                                pos[2]++;
	__GETB1MN _pos,2
	SUBI R30,-LOW(1)
	__PUTB1MN _pos,2
;                                BEEP();
	CALL _BEEP
;                                }
;
;                if (!UP&&!edit&&pos[2]>0)
_0x13E:
	SBIC 0x10,4
	RJMP _0x142
	LDS  R30,_edit
	CPI  R30,0
	BRNE _0x142
	__GETB2MN _pos,2
	CPI  R26,LOW(0x1)
	BRSH _0x143
_0x142:
	RJMP _0x141
_0x143:
;                                {
;                                pos[2]--;
	__GETB1MN _pos,2
	SUBI R30,LOW(1)
	__PUTB1MN _pos,2
;                                BEEP();
	CALL _BEEP
;                                }
;
;                if (!DOWN&&edit&&curmodel.name[pos[2]]<64)
_0x141:
	SBIC 0x10,5
	RJMP _0x145
	LDS  R30,_edit
	CPI  R30,0
	BREQ _0x145
	__POINTW2MN _curmodel,2
	__GETB1MN _pos,2
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	LD   R26,X
	CPI  R26,LOW(0x40)
	BRLT _0x146
_0x145:
	RJMP _0x144
_0x146:
;                                {
;                                curmodel.name[pos[2]]++;
	__POINTW2MN _curmodel,2
	__GETB1MN _pos,2
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	SUBI R30,-LOW(1)
	ST   X,R30
;                                BEEP1();
	CALL _BEEP1
;                                }
;
;                if (!UP&&edit&&curmodel.name[pos[2]]>0)
_0x144:
	SBIC 0x10,4
	RJMP _0x148
	LDS  R30,_edit
	CPI  R30,0
	BREQ _0x148
	__POINTW2MN _curmodel,2
	__GETB1MN _pos,2
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	LD   R26,X
	CPI  R26,LOW(0x1)
	BRGE _0x149
_0x148:
	RJMP _0x147
_0x149:
;                                {
;                                curmodel.name[pos[2]]--;
	__POINTW2MN _curmodel,2
	__GETB1MN _pos,2
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	SUBI R30,LOW(1)
	ST   X,R30
;                                BEEP1();
	CALL _BEEP1
;                                }
;
;
;
;                }
_0x147:
;
;                 if (deep==2&&pos[1]==4)                      //  
_0x12B:
	LDS  R26,_deep
	CPI  R26,LOW(0x2)
	BRNE _0x14B
	__GETB1MN _pos,1
	CPI  R30,LOW(0x4)
	BREQ _0x14C
_0x14B:
	RJMP _0x14A
_0x14C:
;                {
;
;                lcd_setxy(0,8);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(8)
	ST   -Y,R30
	CALL _lcd_setxy
;                lcd_wrsf("Type",255);
	__POINTW1FN _0x0,663
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;
;                lcd_setxy(5,25);
	LDI  R30,LOW(5)
	ST   -Y,R30
	LDI  R30,LOW(25)
	ST   -Y,R30
	CALL _lcd_setxy
;                lcd_wrsf(menuT6[curmodel.type],255);
	__GETB1MN _curmodel,11
	LDI  R26,LOW(_menuT6)
	LDI  R27,HIGH(_menuT6)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;
;                if (!UP&&curmodel.type<1)
	SBIC 0x10,4
	RJMP _0x14E
	__GETB2MN _curmodel,11
	CPI  R26,LOW(0x1)
	BRLT _0x14F
_0x14E:
	RJMP _0x14D
_0x14F:
;                                {
;                                curmodel.type++;
	__GETB1MN _curmodel,11
	SUBI R30,-LOW(1)
	__PUTB1MN _curmodel,11
	SUBI R30,LOW(1)
;                                 BEEP1();
	CALL _BEEP1
;                                }
;
;                if (!DOWN&&curmodel.type>0)
_0x14D:
	SBIC 0x10,5
	RJMP _0x151
	__GETB2MN _curmodel,11
	CPI  R26,LOW(0x1)
	BRGE _0x152
_0x151:
	RJMP _0x150
_0x152:
;                                {
;                                curmodel.type--;
	__GETB1MN _curmodel,11
	SUBI R30,LOW(1)
	__PUTB1MN _curmodel,11
	SUBI R30,-LOW(1)
;                                 BEEP1();
	CALL _BEEP1
;                                }
;
;
;                if (!LEFT&&pen) {pen=0; deep=1; BEEP(); type[cur_model_num]=curmodel.type; BEEP();}
_0x150:
	SBIC 0x10,6
	RJMP _0x154
	LDS  R30,_pen
	CPI  R30,0
	BRNE _0x155
_0x154:
	RJMP _0x153
_0x155:
	LDI  R30,LOW(0)
	STS  _pen,R30
	LDI  R30,LOW(1)
	STS  _deep,R30
	CALL _BEEP
	LDS  R26,_cur_model_num
	LDI  R27,0
	SUBI R26,LOW(-_type)
	SBCI R27,HIGH(-_type)
	__GETB1MN _curmodel,11
	CALL __EEPROMWRB
	CALL _BEEP
;
;                }
_0x153:
;
;                if (deep==2&&pos[1]==5)                      //  
_0x14A:
	LDS  R26,_deep
	CPI  R26,LOW(0x2)
	BRNE _0x157
	__GETB1MN _pos,1
	CPI  R30,LOW(0x5)
	BREQ _0x158
_0x157:
	RJMP _0x156
_0x158:
;                {
;                lcd_setxy(0,8);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(8)
	ST   -Y,R30
	CALL _lcd_setxy
;                lcd_wrsf("Copy MODE",255);
	__POINTW1FN _0x0,668
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;
;                lcd_setxy(2,18);
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(18)
	ST   -Y,R30
	CALL _lcd_setxy
;                lcd_wrsf("From:",255);
	__POINTW1FN _0x0,645
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;
;                lcd_setxy(2,36);
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(36)
	ST   -Y,R30
	CALL _lcd_setxy
;                lcd_wrsf("To:",255);
	__POINTW1FN _0x0,651
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;
;                for (i=0; i<8; i++)temp[i]=modeNames[curmodel.type][T[0]][i];
	LDI  R17,LOW(0)
_0x15A:
	CPI  R17,8
	BRSH _0x15B
	MOV  R30,R17
	LDI  R31,0
	MOVW R24,R30
	MOVW R26,R28
	ADIW R26,6
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	__GETB1MN _curmodel,11
	LDI  R26,LOW(6)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_modeNames)
	SBCI R31,HIGH(-_modeNames)
	MOVW R26,R30
	LDS  R30,_T
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ADD  R30,R24
	ADC  R31,R25
	LPM  R30,Z
	MOVW R26,R22
	ST   X,R30
	SUBI R17,-1
	RJMP _0x15A
_0x15B:
	LDI  R30,LOW(0)
	STD  Y+14,R30
;
;                lcd_setxy(15,27);
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(27)
	ST   -Y,R30
	CALL _lcd_setxy
;
;                if (pos[2]==0)
	__GETB1MN _pos,2
	CPI  R30,0
	BRNE _0x15C
;                        {
;                        if (!edit)lcd_wrs(temp,0);
	LDS  R30,_edit
	CPI  R30,0
	BRNE _0x15D
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	RJMP _0x365
;                        else lcd_wrs(temp,Clip);
_0x15D:
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Clip
_0x365:
	ST   -Y,R30
	CALL _lcd_wrs
;                        }
;                else    lcd_wrs(temp,255);
	RJMP _0x15F
_0x15C:
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrs
;
;                for (i=0; i<8; i++)temp[i]=modeNames[curmodel.type][T[1]][i];
_0x15F:
	LDI  R17,LOW(0)
_0x161:
	CPI  R17,8
	BRSH _0x162
	MOV  R30,R17
	LDI  R31,0
	MOVW R24,R30
	MOVW R26,R28
	ADIW R26,6
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	__GETB1MN _curmodel,11
	LDI  R26,LOW(6)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_modeNames)
	SBCI R31,HIGH(-_modeNames)
	MOVW R26,R30
	__GETB1MN _T,1
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ADD  R30,R24
	ADC  R31,R25
	LPM  R30,Z
	MOVW R26,R22
	ST   X,R30
	SUBI R17,-1
	RJMP _0x161
_0x162:
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(45)
	ST   -Y,R30
	CALL _lcd_setxy
;
;                temp[8]='\0';
	LDI  R30,LOW(0)
	STD  Y+14,R30
;
;                if (pos[2]==1)
	__GETB1MN _pos,2
	CPI  R30,LOW(0x1)
	BRNE _0x163
;                        {
;                        if (!edit)lcd_wrs(temp,0);
	LDS  R30,_edit
	CPI  R30,0
	BRNE _0x164
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	RJMP _0x366
;                        else lcd_wrs(temp,Clip);
_0x164:
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Clip
_0x366:
	ST   -Y,R30
	CALL _lcd_wrs
;                        }
;                else    lcd_wrs(temp,255);
	RJMP _0x166
_0x163:
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrs
;
;                lcd_setxy(40,54);
_0x166:
	LDI  R30,LOW(40)
	ST   -Y,R30
	LDI  R30,LOW(54)
	ST   -Y,R30
	CALL _lcd_setxy
;                if (pos[2]==2)
	__GETB1MN _pos,2
	CPI  R30,LOW(0x2)
	BRNE _0x167
;                        lcd_wrsf("OK",0);
	__POINTW1FN _0x0,655
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	RJMP _0x367
;                else    lcd_wrsf("OK",255);
_0x167:
	__POINTW1FN _0x0,655
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
_0x367:
	ST   -Y,R30
	CALL _lcd_wrsf
;
;                if (!UP&&!edit&&pos[2]<2)
	SBIC 0x10,4
	RJMP _0x16A
	LDS  R30,_edit
	CPI  R30,0
	BRNE _0x16A
	__GETB2MN _pos,2
	CPI  R26,LOW(0x2)
	BRLO _0x16B
_0x16A:
	RJMP _0x169
_0x16B:
;                                {
;                                pos[2]++;
	__GETB1MN _pos,2
	SUBI R30,-LOW(1)
	__PUTB1MN _pos,2
;                                BEEP();
	CALL _BEEP
;                                }
;
;                if (!DOWN&&!edit&&pos[2]>0)
_0x169:
	SBIC 0x10,5
	RJMP _0x16D
	LDS  R30,_edit
	CPI  R30,0
	BRNE _0x16D
	__GETB2MN _pos,2
	CPI  R26,LOW(0x1)
	BRSH _0x16E
_0x16D:
	RJMP _0x16C
_0x16E:
;                                {
;                                pos[2]--;
	__GETB1MN _pos,2
	SUBI R30,LOW(1)
	__PUTB1MN _pos,2
;                                BEEP();
	CALL _BEEP
;                                }
;
;                if (!LEFT&&pen&&!edit) {pen=0; deep=1; BEEP();}
_0x16C:
	SBIC 0x10,6
	RJMP _0x170
	LDS  R30,_pen
	CPI  R30,0
	BREQ _0x170
	LDS  R30,_edit
	CPI  R30,0
	BREQ _0x171
_0x170:
	RJMP _0x16F
_0x171:
	LDI  R30,LOW(0)
	STS  _pen,R30
	LDI  R30,LOW(1)
	STS  _deep,R30
	CALL _BEEP
;                if (!LEFT&&pen&&edit) {pen=0; edit=0; BEEP();}
_0x16F:
	SBIC 0x10,6
	RJMP _0x173
	LDS  R30,_pen
	CPI  R30,0
	BREQ _0x173
	LDS  R30,_edit
	CPI  R30,0
	BRNE _0x174
_0x173:
	RJMP _0x172
_0x174:
	LDI  R30,LOW(0)
	STS  _pen,R30
	STS  _edit,R30
	CALL _BEEP
;
;                if (!RIGHT&&pen&&!edit&&pos[2]<2) {pen=0; edit=1;BEEP();}
_0x172:
	SBIC 0x10,7
	RJMP _0x176
	LDS  R30,_pen
	CPI  R30,0
	BREQ _0x176
	LDS  R30,_edit
	CPI  R30,0
	BRNE _0x176
	__GETB2MN _pos,2
	CPI  R26,LOW(0x2)
	BRLO _0x177
_0x176:
	RJMP _0x175
_0x177:
	LDI  R30,LOW(0)
	STS  _pen,R30
	LDI  R30,LOW(1)
	STS  _edit,R30
	CALL _BEEP
;
;                if (!UP&&edit&&T[pos[2]]<2)
_0x175:
	SBIC 0x10,4
	RJMP _0x179
	LDS  R30,_edit
	CPI  R30,0
	BREQ _0x179
	__GETB1MN _pos,2
	LDI  R31,0
	SUBI R30,LOW(-_T)
	SBCI R31,HIGH(-_T)
	LD   R30,Z
	CPI  R30,LOW(0x2)
	BRLO _0x17A
_0x179:
	RJMP _0x178
_0x17A:
;                                {
;                                T[pos[2]]++;
	__GETB1MN _pos,2
	LDI  R31,0
	SUBI R30,LOW(-_T)
	SBCI R31,HIGH(-_T)
	MOVW R26,R30
	LD   R30,X
	SUBI R30,-LOW(1)
	ST   X,R30
;                                BEEP();
	CALL _BEEP
;                                }
;
;                if (!DOWN&&edit&&T[pos[2]]>0)
_0x178:
	SBIC 0x10,5
	RJMP _0x17C
	LDS  R30,_edit
	CPI  R30,0
	BREQ _0x17C
	__GETB1MN _pos,2
	LDI  R31,0
	SUBI R30,LOW(-_T)
	SBCI R31,HIGH(-_T)
	LD   R30,Z
	CPI  R30,LOW(0x1)
	BRSH _0x17D
_0x17C:
	RJMP _0x17B
_0x17D:
;                                {
;                                T[pos[2]]--;
	__GETB1MN _pos,2
	LDI  R31,0
	SUBI R30,LOW(-_T)
	SBCI R31,HIGH(-_T)
	MOVW R26,R30
	LD   R30,X
	SUBI R30,LOW(1)
	ST   X,R30
;                                BEEP();
	CALL _BEEP
;                                }
;
;                if (!RIGHT&&pen&&!edit&&pos[2]==2) {pen=0;MODE_copy(T[0],T[1]);MODEL_init(); BEEP();deep=1;}
_0x17B:
	SBIC 0x10,7
	RJMP _0x17F
	LDS  R30,_pen
	CPI  R30,0
	BREQ _0x17F
	LDS  R30,_edit
	CPI  R30,0
	BRNE _0x17F
	__GETB1MN _pos,2
	CPI  R30,LOW(0x2)
	BREQ _0x180
_0x17F:
	RJMP _0x17E
_0x180:
	LDI  R30,LOW(0)
	STS  _pen,R30
	LDS  R30,_T
	ST   -Y,R30
	__GETB1MN _T,1
	ST   -Y,R30
	CALL _MODE_copy
	CALL _MODEL_init
	CALL _BEEP
	LDI  R30,LOW(1)
	STS  _deep,R30
;
;                }
_0x17E:
;
;
;              if (deep==2&&pos[1]==6)                      // 
_0x156:
	LDS  R26,_deep
	CPI  R26,LOW(0x2)
	BRNE _0x182
	__GETB1MN _pos,1
	CPI  R30,LOW(0x6)
	BREQ _0x183
_0x182:
	RJMP _0x181
_0x183:
;                {
;                 lcd_setxy(0,8);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(8)
	ST   -Y,R30
	CALL _lcd_setxy
;                lcd_wrsf("Modulation",255);
	__POINTW1FN _0x0,678
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;
;                if (!UP&&curmodel.modulation<1)
	SBIC 0x10,4
	RJMP _0x185
	__GETB2MN _curmodel,12
	CPI  R26,LOW(0x1)
	BRLT _0x186
_0x185:
	RJMP _0x184
_0x186:
;                                {
;                                curmodel.modulation++;
	__GETB1MN _curmodel,12
	SUBI R30,-LOW(1)
	__PUTB1MN _curmodel,12
	SUBI R30,LOW(1)
;                                BEEP();
	CALL _BEEP
;
;                                if (curmodel.modulation==0) TCCR1A=0x82;
	__GETB1MN _curmodel,12
	CPI  R30,0
	BRNE _0x187
	LDI  R30,LOW(130)
	OUT  0x2F,R30
;                                if (curmodel.modulation==1) TCCR1A=0xC2;
_0x187:
	__GETB2MN _curmodel,12
	CPI  R26,LOW(0x1)
	BRNE _0x188
	LDI  R30,LOW(194)
	OUT  0x2F,R30
;                                }
_0x188:
;
;                if (!DOWN&&curmodel.modulation>0)
_0x184:
	SBIC 0x10,5
	RJMP _0x18A
	__GETB2MN _curmodel,12
	CPI  R26,LOW(0x1)
	BRGE _0x18B
_0x18A:
	RJMP _0x189
_0x18B:
;                                {
;                                curmodel.modulation--;
	__GETB1MN _curmodel,12
	SUBI R30,LOW(1)
	__PUTB1MN _curmodel,12
	SUBI R30,-LOW(1)
;                                BEEP();
	CALL _BEEP
;                                if (curmodel.modulation==0) TCCR1A=0x82;
	__GETB1MN _curmodel,12
	CPI  R30,0
	BRNE _0x18C
	LDI  R30,LOW(130)
	OUT  0x2F,R30
;                                if (curmodel.modulation==1) TCCR1A=0xC2;
_0x18C:
	__GETB2MN _curmodel,12
	CPI  R26,LOW(0x1)
	BRNE _0x18D
	LDI  R30,LOW(194)
	OUT  0x2F,R30
;                                }
_0x18D:
;
;
;                 if (!LEFT&&pen) {deep=1; modulation[cur_model_num]=curmodel.modulation; BEEP();}
_0x189:
	SBIC 0x10,6
	RJMP _0x18F
	LDS  R30,_pen
	CPI  R30,0
	BRNE _0x190
_0x18F:
	RJMP _0x18E
_0x190:
	LDI  R30,LOW(1)
	STS  _deep,R30
	LDS  R26,_cur_model_num
	LDI  R27,0
	SUBI R26,LOW(-_modulation)
	SBCI R27,HIGH(-_modulation)
	__GETB1MN _curmodel,12
	CALL __EEPROMWRB
	CALL _BEEP
;
;
;                lcd_setxy(15,25);
_0x18E:
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(25)
	ST   -Y,R30
	CALL _lcd_setxy
;                lcd_wrsf(modulNames[curmodel.modulation],255);
	__GETB1MN _curmodel,12
	LDI  R26,LOW(_modulNames)
	LDI  R27,HIGH(_modulNames)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;
;
;
;
;                 }
;
;
;         if (deep==2&&pos[1]==7)                      //      ===========================================================
_0x181:
	LDS  R26,_deep
	CPI  R26,LOW(0x2)
	BRNE _0x192
	__GETB1MN _pos,1
	CPI  R30,LOW(0x7)
	BREQ _0x193
_0x192:
	RJMP _0x191
_0x193:
;                {
;                lcd_setxy(0,8);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(8)
	ST   -Y,R30
	CALL _lcd_setxy
;                lcd_wrsf("MAX CH",255);
	__POINTW1FN _0x0,689
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;
;                if (!DOWN&&curmodel.num_ch<8)
	SBIC 0x10,5
	RJMP _0x195
	__GETB2MN _curmodel,32
	CPI  R26,LOW(0x8)
	BRLT _0x196
_0x195:
	RJMP _0x194
_0x196:
;                                {
;                                curmodel.num_ch++;
	__GETB1MN _curmodel,32
	SUBI R30,-LOW(1)
	__PUTB1MN _curmodel,32
	SUBI R30,LOW(1)
;                                BEEP();
	CALL _BEEP
;
;
;                                }
;
;                if (!UP&&curmodel.num_ch>2)
_0x194:
	SBIC 0x10,4
	RJMP _0x198
	__GETB2MN _curmodel,32
	CPI  R26,LOW(0x3)
	BRGE _0x199
_0x198:
	RJMP _0x197
_0x199:
;                                {
;                                curmodel.num_ch--;
	__GETB1MN _curmodel,32
	SUBI R30,LOW(1)
	__PUTB1MN _curmodel,32
	SUBI R30,-LOW(1)
;                                BEEP();
	CALL _BEEP
;
;                                }
;
;
;                 if (!LEFT&&pen) {deep=1; num_ch[cur_model_num]=curmodel.num_ch; BEEP(); pen=0;}
_0x197:
	SBIC 0x10,6
	RJMP _0x19B
	LDS  R30,_pen
	CPI  R30,0
	BRNE _0x19C
_0x19B:
	RJMP _0x19A
_0x19C:
	LDI  R30,LOW(1)
	STS  _deep,R30
	LDS  R26,_cur_model_num
	LDI  R27,0
	SUBI R26,LOW(-_num_ch)
	SBCI R27,HIGH(-_num_ch)
	__GETB1MN _curmodel,32
	CALL __EEPROMWRB
	CALL _BEEP
	LDI  R30,LOW(0)
	STS  _pen,R30
;
;
;                lcd_setxy(15,25);
_0x19A:
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(25)
	ST   -Y,R30
	CALL _lcd_setxy
;                lcd_deg12x16(curmodel.num_ch,255);
	__GETB1MN _curmodel,32
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_deg12x16
;
;
;
;
;                }
;
;
;
;
;
;
;        }
_0x191:
;
;        if (pos[0]==1)
_0xDA:
	LDS  R26,_pos
	CPI  R26,LOW(0x1)
	BREQ PC+3
	JMP _0x19D
;        {       if (deep==1){                                                         //      CONTROLS
	LDS  R26,_deep
	CPI  R26,LOW(0x1)
	BREQ PC+3
	JMP _0x19E
;                        if (!UP&&pos[1]<menuT2L-1)
	SBIC 0x10,4
	RJMP _0x1A0
	__GETB2MN _pos,1
	LDI  R30,LOW(_menuT2L*2)
	LDI  R31,HIGH(_menuT2L*2)
	LPM  R30,Z
	SUBI R30,LOW(1)
	LDI  R27,0
	LDI  R31,0
	SBRC R30,7
	SER  R31
	CP   R26,R30
	CPC  R27,R31
	BRLT _0x1A1
_0x1A0:
	RJMP _0x19F
_0x1A1:
;                                {pos[1]++;
	__GETB1MN _pos,1
	SUBI R30,-LOW(1)
	__PUTB1MN _pos,1
;                                BEEP();
	CALL _BEEP
;                                }
;
;                        if (!DOWN&&pos[1]>0)
_0x19F:
	SBIC 0x10,5
	RJMP _0x1A3
	__GETB2MN _pos,1
	CPI  R26,LOW(0x1)
	BRSH _0x1A4
_0x1A3:
	RJMP _0x1A2
_0x1A4:
;                                {pos[1]--;
	__GETB1MN _pos,1
	SUBI R30,LOW(1)
	__PUTB1MN _pos,1
;                                 BEEP();
	CALL _BEEP
;                                 }
;                        if (!LEFT&&pen) {deep=0; pen=0;BEEP();}
_0x1A2:
	SBIC 0x10,6
	RJMP _0x1A6
	LDS  R30,_pen
	CPI  R30,0
	BRNE _0x1A7
_0x1A6:
	RJMP _0x1A5
_0x1A7:
	LDI  R30,LOW(0)
	STS  _deep,R30
	STS  _pen,R30
	CALL _BEEP
;                        if (!RIGHT&&pen)
_0x1A5:
	SBIC 0x10,7
	RJMP _0x1A9
	LDS  R30,_pen
	CPI  R30,0
	BRNE _0x1AA
_0x1A9:
	RJMP _0x1A8
_0x1AA:
;                                {
;                                deep=2;
	LDI  R30,LOW(2)
	STS  _deep,R30
;                                pos[2]=0;
	LDI  R30,LOW(0)
	__PUTB1MN _pos,2
;                                edit=0;
	STS  _edit,R30
;                                pen=0;
	STS  _pen,R30
;
;                                BEEP();
	CALL _BEEP
;                                }
;
;
;
;                        lcd_setxy(0,8);
_0x1A8:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(8)
	ST   -Y,R30
	CALL _lcd_setxy
;                        lcd_wrsf("Controls",255);
	__POINTW1FN _0x0,696
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;
;                        menu_item( menuT2 ,menuT2L,pos[1]);
	LDI  R30,LOW(_menuT2)
	LDI  R31,HIGH(_menuT2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_menuT2L*2)
	LDI  R31,HIGH(_menuT2L*2)
	LPM  R30,Z
	ST   -Y,R30
	__GETB1MN _pos,1
	ST   -Y,R30
	CALL _menu_item
;
;               }
;                if (deep==2)                                       // CONtrols
_0x19E:
	LDS  R26,_deep
	CPI  R26,LOW(0x2)
	BREQ PC+3
	JMP _0x1AB
;                        {
;                        if (pos[1]<2||pos[1]==3) max=6;
	__GETB2MN _pos,1
	CPI  R26,LOW(0x2)
	BRLO _0x1AD
	__GETB1MN _pos,1
	CPI  R30,LOW(0x3)
	BRNE _0x1AC
_0x1AD:
	LDI  R19,LOW(6)
;                        if (pos[1]>4&&pos[1]<8) max=4;
_0x1AC:
	__GETB2MN _pos,1
	CPI  R26,LOW(0x5)
	BRLO _0x1B0
	__GETB2MN _pos,1
	CPI  R26,LOW(0x8)
	BRLO _0x1B1
_0x1B0:
	RJMP _0x1AF
_0x1B1:
	LDI  R19,LOW(4)
;                        if (pos[1]>7||pos[1]==2) max=5;
_0x1AF:
	__GETB2MN _pos,1
	CPI  R26,LOW(0x8)
	BRSH _0x1B3
	__GETB1MN _pos,1
	CPI  R30,LOW(0x2)
	BRNE _0x1B2
_0x1B3:
	LDI  R19,LOW(5)
;
;                        if (!UP&&(pos[2]<max-1)&&!edit)
_0x1B2:
	SBIC 0x10,4
	RJMP _0x1B6
	__GETB2MN _pos,2
	MOV  R30,R19
	SUBI R30,LOW(1)
	CP   R26,R30
	BRSH _0x1B6
	LDS  R30,_edit
	CPI  R30,0
	BREQ _0x1B7
_0x1B6:
	RJMP _0x1B5
_0x1B7:
;                                {
;                                pos[2]++;
	__GETB1MN _pos,2
	SUBI R30,-LOW(1)
	__PUTB1MN _pos,2
	SUBI R30,LOW(1)
;                                if  (pos[1]>3&&pos[1]<7&&pos[2]==1) pos[2]++;
	__GETB2MN _pos,1
	CPI  R26,LOW(0x4)
	BRLO _0x1B9
	__GETB2MN _pos,1
	CPI  R26,LOW(0x7)
	BRSH _0x1B9
	__GETB1MN _pos,2
	CPI  R30,LOW(0x1)
	BREQ _0x1BA
_0x1B9:
	RJMP _0x1B8
_0x1BA:
	__GETB1MN _pos,2
	SUBI R30,-LOW(1)
	__PUTB1MN _pos,2
;                                BEEP();
_0x1B8:
	CALL _BEEP
;                                }
;
;                        if (!DOWN&&(pos[2]>0)&&!edit)
_0x1B5:
	SBIC 0x10,5
	RJMP _0x1BC
	__GETB2MN _pos,2
	CPI  R26,LOW(0x1)
	BRLO _0x1BC
	LDS  R30,_edit
	CPI  R30,0
	BREQ _0x1BD
_0x1BC:
	RJMP _0x1BB
_0x1BD:
;                                {pos[2]--;
	__GETB1MN _pos,2
	SUBI R30,LOW(1)
	__PUTB1MN _pos,2
;                                if  (pos[1]>3&&pos[1]<7&&pos[2]==1) pos[2]--;
	__GETB2MN _pos,1
	CPI  R26,LOW(0x4)
	BRLO _0x1BF
	__GETB2MN _pos,1
	CPI  R26,LOW(0x7)
	BRSH _0x1BF
	__GETB1MN _pos,2
	CPI  R30,LOW(0x1)
	BREQ _0x1C0
_0x1BF:
	RJMP _0x1BE
_0x1C0:
	__GETB1MN _pos,2
	SUBI R30,LOW(1)
	__PUTB1MN _pos,2
;                                BEEP();
_0x1BE:
	CALL _BEEP
;                                }
;
;                        if (!LEFT&&pen&&!edit) {deep=1; pen=0;BEEP();}
_0x1BB:
	SBIC 0x10,6
	RJMP _0x1C2
	LDS  R30,_pen
	CPI  R30,0
	BREQ _0x1C2
	LDS  R30,_edit
	CPI  R30,0
	BREQ _0x1C3
_0x1C2:
	RJMP _0x1C1
_0x1C3:
	LDI  R30,LOW(1)
	STS  _deep,R30
	LDI  R30,LOW(0)
	STS  _pen,R30
	CALL _BEEP
;                        if (!LEFT&&pen&&edit&&!curve_ed_enable) {edit=0; pen=0;SAVE_CH(cur_model_num,pos[1],pos[2]);     }
_0x1C1:
	SBIC 0x10,6
	RJMP _0x1C5
	LDS  R30,_pen
	CPI  R30,0
	BREQ _0x1C5
	LDS  R30,_edit
	CPI  R30,0
	BREQ _0x1C5
	LDS  R30,_curve_ed_enable
	CPI  R30,0
	BREQ _0x1C6
_0x1C5:
	RJMP _0x1C4
_0x1C6:
	LDI  R30,LOW(0)
	STS  _edit,R30
	STS  _pen,R30
	LDS  R30,_cur_model_num
	ST   -Y,R30
	__GETB1MN _pos,1
	ST   -Y,R30
	__GETB1MN _pos,2
	ST   -Y,R30
	CALL _SAVE_CH
;
;                        if (!RIGHT&&pen&&!edit&&pos[2]!=1) {edit=1; pen=0;BEEP(); }
_0x1C4:
	SBIC 0x10,7
	RJMP _0x1C8
	LDS  R30,_pen
	CPI  R30,0
	BREQ _0x1C8
	LDS  R30,_edit
	CPI  R30,0
	BRNE _0x1C8
	__GETB1MN _pos,2
	CPI  R30,LOW(0x1)
	BRNE _0x1C9
_0x1C8:
	RJMP _0x1C7
_0x1C9:
	LDI  R30,LOW(1)
	STS  _edit,R30
	LDI  R30,LOW(0)
	STS  _pen,R30
	CALL _BEEP
;
;
;
;                        if (pos[2]==0&&!UP&&edit) contr[pos[1]].reverse[FLY_MODE]=-1;
_0x1C7:
	__GETB1MN _pos,2
	CPI  R30,0
	BRNE _0x1CB
	SBIC 0x10,4
	RJMP _0x1CB
	LDS  R30,_edit
	CPI  R30,0
	BRNE _0x1CC
_0x1CB:
	RJMP _0x1CA
_0x1CC:
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_contr)
	SBCI R31,HIGH(-_contr)
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LDI  R30,LOW(255)
	ST   X,R30
;                         if (pos[2]==0&&!DOWN&&edit) contr[pos[1]].reverse[FLY_MODE]=1;
_0x1CA:
	__GETB1MN _pos,2
	CPI  R30,0
	BRNE _0x1CE
	SBIC 0x10,5
	RJMP _0x1CE
	LDS  R30,_edit
	CPI  R30,0
	BRNE _0x1CF
_0x1CE:
	RJMP _0x1CD
_0x1CF:
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_contr)
	SBCI R31,HIGH(-_contr)
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LDI  R30,LOW(1)
	ST   X,R30
;
;                           if (pos[2]==2&&!DOWN&&edit&&contr[pos[1]].minRates[FLY_MODE]<150)    {contr[pos[1]].minRates[FLY_MODE]+=2;  BEEP1();}
_0x1CD:
	__GETB1MN _pos,2
	CPI  R30,LOW(0x2)
	BRNE _0x1D1
	SBIC 0x10,5
	RJMP _0x1D1
	LDS  R30,_edit
	CPI  R30,0
	BREQ _0x1D1
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,8
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R26,X
	CPI  R26,LOW(0x96)
	BRLO _0x1D2
_0x1D1:
	RJMP _0x1D0
_0x1D2:
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,8
	MOVW R26,R30
	MOV  R30,R7
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R26,R30
	LD   R30,X
	SUBI R30,-LOW(2)
	ST   X,R30
	CALL _BEEP1
;                         if (pos[2]==2&&!UP&&edit&&contr[pos[1]].minRates[FLY_MODE]>0)          {contr[pos[1]].minRates[FLY_MODE]-=2;  BEEP1();}
_0x1D0:
	__GETB1MN _pos,2
	CPI  R30,LOW(0x2)
	BRNE _0x1D4
	SBIC 0x10,4
	RJMP _0x1D4
	LDS  R30,_edit
	CPI  R30,0
	BREQ _0x1D4
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,8
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R26,X
	CPI  R26,LOW(0x1)
	BRSH _0x1D5
_0x1D4:
	RJMP _0x1D3
_0x1D5:
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,8
	MOVW R26,R30
	MOV  R30,R7
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R26,R30
	LD   R30,X
	SUBI R30,LOW(2)
	ST   X,R30
	CALL _BEEP1
;
;                          if (pos[2]==3&&!DOWN&&edit&&contr[pos[1]].maxRates[FLY_MODE]<150)     {contr[pos[1]].maxRates[FLY_MODE]+=2;  BEEP1();}
_0x1D3:
	__GETB1MN _pos,2
	CPI  R30,LOW(0x3)
	BRNE _0x1D7
	SBIC 0x10,5
	RJMP _0x1D7
	LDS  R30,_edit
	CPI  R30,0
	BREQ _0x1D7
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,4
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R26,X
	CPI  R26,LOW(0x96)
	BRLO _0x1D8
_0x1D7:
	RJMP _0x1D6
_0x1D8:
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,4
	MOVW R26,R30
	MOV  R30,R7
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R26,R30
	LD   R30,X
	SUBI R30,-LOW(2)
	ST   X,R30
	CALL _BEEP1
;                         if (pos[2]==3&&!UP&&edit&&contr[pos[1]].maxRates[FLY_MODE]>0)          {contr[pos[1]].maxRates[FLY_MODE]-=2;  BEEP1();}
_0x1D6:
	__GETB1MN _pos,2
	CPI  R30,LOW(0x3)
	BRNE _0x1DA
	SBIC 0x10,4
	RJMP _0x1DA
	LDS  R30,_edit
	CPI  R30,0
	BREQ _0x1DA
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,4
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R26,X
	CPI  R26,LOW(0x1)
	BRSH _0x1DB
_0x1DA:
	RJMP _0x1D9
_0x1DB:
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,4
	MOVW R26,R30
	MOV  R30,R7
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R26,R30
	LD   R30,X
	SUBI R30,LOW(2)
	ST   X,R30
	CALL _BEEP1
;
;
;                        if (pos[1]<4&&pos[1]!=2)
_0x1D9:
	__GETB2MN _pos,1
	CPI  R26,LOW(0x4)
	BRSH _0x1DD
	__GETB1MN _pos,1
	CPI  R30,LOW(0x2)
	BRNE _0x1DE
_0x1DD:
	RJMP _0x1DC
_0x1DE:
;                                {
;                                if (pos[2]==4&&!DOWN&&edit&&contr[pos[1]].minDRates[FLY_MODE]<150)     { contr[pos[1]].minDRates[FLY_MODE]+=2; BEEP1();}
	__GETB1MN _pos,2
	CPI  R30,LOW(0x4)
	BRNE _0x1E0
	SBIC 0x10,5
	RJMP _0x1E0
	LDS  R30,_edit
	CPI  R30,0
	BREQ _0x1E0
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,16
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R26,X
	CPI  R26,LOW(0x96)
	BRLO _0x1E1
_0x1E0:
	RJMP _0x1DF
_0x1E1:
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,16
	MOVW R26,R30
	MOV  R30,R7
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R26,R30
	LD   R30,X
	SUBI R30,-LOW(2)
	ST   X,R30
	CALL _BEEP1
;                                if (pos[2]==4&&!UP&&edit&&contr[pos[1]].minDRates[FLY_MODE]>0)         { contr[pos[1]].minDRates[FLY_MODE]-=2; BEEP1();}
_0x1DF:
	__GETB1MN _pos,2
	CPI  R30,LOW(0x4)
	BRNE _0x1E3
	SBIC 0x10,4
	RJMP _0x1E3
	LDS  R30,_edit
	CPI  R30,0
	BREQ _0x1E3
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,16
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R26,X
	CPI  R26,LOW(0x1)
	BRSH _0x1E4
_0x1E3:
	RJMP _0x1E2
_0x1E4:
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,16
	MOVW R26,R30
	MOV  R30,R7
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R26,R30
	LD   R30,X
	SUBI R30,LOW(2)
	ST   X,R30
	CALL _BEEP1
;
;                                if (pos[2]==5&&!DOWN&&edit&&contr[pos[1]].maxDRates[FLY_MODE]<150)     { contr[pos[1]].maxDRates[FLY_MODE]+=2; BEEP1();}
_0x1E2:
	__GETB1MN _pos,2
	CPI  R30,LOW(0x5)
	BRNE _0x1E6
	SBIC 0x10,5
	RJMP _0x1E6
	LDS  R30,_edit
	CPI  R30,0
	BREQ _0x1E6
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,12
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R26,X
	CPI  R26,LOW(0x96)
	BRLO _0x1E7
_0x1E6:
	RJMP _0x1E5
_0x1E7:
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,12
	MOVW R26,R30
	MOV  R30,R7
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R26,R30
	LD   R30,X
	SUBI R30,-LOW(2)
	ST   X,R30
	CALL _BEEP1
;                                if (pos[2]==5&&!UP&&edit&&contr[pos[1]].maxDRates[FLY_MODE]>0)         { contr[pos[1]].maxDRates[FLY_MODE]-=2; BEEP1();}
_0x1E5:
	__GETB1MN _pos,2
	CPI  R30,LOW(0x5)
	BRNE _0x1E9
	SBIC 0x10,4
	RJMP _0x1E9
	LDS  R30,_edit
	CPI  R30,0
	BREQ _0x1E9
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,12
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R26,X
	CPI  R26,LOW(0x1)
	BRSH _0x1EA
_0x1E9:
	RJMP _0x1E8
_0x1EA:
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,12
	MOVW R26,R30
	MOV  R30,R7
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R26,R30
	LD   R30,X
	SUBI R30,LOW(2)
	ST   X,R30
	CALL _BEEP1
;
;                                }
_0x1E8:
;                        if (pos[1]==2)// Throttle cut
_0x1DC:
	__GETB1MN _pos,1
	CPI  R30,LOW(0x2)
	BREQ PC+3
	JMP _0x1EB
;                                {
;                                if (pos[2]==4&&!DOWN&&edit&&contr[pos[1]].minDRates[FLY_MODE]<150)     { contr[pos[1]].minDRates[FLY_MODE]+=2; BEEP1();}
	__GETB1MN _pos,2
	CPI  R30,LOW(0x4)
	BRNE _0x1ED
	SBIC 0x10,5
	RJMP _0x1ED
	LDS  R30,_edit
	CPI  R30,0
	BREQ _0x1ED
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,16
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R26,X
	CPI  R26,LOW(0x96)
	BRLO _0x1EE
_0x1ED:
	RJMP _0x1EC
_0x1EE:
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,16
	MOVW R26,R30
	MOV  R30,R7
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R26,R30
	LD   R30,X
	SUBI R30,-LOW(2)
	ST   X,R30
	CALL _BEEP1
;                                if (pos[2]==4&&!UP&&edit&&contr[pos[1]].minDRates[FLY_MODE]>0)          {contr[pos[1]].minDRates[FLY_MODE]-=2;  BEEP1();}
_0x1EC:
	__GETB1MN _pos,2
	CPI  R30,LOW(0x4)
	BRNE _0x1F0
	SBIC 0x10,4
	RJMP _0x1F0
	LDS  R30,_edit
	CPI  R30,0
	BREQ _0x1F0
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,16
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R26,X
	CPI  R26,LOW(0x1)
	BRSH _0x1F1
_0x1F0:
	RJMP _0x1EF
_0x1F1:
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,16
	MOVW R26,R30
	MOV  R30,R7
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R26,R30
	LD   R30,X
	SUBI R30,LOW(2)
	ST   X,R30
	CALL _BEEP1
;                                }
_0x1EF:
;                        if (pos[2]==1&&!RIGHT&&pen&&!edit) {curve_ed_enable=1; edit=1;pen=0;pos[3]=0;edit_cur=0;BEEP();}
_0x1EB:
	__GETB1MN _pos,2
	CPI  R30,LOW(0x1)
	BRNE _0x1F3
	SBIC 0x10,7
	RJMP _0x1F3
	LDS  R30,_pen
	CPI  R30,0
	BREQ _0x1F3
	LDS  R30,_edit
	CPI  R30,0
	BREQ _0x1F4
_0x1F3:
	RJMP _0x1F2
_0x1F4:
	LDI  R30,LOW(1)
	STS  _curve_ed_enable,R30
	STS  _edit,R30
	LDI  R30,LOW(0)
	STS  _pen,R30
	__PUTB1MN _pos,3
	STS  _edit_cur,R30
	CALL _BEEP
;                        if (pos[2]==1&&!LEFT&&pen&&edit&&curve_ed_enable&&!edit_cur) {curve_ed_enable=0; edit=0;pen=0;BEEP();}
_0x1F2:
	__GETB1MN _pos,2
	CPI  R30,LOW(0x1)
	BRNE _0x1F6
	SBIC 0x10,6
	RJMP _0x1F6
	LDS  R30,_pen
	CPI  R30,0
	BREQ _0x1F6
	LDS  R30,_edit
	CPI  R30,0
	BREQ _0x1F6
	LDS  R30,_curve_ed_enable
	CPI  R30,0
	BREQ _0x1F6
	LDS  R30,_edit_cur
	CPI  R30,0
	BREQ _0x1F7
_0x1F6:
	RJMP _0x1F5
_0x1F7:
	LDI  R30,LOW(0)
	STS  _curve_ed_enable,R30
	STS  _edit,R30
	STS  _pen,R30
	CALL _BEEP
;
;                        if(curve_ed_enable)                                             //
_0x1F5:
	LDS  R30,_curve_ed_enable
	CPI  R30,0
	BRNE PC+3
	JMP _0x1F8
;                                {
;
;                                if (!DOWN&&!edit_cur&&pen&&pos[3]<6) {pos[3]++;pen=0;BEEP();}
	SBIC 0x10,5
	RJMP _0x1FA
	LDS  R30,_edit_cur
	CPI  R30,0
	BRNE _0x1FA
	LDS  R30,_pen
	CPI  R30,0
	BREQ _0x1FA
	__GETB2MN _pos,3
	CPI  R26,LOW(0x6)
	BRLO _0x1FB
_0x1FA:
	RJMP _0x1F9
_0x1FB:
	__GETB1MN _pos,3
	SUBI R30,-LOW(1)
	__PUTB1MN _pos,3
	SUBI R30,LOW(1)
	LDI  R30,LOW(0)
	STS  _pen,R30
	CALL _BEEP
;                                if (!UP&&!edit_cur&&pen&&pos[3]>0) {pos[3]--;pen=0;BEEP();}
_0x1F9:
	SBIC 0x10,4
	RJMP _0x1FD
	LDS  R30,_edit_cur
	CPI  R30,0
	BRNE _0x1FD
	LDS  R30,_pen
	CPI  R30,0
	BREQ _0x1FD
	__GETB2MN _pos,3
	CPI  R26,LOW(0x1)
	BRSH _0x1FE
_0x1FD:
	RJMP _0x1FC
_0x1FE:
	__GETB1MN _pos,3
	SUBI R30,LOW(1)
	__PUTB1MN _pos,3
	SUBI R30,-LOW(1)
	LDI  R30,LOW(0)
	STS  _pen,R30
	CALL _BEEP
;
;                                if (!RIGHT&&pen) {edit_cur=1; pen=0;BEEP();}
_0x1FC:
	SBIC 0x10,7
	RJMP _0x200
	LDS  R30,_pen
	CPI  R30,0
	BRNE _0x201
_0x200:
	RJMP _0x1FF
_0x201:
	LDI  R30,LOW(1)
	STS  _edit_cur,R30
	LDI  R30,LOW(0)
	STS  _pen,R30
	CALL _BEEP
;
;                                if (!DOWN&&edit_cur&&contr[pos[1]].nodes[pos[3]][FLY_MODE]<100) {contr[pos[1]].nodes[pos[3]][FLY_MODE]+=2; BEEP1();}
_0x1FF:
	SBIC 0x10,5
	RJMP _0x203
	LDS  R30,_edit_cur
	CPI  R30,0
	BREQ _0x203
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,24
	MOVW R26,R30
	__GETB1MN _pos,3
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R26,X
	CPI  R26,LOW(0x64)
	BRLT _0x204
_0x203:
	RJMP _0x202
_0x204:
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,24
	MOVW R26,R30
	__GETB1MN _pos,3
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R7
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R26,R30
	LD   R30,X
	SUBI R30,-LOW(2)
	ST   X,R30
	CALL _BEEP1
;                                if (!UP&&edit_cur&&contr[pos[1]].nodes[pos[3]][FLY_MODE]>-100){ contr[pos[1]].nodes[pos[3]][FLY_MODE]-=2;  BEEP1();}
_0x202:
	SBIC 0x10,4
	RJMP _0x206
	LDS  R30,_edit_cur
	CPI  R30,0
	BREQ _0x206
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,24
	MOVW R26,R30
	__GETB1MN _pos,3
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R26,X
	LDI  R30,LOW(156)
	CP   R30,R26
	BRLT _0x207
_0x206:
	RJMP _0x205
_0x207:
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,24
	MOVW R26,R30
	__GETB1MN _pos,3
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R7
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R26,R30
	LD   R30,X
	SUBI R30,LOW(2)
	ST   X,R30
	CALL _BEEP1
;
;                                if (!LEFT&&pen) {edit_cur=0; pen=0;SAVE_NODE();}
_0x205:
	SBIC 0x10,6
	RJMP _0x209
	LDS  R30,_pen
	CPI  R30,0
	BRNE _0x20A
_0x209:
	RJMP _0x208
_0x20A:
	LDI  R30,LOW(0)
	STS  _edit_cur,R30
	STS  _pen,R30
	CALL _SAVE_NODE
;
;                                edit_curve(pos[3]);
_0x208:
	__GETB1MN _pos,3
	ST   -Y,R30
	CALL _edit_curve
;
;                                }
;
;
;                        lcd_setxy(0,7);
_0x1F8:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(7)
	ST   -Y,R30
	CALL _lcd_setxy
;                        lcd_wrsf(menuT2[pos[1]],255);
	__GETB1MN _pos,1
	LDI  R26,LOW(_menuT2)
	LDI  R27,HIGH(_menuT2)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;                        lcd_setxy(70,7);
	LDI  R30,LOW(70)
	ST   -Y,R30
	LDI  R30,LOW(7)
	ST   -Y,R30
	CALL _lcd_setxy
;                        lcd_wrsf("   ",255);
	__POINTW1FN _0x0,132
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;
;                        if (!curve_ed_enable) edit_CH (pos[1],pos[2])    ;
	LDS  R30,_curve_ed_enable
	CPI  R30,0
	BRNE _0x20B
	__GETB1MN _pos,1
	ST   -Y,R30
	__GETB1MN _pos,2
	ST   -Y,R30
	CALL _edit_CH
;
;
;                                if (pos[1]>7)                         ////     
_0x20B:
	__GETB2MN _pos,1
	CPI  R26,LOW(0x8)
	BRSH PC+3
	JMP _0x20C
;                                        {
;                                        if (pos[2]==4&&!UP&&edit&&contr[pos[1]].from[FLY_MODE]>0){ contr[pos[1]].from[FLY_MODE]--;   BEEP1();}
	__GETB1MN _pos,2
	CPI  R30,LOW(0x4)
	BRNE _0x20E
	SBIC 0x10,4
	RJMP _0x20E
	LDS  R30,_edit
	CPI  R30,0
	BREQ _0x20E
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,20
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R26,X
	CPI  R26,LOW(0x1)
	BRGE _0x20F
_0x20E:
	RJMP _0x20D
_0x20F:
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,20
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	SUBI R30,LOW(1)
	ST   X,R30
	CALL _BEEP1
;                                        if (pos[2]==4&&!DOWN&&edit&&contr[pos[1]].from[FLY_MODE]<7) {contr[pos[1]].from[FLY_MODE]++;   BEEP1();}
_0x20D:
	__GETB1MN _pos,2
	CPI  R30,LOW(0x4)
	BRNE _0x211
	SBIC 0x10,5
	RJMP _0x211
	LDS  R30,_edit
	CPI  R30,0
	BREQ _0x211
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,20
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R26,X
	CPI  R26,LOW(0x7)
	BRLT _0x212
_0x211:
	RJMP _0x210
_0x212:
	__GETB1MN _pos,1
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,20
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	SUBI R30,-LOW(1)
	ST   X,R30
	CALL _BEEP1
;
;
;                                        }
_0x210:
;
;
;
;
;
;
;
;
;
;
;
;
;
;                        }
_0x20C:
;
;              }
_0x1AB:
;
;
;
;              if (pos[0]==2)
_0x19D:
	LDS  R26,_pos
	CPI  R26,LOW(0x2)
	BREQ PC+3
	JMP _0x213
;                {
;                if (deep==1)
	LDS  R26,_deep
	CPI  R26,LOW(0x1)
	BREQ PC+3
	JMP _0x214
;                        {                                                          //CHANNELS
;                        if (!UP&&pos[1]<menuT5L-1)
	SBIC 0x10,4
	RJMP _0x216
	__GETB2MN _pos,1
	LDI  R30,LOW(_menuT5L*2)
	LDI  R31,HIGH(_menuT5L*2)
	LPM  R30,Z
	SUBI R30,LOW(1)
	LDI  R27,0
	LDI  R31,0
	SBRC R30,7
	SER  R31
	CP   R26,R30
	CPC  R27,R31
	BRLT _0x217
_0x216:
	RJMP _0x215
_0x217:
;                                {
;                                pos[1]++;
	__GETB1MN _pos,1
	SUBI R30,-LOW(1)
	__PUTB1MN _pos,1
;                                BEEP();
	CALL _BEEP
;                                }
;                        if (!DOWN&&pos[1]>0)
_0x215:
	SBIC 0x10,5
	RJMP _0x219
	__GETB2MN _pos,1
	CPI  R26,LOW(0x1)
	BRSH _0x21A
_0x219:
	RJMP _0x218
_0x21A:
;                                {
;                                pos[1]--;
	__GETB1MN _pos,1
	SUBI R30,LOW(1)
	__PUTB1MN _pos,1
;                                BEEP();
	CALL _BEEP
;                                }
;                        if (!LEFT&&pen) {deep=0; pen=0; BEEP();}
_0x218:
	SBIC 0x10,6
	RJMP _0x21C
	LDS  R30,_pen
	CPI  R30,0
	BRNE _0x21D
_0x21C:
	RJMP _0x21B
_0x21D:
	LDI  R30,LOW(0)
	STS  _deep,R30
	STS  _pen,R30
	CALL _BEEP
;                        if (!RIGHT&&pen)
_0x21B:
	SBIC 0x10,7
	RJMP _0x21F
	LDS  R30,_pen
	CPI  R30,0
	BRNE _0x220
_0x21F:
	RJMP _0x21E
_0x220:
;                                {
;                                deep=2;
	LDI  R30,LOW(2)
	STS  _deep,R30
;                                pos[2]=0;
	LDI  R30,LOW(0)
	__PUTB1MN _pos,2
;                                pen=0;
	STS  _pen,R30
;                                BEEP();
	CALL _BEEP
;                                }
;
;
;
;                        lcd_setxy(0,8);
_0x21E:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(8)
	ST   -Y,R30
	CALL _lcd_setxy
;                        lcd_wrsf("Channels",255);
	__POINTW1FN _0x0,705
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;
;                        menu_item( menuT5 ,menuT5L,pos[1]);
	LDI  R30,LOW(_menuT5)
	LDI  R31,HIGH(_menuT5)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_menuT5L*2)
	LDI  R31,HIGH(_menuT5L*2)
	LPM  R30,Z
	ST   -Y,R30
	__GETB1MN _pos,1
	ST   -Y,R30
	CALL _menu_item
;                        }
;                if (deep==2)
_0x214:
	LDS  R26,_deep
	CPI  R26,LOW(0x2)
	BREQ PC+3
	JMP _0x221
;                        {
;                        lcd_setxy(0,8);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(8)
	ST   -Y,R30
	CALL _lcd_setxy
;                        lcd_wrsf(menuT5[pos[1]],255);
	__GETB1MN _pos,1
	LDI  R26,LOW(_menuT5)
	LDI  R27,HIGH(_menuT5)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;                        lcd_setxy(70,8);
	LDI  R30,LOW(70)
	ST   -Y,R30
	LDI  R30,LOW(8)
	ST   -Y,R30
	CALL _lcd_setxy
;                        lcd_wrsf("   ",255);
	__POINTW1FN _0x0,132
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;                        if (!LEFT&&!edit&&pen) {deep=1; pen=0; BEEP();}
	SBIC 0x10,6
	RJMP _0x223
	LDS  R30,_edit
	CPI  R30,0
	BRNE _0x223
	LDS  R30,_pen
	CPI  R30,0
	BRNE _0x224
_0x223:
	RJMP _0x222
_0x224:
	LDI  R30,LOW(1)
	STS  _deep,R30
	LDI  R30,LOW(0)
	STS  _pen,R30
	CALL _BEEP
;                        if (!LEFT&&edit&&pen) {edit=0; pen=0;CH[cur_model_num][pos[1]][pos[2]][FLY_MODE]=chans[pos[1]].CH[pos[2]][FLY_MODE]; BEEP();}
_0x222:
	SBIC 0x10,6
	RJMP _0x226
	LDS  R30,_edit
	CPI  R30,0
	BREQ _0x226
	LDS  R30,_pen
	CPI  R30,0
	BRNE _0x227
_0x226:
	RJMP _0x225
_0x227:
	LDI  R30,LOW(0)
	STS  _edit,R30
	STS  _pen,R30
	LDS  R30,_cur_model_num
	LDI  R31,0
	LDI  R26,LOW(396)
	LDI  R27,HIGH(396)
	CALL __MULW12U
	SUBI R30,LOW(-_CH)
	SBCI R31,HIGH(-_CH)
	MOVW R26,R30
	__GETB1MN _pos,1
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(44)
	LDI  R27,HIGH(44)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	__GETB1MN _pos,2
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R7
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	__GETB1MN _pos,1
	LDI  R26,LOW(88)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_chans)
	SBCI R31,HIGH(-_chans)
	MOVW R26,R30
	__GETB1MN _pos,2
	LDI  R31,0
	CALL __LSLW3
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R7
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	MOVW R26,R22
	CALL __EEPROMWRB
	CALL _BEEP
;                        if (!RIGHT&&pen) {edit=1; pen=0; BEEP();}
_0x225:
	SBIC 0x10,7
	RJMP _0x229
	LDS  R30,_pen
	CPI  R30,0
	BRNE _0x22A
_0x229:
	RJMP _0x228
_0x22A:
	LDI  R30,LOW(1)
	STS  _edit,R30
	LDI  R30,LOW(0)
	STS  _pen,R30
	CALL _BEEP
;
;                        if (!UP&&!edit&&pos[2]<10)
_0x228:
	SBIC 0x10,4
	RJMP _0x22C
	LDS  R30,_edit
	CPI  R30,0
	BRNE _0x22C
	__GETB2MN _pos,2
	CPI  R26,LOW(0xA)
	BRLO _0x22D
_0x22C:
	RJMP _0x22B
_0x22D:
;                                {
;                                pos[2]++;
	__GETB1MN _pos,2
	SUBI R30,-LOW(1)
	__PUTB1MN _pos,2
;                                BEEP();
	CALL _BEEP
;                                }
;                        if (!DOWN&&!edit&&pos[2]>0)
_0x22B:
	SBIC 0x10,5
	RJMP _0x22F
	LDS  R30,_edit
	CPI  R30,0
	BRNE _0x22F
	__GETB2MN _pos,2
	CPI  R26,LOW(0x1)
	BRSH _0x230
_0x22F:
	RJMP _0x22E
_0x230:
;                                {
;                                pos[2]--;
	__GETB1MN _pos,2
	SUBI R30,LOW(1)
	__PUTB1MN _pos,2
;                                BEEP();
	CALL _BEEP
;                                }
;                        if (!DOWN&&edit&&chans[pos[1]].CH[pos[2]][FLY_MODE]<100)
_0x22E:
	SBIC 0x10,5
	RJMP _0x232
	LDS  R30,_edit
	CPI  R30,0
	BREQ _0x232
	__GETB1MN _pos,1
	LDI  R26,LOW(88)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_chans)
	SBCI R31,HIGH(-_chans)
	MOVW R26,R30
	__GETB1MN _pos,2
	LDI  R31,0
	CALL __LSLW3
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R7
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	CPI  R30,LOW(0x64)
	LDI  R26,HIGH(0x64)
	CPC  R31,R26
	BRLT _0x233
_0x232:
	RJMP _0x231
_0x233:
;                                {
;                                chans[pos[1]].CH[pos[2]][FLY_MODE]+=2;
	__GETB1MN _pos,1
	LDI  R26,LOW(88)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_chans)
	SBCI R31,HIGH(-_chans)
	MOVW R26,R30
	__GETB1MN _pos,2
	LDI  R31,0
	CALL __LSLW3
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R7
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X+
	LD   R31,X+
	ADIW R30,2
	ST   -X,R31
	ST   -X,R30
;                                 BEEP1();
	CALL _BEEP1
;                                }
;                        if (!UP&&edit&&chans[pos[1]].CH[pos[2]][FLY_MODE]>-100)
_0x231:
	SBIC 0x10,4
	RJMP _0x235
	LDS  R30,_edit
	CPI  R30,0
	BREQ _0x235
	__GETB1MN _pos,1
	LDI  R26,LOW(88)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_chans)
	SBCI R31,HIGH(-_chans)
	MOVW R26,R30
	__GETB1MN _pos,2
	LDI  R31,0
	CALL __LSLW3
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R7
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R30
	LDI  R30,LOW(65436)
	LDI  R31,HIGH(65436)
	CP   R30,R26
	CPC  R31,R27
	BRLT _0x236
_0x235:
	RJMP _0x234
_0x236:
;                                {
;                                chans[pos[1]].CH[pos[2]][FLY_MODE]-=2;
	__GETB1MN _pos,1
	LDI  R26,LOW(88)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_chans)
	SBCI R31,HIGH(-_chans)
	MOVW R26,R30
	__GETB1MN _pos,2
	LDI  R31,0
	CALL __LSLW3
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R7
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X+
	LD   R31,X+
	SBIW R30,2
	ST   -X,R31
	ST   -X,R30
;                                 BEEP1();
	CALL _BEEP1
;                                }
;
;                        lcd_line(92,18,92,64,1);
_0x234:
	LDI  R30,LOW(92)
	ST   -Y,R30
	LDI  R30,LOW(18)
	ST   -Y,R30
	LDI  R30,LOW(92)
	ST   -Y,R30
	LDI  R30,LOW(64)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;                        lcd_line(95,18,95,64,1);
	LDI  R30,LOW(95)
	ST   -Y,R30
	LDI  R30,LOW(18)
	ST   -Y,R30
	LDI  R30,LOW(95)
	ST   -Y,R30
	LDI  R30,LOW(64)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;
;                        if (pos[2]>=5&&pos[2]<10)
	__GETB2MN _pos,2
	CPI  R26,LOW(0x5)
	BRLO _0x238
	__GETB2MN _pos,2
	CPI  R26,LOW(0xA)
	BRLO _0x239
_0x238:
	RJMP _0x237
_0x239:
;                                {
;                                lcd_line(93,33,93,48,1);
	LDI  R30,LOW(93)
	ST   -Y,R30
	LDI  R30,LOW(33)
	ST   -Y,R30
	LDI  R30,LOW(93)
	ST   -Y,R30
	LDI  R30,LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;                                lcd_line(94,33,94,48,1);
	LDI  R30,LOW(94)
	ST   -Y,R30
	LDI  R30,LOW(33)
	ST   -Y,R30
	LDI  R30,LOW(94)
	ST   -Y,R30
	LDI  R30,LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;                                lcd_line(93,18,94,18,1);
	LDI  R30,LOW(93)
	ST   -Y,R30
	LDI  R30,LOW(18)
	ST   -Y,R30
	LDI  R30,LOW(94)
	ST   -Y,R30
	LDI  R30,LOW(18)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;                                f=5;
	LDI  R18,LOW(5)
;                                l=10;
	LDI  R21,LOW(10)
;                                }
;                        if (pos[2]>=10)
_0x237:
	__GETB2MN _pos,2
	CPI  R26,LOW(0xA)
	BRLO _0x23A
;                                {
;                                lcd_line(93,48,93,64,1);
	LDI  R30,LOW(93)
	ST   -Y,R30
	LDI  R30,LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(93)
	ST   -Y,R30
	LDI  R30,LOW(64)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;                                lcd_line(94,48,94,64,1);
	LDI  R30,LOW(94)
	ST   -Y,R30
	LDI  R30,LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(94)
	ST   -Y,R30
	LDI  R30,LOW(64)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;                                lcd_line(93,18,94,18,1);
	LDI  R30,LOW(93)
	ST   -Y,R30
	LDI  R30,LOW(18)
	ST   -Y,R30
	LDI  R30,LOW(94)
	ST   -Y,R30
	LDI  R30,LOW(18)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;                                f=10;
	LDI  R18,LOW(10)
;                                l=11;
	LDI  R21,LOW(11)
;                                }
;
;                         if (pos[2]<5)
_0x23A:
	__GETB2MN _pos,2
	CPI  R26,LOW(0x5)
	BRSH _0x23B
;                                {
;                                lcd_line(93,18,93,33,1);
	LDI  R30,LOW(93)
	ST   -Y,R30
	LDI  R30,LOW(18)
	ST   -Y,R30
	LDI  R30,LOW(93)
	ST   -Y,R30
	LDI  R30,LOW(33)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;                                lcd_line(94,18,94,33,1);
	LDI  R30,LOW(94)
	ST   -Y,R30
	LDI  R30,LOW(18)
	ST   -Y,R30
	LDI  R30,LOW(94)
	ST   -Y,R30
	LDI  R30,LOW(33)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;                                lcd_line(93,64,94,64,1);
	LDI  R30,LOW(93)
	ST   -Y,R30
	LDI  R30,LOW(64)
	ST   -Y,R30
	LDI  R30,LOW(94)
	ST   -Y,R30
	LDI  R30,LOW(64)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;                                f=0;
	LDI  R18,LOW(0)
;                                l=5;
	LDI  R21,LOW(5)
;                                }
;
;                        c=0;
_0x23B:
	LDI  R20,LOW(0)
;                        for (i=f; i<l; i++)
	MOV  R17,R18
_0x23D:
	CP   R17,R21
	BRLO PC+3
	JMP _0x23E
;                                {
;
;                                if (i==pos[2])
	__GETB1MN _pos,2
	CP   R30,R17
	BREQ PC+3
	JMP _0x23F
;                                        {
;                                        lcd_setxy(0,c*9+18);
	LDI  R30,LOW(0)
	ST   -Y,R30
	MOV  R26,R20
	LDI  R30,LOW(9)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,-LOW(18)
	ST   -Y,R30
	CALL _lcd_setxy
;                                        if (!edit)lcd_wrsf(menuT2[i],0);
	LDS  R30,_edit
	CPI  R30,0
	BRNE _0x240
	MOV  R30,R17
	LDI  R26,LOW(_menuT2)
	LDI  R27,HIGH(_menuT2)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	RJMP _0x368
;                                        else lcd_wrsf(menuT2[i],Clip);
_0x240:
	MOV  R30,R17
	LDI  R26,LOW(_menuT2)
	LDI  R27,HIGH(_menuT2)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Clip
_0x368:
	ST   -Y,R30
	CALL _lcd_wrsf
;
;                                        lcd_setxy(56,c*9+18);
	LDI  R30,LOW(56)
	ST   -Y,R30
	MOV  R26,R20
	LDI  R30,LOW(9)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,-LOW(18)
	ST   -Y,R30
	CALL _lcd_setxy
;                                         if (!edit)lcd_wrsf("    ",0);
	LDS  R30,_edit
	CPI  R30,0
	BRNE _0x242
	__POINTW1FN _0x0,131
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	RJMP _0x369
;                                        else lcd_wrsf("    ",Clip);
_0x242:
	__POINTW1FN _0x0,131
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Clip
_0x369:
	ST   -Y,R30
	CALL _lcd_wrsf
;
;                                        lcd_setxy(60,c*9+18);
	LDI  R30,LOW(60)
	ST   -Y,R30
	MOV  R26,R20
	LDI  R30,LOW(9)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,-LOW(18)
	ST   -Y,R30
	CALL _lcd_setxy
;                                        sprintf(buf,"%-i",chans[pos[1]].CH[i][FLY_MODE]);
	LDI  R30,LOW(_buf)
	LDI  R31,HIGH(_buf)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,525
	ST   -Y,R31
	ST   -Y,R30
	__GETB1MN _pos,1
	LDI  R26,LOW(88)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_chans)
	SBCI R31,HIGH(-_chans)
	MOVW R26,R30
	MOV  R30,R17
	LDI  R31,0
	CALL __LSLW3
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R7
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	CALL __CWD1
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
;                                        if (!edit)lcd_wrs(buf,0);
	LDS  R30,_edit
	CPI  R30,0
	BRNE _0x244
	LDI  R30,LOW(_buf)
	LDI  R31,HIGH(_buf)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	RJMP _0x36A
;                                        else lcd_wrs(buf,Clip);
_0x244:
	LDI  R30,LOW(_buf)
	LDI  R31,HIGH(_buf)
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Clip
_0x36A:
	ST   -Y,R30
	CALL _lcd_wrs
;
;                                        }
;                                else
	RJMP _0x246
_0x23F:
;                                        {
;                                        lcd_setxy(0,c*9+18);
	LDI  R30,LOW(0)
	ST   -Y,R30
	MOV  R26,R20
	LDI  R30,LOW(9)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,-LOW(18)
	ST   -Y,R30
	CALL _lcd_setxy
;                                        lcd_wrsf(menuT2[i],255);
	MOV  R30,R17
	LDI  R26,LOW(_menuT2)
	LDI  R27,HIGH(_menuT2)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;                                        lcd_setxy(56,c*9+18);
	LDI  R30,LOW(56)
	ST   -Y,R30
	MOV  R26,R20
	LDI  R30,LOW(9)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,-LOW(18)
	ST   -Y,R30
	CALL _lcd_setxy
;                                        lcd_wrsf("   ",255);
	__POINTW1FN _0x0,132
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;                                        lcd_setxy(60,c*9+18);
	LDI  R30,LOW(60)
	ST   -Y,R30
	MOV  R26,R20
	LDI  R30,LOW(9)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,-LOW(18)
	ST   -Y,R30
	CALL _lcd_setxy
;                                        sprintf(buf,"%-i",chans[pos[1]].CH[i][FLY_MODE]);
	LDI  R30,LOW(_buf)
	LDI  R31,HIGH(_buf)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,525
	ST   -Y,R31
	ST   -Y,R30
	__GETB1MN _pos,1
	LDI  R26,LOW(88)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_chans)
	SBCI R31,HIGH(-_chans)
	MOVW R26,R30
	MOV  R30,R17
	LDI  R31,0
	CALL __LSLW3
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R7
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	CALL __CWD1
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
;                                        lcd_wrs(buf,255);
	LDI  R30,LOW(_buf)
	LDI  R31,HIGH(_buf)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrs
;                                        }
_0x246:
;                                c++;
	SUBI R20,-1
;
;                                }
	SUBI R17,-1
	RJMP _0x23D
_0x23E:
;
;
;
;                        }
;
;
;                }
_0x221:
;
;
;         if (pos[0]==3)
_0x213:
	LDS  R26,_pos
	CPI  R26,LOW(0x3)
	BREQ PC+3
	JMP _0x247
;        {
;        if (deep==1)
	LDS  R26,_deep
	CPI  R26,LOW(0x1)
	BREQ PC+3
	JMP _0x248
;                {                                                          //    TIMER
;                if (!UP&&pos[1]<menuT3L-1)
	SBIC 0x10,4
	RJMP _0x24A
	__GETB2MN _pos,1
	LDI  R30,LOW(_menuT3L*2)
	LDI  R31,HIGH(_menuT3L*2)
	LPM  R30,Z
	SUBI R30,LOW(1)
	LDI  R27,0
	LDI  R31,0
	SBRC R30,7
	SER  R31
	CP   R26,R30
	CPC  R27,R31
	BRLT _0x24B
_0x24A:
	RJMP _0x249
_0x24B:
;                        {
;                        pos[1]++;
	__GETB1MN _pos,1
	SUBI R30,-LOW(1)
	__PUTB1MN _pos,1
;                        BEEP();
	CALL _BEEP
;                        }
;                if (!DOWN&&pos[1]>0)
_0x249:
	SBIC 0x10,5
	RJMP _0x24D
	__GETB2MN _pos,1
	CPI  R26,LOW(0x1)
	BRSH _0x24E
_0x24D:
	RJMP _0x24C
_0x24E:
;                        {
;                        pos[1]--;
	__GETB1MN _pos,1
	SUBI R30,LOW(1)
	__PUTB1MN _pos,1
;                        BEEP();
	CALL _BEEP
;                        }
;                if (!LEFT&&pen) {deep=0; pen=0;BEEP();}
_0x24C:
	SBIC 0x10,6
	RJMP _0x250
	LDS  R30,_pen
	CPI  R30,0
	BRNE _0x251
_0x250:
	RJMP _0x24F
_0x251:
	LDI  R30,LOW(0)
	STS  _deep,R30
	STS  _pen,R30
	CALL _BEEP
;                if (!RIGHT&&pen)
_0x24F:
	SBIC 0x10,7
	RJMP _0x253
	LDS  R30,_pen
	CPI  R30,0
	BRNE _0x254
_0x253:
	RJMP _0x252
_0x254:
;                        {
;                        deep=2;
	LDI  R30,LOW(2)
	STS  _deep,R30
;                        pos[2]=0;
	LDI  R30,LOW(0)
	__PUTB1MN _pos,2
;                        pen=0;
	STS  _pen,R30
;                        BEEP();
	CALL _BEEP
;                        }
;
;
;
;                lcd_setxy(0,8);
_0x252:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(8)
	ST   -Y,R30
	CALL _lcd_setxy
;                lcd_wrsf("Timer",255);
	__POINTW1FN _0x0,714
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;
;                menu_item( menuT3 ,menuT3L,pos[1]);
	LDI  R30,LOW(_menuT3)
	LDI  R31,HIGH(_menuT3)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_menuT3L*2)
	LDI  R31,HIGH(_menuT3L*2)
	LPM  R30,Z
	ST   -Y,R30
	__GETB1MN _pos,1
	ST   -Y,R30
	CALL _menu_item
;
;
;                }
;
;       if (deep==2&&pos[1]==0)    // 
_0x248:
	LDS  R26,_deep
	CPI  R26,LOW(0x2)
	BRNE _0x256
	__GETB1MN _pos,1
	CPI  R30,0
	BREQ _0x257
_0x256:
	RJMP _0x255
_0x257:
;                {
;                if (!LEFT&&pen) {deep=1; pen=0; timer[cur_model_num]=curmodel.timer;BEEP();}
	SBIC 0x10,6
	RJMP _0x259
	LDS  R30,_pen
	CPI  R30,0
	BRNE _0x25A
_0x259:
	RJMP _0x258
_0x25A:
	LDI  R30,LOW(1)
	STS  _deep,R30
	LDI  R30,LOW(0)
	STS  _pen,R30
	LDS  R30,_cur_model_num
	LDI  R26,LOW(_timer)
	LDI  R27,HIGH(_timer)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	__GETW1MN _curmodel,29
	CALL __EEPROMWRW
	CALL _BEEP
;
;                if (!DOWN&&curmodel.timer<3599)
_0x258:
	SBIC 0x10,5
	RJMP _0x25C
	__GETW2MN _curmodel,29
	CPI  R26,LOW(0xE0F)
	LDI  R30,HIGH(0xE0F)
	CPC  R27,R30
	BRLT _0x25D
_0x25C:
	RJMP _0x25B
_0x25D:
;                        {
;                        curmodel.timer+=10;
	__GETW1MN _curmodel,29
	ADIW R30,10
	__PUTW1MN _curmodel,29
;                        BEEP1();
	CALL _BEEP1
;                        }
;                if (!UP&&curmodel.timer>0)
_0x25B:
	SBIC 0x10,4
	RJMP _0x25F
	__GETW2MN _curmodel,29
	CALL __CPW02
	BRLT _0x260
_0x25F:
	RJMP _0x25E
_0x260:
;                        {
;                       curmodel.timer-=10;
	__GETW1MN _curmodel,29
	SBIW R30,10
	__PUTW1MN _curmodel,29
;                        BEEP1();
	CALL _BEEP1
;                        }
;
;
;
;
;
;                        sprintf(buf,"%-i:%-i",curmodel.timer/60,curmodel.timer%60);
_0x25E:
	LDI  R30,LOW(_buf)
	LDI  R31,HIGH(_buf)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,720
	ST   -Y,R31
	ST   -Y,R30
	__GETW2MN _curmodel,29
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	CALL __DIVW21
	CALL __CWD1
	CALL __PUTPARD1
	__GETW2MN _curmodel,29
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	CALL __MODW21
	CALL __CWD1
	CALL __PUTPARD1
	LDI  R24,8
	CALL _sprintf
	ADIW R28,12
;
;                lcd_setxy(25,25);
	LDI  R30,LOW(25)
	ST   -Y,R30
	ST   -Y,R30
	CALL _lcd_setxy
;                lcd_wrs(buf,255);
	LDI  R30,LOW(_buf)
	LDI  R31,HIGH(_buf)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrs
;                }
;
;       if (deep==2&&pos[1]==1)      // 
_0x255:
	LDS  R26,_deep
	CPI  R26,LOW(0x2)
	BRNE _0x262
	__GETB1MN _pos,1
	CPI  R30,LOW(0x1)
	BREQ _0x263
_0x262:
	RJMP _0x261
_0x263:
;                {
;                if (!LEFT&&pen) {deep=1;timer_mode[cur_model_num]=curmodel.timer_mode; pen=0;BEEP();}
	SBIC 0x10,6
	RJMP _0x265
	LDS  R30,_pen
	CPI  R30,0
	BRNE _0x266
_0x265:
	RJMP _0x264
_0x266:
	LDI  R30,LOW(1)
	STS  _deep,R30
	LDS  R26,_cur_model_num
	LDI  R27,0
	SUBI R26,LOW(-_timer_mode)
	SBCI R27,HIGH(-_timer_mode)
	__GETB1MN _curmodel,31
	CALL __EEPROMWRB
	LDI  R30,LOW(0)
	STS  _pen,R30
	CALL _BEEP
;
;
;
;                if (!UP&&curmodel.timer_mode<3)
_0x264:
	SBIC 0x10,4
	RJMP _0x268
	__GETB2MN _curmodel,31
	CPI  R26,LOW(0x3)
	BRLT _0x269
_0x268:
	RJMP _0x267
_0x269:
;                        {
;                        curmodel.timer_mode++;
	__GETB1MN _curmodel,31
	SUBI R30,-LOW(1)
	__PUTB1MN _curmodel,31
	SUBI R30,LOW(1)
;                        BEEP();
	CALL _BEEP
;                        }
;                if (!DOWN&&curmodel.timer_mode>0)
_0x267:
	SBIC 0x10,5
	RJMP _0x26B
	__GETB2MN _curmodel,31
	CPI  R26,LOW(0x1)
	BRGE _0x26C
_0x26B:
	RJMP _0x26A
_0x26C:
;                        {
;                       curmodel.timer_mode--;
	__GETB1MN _curmodel,31
	SUBI R30,LOW(1)
	__PUTB1MN _curmodel,31
	SUBI R30,-LOW(1)
;                        BEEP();
	CALL _BEEP
;                        }
;
;                lcd_setxy(15,20);
_0x26A:
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _lcd_setxy
;                lcd_wrsf(Timer_modes1[curmodel.timer_mode/2],255);
	__GETB2MN _curmodel,31
	LDI  R30,LOW(2)
	CALL __DIVB21
	LDI  R26,LOW(_Timer_modes1)
	LDI  R27,HIGH(_Timer_modes1)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;                lcd_setxy(15,30);
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(30)
	ST   -Y,R30
	CALL _lcd_setxy
;                lcd_wrsf(Timer_modes2[curmodel.timer_mode%2],255);
	__GETB2MN _curmodel,31
	LDI  R30,LOW(2)
	CALL __MODB21
	LDI  R26,LOW(_Timer_modes2)
	LDI  R27,HIGH(_Timer_modes2)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;
;                }
;
;
;
;       }
_0x261:
;
;       if (pos[0]==4)
_0x247:
	LDS  R26,_pos
	CPI  R26,LOW(0x4)
	BREQ PC+3
	JMP _0x26D
;                {
;                if (deep==1)
	LDS  R26,_deep
	CPI  R26,LOW(0x1)
	BREQ PC+3
	JMP _0x26E
;                        {                                                         //OPTIONS
;                        if (!UP&&pos[1]<menuT4L-1)
	SBIC 0x10,4
	RJMP _0x270
	__GETB2MN _pos,1
	LDI  R30,LOW(_menuT4L*2)
	LDI  R31,HIGH(_menuT4L*2)
	LPM  R30,Z
	SUBI R30,LOW(1)
	LDI  R27,0
	LDI  R31,0
	SBRC R30,7
	SER  R31
	CP   R26,R30
	CPC  R27,R31
	BRLT _0x271
_0x270:
	RJMP _0x26F
_0x271:
;                                {
;                                pos[1]++;
	__GETB1MN _pos,1
	SUBI R30,-LOW(1)
	__PUTB1MN _pos,1
;                                BEEP();
	CALL _BEEP
;                                }
;                        if (!DOWN&&pos[1]>0)
_0x26F:
	SBIC 0x10,5
	RJMP _0x273
	__GETB2MN _pos,1
	CPI  R26,LOW(0x1)
	BRSH _0x274
_0x273:
	RJMP _0x272
_0x274:
;                                {
;                                pos[1]--;
	__GETB1MN _pos,1
	SUBI R30,LOW(1)
	__PUTB1MN _pos,1
;                                BEEP();
	CALL _BEEP
;                                }
;                        if (!LEFT&&pen) {deep=0; pen=0;BEEP();}
_0x272:
	SBIC 0x10,6
	RJMP _0x276
	LDS  R30,_pen
	CPI  R30,0
	BRNE _0x277
_0x276:
	RJMP _0x275
_0x277:
	LDI  R30,LOW(0)
	STS  _deep,R30
	STS  _pen,R30
	CALL _BEEP
;                        if (!RIGHT&&pen)
_0x275:
	SBIC 0x10,7
	RJMP _0x279
	LDS  R30,_pen
	CPI  R30,0
	BRNE _0x27A
_0x279:
	RJMP _0x278
_0x27A:
;                                {
;                                deep=2;
	LDI  R30,LOW(2)
	STS  _deep,R30
;                                pos[2]=0;
	LDI  R30,LOW(0)
	__PUTB1MN _pos,2
;                                pen=0;
	STS  _pen,R30
;                                BEEP();
	CALL _BEEP
;                                }
;
;
;
;                lcd_setxy(0,8);
_0x278:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(8)
	ST   -Y,R30
	CALL _lcd_setxy
;                lcd_wrsf("Options",255);
	__POINTW1FN _0x0,728
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;
;                menu_item( menuT4 ,menuT4L,pos[1]);
	LDI  R30,LOW(_menuT4)
	LDI  R31,HIGH(_menuT4)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_menuT4L*2)
	LDI  R31,HIGH(_menuT4L*2)
	LPM  R30,Z
	ST   -Y,R30
	__GETB1MN _pos,1
	ST   -Y,R30
	CALL _menu_item
;                        }
;                if (deep==2&&pos[1]==0)
_0x26E:
	LDS  R26,_deep
	CPI  R26,LOW(0x2)
	BRNE _0x27C
	__GETB1MN _pos,1
	CPI  R30,0
	BREQ _0x27D
_0x27C:
	RJMP _0x27B
_0x27D:
;                        {
;                        lcd_setxy(0,8);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(8)
	ST   -Y,R30
	CALL _lcd_setxy
;                        lcd_wrsf("Sound",255);
	__POINTW1FN _0x0,736
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;                        lcd_setxy(10,25);
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(25)
	ST   -Y,R30
	CALL _lcd_setxy
;                        if (sound)lcd_wrsf("ON",255);
	LDS  R30,_sound
	CPI  R30,0
	BREQ _0x27E
	__POINTW1FN _0x0,742
	RJMP _0x36B
;                        else lcd_wrsf("OFF",255);
_0x27E:
	__POINTW1FN _0x0,521
_0x36B:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;                        if (!DOWN&&pen) {sound=1; BEEP();pen=0;}
	SBIC 0x10,5
	RJMP _0x281
	LDS  R30,_pen
	CPI  R30,0
	BRNE _0x282
_0x281:
	RJMP _0x280
_0x282:
	LDI  R30,LOW(1)
	STS  _sound,R30
	CALL _BEEP
	LDI  R30,LOW(0)
	STS  _pen,R30
;                        if (!UP&&pen) {sound=0; BEEP();pen=0;}
_0x280:
	SBIC 0x10,4
	RJMP _0x284
	LDS  R30,_pen
	CPI  R30,0
	BRNE _0x285
_0x284:
	RJMP _0x283
_0x285:
	LDI  R30,LOW(0)
	STS  _sound,R30
	CALL _BEEP
	LDI  R30,LOW(0)
	STS  _pen,R30
;                        if (!LEFT&&pen) {deep=1; pen=0; EEPRsound=sound; BEEP();}
_0x283:
	SBIC 0x10,6
	RJMP _0x287
	LDS  R30,_pen
	CPI  R30,0
	BRNE _0x288
_0x287:
	RJMP _0x286
_0x288:
	LDI  R30,LOW(1)
	STS  _deep,R30
	LDI  R30,LOW(0)
	STS  _pen,R30
	LDS  R30,_sound
	LDI  R26,LOW(_EEPRsound)
	LDI  R27,HIGH(_EEPRsound)
	CALL __EEPROMWRB
	CALL _BEEP
;                        }
_0x286:
;
;
;
;
;
;
;
;                }
_0x27B:
;
;
;
;
;
;        }
_0x26D:
;  }
_0xD9:
_0xCE:
; lcd_refresh();
	CALL _lcd_refresh
; }
	CALL __LOADLOCR6
	ADIW R28,15
	RET
;
;
;
;
;
;
;
;
;
;
;void calibr (void)
;{
_calibr:
;unsigned char i,x2,y2;
;int t1,t2;
;    read_adc(Ailerons);
	SBIW R28,2
	CALL __SAVELOCR6
;	i -> R17
;	x2 -> R16
;	y2 -> R19
;	t1 -> R20,R21
;	t2 -> Y+6
	LDI  R30,LOW(5)
	ST   -Y,R30
	CALL _read_adc
;        AD[0]=ADCW-ADmid[0];
	IN   R30,0x4
	IN   R31,0x4+1
	LDS  R26,_ADmid
	LDS  R27,_ADmid+1
	SUB  R30,R26
	SBC  R31,R27
	STS  _AD,R30
	STS  _AD+1,R31
;        read_adc(Throttle);
	LDI  R30,LOW(6)
	ST   -Y,R30
	CALL _read_adc
;        AD[2]=ADCW-ADmid[2];
	IN   R30,0x4
	IN   R31,0x4+1
	__GETW2MN _ADmid,4
	SUB  R30,R26
	SBC  R31,R27
	__PUTW1MN _AD,4
;        read_adc(Rudder);
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _read_adc
;        AD[3]=ADCW-ADmid[3];
	IN   R30,0x4
	IN   R31,0x4+1
	__GETW2MN _ADmid,6
	SUB  R30,R26
	SBC  R31,R27
	__PUTW1MN _AD,6
;        read_adc(Elevator);
	LDI  R30,LOW(4)
	ST   -Y,R30
	CALL _read_adc
;        AD[1]=ADCW-ADmid[1];
	IN   R30,0x4
	IN   R31,0x4+1
	__GETW2MN _ADmid,2
	SUB  R30,R26
	SBC  R31,R27
	__PUTW1MN _AD,2
;        read_adc(Rpop_contr);
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _read_adc
;        AD[4]=ADCW-ADmid[4];
	IN   R30,0x4
	IN   R31,0x4+1
	__GETW2MN _ADmid,8
	SUB  R30,R26
	SBC  R31,R27
	__PUTW1MN _AD,8
;        read_adc(Batt);
	LDI  R30,LOW(7)
	ST   -Y,R30
	CALL _read_adc
;        U_bat=ADCW;
	__INWR 4,5,4
;        U_bat=U_bat*2;
	LSL  R4
	ROL  R5
;
;
;
; for (i=0; i<5; i++)
	LDI  R17,LOW(0)
_0x28A:
	CPI  R17,5
	BRSH _0x28B
;        {
;        ADmin[i]=AD[i];
	MOV  R30,R17
	LDI  R26,LOW(_ADmin)
	LDI  R27,HIGH(_ADmin)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOV  R30,R17
	LDI  R26,LOW(_AD)
	LDI  R27,HIGH(_AD)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;        ADmax[i]=AD[i];
	MOV  R30,R17
	LDI  R26,LOW(_ADmax)
	LDI  R27,HIGH(_ADmax)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOV  R30,R17
	LDI  R26,LOW(_AD)
	LDI  R27,HIGH(_AD)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;        }
	SUBI R17,-1
	RJMP _0x28A
_0x28B:
;
; sound=1;
	LDI  R30,LOW(1)
	STS  _sound,R30
;
; lcd_clear();
	CALL _lcd_clear
; lcd_setxy(4,5);
	LDI  R30,LOW(4)
	ST   -Y,R30
	LDI  R30,LOW(5)
	ST   -Y,R30
	CALL _lcd_setxy
; lcd_wrsf("Calibrating",255);
	__POINTW1FN _0x0,745
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
; lcd_refresh();
	CALL _lcd_refresh
; delay_ms(1000);
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;
;  BEEP();
	CALL _BEEP
;   BEEP();
	CALL _BEEP
;    BEEP();
	CALL _BEEP
;      BEEP();
	CALL _BEEP
;        BEEP();
	CALL _BEEP
;while (RIGHT){
_0x28C:
	SBIS 0x10,7
	RJMP _0x28E
;lcd_clear();
	CALL _lcd_clear
;
;        read_adc(Ailerons);
	LDI  R30,LOW(5)
	ST   -Y,R30
	CALL _read_adc
;        AD[0]=ADCW-ADmid[0];
	IN   R30,0x4
	IN   R31,0x4+1
	LDS  R26,_ADmid
	LDS  R27,_ADmid+1
	SUB  R30,R26
	SBC  R31,R27
	STS  _AD,R30
	STS  _AD+1,R31
;        read_adc(Throttle);
	LDI  R30,LOW(6)
	ST   -Y,R30
	CALL _read_adc
;        AD[2]=ADCW-ADmid[2];
	IN   R30,0x4
	IN   R31,0x4+1
	__GETW2MN _ADmid,4
	SUB  R30,R26
	SBC  R31,R27
	__PUTW1MN _AD,4
;        read_adc(Rudder);
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _read_adc
;        AD[3]=ADCW-ADmid[3];
	IN   R30,0x4
	IN   R31,0x4+1
	__GETW2MN _ADmid,6
	SUB  R30,R26
	SBC  R31,R27
	__PUTW1MN _AD,6
;        read_adc(Elevator);
	LDI  R30,LOW(4)
	ST   -Y,R30
	CALL _read_adc
;        AD[1]=ADCW-ADmid[1];
	IN   R30,0x4
	IN   R31,0x4+1
	__GETW2MN _ADmid,2
	SUB  R30,R26
	SBC  R31,R27
	__PUTW1MN _AD,2
;        read_adc(Rpop_contr);
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _read_adc
;        AD[4]=ADCW-ADmid[4];
	IN   R30,0x4
	IN   R31,0x4+1
	__GETW2MN _ADmid,8
	SUB  R30,R26
	SBC  R31,R27
	__PUTW1MN _AD,8
;        read_adc(Batt);
	LDI  R30,LOW(7)
	ST   -Y,R30
	CALL _read_adc
;        U_bat=ADCW;
	__INWR 4,5,4
;        U_bat=U_bat*2;
	LSL  R4
	ROL  R5
;
;lcd_line(8,10,8,40,1);
	LDI  R30,LOW(8)
	ST   -Y,R30
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(8)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;lcd_line(8,10,38,10,1);
	LDI  R30,LOW(8)
	ST   -Y,R30
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(38)
	ST   -Y,R30
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;lcd_line(38,10,38,40,1);
	LDI  R30,LOW(38)
	ST   -Y,R30
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(38)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;lcd_line(8,40,38,40,1);
	LDI  R30,LOW(8)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	LDI  R30,LOW(38)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;lcd_line(7,9,7,41,1);
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(9)
	ST   -Y,R30
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(41)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;lcd_line(7,9,39,9,1);
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(9)
	ST   -Y,R30
	LDI  R30,LOW(39)
	ST   -Y,R30
	LDI  R30,LOW(9)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;lcd_line(39,9,39,41,1);
	LDI  R30,LOW(39)
	ST   -Y,R30
	LDI  R30,LOW(9)
	ST   -Y,R30
	LDI  R30,LOW(39)
	ST   -Y,R30
	LDI  R30,LOW(41)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;lcd_line(7,41,39,41,1);
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(41)
	ST   -Y,R30
	LDI  R30,LOW(39)
	ST   -Y,R30
	LDI  R30,LOW(41)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;
;
;lcd_line(58,10,58,40,1);
	LDI  R30,LOW(58)
	ST   -Y,R30
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(58)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;lcd_line(58,10,88,10,1);
	LDI  R30,LOW(58)
	ST   -Y,R30
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(88)
	ST   -Y,R30
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;lcd_line(88,10,88,40,1);
	LDI  R30,LOW(88)
	ST   -Y,R30
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(88)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;lcd_line(58,40,88,40,1);
	LDI  R30,LOW(58)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	LDI  R30,LOW(88)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;lcd_line(57,9,57,41,1);
	LDI  R30,LOW(57)
	ST   -Y,R30
	LDI  R30,LOW(9)
	ST   -Y,R30
	LDI  R30,LOW(57)
	ST   -Y,R30
	LDI  R30,LOW(41)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;lcd_line(57,9,89,9,1);
	LDI  R30,LOW(57)
	ST   -Y,R30
	LDI  R30,LOW(9)
	ST   -Y,R30
	LDI  R30,LOW(89)
	ST   -Y,R30
	LDI  R30,LOW(9)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;lcd_line(89,9,89,41,1);
	LDI  R30,LOW(89)
	ST   -Y,R30
	LDI  R30,LOW(9)
	ST   -Y,R30
	LDI  R30,LOW(89)
	ST   -Y,R30
	LDI  R30,LOW(41)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;lcd_line(57,41,89,41,1);
	LDI  R30,LOW(57)
	ST   -Y,R30
	LDI  R30,LOW(41)
	ST   -Y,R30
	LDI  R30,LOW(89)
	ST   -Y,R30
	LDI  R30,LOW(41)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;
;for (i=0; i<5; i++){
	LDI  R17,LOW(0)
_0x290:
	CPI  R17,5
	BRLO PC+3
	JMP _0x291
;      if (ADmin[i]>AD[i]) ADmin[i]=AD[i];
	MOV  R30,R17
	LDI  R26,LOW(_ADmin)
	LDI  R27,HIGH(_ADmin)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R0,X+
	LD   R1,X
	MOV  R30,R17
	LDI  R26,LOW(_AD)
	LDI  R27,HIGH(_AD)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	CP   R30,R0
	CPC  R31,R1
	BRGE _0x292
	MOV  R30,R17
	LDI  R26,LOW(_ADmin)
	LDI  R27,HIGH(_ADmin)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOV  R30,R17
	LDI  R26,LOW(_AD)
	LDI  R27,HIGH(_AD)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;    if (ADmax[i]<AD[i]) ADmax[i]=AD[i];}
_0x292:
	MOV  R30,R17
	LDI  R26,LOW(_ADmax)
	LDI  R27,HIGH(_ADmax)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R0,X+
	LD   R1,X
	MOV  R30,R17
	LDI  R26,LOW(_AD)
	LDI  R27,HIGH(_AD)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	CP   R0,R30
	CPC  R1,R31
	BRGE _0x293
	MOV  R30,R17
	LDI  R26,LOW(_ADmax)
	LDI  R27,HIGH(_ADmax)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOV  R30,R17
	LDI  R26,LOW(_AD)
	LDI  R27,HIGH(_AD)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
_0x293:
	SUBI R17,-1
	RJMP _0x290
_0x291:
;
;
;x2=(AD[0]-ADmin[0])*28/(ADmax[0]-ADmin[0])+59;
	LDS  R26,_ADmin
	LDS  R27,_ADmin+1
	LDS  R30,_AD
	LDS  R31,_AD+1
	SUB  R30,R26
	SBC  R31,R27
	LDI  R26,LOW(28)
	LDI  R27,HIGH(28)
	CALL __MULW12
	MOVW R0,R30
	LDS  R26,_ADmin
	LDS  R27,_ADmin+1
	LDS  R30,_ADmax
	LDS  R31,_ADmax+1
	SUB  R30,R26
	SBC  R31,R27
	MOVW R26,R0
	CALL __DIVW21
	ADIW R30,59
	MOV  R16,R30
;y2=30-(AD[2]-ADmin[2])*28/(ADmax[2]-ADmin[2])+9;
	__GETW2MN _AD,4
	__GETW1MN _ADmin,4
	SUB  R26,R30
	SBC  R27,R31
	LDI  R30,LOW(28)
	LDI  R31,HIGH(28)
	CALL __MULW12
	MOVW R0,R30
	__GETW1MN _ADmax,4
	__GETW2MN _ADmin,4
	SUB  R30,R26
	SBC  R31,R27
	MOVW R26,R0
	CALL __DIVW21
	LDI  R26,LOW(30)
	LDI  R27,HIGH(30)
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	ADIW R30,9
	MOV  R19,R30
;
;lcd_pixel(x2,y2-2,1);
	ST   -Y,R16
	MOV  R30,R19
	SUBI R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_line(x2-1,y2-1,x2+1,y2-1,1);
	MOV  R30,R16
	SUBI R30,LOW(1)
	ST   -Y,R30
	MOV  R30,R19
	SUBI R30,LOW(1)
	ST   -Y,R30
	MOV  R30,R16
	SUBI R30,-LOW(1)
	ST   -Y,R30
	MOV  R30,R19
	SUBI R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;lcd_line(x2-2,y2,x2+2,y2,1);
	MOV  R30,R16
	SUBI R30,LOW(2)
	ST   -Y,R30
	ST   -Y,R19
	MOV  R30,R16
	SUBI R30,-LOW(2)
	ST   -Y,R30
	ST   -Y,R19
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;lcd_line(x2-1,y2+1,x2+1,y2+1,1);
	MOV  R30,R16
	SUBI R30,LOW(1)
	ST   -Y,R30
	MOV  R30,R19
	SUBI R30,-LOW(1)
	ST   -Y,R30
	MOV  R30,R16
	SUBI R30,-LOW(1)
	ST   -Y,R30
	MOV  R30,R19
	SUBI R30,-LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;lcd_pixel(x2,y2+2,1);
	ST   -Y,R16
	MOV  R30,R19
	SUBI R30,-LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;
;x2=(AD[3]-ADmin[3])*28/(ADmax[3]-ADmin[3])+9            ;
	__GETW2MN _AD,6
	__GETW1MN _ADmin,6
	SUB  R26,R30
	SBC  R27,R31
	LDI  R30,LOW(28)
	LDI  R31,HIGH(28)
	CALL __MULW12
	MOVW R0,R30
	__GETW1MN _ADmax,6
	__GETW2MN _ADmin,6
	SUB  R30,R26
	SBC  R31,R27
	MOVW R26,R0
	CALL __DIVW21
	ADIW R30,9
	MOV  R16,R30
;y2=30-(AD[1]-ADmin[1])*28/(ADmax[1]-ADmin[1])+9;
	__GETW2MN _AD,2
	__GETW1MN _ADmin,2
	SUB  R26,R30
	SBC  R27,R31
	LDI  R30,LOW(28)
	LDI  R31,HIGH(28)
	CALL __MULW12
	MOVW R0,R30
	__GETW1MN _ADmax,2
	__GETW2MN _ADmin,2
	SUB  R30,R26
	SBC  R31,R27
	MOVW R26,R0
	CALL __DIVW21
	LDI  R26,LOW(30)
	LDI  R27,HIGH(30)
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	ADIW R30,9
	MOV  R19,R30
;
;lcd_pixel(x2,y2-2,1);
	ST   -Y,R16
	MOV  R30,R19
	SUBI R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;lcd_line(x2-1,y2-1,x2+1,y2-1,1);
	MOV  R30,R16
	SUBI R30,LOW(1)
	ST   -Y,R30
	MOV  R30,R19
	SUBI R30,LOW(1)
	ST   -Y,R30
	MOV  R30,R16
	SUBI R30,-LOW(1)
	ST   -Y,R30
	MOV  R30,R19
	SUBI R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;lcd_line(x2-2,y2,x2+2,y2,1);
	MOV  R30,R16
	SUBI R30,LOW(2)
	ST   -Y,R30
	ST   -Y,R19
	MOV  R30,R16
	SUBI R30,-LOW(2)
	ST   -Y,R30
	ST   -Y,R19
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;lcd_line(x2-1,y2+1,x2+1,y2+1,1);
	MOV  R30,R16
	SUBI R30,LOW(1)
	ST   -Y,R30
	MOV  R30,R19
	SUBI R30,-LOW(1)
	ST   -Y,R30
	MOV  R30,R16
	SUBI R30,-LOW(1)
	ST   -Y,R30
	MOV  R30,R19
	SUBI R30,-LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_line
;lcd_pixel(x2,y2+2,1);
	ST   -Y,R16
	MOV  R30,R19
	SUBI R30,-LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_pixel
;
;
;x2=(AD[4]-ADmin[4])*50/(ADmax[4]-ADmin[4])+23 ;
	__GETW2MN _AD,8
	__GETW1MN _ADmin,8
	SUB  R26,R30
	SBC  R27,R31
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	CALL __MULW12
	MOVW R0,R30
	__GETW1MN _ADmax,8
	__GETW2MN _ADmin,8
	SUB  R30,R26
	SBC  R31,R27
	MOVW R26,R0
	CALL __DIVW21
	ADIW R30,23
	MOV  R16,R30
;lcd_rectangle(23,50,73,52,1);
	LDI  R30,LOW(23)
	ST   -Y,R30
	LDI  R30,LOW(50)
	ST   -Y,R30
	LDI  R30,LOW(73)
	ST   -Y,R30
	LDI  R30,LOW(52)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_rectangle
;lcd_fillrect(x2-1,48,x2+1,54,1);
	MOV  R30,R16
	SUBI R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(48)
	ST   -Y,R30
	MOV  R30,R16
	SUBI R30,-LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(54)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_fillrect
;
;lcd_refresh();
	CALL _lcd_refresh
;}
	RJMP _0x28C
_0x28E:
;    read_adc(Ailerons);
	LDI  R30,LOW(5)
	ST   -Y,R30
	CALL _read_adc
;        AD[0]=ADCW-ADmid[0];
	IN   R30,0x4
	IN   R31,0x4+1
	LDS  R26,_ADmid
	LDS  R27,_ADmid+1
	SUB  R30,R26
	SBC  R31,R27
	STS  _AD,R30
	STS  _AD+1,R31
;        read_adc(Throttle);
	LDI  R30,LOW(6)
	ST   -Y,R30
	CALL _read_adc
;        AD[2]=ADCW-ADmid[2];
	IN   R30,0x4
	IN   R31,0x4+1
	__GETW2MN _ADmid,4
	SUB  R30,R26
	SBC  R31,R27
	__PUTW1MN _AD,4
;        read_adc(Rudder);
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _read_adc
;        AD[3]=ADCW-ADmid[3];
	IN   R30,0x4
	IN   R31,0x4+1
	__GETW2MN _ADmid,6
	SUB  R30,R26
	SBC  R31,R27
	__PUTW1MN _AD,6
;        read_adc(Elevator);
	LDI  R30,LOW(4)
	ST   -Y,R30
	CALL _read_adc
;        AD[1]=ADCW-ADmid[1];
	IN   R30,0x4
	IN   R31,0x4+1
	__GETW2MN _ADmid,2
	SUB  R30,R26
	SBC  R31,R27
	__PUTW1MN _AD,2
;        read_adc(Rpop_contr);
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _read_adc
;        AD[4]=ADCW-ADmid[4];
	IN   R30,0x4
	IN   R31,0x4+1
	__GETW2MN _ADmid,8
	SUB  R30,R26
	SBC  R31,R27
	__PUTW1MN _AD,8
;        read_adc(Batt);
	LDI  R30,LOW(7)
	ST   -Y,R30
	CALL _read_adc
;        U_bat=ADCW;
	__INWR 4,5,4
;        U_bat=U_bat*2;
	LSL  R4
	ROL  R5
;
;for (i=0; i<5; i++)
	LDI  R17,LOW(0)
_0x295:
	CPI  R17,5
	BRLO PC+3
	JMP _0x296
;        {
;        EEPR_ADmid[i]=AD[i];
	MOV  R30,R17
	LDI  R26,LOW(_EEPR_ADmid)
	LDI  R27,HIGH(_EEPR_ADmid)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOV  R30,R17
	LDI  R26,LOW(_AD)
	LDI  R27,HIGH(_AD)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R0
	CALL __EEPROMWRW
;        t1=7500/(ADmax[i]-AD[i]);
	MOV  R30,R17
	LDI  R26,LOW(_ADmax)
	LDI  R27,HIGH(_ADmax)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R0,X+
	LD   R1,X
	MOV  R30,R17
	LDI  R26,LOW(_AD)
	LDI  R27,HIGH(_AD)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R30
	MOVW R30,R0
	SUB  R30,R26
	SBC  R31,R27
	LDI  R26,LOW(7500)
	LDI  R27,HIGH(7500)
	CALL __DIVW21
	MOVW R20,R30
;        t2=7500/(AD[i]-ADmin[i]);
	MOV  R30,R17
	LDI  R26,LOW(_AD)
	LDI  R27,HIGH(_AD)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R0,X+
	LD   R1,X
	MOV  R30,R17
	LDI  R26,LOW(_ADmin)
	LDI  R27,HIGH(_ADmin)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R30
	MOVW R30,R0
	SUB  R30,R26
	SBC  R31,R27
	LDI  R26,LOW(7500)
	LDI  R27,HIGH(7500)
	CALL __DIVW21
	STD  Y+6,R30
	STD  Y+6+1,R31
;        EEPR_Kmin[i]=t2;
	MOV  R26,R17
	LDI  R27,0
	SUBI R26,LOW(-_EEPR_Kmin)
	SBCI R27,HIGH(-_EEPR_Kmin)
	LDD  R30,Y+6
	CALL __EEPROMWRB
;        EEPR_Kmax[i]=t1;
	MOV  R26,R17
	LDI  R27,0
	SUBI R26,LOW(-_EEPR_Kmax)
	SBCI R27,HIGH(-_EEPR_Kmax)
	MOV  R30,R20
	CALL __EEPROMWRB
;
;         BEEP();
	CALL _BEEP
;          BEEP();
	CALL _BEEP
;        }
	SUBI R17,-1
	RJMP _0x295
_0x296:
;}
	CALL __LOADLOCR6
	ADIW R28,8
	RET
;
;
;
;
;
;
;
;void TX_init (void)
;{ char i;
_TX_init:
;cur_model_num=start_model;
	ST   -Y,R17
;	i -> R17
	LDI  R26,LOW(_start_model)
	LDI  R27,HIGH(_start_model)
	CALL __EEPROMRDB
	STS  _cur_model_num,R30
;
;for (i=0; i<5; i++)
	LDI  R17,LOW(0)
_0x298:
	CPI  R17,5
	BRLT PC+3
	JMP _0x299
;        {
;
;
;        ADmid[i]=EEPR_ADmid[i];
	MOV  R30,R17
	LDI  R26,LOW(_ADmid)
	LDI  R27,HIGH(_ADmid)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOV  R30,R17
	LDI  R26,LOW(_EEPR_ADmid)
	LDI  R27,HIGH(_EEPR_ADmid)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __EEPROMRDW
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;        Kmin[i]=EEPR_Kmin[i];
	MOV  R30,R17
	LDI  R26,LOW(_Kmin)
	LDI  R27,HIGH(_Kmin)
	LDI  R31,0
	CALL __LSLW2
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOV  R26,R17
	LDI  R27,0
	SUBI R26,LOW(-_EEPR_Kmin)
	SBCI R27,HIGH(-_EEPR_Kmin)
	CALL __EEPROMRDB
	MOVW R26,R0
	CALL __CBD1
	CALL __PUTDP1
;        Kmax[i]=EEPR_Kmax[i];
	MOV  R30,R17
	LDI  R26,LOW(_Kmax)
	LDI  R27,HIGH(_Kmax)
	LDI  R31,0
	CALL __LSLW2
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOV  R26,R17
	LDI  R27,0
	SUBI R26,LOW(-_EEPR_Kmax)
	SBCI R27,HIGH(-_EEPR_Kmax)
	CALL __EEPROMRDB
	MOVW R26,R0
	CALL __CBD1
	CALL __PUTDP1
;
;        }
	SUBI R17,-1
	RJMP _0x298
_0x299:
;
;sound=EEPRsound;
	LDI  R26,LOW(_EEPRsound)
	LDI  R27,HIGH(_EEPRsound)
	CALL __EEPROMRDB
	STS  _sound,R30
;MODEL_init();
	CALL _MODEL_init
;
;if (curmodel.modulation==0) TCCR1A=0x82;
	__GETB1MN _curmodel,12
	CPI  R30,0
	BRNE _0x29A
	LDI  R30,LOW(130)
	OUT  0x2F,R30
;if (curmodel.modulation==1) TCCR1A=0xC2;
_0x29A:
	__GETB2MN _curmodel,12
	CPI  R26,LOW(0x1)
	BRNE _0x29B
	LDI  R30,LOW(194)
	OUT  0x2F,R30
;
;if  (curmodel.timer_mode<2)    time=0;
_0x29B:
	__GETB2MN _curmodel,31
	CPI  R26,LOW(0x2)
	BRGE _0x29C
	CLR  R10
	CLR  R11
;                else    time=curmodel.timer;
	RJMP _0x29D
_0x29C:
	__GETWRMN 10,11,_curmodel,29
;
;
;
;}
_0x29D:
	LD   R17,Y+
	RET
;
;void TX_reset (void)
;{#asm("cli")
_TX_reset:
	cli
;lcd_setxy(15,8);
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(8)
	ST   -Y,R30
	CALL _lcd_setxy
;lcd_wrsf("Please",255);
	__POINTW1FN _0x0,625
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;lcd_setxy(25,16);
	LDI  R30,LOW(25)
	ST   -Y,R30
	LDI  R30,LOW(16)
	ST   -Y,R30
	CALL _lcd_setxy
;lcd_wrsf("wait...",255);
	__POINTW1FN _0x0,632
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_wrsf
;
;lcd_rectangle(18,35,78,45,1);
	LDI  R30,LOW(18)
	ST   -Y,R30
	LDI  R30,LOW(35)
	ST   -Y,R30
	LDI  R30,LOW(78)
	ST   -Y,R30
	LDI  R30,LOW(45)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_rectangle
;lcd_refresh();
	CALL _lcd_refresh
;cur_model_num=0;
	LDI  R30,LOW(0)
	STS  _cur_model_num,R30
;MODEL_reset();
	CALL _MODEL_reset
;lcd_fillrect(18,35,33,45,1);
	LDI  R30,LOW(18)
	ST   -Y,R30
	LDI  R30,LOW(35)
	ST   -Y,R30
	LDI  R30,LOW(33)
	ST   -Y,R30
	LDI  R30,LOW(45)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_fillrect
;lcd_refresh();
	CALL _lcd_refresh
;
;cur_model_num=1;
	LDI  R30,LOW(1)
	STS  _cur_model_num,R30
;MODEL_reset();
	CALL _MODEL_reset
;lcd_fillrect(18,35,48,45,1);
	LDI  R30,LOW(18)
	ST   -Y,R30
	LDI  R30,LOW(35)
	ST   -Y,R30
	LDI  R30,LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(45)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_fillrect
;lcd_refresh();
	CALL _lcd_refresh
;
;cur_model_num=2;
	LDI  R30,LOW(2)
	STS  _cur_model_num,R30
;MODEL_reset();
	CALL _MODEL_reset
;lcd_fillrect(18,35,63,45,1);
	LDI  R30,LOW(18)
	ST   -Y,R30
	LDI  R30,LOW(35)
	ST   -Y,R30
	LDI  R30,LOW(63)
	ST   -Y,R30
	LDI  R30,LOW(45)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_fillrect
;lcd_refresh();
	CALL _lcd_refresh
;
;cur_model_num=3;
	LDI  R30,LOW(3)
	STS  _cur_model_num,R30
;MODEL_reset();
	CALL _MODEL_reset
;lcd_fillrect(18,35,78,45,1);
	LDI  R30,LOW(18)
	ST   -Y,R30
	LDI  R30,LOW(35)
	ST   -Y,R30
	LDI  R30,LOW(78)
	ST   -Y,R30
	LDI  R30,LOW(45)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_fillrect
;lcd_refresh();
	CALL _lcd_refresh
;
;start_model=0;
	LDI  R26,LOW(_start_model)
	LDI  R27,HIGH(_start_model)
	LDI  R30,LOW(0)
	CALL __EEPROMWRB
;EEPRsound=1;
	LDI  R26,LOW(_EEPRsound)
	LDI  R27,HIGH(_EEPRsound)
	LDI  R30,LOW(1)
	CALL __EEPROMWRB
;calibr();
	RCALL _calibr
;
;FirstON=1;
	LDI  R26,LOW(_FirstON)
	LDI  R27,HIGH(_FirstON)
	LDI  R30,LOW(1)
	CALL __EEPROMWRB
;#asm("sei")
	sei
;}
	RET
;
;
;#include <math.c>
;
;
;void CHcalc (char i)
; 0000 0039 { signed long Y0;
_CHcalc:
;char j;
;
;
;output[i]=0;
	SBIW R28,4
	ST   -Y,R17
;	i -> Y+5
;	Y0 -> Y+1
;	j -> R17
	LDD  R30,Y+5
	LDI  R26,LOW(_output)
	LDI  R27,HIGH(_output)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
;           for (j=0; j<10; j++)
	LDI  R17,LOW(0)
_0x29F:
	CPI  R17,10
	BRLT PC+3
	JMP _0x2A0
;                {
;                if (chans[i].CH[j][FLY_MODE]!=0)
	LDD  R30,Y+5
	LDI  R26,LOW(88)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_chans)
	SBCI R31,HIGH(-_chans)
	MOVW R26,R30
	MOV  R30,R17
	LDI  R31,0
	CALL __LSLW3
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R7
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	SBIW R30,0
	BRNE PC+3
	JMP _0x2A1
;                        {
;                        Y0=chans[i].CH[j][FLY_MODE];
	LDD  R30,Y+5
	LDI  R26,LOW(88)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_chans)
	SBCI R31,HIGH(-_chans)
	MOVW R26,R30
	MOV  R30,R17
	LDI  R31,0
	CALL __LSLW3
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R7
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	CALL __CWD1
	__PUTD1S 1
;                        output[i]=output[i]+out_cur[j]*Y0/100;
	LDD  R30,Y+5
	LDI  R26,LOW(_output)
	LDI  R27,HIGH(_output)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDD  R30,Y+5
	LDI  R26,LOW(_output)
	LDI  R27,HIGH(_output)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	PUSH R31
	PUSH R30
	MOV  R30,R17
	LDI  R26,LOW(_out_cur)
	LDI  R27,HIGH(_out_cur)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R30
	__GETD1S 1
	CALL __CWD2
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x64
	CALL __DIVD21
	POP  R26
	POP  R27
	CALL __CWD2
	CALL __ADDD12
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;                        }
;                }
_0x2A1:
	SUBI R17,-1
	RJMP _0x29F
_0x2A0:
;
;           Y0=chans[i].CH[10][FLY_MODE];
	LDD  R30,Y+5
	LDI  R26,LOW(88)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _chans,80
	MOVW R26,R30
	MOV  R30,R7
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	CALL __CWD1
	__PUTD1S 1
;           output[i]=output[i]+750*Y0/100+2250;
	LDD  R30,Y+5
	LDI  R26,LOW(_output)
	LDI  R27,HIGH(_output)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDD  R30,Y+5
	LDI  R26,LOW(_output)
	LDI  R27,HIGH(_output)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	PUSH R31
	PUSH R30
	__GETD1S 1
	__GETD2N 0x2EE
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x64
	CALL __DIVD21
	POP  R26
	POP  R27
	CALL __CWD2
	CALL __ADDD12
	__ADDD1N 2250
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;
;}
	LDD  R17,Y+0
	ADIW R28,6
	RET
;
;
;void Calc (void)
;        {  char DUAL[4];
_Calc:
;        int Y2;
;        signed  long k,Y0,Y1;
;
;        //  ;
;
;
;
;        if (timersound&&pen&&(!LEFT||!RIGHT||!UP||!DOWN))
	SBIW R28,16
	ST   -Y,R17
	ST   -Y,R16
;	DUAL -> Y+14
;	Y2 -> R16,R17
;	k -> Y+10
;	Y0 -> Y+6
;	Y1 -> Y+2
	TST  R12
	BREQ _0x2A3
	LDS  R30,_pen
	CPI  R30,0
	BREQ _0x2A3
	SBIS 0x10,6
	RJMP _0x2A4
	SBIS 0x10,7
	RJMP _0x2A4
	SBIS 0x10,4
	RJMP _0x2A4
	SBIC 0x10,5
	RJMP _0x2A3
_0x2A4:
	RJMP _0x2A6
_0x2A3:
	RJMP _0x2A2
_0x2A6:
;                {
;                pen=0;
	LDI  R30,LOW(0)
	STS  _pen,R30
;                timersound=0;
	CLR  R12
;                PORTG&=0xFB;
	LDS  R30,101
	ANDI R30,0xFB
	STS  101,R30
;                trim_sound_en=1;
	LDI  R30,LOW(1)
	STS  _trim_sound_en,R30
;                }
;
;        if (!en&&!LEFT&&pen&&!timersound)
_0x2A2:
	LDS  R30,_en
	CPI  R30,0
	BRNE _0x2A8
	SBIC 0x10,6
	RJMP _0x2A8
	LDS  R30,_pen
	CPI  R30,0
	BREQ _0x2A8
	TST  R12
	BREQ _0x2A9
_0x2A8:
	RJMP _0x2A7
_0x2A9:
;
;                {
;                if  (curmodel.timer_mode<2)    time=0;
	__GETB2MN _curmodel,31
	CPI  R26,LOW(0x2)
	BRGE _0x2AA
	CLR  R10
	CLR  R11
;                else    time=curmodel.timer;
	RJMP _0x2AB
_0x2AA:
	__GETWRMN 10,11,_curmodel,29
;                enable_counting=0;
_0x2AB:
	CLR  R13
;                pen=0;
	LDI  R30,LOW(0)
	STS  _pen,R30
;                 trim_sound_en=1;
	LDI  R30,LOW(1)
	STS  _trim_sound_en,R30
;                }
;
;        if (!en&&!UP&&!timersound&&pen) {enable_counting=0; trim_sound_en=1; pen=0;   }
_0x2A7:
	LDS  R30,_en
	CPI  R30,0
	BRNE _0x2AD
	SBIC 0x10,4
	RJMP _0x2AD
	TST  R12
	BRNE _0x2AD
	LDS  R30,_pen
	CPI  R30,0
	BRNE _0x2AE
_0x2AD:
	RJMP _0x2AC
_0x2AE:
	CLR  R13
	LDI  R30,LOW(1)
	STS  _trim_sound_en,R30
	LDI  R30,LOW(0)
	STS  _pen,R30
;        if (!en&&!DOWN&&!timersound&&pen) {enable_counting=1; trim_sound_en=1; pen=0;}
_0x2AC:
	LDS  R30,_en
	CPI  R30,0
	BRNE _0x2B0
	SBIC 0x10,5
	RJMP _0x2B0
	TST  R12
	BRNE _0x2B0
	LDS  R30,_pen
	CPI  R30,0
	BRNE _0x2B1
_0x2B0:
	RJMP _0x2AF
_0x2B1:
	LDI  R30,LOW(1)
	MOV  R13,R30
	STS  _trim_sound_en,R30
	LDI  R30,LOW(0)
	STS  _pen,R30
;
;
;        if (enable_counting)
_0x2AF:
	TST  R13
	BRNE PC+3
	JMP _0x2B2
;                {
;                temp_time++;
	MOVW R30,R8
	ADIW R30,1
	MOVW R8,R30
;                if (temp_time==50)
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	CP   R30,R8
	CPC  R31,R9
	BRNE _0x2B3
;                        {
;                        temp_time=0;
	CLR  R8
	CLR  R9
;                        if (curmodel.timer_mode<2) time++;
	__GETB2MN _curmodel,31
	CPI  R26,LOW(0x2)
	BRGE _0x2B4
	MOVW R30,R10
	ADIW R30,1
	MOVW R10,R30
	SBIW R30,1
;                        else time--;
	RJMP _0x2B5
_0x2B4:
	MOVW R30,R10
	SBIW R30,1
	MOVW R10,R30
	ADIW R30,1
;                        }
_0x2B5:
;                if (curmodel.timer_mode==0&&time==curmodel.timer&&enable_counting&&time!=0)
_0x2B3:
	__GETB2MN _curmodel,31
	CPI  R26,LOW(0x0)
	BRNE _0x2B7
	__GETW1MN _curmodel,29
	CP   R30,R10
	CPC  R31,R11
	BRNE _0x2B7
	TST  R13
	BREQ _0x2B7
	CLR  R0
	CP   R0,R10
	CPC  R0,R11
	BRNE _0x2B8
_0x2B7:
	RJMP _0x2B6
_0x2B8:
;                        {
;                        counter=0;
	LDI  R30,LOW(0)
	STS  _counter,R30
;                        precounter=0;
	STS  _precounter,R30
;                        timersound=1;
	LDI  R30,LOW(1)
	MOV  R12,R30
;                        }
;
;                if (curmodel.timer_mode==2&&time==0&&enable_counting)
_0x2B6:
	__GETB2MN _curmodel,31
	CPI  R26,LOW(0x2)
	BRNE _0x2BA
	CLR  R0
	CP   R0,R10
	CPC  R0,R11
	BRNE _0x2BA
	TST  R13
	BRNE _0x2BB
_0x2BA:
	RJMP _0x2B9
_0x2BB:
;                        {
;                        enable_counting=0;
	CLR  R13
;                        counter=0;
	LDI  R30,LOW(0)
	STS  _counter,R30
;                        precounter=0;
	STS  _precounter,R30
;                        timersound=1;
	LDI  R30,LOW(1)
	MOV  R12,R30
;                        time=curmodel.timer ;
	__GETWRMN 10,11,_curmodel,29
;                        }
;
;
;                }
_0x2B9:
;
;        if (timersound)
_0x2B2:
	TST  R12
	BREQ _0x2BC
;                {
;
;                 if (precounter==20||precounter==0)
	LDS  R26,_precounter
	CPI  R26,LOW(0x14)
	BREQ _0x2BE
	CPI  R26,LOW(0x0)
	BRNE _0x2BD
_0x2BE:
;                        {
;                        precounter=0;
	LDI  R30,LOW(0)
	STS  _precounter,R30
;                        counter++;
	LDS  R30,_counter
	SUBI R30,-LOW(1)
	STS  _counter,R30
;                        if (counter%2==0) PORTG|=0x4;
	LDS  R26,_counter
	LDI  R30,LOW(2)
	CALL __MODB21
	CPI  R30,0
	BRNE _0x2C0
	LDS  R30,101
	ORI  R30,4
	RJMP _0x36C
;                        else PORTG&=0xFB;
_0x2C0:
	LDS  R30,101
	ANDI R30,0xFB
_0x36C:
	STS  101,R30
;                        }
;                 if (counter==25) timersound=0;
_0x2BD:
	LDS  R26,_counter
	CPI  R26,LOW(0x19)
	BRNE _0x2C2
	CLR  R12
;
;                precounter++;
_0x2C2:
	LDS  R30,_precounter
	SUBI R30,-LOW(1)
	STS  _precounter,R30
;                }
;
;
;
;
;        //  
;       if (!MODE_KEY2) FLY_MODE=0;
_0x2BC:
	SBIS 0x1,7
	CLR  R7
;         if (MODE_KEY1&&MODE_KEY2) FLY_MODE=1;
	SBIS 0x1,6
	RJMP _0x2C5
	SBIC 0x1,7
	RJMP _0x2C6
_0x2C5:
	RJMP _0x2C4
_0x2C6:
	LDI  R30,LOW(1)
	MOV  R7,R30
;         if (!MODE_KEY1) FLY_MODE=2;
_0x2C4:
	SBIC 0x1,6
	RJMP _0x2C7
	LDI  R30,LOW(2)
	MOV  R7,R30
;        // 
;        if (Pre_Trim)
_0x2C7:
	SBRS R2,0
	RJMP _0x2C8
;        {
;        if (!trim_0up&&curmodel.trimmer[FLY_MODE][0]<80) {curmodel.trimmer[FLY_MODE][0]++;  S_trim[0]=1; trim_sound_en=1;  }
	SBIC 0x19,3
	RJMP _0x2CA
	__POINTW2MN _curmodel,13
	MOV  R30,R7
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	LD   R26,X
	CPI  R26,LOW(0x50)
	BRLT _0x2CB
_0x2CA:
	RJMP _0x2C9
_0x2CB:
	__POINTW2MN _curmodel,13
	MOV  R30,R7
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	SUBI R30,-LOW(1)
	ST   X,R30
	LDI  R30,LOW(1)
	STS  _S_trim,R30
	STS  _trim_sound_en,R30
;        if (!trim_0down&&curmodel.trimmer[FLY_MODE][0]>-80){ curmodel.trimmer[FLY_MODE][0]--;  S_trim[0]=1; trim_sound_en=1; }
_0x2C9:
	SBIC 0x19,0
	RJMP _0x2CD
	__POINTW2MN _curmodel,13
	MOV  R30,R7
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	LD   R26,X
	LDI  R30,LOW(176)
	CP   R30,R26
	BRLT _0x2CE
_0x2CD:
	RJMP _0x2CC
_0x2CE:
	__POINTW2MN _curmodel,13
	MOV  R30,R7
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	SUBI R30,LOW(1)
	ST   X,R30
	LDI  R30,LOW(1)
	STS  _S_trim,R30
	STS  _trim_sound_en,R30
;
;        if (!trim_1up&&curmodel.trimmer[FLY_MODE][1]<80) {curmodel.trimmer[FLY_MODE][1]++;  S_trim[1]=1; trim_sound_en=1; }
_0x2CC:
	SBIC 0x19,1
	RJMP _0x2D0
	__POINTW2MN _curmodel,13
	MOV  R30,R7
	LDI  R31,0
	CALL __LSLW2
	ADD  R30,R26
	ADC  R31,R27
	LDD  R30,Z+1
	CPI  R30,LOW(0x50)
	BRLT _0x2D1
_0x2D0:
	RJMP _0x2CF
_0x2D1:
	__POINTW2MN _curmodel,13
	MOV  R30,R7
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,1
	LD   R30,X
	SUBI R30,-LOW(1)
	ST   X,R30
	LDI  R30,LOW(1)
	__PUTB1MN _S_trim,1
	STS  _trim_sound_en,R30
;        if (!trim_1down&&curmodel.trimmer[FLY_MODE][1]>-80){ curmodel.trimmer[FLY_MODE][1]--;  S_trim[1]=1; trim_sound_en=1; }
_0x2CF:
	SBIC 0x19,2
	RJMP _0x2D3
	__POINTW2MN _curmodel,13
	MOV  R30,R7
	LDI  R31,0
	CALL __LSLW2
	ADD  R30,R26
	ADC  R31,R27
	LDD  R30,Z+1
	MOV  R26,R30
	LDI  R30,LOW(176)
	CP   R30,R26
	BRLT _0x2D4
_0x2D3:
	RJMP _0x2D2
_0x2D4:
	__POINTW2MN _curmodel,13
	MOV  R30,R7
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,1
	LD   R30,X
	SUBI R30,LOW(1)
	ST   X,R30
	LDI  R30,LOW(1)
	__PUTB1MN _S_trim,1
	STS  _trim_sound_en,R30
;
;        if (!trim_2up&&curmodel.trimmer[FLY_MODE][2]<80) {curmodel.trimmer[FLY_MODE][2]++;  S_trim[2]=1; trim_sound_en=1; }
_0x2D2:
	SBIC 0x19,5
	RJMP _0x2D6
	__POINTW2MN _curmodel,13
	MOV  R30,R7
	LDI  R31,0
	CALL __LSLW2
	ADD  R30,R26
	ADC  R31,R27
	LDD  R30,Z+2
	CPI  R30,LOW(0x50)
	BRLT _0x2D7
_0x2D6:
	RJMP _0x2D5
_0x2D7:
	__POINTW2MN _curmodel,13
	MOV  R30,R7
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,2
	LD   R30,X
	SUBI R30,-LOW(1)
	ST   X,R30
	LDI  R30,LOW(1)
	__PUTB1MN _S_trim,2
	STS  _trim_sound_en,R30
;        if (!trim_2down&&curmodel.trimmer[FLY_MODE][2]>-80){ curmodel.trimmer[FLY_MODE][2]--;  S_trim[2]=1; trim_sound_en=1; }
_0x2D5:
	SBIC 0x19,4
	RJMP _0x2D9
	__POINTW2MN _curmodel,13
	MOV  R30,R7
	LDI  R31,0
	CALL __LSLW2
	ADD  R30,R26
	ADC  R31,R27
	LDD  R30,Z+2
	MOV  R26,R30
	LDI  R30,LOW(176)
	CP   R30,R26
	BRLT _0x2DA
_0x2D9:
	RJMP _0x2D8
_0x2DA:
	__POINTW2MN _curmodel,13
	MOV  R30,R7
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,2
	LD   R30,X
	SUBI R30,LOW(1)
	ST   X,R30
	LDI  R30,LOW(1)
	__PUTB1MN _S_trim,2
	STS  _trim_sound_en,R30
;
;        if (!trim_3up&&curmodel.trimmer[FLY_MODE][3]<80){ curmodel.trimmer[FLY_MODE][3]++;  S_trim[3]=1; trim_sound_en=1; }
_0x2D8:
	SBIC 0x19,7
	RJMP _0x2DC
	__POINTW2MN _curmodel,13
	MOV  R30,R7
	LDI  R31,0
	CALL __LSLW2
	ADD  R30,R26
	ADC  R31,R27
	LDD  R30,Z+3
	CPI  R30,LOW(0x50)
	BRLT _0x2DD
_0x2DC:
	RJMP _0x2DB
_0x2DD:
	__POINTW2MN _curmodel,13
	MOV  R30,R7
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,3
	LD   R30,X
	SUBI R30,-LOW(1)
	ST   X,R30
	LDI  R30,LOW(1)
	__PUTB1MN _S_trim,3
	STS  _trim_sound_en,R30
;        if (!trim_3down&&curmodel.trimmer[FLY_MODE][3]>-80) {curmodel.trimmer[FLY_MODE][3]--;  S_trim[3]=1; trim_sound_en=1; }
_0x2DB:
	SBIC 0x19,6
	RJMP _0x2DF
	__POINTW2MN _curmodel,13
	MOV  R30,R7
	LDI  R31,0
	CALL __LSLW2
	ADD  R30,R26
	ADC  R31,R27
	LDD  R30,Z+3
	MOV  R26,R30
	LDI  R30,LOW(176)
	CP   R30,R26
	BRLT _0x2E0
_0x2DF:
	RJMP _0x2DE
_0x2E0:
	__POINTW2MN _curmodel,13
	MOV  R30,R7
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,3
	LD   R30,X
	SUBI R30,LOW(1)
	ST   X,R30
	LDI  R30,LOW(1)
	__PUTB1MN _S_trim,3
	STS  _trim_sound_en,R30
;        }
_0x2DE:
;        Pre_Trim=!Pre_Trim;
_0x2C8:
	LDI  R30,LOW(1)
	EOR  R2,R30
;        //   
;
;        if (!Tcut_KEY&&input[2]+500<0) Cut_enable=1;
	SBIC 0x13,3
	RJMP _0x2E2
	__GETW2MN _input,4
	SUBI R26,LOW(-500)
	SBCI R27,HIGH(-500)
	TST  R27
	BRMI _0x2E3
_0x2E2:
	RJMP _0x2E1
_0x2E3:
	LDI  R30,LOW(1)
	MOV  R6,R30
;
;        if (input[2]+500>0) Cut_enable=0;
_0x2E1:
	__GETW2MN _input,4
	SUBI R26,LOW(-500)
	SBCI R27,HIGH(-500)
	CALL __CPW02
	BRGE _0x2E4
	CLR  R6
;
;        read_adc(Ailerons);
_0x2E4:
	LDI  R30,LOW(5)
	ST   -Y,R30
	CALL _read_adc
;        AD[0]=ADCW-ADmid[0];
	IN   R30,0x4
	IN   R31,0x4+1
	LDS  R26,_ADmid
	LDS  R27,_ADmid+1
	SUB  R30,R26
	SBC  R31,R27
	STS  _AD,R30
	STS  _AD+1,R31
;        read_adc(Throttle);
	LDI  R30,LOW(6)
	ST   -Y,R30
	CALL _read_adc
;        AD[2]=ADCW-ADmid[2];
	IN   R30,0x4
	IN   R31,0x4+1
	__GETW2MN _ADmid,4
	SUB  R30,R26
	SBC  R31,R27
	__PUTW1MN _AD,4
;        read_adc(Rudder);
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _read_adc
;        AD[3]=ADCW-ADmid[3];
	IN   R30,0x4
	IN   R31,0x4+1
	__GETW2MN _ADmid,6
	SUB  R30,R26
	SBC  R31,R27
	__PUTW1MN _AD,6
;        read_adc(Elevator);
	LDI  R30,LOW(4)
	ST   -Y,R30
	CALL _read_adc
;        AD[1]=ADCW-ADmid[1];
	IN   R30,0x4
	IN   R31,0x4+1
	__GETW2MN _ADmid,2
	SUB  R30,R26
	SBC  R31,R27
	__PUTW1MN _AD,2
;        read_adc(Rpop_contr);
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _read_adc
;        AD[4]=ADCW-ADmid[4];
	IN   R30,0x4
	IN   R31,0x4+1
	__GETW2MN _ADmid,8
	SUB  R30,R26
	SBC  R31,R27
	__PUTW1MN _AD,8
;        read_adc(Batt);
	LDI  R30,LOW(7)
	ST   -Y,R30
	CALL _read_adc
;        U_bat=ADCW;
	__INWR 4,5,4
;        U_bat=U_bat*2;
	LSL  R4
	ROL  R5
;
;        if(!SW1)input[4]=-750;
	SBIC 0x1,4
	RJMP _0x2E5
	__POINTW1MN _input,8
	LDI  R26,LOW(64786)
	LDI  R27,HIGH(64786)
	RJMP _0x36D
;        else input[4]=750;
_0x2E5:
	__POINTW1MN _input,8
	LDI  R26,LOW(750)
	LDI  R27,HIGH(750)
_0x36D:
	STD  Z+0,R26
	STD  Z+1,R27
;
;        if(!SW2_1)input[5]=750;
	SBIC 0x1,3
	RJMP _0x2E7
	__POINTW1MN _input,10
	LDI  R26,LOW(750)
	LDI  R27,HIGH(750)
	STD  Z+0,R26
	STD  Z+1,R27
;        if(SW2_1&&SW2_2)input[5]=0;
_0x2E7:
	SBIS 0x1,3
	RJMP _0x2E9
	SBIC 0x1,2
	RJMP _0x2EA
_0x2E9:
	RJMP _0x2E8
_0x2EA:
	__POINTW1MN _input,10
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	STD  Z+0,R26
	STD  Z+1,R27
;        if(!SW2_2)input[5]=-750;
_0x2E8:
	SBIC 0x1,2
	RJMP _0x2EB
	__POINTW1MN _input,10
	LDI  R26,LOW(64786)
	LDI  R27,HIGH(64786)
	STD  Z+0,R26
	STD  Z+1,R27
;
;        if(!SW3)input[6]=-750;
_0x2EB:
	SBIC 0x1,5
	RJMP _0x2EC
	__POINTW1MN _input,12
	LDI  R26,LOW(64786)
	LDI  R27,HIGH(64786)
	RJMP _0x36E
;        else input[6]=750;
_0x2EC:
	__POINTW1MN _input,12
	LDI  R26,LOW(750)
	LDI  R27,HIGH(750)
_0x36E:
	STD  Z+0,R26
	STD  Z+1,R27
;
;
;
;        for (i=0; i<4; i++)
	LDI  R30,LOW(0)
	STS  _i,R30
_0x2EF:
	LDS  R26,_i
	CPI  R26,LOW(0x4)
	BRLO PC+3
	JMP _0x2F0
;        {
;          if (AD[i]>0) input[i]=AD[i]*Kmax[i]/10;
	LDS  R30,_i
	LDI  R26,LOW(_AD)
	LDI  R27,HIGH(_AD)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R30
	CALL __CPW02
	BRGE _0x2F1
	LDS  R30,_i
	LDI  R26,LOW(_input)
	LDI  R27,HIGH(_input)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDS  R30,_i
	LDI  R26,LOW(_AD)
	LDI  R27,HIGH(_AD)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R0,X+
	LD   R1,X
	LDS  R30,_i
	LDI  R26,LOW(_Kmax)
	LDI  R27,HIGH(_Kmax)
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETD1P
	MOVW R26,R0
	CALL __CWD2
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0xA
	CALL __DIVD21
	POP  R26
	POP  R27
	RJMP _0x36F
;          else input[i]=AD[i]*Kmin[i]/10;
_0x2F1:
	LDS  R30,_i
	LDI  R26,LOW(_input)
	LDI  R27,HIGH(_input)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDS  R30,_i
	LDI  R26,LOW(_AD)
	LDI  R27,HIGH(_AD)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R0,X+
	LD   R1,X
	LDS  R30,_i
	LDI  R26,LOW(_Kmin)
	LDI  R27,HIGH(_Kmin)
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETD1P
	MOVW R26,R0
	CALL __CWD2
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0xA
	CALL __DIVD21
	POP  R26
	POP  R27
_0x36F:
	ST   X+,R30
	ST   X,R31
;        }
	LDS  R30,_i
	SUBI R30,-LOW(1)
	STS  _i,R30
	RJMP _0x2EF
_0x2F0:
;
;
;
;
;
;        input[8]=input[contr[8].from[FLY_MODE]];
	__POINTW2MN _contr,436
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	LDI  R26,LOW(_input)
	LDI  R27,HIGH(_input)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	__PUTW1MN _input,16
;        input[9]=input[contr[9].from[FLY_MODE]];
	__POINTW2MN _contr,488
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	LDI  R26,LOW(_input)
	LDI  R27,HIGH(_input)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	__PUTW1MN _input,18
;
;
;
;
;
;
;        if (AD[4]>0) input[7]=AD[4]*Kmax[4]/10;
	__GETW2MN _AD,8
	CALL __CPW02
	BRGE _0x2F3
	__GETW2MN _AD,8
	__GETD1MN _Kmax,16
	RJMP _0x370
;        else input[7]=AD[4]*Kmin[4]/10;
_0x2F3:
	__GETW2MN _AD,8
	__GETD1MN _Kmin,16
_0x370:
	CALL __CWD2
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0xA
	CALL __DIVD21
	__PUTW1MN _input,14
;
;
;
;
;        for (i=0; i<4; i++)
	LDI  R30,LOW(0)
	STS  _i,R30
_0x2F6:
	LDS  R26,_i
	CPI  R26,LOW(0x4)
	BRLO PC+3
	JMP _0x2F7
;        {if (input[i]<=-500)
	LDS  R30,_i
	LDI  R26,LOW(_input)
	LDI  R27,HIGH(_input)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R30
	LDI  R30,LOW(65036)
	LDI  R31,HIGH(65036)
	CP   R30,R26
	CPC  R31,R27
	BRGE PC+3
	JMP _0x2F8
;                {
;                 Y1=contr[i].nodes[1][FLY_MODE];
	LDS  R30,_i
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,24
	ADIW R30,4
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	CALL __CBD1
	__PUTD1S 2
;                 Y0=contr[i].nodes[0][FLY_MODE];
	LDS  R30,_i
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,24
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	CALL __CBD1
	__PUTD1S 6
;                 k=(Y1-Y0)*3;
	__GETD2S 6
	__GETD1S 2
	CALL __SUBD12
	__GETD2N 0x3
	CALL __MULD12
	__PUTD1S 10
;                 out_cur[i]=(input[i]+750)*k/100+Y0*75/10;
	LDS  R30,_i
	LDI  R26,LOW(_out_cur)
	LDI  R27,HIGH(_out_cur)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDS  R30,_i
	LDI  R26,LOW(_input)
	LDI  R27,HIGH(_input)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	SUBI R30,LOW(-750)
	SBCI R31,HIGH(-750)
	MOVW R26,R30
	__GETD1S 10
	CALL __CWD2
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x64
	CALL __DIVD21
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	__GETD2S 6
	__GETD1N 0x4B
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0xA
	CALL __DIVD21
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDD12
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;                }
;
;        if (input[i]<=-250&&input[i]>-500)
_0x2F8:
	LDS  R30,_i
	LDI  R26,LOW(_input)
	LDI  R27,HIGH(_input)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R0,R30
	MOVW R26,R30
	LDI  R30,LOW(65286)
	LDI  R31,HIGH(65286)
	CP   R30,R26
	CPC  R31,R27
	BRLT _0x2FA
	LDI  R30,LOW(65036)
	LDI  R31,HIGH(65036)
	CP   R30,R0
	CPC  R31,R1
	BRLT _0x2FB
_0x2FA:
	RJMP _0x2F9
_0x2FB:
;                {
;                 Y1=contr[i].nodes[2][FLY_MODE];
	LDS  R30,_i
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,24
	ADIW R30,8
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	CALL __CBD1
	__PUTD1S 2
;                 Y0=contr[i].nodes[1][FLY_MODE];
	LDS  R30,_i
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,24
	ADIW R30,4
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	CALL __CBD1
	__PUTD1S 6
;                 k=(Y1-Y0)*3;
	__GETD2S 6
	__GETD1S 2
	CALL __SUBD12
	__GETD2N 0x3
	CALL __MULD12
	__PUTD1S 10
;                 out_cur[i]=(input[i]+500)*k/100+Y0*75/10;
	LDS  R30,_i
	LDI  R26,LOW(_out_cur)
	LDI  R27,HIGH(_out_cur)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDS  R30,_i
	LDI  R26,LOW(_input)
	LDI  R27,HIGH(_input)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	SUBI R30,LOW(-500)
	SBCI R31,HIGH(-500)
	MOVW R26,R30
	__GETD1S 10
	CALL __CWD2
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x64
	CALL __DIVD21
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	__GETD2S 6
	__GETD1N 0x4B
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0xA
	CALL __DIVD21
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDD12
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;                }
;
;        if (input[i]<=0&&input[i]>-250)
_0x2F9:
	LDS  R30,_i
	LDI  R26,LOW(_input)
	LDI  R27,HIGH(_input)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R30
	CALL __CPW02
	BRLT _0x2FD
	MOVW R26,R30
	LDI  R30,LOW(65286)
	LDI  R31,HIGH(65286)
	CP   R30,R26
	CPC  R31,R27
	BRLT _0x2FE
_0x2FD:
	RJMP _0x2FC
_0x2FE:
;                {
;                 Y1=contr[i].nodes[3][FLY_MODE];
	LDS  R30,_i
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,24
	ADIW R30,12
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	CALL __CBD1
	__PUTD1S 2
;                 Y0=contr[i].nodes[2][FLY_MODE];
	LDS  R30,_i
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,24
	ADIW R30,8
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	CALL __CBD1
	__PUTD1S 6
;                 k=(Y1-Y0)*3;
	__GETD2S 6
	__GETD1S 2
	CALL __SUBD12
	__GETD2N 0x3
	CALL __MULD12
	__PUTD1S 10
;                 out_cur[i]=(input[i]+250)*k/100+Y0*75/10;
	LDS  R30,_i
	LDI  R26,LOW(_out_cur)
	LDI  R27,HIGH(_out_cur)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDS  R30,_i
	LDI  R26,LOW(_input)
	LDI  R27,HIGH(_input)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	SUBI R30,LOW(-250)
	SBCI R31,HIGH(-250)
	MOVW R26,R30
	__GETD1S 10
	CALL __CWD2
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x64
	CALL __DIVD21
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	__GETD2S 6
	__GETD1N 0x4B
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0xA
	CALL __DIVD21
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDD12
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;                }
;         if (input[i]<=250&&input[i]>0)
_0x2FC:
	LDS  R30,_i
	LDI  R26,LOW(_input)
	LDI  R27,HIGH(_input)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	CPI  R30,LOW(0xFB)
	LDI  R26,HIGH(0xFB)
	CPC  R31,R26
	BRGE _0x300
	MOVW R26,R30
	CALL __CPW02
	BRLT _0x301
_0x300:
	RJMP _0x2FF
_0x301:
;                {
;                 Y1=contr[i].nodes[4][FLY_MODE];
	LDS  R30,_i
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,24
	ADIW R30,16
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	CALL __CBD1
	__PUTD1S 2
;                 Y0=contr[i].nodes[3][FLY_MODE];
	LDS  R30,_i
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,24
	ADIW R30,12
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	CALL __CBD1
	__PUTD1S 6
;                 k=(Y1-Y0)*3;
	__GETD2S 6
	__GETD1S 2
	CALL __SUBD12
	__GETD2N 0x3
	CALL __MULD12
	__PUTD1S 10
;                 out_cur[i]=input[i]*k/100+Y0*75/10;
	LDS  R30,_i
	LDI  R26,LOW(_out_cur)
	LDI  R27,HIGH(_out_cur)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDS  R30,_i
	LDI  R26,LOW(_input)
	LDI  R27,HIGH(_input)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R30
	__GETD1S 10
	CALL __CWD2
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x64
	CALL __DIVD21
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	__GETD2S 6
	__GETD1N 0x4B
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0xA
	CALL __DIVD21
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDD12
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;                }
;          if (input[i]<=500&&input[i]>250)
_0x2FF:
	LDS  R30,_i
	LDI  R26,LOW(_input)
	LDI  R27,HIGH(_input)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	CPI  R30,LOW(0x1F5)
	LDI  R26,HIGH(0x1F5)
	CPC  R31,R26
	BRGE _0x303
	CPI  R30,LOW(0xFB)
	LDI  R26,HIGH(0xFB)
	CPC  R31,R26
	BRGE _0x304
_0x303:
	RJMP _0x302
_0x304:
;                {
;                 Y1=contr[i].nodes[5][FLY_MODE];
	LDS  R30,_i
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,24
	ADIW R30,20
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	CALL __CBD1
	__PUTD1S 2
;                 Y0=contr[i].nodes[4][FLY_MODE];
	LDS  R30,_i
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,24
	ADIW R30,16
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	CALL __CBD1
	__PUTD1S 6
;                 k=(Y1-Y0)*3;
	__GETD2S 6
	__GETD1S 2
	CALL __SUBD12
	__GETD2N 0x3
	CALL __MULD12
	__PUTD1S 10
;                 out_cur[i]=(input[i]-250)*k/100+Y0*75/10;
	LDS  R30,_i
	LDI  R26,LOW(_out_cur)
	LDI  R27,HIGH(_out_cur)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDS  R30,_i
	LDI  R26,LOW(_input)
	LDI  R27,HIGH(_input)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	SUBI R30,LOW(250)
	SBCI R31,HIGH(250)
	MOVW R26,R30
	__GETD1S 10
	CALL __CWD2
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x64
	CALL __DIVD21
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	__GETD2S 6
	__GETD1N 0x4B
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0xA
	CALL __DIVD21
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDD12
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;                }
;
;        if (input[i]>500)
_0x302:
	LDS  R30,_i
	LDI  R26,LOW(_input)
	LDI  R27,HIGH(_input)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	CPI  R30,LOW(0x1F5)
	LDI  R26,HIGH(0x1F5)
	CPC  R31,R26
	BRGE PC+3
	JMP _0x305
;                {
;                 Y1=contr[i].nodes[6][FLY_MODE];
	LDS  R30,_i
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,24
	ADIW R30,24
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	CALL __CBD1
	__PUTD1S 2
;                 Y0=contr[i].nodes[5][FLY_MODE];
	LDS  R30,_i
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,24
	ADIW R30,20
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	CALL __CBD1
	__PUTD1S 6
;                 k=(Y1-Y0)*3;
	__GETD2S 6
	__GETD1S 2
	CALL __SUBD12
	__GETD2N 0x3
	CALL __MULD12
	__PUTD1S 10
;                 out_cur[i]=(input[i]-500)*k/100+Y0*75/10;
	LDS  R30,_i
	LDI  R26,LOW(_out_cur)
	LDI  R27,HIGH(_out_cur)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDS  R30,_i
	LDI  R26,LOW(_input)
	LDI  R27,HIGH(_input)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	SUBI R30,LOW(500)
	SBCI R31,HIGH(500)
	MOVW R26,R30
	__GETD1S 10
	CALL __CWD2
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x64
	CALL __DIVD21
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	__GETD2S 6
	__GETD1N 0x4B
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0xA
	CALL __DIVD21
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDD12
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;                }
;
;
;        }
_0x305:
	LDS  R30,_i
	SUBI R30,-LOW(1)
	STS  _i,R30
	RJMP _0x2F6
_0x2F7:
;        for (i=7; i<10; i++)
	LDI  R30,LOW(7)
	STS  _i,R30
_0x307:
	LDS  R26,_i
	CPI  R26,LOW(0xA)
	BRLO PC+3
	JMP _0x308
;        {
;
;        if (input[i]<=-500)
	LDS  R30,_i
	LDI  R26,LOW(_input)
	LDI  R27,HIGH(_input)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R30
	LDI  R30,LOW(65036)
	LDI  R31,HIGH(65036)
	CP   R30,R26
	CPC  R31,R27
	BRGE PC+3
	JMP _0x309
;                {
;                 Y1=contr[i].nodes[1][FLY_MODE];
	LDS  R30,_i
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,24
	ADIW R30,4
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	CALL __CBD1
	__PUTD1S 2
;                 Y0=contr[i].nodes[0][FLY_MODE];
	LDS  R30,_i
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,24
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	CALL __CBD1
	__PUTD1S 6
;                 k=(Y1-Y0)*3;
	__GETD2S 6
	__GETD1S 2
	CALL __SUBD12
	__GETD2N 0x3
	CALL __MULD12
	__PUTD1S 10
;                 out_cur[i]=(input[i]+750)*k/100+Y0*75/10;
	LDS  R30,_i
	LDI  R26,LOW(_out_cur)
	LDI  R27,HIGH(_out_cur)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDS  R30,_i
	LDI  R26,LOW(_input)
	LDI  R27,HIGH(_input)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	SUBI R30,LOW(-750)
	SBCI R31,HIGH(-750)
	MOVW R26,R30
	__GETD1S 10
	CALL __CWD2
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x64
	CALL __DIVD21
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	__GETD2S 6
	__GETD1N 0x4B
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0xA
	CALL __DIVD21
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDD12
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;                }
;
;        if (input[i]<=-250&&input[i]>-500)
_0x309:
	LDS  R30,_i
	LDI  R26,LOW(_input)
	LDI  R27,HIGH(_input)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R0,R30
	MOVW R26,R30
	LDI  R30,LOW(65286)
	LDI  R31,HIGH(65286)
	CP   R30,R26
	CPC  R31,R27
	BRLT _0x30B
	LDI  R30,LOW(65036)
	LDI  R31,HIGH(65036)
	CP   R30,R0
	CPC  R31,R1
	BRLT _0x30C
_0x30B:
	RJMP _0x30A
_0x30C:
;                {
;                 Y1=contr[i].nodes[2][FLY_MODE];
	LDS  R30,_i
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,24
	ADIW R30,8
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	CALL __CBD1
	__PUTD1S 2
;                 Y0=contr[i].nodes[1][FLY_MODE];
	LDS  R30,_i
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,24
	ADIW R30,4
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	CALL __CBD1
	__PUTD1S 6
;                 k=(Y1-Y0)*3;
	__GETD2S 6
	__GETD1S 2
	CALL __SUBD12
	__GETD2N 0x3
	CALL __MULD12
	__PUTD1S 10
;                 out_cur[i]=(input[i]+500)*k/100+Y0*75/10;
	LDS  R30,_i
	LDI  R26,LOW(_out_cur)
	LDI  R27,HIGH(_out_cur)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDS  R30,_i
	LDI  R26,LOW(_input)
	LDI  R27,HIGH(_input)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	SUBI R30,LOW(-500)
	SBCI R31,HIGH(-500)
	MOVW R26,R30
	__GETD1S 10
	CALL __CWD2
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x64
	CALL __DIVD21
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	__GETD2S 6
	__GETD1N 0x4B
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0xA
	CALL __DIVD21
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDD12
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;                }
;
;        if (input[i]<=0&&input[i]>-250)
_0x30A:
	LDS  R30,_i
	LDI  R26,LOW(_input)
	LDI  R27,HIGH(_input)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R30
	CALL __CPW02
	BRLT _0x30E
	MOVW R26,R30
	LDI  R30,LOW(65286)
	LDI  R31,HIGH(65286)
	CP   R30,R26
	CPC  R31,R27
	BRLT _0x30F
_0x30E:
	RJMP _0x30D
_0x30F:
;                {
;                 Y1=contr[i].nodes[3][FLY_MODE];
	LDS  R30,_i
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,24
	ADIW R30,12
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	CALL __CBD1
	__PUTD1S 2
;                 Y0=contr[i].nodes[2][FLY_MODE];
	LDS  R30,_i
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,24
	ADIW R30,8
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	CALL __CBD1
	__PUTD1S 6
;                 k=(Y1-Y0)*3;
	__GETD2S 6
	__GETD1S 2
	CALL __SUBD12
	__GETD2N 0x3
	CALL __MULD12
	__PUTD1S 10
;                 out_cur[i]=(input[i]+250)*k/100+Y0*75/10;
	LDS  R30,_i
	LDI  R26,LOW(_out_cur)
	LDI  R27,HIGH(_out_cur)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDS  R30,_i
	LDI  R26,LOW(_input)
	LDI  R27,HIGH(_input)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	SUBI R30,LOW(-250)
	SBCI R31,HIGH(-250)
	MOVW R26,R30
	__GETD1S 10
	CALL __CWD2
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x64
	CALL __DIVD21
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	__GETD2S 6
	__GETD1N 0x4B
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0xA
	CALL __DIVD21
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDD12
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;                }
;         if (input[i]<=250&&input[i]>0)
_0x30D:
	LDS  R30,_i
	LDI  R26,LOW(_input)
	LDI  R27,HIGH(_input)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	CPI  R30,LOW(0xFB)
	LDI  R26,HIGH(0xFB)
	CPC  R31,R26
	BRGE _0x311
	MOVW R26,R30
	CALL __CPW02
	BRLT _0x312
_0x311:
	RJMP _0x310
_0x312:
;                {
;                 Y1=contr[i].nodes[4][FLY_MODE];
	LDS  R30,_i
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,24
	ADIW R30,16
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	CALL __CBD1
	__PUTD1S 2
;                 Y0=contr[i].nodes[3][FLY_MODE];
	LDS  R30,_i
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,24
	ADIW R30,12
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	CALL __CBD1
	__PUTD1S 6
;                 k=(Y1-Y0)*3;
	__GETD2S 6
	__GETD1S 2
	CALL __SUBD12
	__GETD2N 0x3
	CALL __MULD12
	__PUTD1S 10
;                 out_cur[i]=input[i]*k/100+Y0*75/10;
	LDS  R30,_i
	LDI  R26,LOW(_out_cur)
	LDI  R27,HIGH(_out_cur)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDS  R30,_i
	LDI  R26,LOW(_input)
	LDI  R27,HIGH(_input)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R30
	__GETD1S 10
	CALL __CWD2
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x64
	CALL __DIVD21
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	__GETD2S 6
	__GETD1N 0x4B
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0xA
	CALL __DIVD21
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDD12
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;                }
;          if (input[i]<=500&&input[i]>250)
_0x310:
	LDS  R30,_i
	LDI  R26,LOW(_input)
	LDI  R27,HIGH(_input)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	CPI  R30,LOW(0x1F5)
	LDI  R26,HIGH(0x1F5)
	CPC  R31,R26
	BRGE _0x314
	CPI  R30,LOW(0xFB)
	LDI  R26,HIGH(0xFB)
	CPC  R31,R26
	BRGE _0x315
_0x314:
	RJMP _0x313
_0x315:
;                {
;                 Y1=contr[i].nodes[5][FLY_MODE];
	LDS  R30,_i
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,24
	ADIW R30,20
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	CALL __CBD1
	__PUTD1S 2
;                 Y0=contr[i].nodes[4][FLY_MODE];
	LDS  R30,_i
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,24
	ADIW R30,16
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	CALL __CBD1
	__PUTD1S 6
;                 k=(Y1-Y0)*3;
	__GETD2S 6
	__GETD1S 2
	CALL __SUBD12
	__GETD2N 0x3
	CALL __MULD12
	__PUTD1S 10
;                 out_cur[i]=(input[i]-250)*k/100+Y0*75/10;
	LDS  R30,_i
	LDI  R26,LOW(_out_cur)
	LDI  R27,HIGH(_out_cur)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDS  R30,_i
	LDI  R26,LOW(_input)
	LDI  R27,HIGH(_input)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	SUBI R30,LOW(250)
	SBCI R31,HIGH(250)
	MOVW R26,R30
	__GETD1S 10
	CALL __CWD2
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x64
	CALL __DIVD21
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	__GETD2S 6
	__GETD1N 0x4B
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0xA
	CALL __DIVD21
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDD12
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;                }
;
;        if (input[i]>500)
_0x313:
	LDS  R30,_i
	LDI  R26,LOW(_input)
	LDI  R27,HIGH(_input)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	CPI  R30,LOW(0x1F5)
	LDI  R26,HIGH(0x1F5)
	CPC  R31,R26
	BRGE PC+3
	JMP _0x316
;                {
;                 Y1=contr[i].nodes[6][FLY_MODE];
	LDS  R30,_i
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,24
	ADIW R30,24
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	CALL __CBD1
	__PUTD1S 2
;                 Y0=contr[i].nodes[5][FLY_MODE];
	LDS  R30,_i
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,24
	ADIW R30,20
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	CALL __CBD1
	__PUTD1S 6
;                 k=(Y1-Y0)*3;
	__GETD2S 6
	__GETD1S 2
	CALL __SUBD12
	__GETD2N 0x3
	CALL __MULD12
	__PUTD1S 10
;                 out_cur[i]=(input[i]-500)*k/100+Y0*75/10;
	LDS  R30,_i
	LDI  R26,LOW(_out_cur)
	LDI  R27,HIGH(_out_cur)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDS  R30,_i
	LDI  R26,LOW(_input)
	LDI  R27,HIGH(_input)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	SUBI R30,LOW(500)
	SBCI R31,HIGH(500)
	MOVW R26,R30
	__GETD1S 10
	CALL __CWD2
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x64
	CALL __DIVD21
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	__GETD2S 6
	__GETD1N 0x4B
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0xA
	CALL __DIVD21
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDD12
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;                }
;
;
;
;
;        }
_0x316:
	LDS  R30,_i
	SUBI R30,-LOW(1)
	STS  _i,R30
	RJMP _0x307
_0x308:
;//  
;DUAL[0]=DUAL_ail;
	LDI  R30,0
	SBIC 0x13,1
	LDI  R30,1
	STD  Y+14,R30
;DUAL[1]=DUAL_elev;
	LDI  R30,0
	SBIC 0x13,0
	LDI  R30,1
	STD  Y+15,R30
;DUAL[3]=DUAL_rud;
	LDI  R30,0
	SBIC 0x13,2
	LDI  R30,1
	STD  Y+17,R30
;
;for (i=0; i<10; i++)
	LDI  R30,LOW(0)
	STS  _i,R30
_0x318:
	LDS  R26,_i
	CPI  R26,LOW(0xA)
	BRLO PC+3
	JMP _0x319
;        {
;        Y0=contr[i].reverse[FLY_MODE];
	LDS  R30,_i
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_contr)
	SBCI R31,HIGH(-_contr)
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	CALL __CBD1
	__PUTD1S 6
;
;        if (i<4&&i!=2)
	LDS  R26,_i
	CPI  R26,LOW(0x4)
	BRSH _0x31B
	CPI  R26,LOW(0x2)
	BRNE _0x31C
_0x31B:
	RJMP _0x31A
_0x31C:
;                {
;                if (DUAL[i])
	LDS  R30,_i
	LDI  R31,0
	MOVW R26,R28
	ADIW R26,14
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	CPI  R30,0
	BREQ _0x31D
;                        {
;                        if (input[i]<0)
	LDS  R30,_i
	LDI  R26,LOW(_input)
	LDI  R27,HIGH(_input)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	TST  R31
	BRPL _0x31E
;                                Y1=contr[i].minRates[FLY_MODE];
	LDS  R30,_i
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,8
	RJMP _0x371
;
;                        else
_0x31E:
;                                Y1=contr[i].maxRates[FLY_MODE];
	LDS  R30,_i
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,4
_0x371:
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	CLR  R31
	CLR  R22
	CLR  R23
	__PUTD1S 2
;                        }
;                else
	RJMP _0x320
_0x31D:
;                        {
;                        if (input[i]<0)
	LDS  R30,_i
	LDI  R26,LOW(_input)
	LDI  R27,HIGH(_input)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	TST  R31
	BRPL _0x321
;                                Y1=contr[i].minDRates[FLY_MODE];
	LDS  R30,_i
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,16
	RJMP _0x372
;
;                        else
_0x321:
;                                Y1=contr[i].maxDRates[FLY_MODE];
	LDS  R30,_i
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,12
_0x372:
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	CLR  R31
	CLR  R22
	CLR  R23
	__PUTD1S 2
;                        }
_0x320:
;
;
;
;                }
;
;
;
;        else
	RJMP _0x323
_0x31A:
;                {
;                if (input[i]<0)
	LDS  R30,_i
	LDI  R26,LOW(_input)
	LDI  R27,HIGH(_input)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	TST  R31
	BRPL _0x324
;                        Y1=contr[i].minRates[FLY_MODE];
	LDS  R30,_i
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,8
	RJMP _0x373
;
;                else
_0x324:
;                        Y1=contr[i].maxRates[FLY_MODE];
	LDS  R30,_i
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,4
_0x373:
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	CLR  R31
	CLR  R22
	CLR  R23
	__PUTD1S 2
;                }
_0x323:
;
;
;
;
;        if (i>=4&&i<=6)  out_cur[i]=input[i]*Y1/100;
	LDS  R26,_i
	CPI  R26,LOW(0x4)
	BRLO _0x327
	CPI  R26,LOW(0x7)
	BRLO _0x328
_0x327:
	RJMP _0x326
_0x328:
	LDS  R30,_i
	LDI  R26,LOW(_out_cur)
	LDI  R27,HIGH(_out_cur)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDS  R30,_i
	LDI  R26,LOW(_input)
	LDI  R27,HIGH(_input)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R30
	__GETD1S 2
	CALL __CWD2
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x64
	CALL __DIVD21
	POP  R26
	POP  R27
	RJMP _0x374
;        else out_cur[i]=out_cur[i]*Y1/100;
_0x326:
	LDS  R30,_i
	LDI  R26,LOW(_out_cur)
	LDI  R27,HIGH(_out_cur)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDS  R30,_i
	LDI  R26,LOW(_out_cur)
	LDI  R27,HIGH(_out_cur)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R30
	__GETD1S 2
	CALL __CWD2
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x64
	CALL __DIVD21
	POP  R26
	POP  R27
_0x374:
	ST   X+,R30
	ST   X,R31
;
;        if (i==2&&Cut_enable)
	LDS  R26,_i
	CPI  R26,LOW(0x2)
	BRNE _0x32B
	TST  R6
	BRNE _0x32C
_0x32B:
	RJMP _0x32A
_0x32C:
;                {
;                Y1=contr[i].minDRates[FLY_MODE];
	LDS  R30,_i
	LDI  R26,LOW(52)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _contr,16
	MOVW R26,R30
	CLR  R30
	ADD  R26,R7
	ADC  R27,R30
	LD   R30,X
	CLR  R31
	CLR  R22
	CLR  R23
	__PUTD1S 2
;                out_cur[i]=-75*Y1/10;
	LDS  R30,_i
	LDI  R26,LOW(_out_cur)
	LDI  R27,HIGH(_out_cur)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	__GETD1S 2
	__GETD2N 0xFFFFFFB5
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0xA
	CALL __DIVD21
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;                }
;
;        if (i<4)
_0x32A:
	LDS  R26,_i
	CPI  R26,LOW(0x4)
	BRSH _0x32D
;                {
;                Y2=curmodel.trimmer[FLY_MODE][i];
	__POINTW2MN _curmodel,13
	MOV  R30,R7
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	LDS  R30,_i
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	LDI  R31,0
	SBRC R30,7
	SER  R31
	MOVW R16,R30
;                out_cur[i]+=Y2*5;
	LDS  R30,_i
	LDI  R26,LOW(_out_cur)
	LDI  R27,HIGH(_out_cur)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	MOVW R24,R30
	LD   R22,Z
	LDD  R23,Z+1
	MOVW R26,R16
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	CALL __MULW12
	ADD  R30,R22
	ADC  R31,R23
	MOVW R26,R24
	ST   X+,R30
	ST   X,R31
;                }
;        out_cur[i]=out_cur[i]*Y0;
_0x32D:
	LDS  R30,_i
	LDI  R26,LOW(_out_cur)
	LDI  R27,HIGH(_out_cur)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDS  R30,_i
	LDI  R26,LOW(_out_cur)
	LDI  R27,HIGH(_out_cur)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R30
	__GETD1S 6
	CALL __CWD2
	CALL __MULD12
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;
;        }
	LDS  R30,_i
	SUBI R30,-LOW(1)
	STS  _i,R30
	RJMP _0x318
_0x319:
;
;
;        if (trim_0up && trim_0down && S_trim[0]){ trimmer[cur_model_num][FLY_MODE][0]=curmodel.trimmer[FLY_MODE][0]; S_trim[0]=0;}
	SBIS 0x19,3
	RJMP _0x32F
	SBIS 0x19,0
	RJMP _0x32F
	LDS  R30,_S_trim
	CPI  R30,0
	BRNE _0x330
_0x32F:
	RJMP _0x32E
_0x330:
	LDS  R30,_cur_model_num
	LDI  R31,0
	CALL __LSLW4
	SUBI R30,LOW(-_trimmer)
	SBCI R31,HIGH(-_trimmer)
	MOVW R26,R30
	MOV  R30,R7
	LDI  R31,0
	CALL __LSLW2
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	__POINTW2MN _curmodel,13
	MOV  R30,R7
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	MOVW R26,R0
	CALL __EEPROMWRB
	LDI  R30,LOW(0)
	STS  _S_trim,R30
;        if (trim_1up && trim_1down && S_trim[1]){ trimmer[cur_model_num][FLY_MODE][1]=curmodel.trimmer[FLY_MODE][1]; S_trim[1]=0;}
_0x32E:
	SBIS 0x19,1
	RJMP _0x332
	SBIS 0x19,2
	RJMP _0x332
	__GETB1MN _S_trim,1
	CPI  R30,0
	BRNE _0x333
_0x332:
	RJMP _0x331
_0x333:
	LDS  R30,_cur_model_num
	LDI  R31,0
	CALL __LSLW4
	SUBI R30,LOW(-_trimmer)
	SBCI R31,HIGH(-_trimmer)
	MOVW R26,R30
	MOV  R30,R7
	LDI  R31,0
	CALL __LSLW2
	ADD  R30,R26
	ADC  R31,R27
	ADIW R30,1
	MOVW R0,R30
	__POINTW2MN _curmodel,13
	MOV  R30,R7
	LDI  R31,0
	CALL __LSLW2
	ADD  R30,R26
	ADC  R31,R27
	LDD  R30,Z+1
	MOVW R26,R0
	CALL __EEPROMWRB
	LDI  R30,LOW(0)
	__PUTB1MN _S_trim,1
;        if (trim_2up && trim_2down && S_trim[2]){ trimmer[cur_model_num][FLY_MODE][2]=curmodel.trimmer[FLY_MODE][2]; S_trim[2]=0;}
_0x331:
	SBIS 0x19,5
	RJMP _0x335
	SBIS 0x19,4
	RJMP _0x335
	__GETB1MN _S_trim,2
	CPI  R30,0
	BRNE _0x336
_0x335:
	RJMP _0x334
_0x336:
	LDS  R30,_cur_model_num
	LDI  R31,0
	CALL __LSLW4
	SUBI R30,LOW(-_trimmer)
	SBCI R31,HIGH(-_trimmer)
	MOVW R26,R30
	MOV  R30,R7
	LDI  R31,0
	CALL __LSLW2
	ADD  R30,R26
	ADC  R31,R27
	ADIW R30,2
	MOVW R0,R30
	__POINTW2MN _curmodel,13
	MOV  R30,R7
	LDI  R31,0
	CALL __LSLW2
	ADD  R30,R26
	ADC  R31,R27
	LDD  R30,Z+2
	MOVW R26,R0
	CALL __EEPROMWRB
	LDI  R30,LOW(0)
	__PUTB1MN _S_trim,2
;        if (trim_3up && trim_3down && S_trim[3]){ trimmer[cur_model_num][FLY_MODE][3]=curmodel.trimmer[FLY_MODE][3]; S_trim[3]=0;}
_0x334:
	SBIS 0x19,7
	RJMP _0x338
	SBIS 0x19,6
	RJMP _0x338
	__GETB1MN _S_trim,3
	CPI  R30,0
	BRNE _0x339
_0x338:
	RJMP _0x337
_0x339:
	LDS  R30,_cur_model_num
	LDI  R31,0
	CALL __LSLW4
	SUBI R30,LOW(-_trimmer)
	SBCI R31,HIGH(-_trimmer)
	MOVW R26,R30
	MOV  R30,R7
	LDI  R31,0
	CALL __LSLW2
	ADD  R30,R26
	ADC  R31,R27
	ADIW R30,3
	MOVW R0,R30
	__POINTW2MN _curmodel,13
	MOV  R30,R7
	LDI  R31,0
	CALL __LSLW2
	ADD  R30,R26
	ADC  R31,R27
	LDD  R30,Z+3
	MOVW R26,R0
	CALL __EEPROMWRB
	LDI  R30,LOW(0)
	__PUTB1MN _S_trim,3
;
;
;           }
_0x337:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,18
	RET
;
;
;
;// SPI functions
;#include <spi.h>
;
;int nb,del;
;
;interrupt [TIM1_COMPA] void timer1_compa_isr(void)       // ,         :)
; 0000 0040 {char i;
_timer1_compa_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0041 
; 0000 0042 LED2=1;
	ST   -Y,R17
;	i -> R17
	SBI  0x15,7
; 0000 0043 if (nb<curmodel.num_ch)
	__GETB1MN _curmodel,32
	LDS  R26,_nb
	LDS  R27,_nb+1
	LDI  R31,0
	SBRC R30,7
	SER  R31
	CP   R26,R30
	CPC  R27,R31
	BRGE _0x33C
; 0000 0044         {
; 0000 0045         if (nb<curmodel.num_ch-1)
	__GETB1MN _curmodel,32
	SUBI R30,LOW(1)
	LDI  R31,0
	SBRC R30,7
	SER  R31
	CP   R26,R30
	CPC  R27,R31
	BRGE _0x33D
; 0000 0046 
; 0000 0047         CHcalc(nb+1);
	LDS  R30,_nb
	LDS  R31,_nb+1
	ADIW R30,1
	ST   -Y,R30
	CALL _CHcalc
; 0000 0048 
; 0000 0049         ICR1H=output[nb]>>8;        //  
_0x33D:
	LDS  R30,_nb
	LDS  R31,_nb+1
	LDI  R26,LOW(_output)
	LDI  R27,HIGH(_output)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	CALL __ASRW8
	OUT  0x27,R30
; 0000 004A         ICR1L=output[nb]&0b11111111;
	LDS  R30,_nb
	LDS  R31,_nb+1
	LDI  R26,LOW(_output)
	LDI  R27,HIGH(_output)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ANDI R31,HIGH(0xFF)
	OUT  0x26,R30
; 0000 004B 
; 0000 004C         nb++;
	LDI  R26,LOW(_nb)
	LDI  R27,HIGH(_nb)
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
; 0000 004D         }
; 0000 004E 
; 0000 004F  else
	RJMP _0x33E
_0x33C:
; 0000 0050         {
; 0000 0051         del=0;
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	STS  _del,R30
	STS  _del+1,R31
; 0000 0052         nb=0;
	STS  _nb,R30
	STS  _nb+1,R31
; 0000 0053         for(i=0; i<curmodel.num_ch; i++) del+=output[i];
	LDI  R17,LOW(0)
_0x340:
	__GETB1MN _curmodel,32
	CP   R17,R30
	BRGE _0x341
	MOV  R30,R17
	LDI  R26,LOW(_output)
	LDI  R27,HIGH(_output)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	LDS  R26,_del
	LDS  R27,_del+1
	ADD  R30,R26
	ADC  R31,R27
	STS  _del,R30
	STS  _del+1,R31
	SUBI R17,-1
	RJMP _0x340
_0x341:
; 0000 0057 del=30000-del;
	LDS  R26,_del
	LDS  R27,_del+1
	LDI  R30,LOW(30000)
	LDI  R31,HIGH(30000)
	SUB  R30,R26
	SBC  R31,R27
	STS  _del,R30
	STS  _del+1,R31
; 0000 0058 
; 0000 0059         ICR1H=del>>8;
	CALL __ASRW8
	OUT  0x27,R30
; 0000 005A         ICR1L=del&0b11111111;     //  
	LDS  R30,_del
	LDS  R31,_del+1
	ANDI R31,HIGH(0xFF)
	OUT  0x26,R30
; 0000 005B 
; 0000 005C         PreClip++;
	LDS  R30,_PreClip
	SUBI R30,-LOW(1)
	STS  _PreClip,R30
; 0000 005D 
; 0000 005E         if (PreClip>=30)
	LDS  R26,_PreClip
	CPI  R26,LOW(0x1E)
	BRLO _0x342
; 0000 005F                 {
; 0000 0060                 PreClip=0;
	LDI  R30,LOW(0)
	STS  _PreClip,R30
; 0000 0061                 if (Clip==255) Clip=0;
	LDS  R26,_Clip
	CPI  R26,LOW(0xFF)
	BRNE _0x343
	RJMP _0x375
; 0000 0062                 else Clip=255;
_0x343:
	LDI  R30,LOW(255)
_0x375:
	STS  _Clip,R30
; 0000 0063                 }
; 0000 0064 
; 0000 0065         Calc();
_0x342:
	CALL _Calc
; 0000 0066 
; 0000 0067         CHcalc(0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _CHcalc
; 0000 0068 
; 0000 0069         LED2=0;
	CBI  0x15,7
; 0000 006A         }
_0x33E:
; 0000 006B 
; 0000 006C }
	LD   R17,Y+
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;
;
;
;
;
;// Declare your global variables here
;
;
;
;void main(void)
; 0000 0078 {
_main:
; 0000 0079 // Declare your local variables here
; 0000 007A 
; 0000 007B // Input/Output Ports initialization
; 0000 007C // Port A initialization
; 0000 007D // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 007E // State7=P State6=P State5=P State4=P State3=P State2=P State1=P State0=P
; 0000 007F PORTA=0xFF;
	LDI  R30,LOW(255)
	OUT  0x1B,R30
; 0000 0080 DDRA=0x00;
	LDI  R30,LOW(0)
	OUT  0x1A,R30
; 0000 0081 
; 0000 0082 // Port B initialization
; 0000 0083 // Func7=In Func6=In Func5=Out Func4=In Func3=In Func2=Out Func1=Out Func0=IN
; 0000 0084 // State7=T State6=T State5=0 State4=T State3=T State2=0 State1=0 State0=1
; 0000 0085 PORTB=0x01;
	LDI  R30,LOW(1)
	OUT  0x18,R30
; 0000 0086 DDRB=0x26;
	LDI  R30,LOW(38)
	OUT  0x17,R30
; 0000 0087 
; 0000 0088 // Port C initialization
; 0000 0089 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=In
; 0000 008A // State7=0 State6=0 State5=0 State4=0 State3=T State2=T State1=T State0=T
; 0000 008B PORTC=0x0F;
	LDI  R30,LOW(15)
	OUT  0x15,R30
; 0000 008C DDRC=0xF0;
	LDI  R30,LOW(240)
	OUT  0x14,R30
; 0000 008D 
; 0000 008E // Port D initialization
; 0000 008F // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 0090 // State7=P State6=P State5=P State4=P State3=T State2=T State1=T State0=T
; 0000 0091 PORTD=0xF0;
	OUT  0x12,R30
; 0000 0092 DDRD=0x00;
	LDI  R30,LOW(0)
	OUT  0x11,R30
; 0000 0093 
; 0000 0094 // Port E initialization
; 0000 0095 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 0096 // State7=P State6=P State5=P State4=P State3=P State2=P State1=T State0=T
; 0000 0097 PORTE=0xFC;
	LDI  R30,LOW(252)
	OUT  0x3,R30
; 0000 0098 DDRE=0x00;
	LDI  R30,LOW(0)
	OUT  0x2,R30
; 0000 0099 
; 0000 009A // Port F initialization
; 0000 009B // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 009C // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 009D PORTF=0x00;
	STS  98,R30
; 0000 009E DDRF=0x00;
	STS  97,R30
; 0000 009F 
; 0000 00A0 // Port G initialization
; 0000 00A1 // Func4=In Func3=In Func2=Out Func1=In Func0=In
; 0000 00A2 // State4=T State3=T State2=0 State1=T State0=T
; 0000 00A3 PORTG=0x00;
	STS  101,R30
; 0000 00A4 DDRG=0x04;
	LDI  R30,LOW(4)
	STS  100,R30
; 0000 00A5 
; 0000 00A6 // Timer/Counter 0 initialization
; 0000 00A7 // Clock source: System Clock
; 0000 00A8 // Clock value: Timer 0 Stopped
; 0000 00A9 // Mode: Normal top=FFh
; 0000 00AA // OC0 output: Disconnected
; 0000 00AB ASSR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 00AC TCCR0=0x00;
	OUT  0x33,R30
; 0000 00AD TCNT0=0x00;
	OUT  0x32,R30
; 0000 00AE OCR0=0x00;
	OUT  0x31,R30
; 0000 00AF 
; 0000 00B0 // Timer/Counter 1 initialization
; 0000 00B1 // Clock source: System Clock
; 0000 00B2 // Clock value: Timer 1 Stopped
; 0000 00B3 // Mode: Fast PWM top=ICR1
; 0000 00B4 // OC1A output: Non-Inv.
; 0000 00B5 // OC1B output: Discon.
; 0000 00B6 // OC1C output: Discon.
; 0000 00B7 // Noise Canceler: Off
; 0000 00B8 // Input Capture on Falling Edge
; 0000 00B9 // Timer 1 Overflow Interrupt: Off
; 0000 00BA // Input Capture Interrupt: Off
; 0000 00BB // Compare A Match Interrupt: Off
; 0000 00BC // Compare B Match Interrupt: Off
; 0000 00BD // Compare C Match Interrupt: Off
; 0000 00BE TCCR1A=0x82;
	LDI  R30,LOW(130)
	OUT  0x2F,R30
; 0000 00BF 
; 0000 00C0 TCCR1B=0x1A;
	LDI  R30,LOW(26)
	OUT  0x2E,R30
; 0000 00C1 TCNT1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
; 0000 00C2 TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 00C3 ICR1H=0x17;
	LDI  R30,LOW(23)
	OUT  0x27,R30
; 0000 00C4 ICR1L=0x70;
	LDI  R30,LOW(112)
	OUT  0x26,R30
; 0000 00C5 OCR1AH=0x02;
	LDI  R30,LOW(2)
	OUT  0x2B,R30
; 0000 00C6 OCR1AL=0x68;
	LDI  R30,LOW(104)
	OUT  0x2A,R30
; 0000 00C7 OCR1BH=0x00;
	LDI  R30,LOW(0)
	OUT  0x29,R30
; 0000 00C8 OCR1BL=0x00;
	OUT  0x28,R30
; 0000 00C9 OCR1CH=0x00;
	STS  121,R30
; 0000 00CA OCR1CL=0x00;
	STS  120,R30
; 0000 00CB 
; 0000 00CC // Timer/Counter 2 initialization
; 0000 00CD // Clock source: System Clock
; 0000 00CE // Clock value: Timer 2 Stopped
; 0000 00CF // Mode: Normal top=FFh
; 0000 00D0 // OC2 output: Disconnected
; 0000 00D1 TCCR2=0x00;
	OUT  0x25,R30
; 0000 00D2 TCNT2=0x00;
	OUT  0x24,R30
; 0000 00D3 OCR2=0x00;
	OUT  0x23,R30
; 0000 00D4 
; 0000 00D5 // Timer/Counter 3 initialization
; 0000 00D6 // Clock source: System Clock
; 0000 00D7 // Clock value: Timer 3 Stopped
; 0000 00D8 // Mode: Normal top=FFFFh
; 0000 00D9 // Noise Canceler: Off
; 0000 00DA // Input Capture on Falling Edge
; 0000 00DB // OC3A output: Discon.
; 0000 00DC // OC3B output: Discon.
; 0000 00DD // OC3C output: Discon.
; 0000 00DE // Timer 3 Overflow Interrupt: Off
; 0000 00DF // Input Capture Interrupt: Off
; 0000 00E0 // Compare A Match Interrupt: Off
; 0000 00E1 // Compare B Match Interrupt: Off
; 0000 00E2 // Compare C Match Interrupt: Off
; 0000 00E3 TCCR3A=0x00;
	STS  139,R30
; 0000 00E4 TCCR3B=0x00;
	STS  138,R30
; 0000 00E5 TCNT3H=0x00;
	STS  137,R30
; 0000 00E6 TCNT3L=0x00;
	STS  136,R30
; 0000 00E7 ICR3H=0x00;
	STS  129,R30
; 0000 00E8 ICR3L=0x00;
	STS  128,R30
; 0000 00E9 OCR3AH=0x00;
	STS  135,R30
; 0000 00EA OCR3AL=0x00;
	STS  134,R30
; 0000 00EB OCR3BH=0x00;
	STS  133,R30
; 0000 00EC OCR3BL=0x00;
	STS  132,R30
; 0000 00ED OCR3CH=0x00;
	STS  131,R30
; 0000 00EE OCR3CL=0x00;
	STS  130,R30
; 0000 00EF 
; 0000 00F0 // External Interrupt(s) initialization
; 0000 00F1 // INT0: Off
; 0000 00F2 // INT1: Off
; 0000 00F3 // INT2: Off
; 0000 00F4 // INT3: Off
; 0000 00F5 // INT4: Off
; 0000 00F6 // INT5: Off
; 0000 00F7 // INT6: Off
; 0000 00F8 // INT7: Off
; 0000 00F9 EICRA=0x00;
	STS  106,R30
; 0000 00FA EICRB=0x00;
	OUT  0x3A,R30
; 0000 00FB EIMSK=0x00;
	OUT  0x39,R30
; 0000 00FC 
; 0000 00FD // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 00FE TIMSK=0x00;
	OUT  0x37,R30
; 0000 00FF ETIMSK=0x00;
	STS  125,R30
; 0000 0100 
; 0000 0101 // Analog Comparator initialization
; 0000 0102 // Analog Comparator: Off
; 0000 0103 // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 0104 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 0105 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
; 0000 0106 
; 0000 0107 // ADC initialization
; 0000 0108 // ADC Clock frequency: 187,500 kHz
; 0000 0109 // ADC Voltage Reference: AREF pin
; 0000 010A ADMUX=ADC_VREF_TYPE;
	OUT  0x7,R30
; 0000 010B ADCSRA=0x86;
	LDI  R30,LOW(134)
	OUT  0x6,R30
; 0000 010C /*
; 0000 010D // SPI initialization
; 0000 010E // SPI Type: Master
; 0000 010F // SPI Clock Rate: 3000,000 kHz
; 0000 0110 // SPI Clock Phase: Cycle Half
; 0000 0111 // SPI Clock Polarity: Low
; 0000 0112 // SPI Data Order: MSB First
; 0000 0113 SPCR=0x50;
; 0000 0114 SPSR=0x00;
; 0000 0115  */
; 0000 0116 
; 0000 0117 
; 0000 0118 // SPI initialization
; 0000 0119 // SPI Type: Master
; 0000 011A // SPI Clock Rate: 2*3000,000 kHz
; 0000 011B // SPI Clock Phase: Cycle Half
; 0000 011C // SPI Clock Polarity: Low
; 0000 011D // SPI Data Order: MSB First
; 0000 011E SPCR=0x50;
	LDI  R30,LOW(80)
	OUT  0xD,R30
; 0000 011F SPSR=0x01;
	LDI  R30,LOW(1)
	OUT  0xE,R30
; 0000 0120 
; 0000 0121 
; 0000 0122 
; 0000 0123 
; 0000 0124 
; 0000 0125 
; 0000 0126 
; 0000 0127 LED1=1;
	SBI  0x15,6
; 0000 0128 
; 0000 0129 grafinit();
	CALL _grafinit
; 0000 012A 
; 0000 012B if (FirstON!=1)TX_reset();
	LDI  R26,LOW(_FirstON)
	LDI  R27,HIGH(_FirstON)
	CALL __EEPROMRDB
	CPI  R30,LOW(0x1)
	BREQ _0x349
	CALL _TX_reset
; 0000 012C if (!LEFT&&!UP&&!DOWN)calibr();
_0x349:
	SBIC 0x10,6
	RJMP _0x34B
	SBIC 0x10,4
	RJMP _0x34B
	SBIS 0x10,5
	RJMP _0x34C
_0x34B:
	RJMP _0x34A
_0x34C:
	CALL _calibr
; 0000 012D 
; 0000 012E #asm("cli")
_0x34A:
	cli
; 0000 012F 
; 0000 0130 
; 0000 0131 TX_init();
	CALL _TX_init
; 0000 0132 
; 0000 0133 Calc();  // c;
	CALL _Calc
; 0000 0134 CHcalc(0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _CHcalc
; 0000 0135 TIMSK=0x10;
	LDI  R30,LOW(16)
	OUT  0x37,R30
; 0000 0136 #asm("sei")
	sei
; 0000 0137 
; 0000 0138 LED1=0;
	CBI  0x15,6
; 0000 0139 
; 0000 013A 
; 0000 013B 
; 0000 013C 
; 0000 013D 
; 0000 013E 
; 0000 013F while (1)
_0x34F:
; 0000 0140       {
; 0000 0141 
; 0000 0142 
; 0000 0143 
; 0000 0144 
; 0000 0145  trim_sound();
	CALL _trim_sound
; 0000 0146 
; 0000 0147   menu();
	CALL _menu
; 0000 0148 
; 0000 0149 
; 0000 014A       };
	RJMP _0x34F
; 0000 014B }
_0x352:
	RJMP _0x352
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	JMP  _0x20E0001
__put_G100:
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x2000010
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x2000012
	__CPWRN 16,17,2
	BRLO _0x2000013
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	ST   X+,R30
	ST   X,R31
_0x2000012:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LDD  R26,Y+6
	STD  Z+0,R26
_0x2000013:
	RJMP _0x2000014
_0x2000010:
	LDD  R30,Y+6
	ST   -Y,R30
	RCALL _putchar
_0x2000014:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,7
	RET
__print_G100:
	SBIW R28,6
	CALL __SAVELOCR6
	LDI  R17,0
_0x2000015:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x2000017
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x200001B
	CPI  R18,37
	BRNE _0x200001C
	LDI  R17,LOW(1)
	RJMP _0x200001D
_0x200001C:
	ST   -Y,R18
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	RCALL __put_G100
_0x200001D:
	RJMP _0x200001A
_0x200001B:
	CPI  R30,LOW(0x1)
	BRNE _0x200001E
	CPI  R18,37
	BRNE _0x200001F
	ST   -Y,R18
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	RCALL __put_G100
	RJMP _0x20000BC
_0x200001F:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x2000020
	LDI  R16,LOW(1)
	RJMP _0x200001A
_0x2000020:
	CPI  R18,43
	BRNE _0x2000021
	LDI  R20,LOW(43)
	RJMP _0x200001A
_0x2000021:
	CPI  R18,32
	BRNE _0x2000022
	LDI  R20,LOW(32)
	RJMP _0x200001A
_0x2000022:
	RJMP _0x2000023
_0x200001E:
	CPI  R30,LOW(0x2)
	BRNE _0x2000024
_0x2000023:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x2000025
	ORI  R16,LOW(128)
	RJMP _0x200001A
_0x2000025:
	RJMP _0x2000026
_0x2000024:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x200001A
_0x2000026:
	CPI  R18,48
	BRLO _0x2000029
	CPI  R18,58
	BRLO _0x200002A
_0x2000029:
	RJMP _0x2000028
_0x200002A:
	MOV  R26,R21
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOVW R30,R0
	MOV  R21,R30
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x200001A
_0x2000028:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x200002E
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Z+4
	ST   -Y,R26
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	RCALL __put_G100
	RJMP _0x200002F
_0x200002E:
	CPI  R30,LOW(0x73)
	BRNE _0x2000031
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlen
	MOV  R17,R30
	RJMP _0x2000032
_0x2000031:
	CPI  R30,LOW(0x70)
	BRNE _0x2000034
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x2000032:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x2000035
_0x2000034:
	CPI  R30,LOW(0x64)
	BREQ _0x2000038
	CPI  R30,LOW(0x69)
	BRNE _0x2000039
_0x2000038:
	ORI  R16,LOW(4)
	RJMP _0x200003A
_0x2000039:
	CPI  R30,LOW(0x75)
	BRNE _0x200003B
_0x200003A:
	LDI  R30,LOW(_tbl10_G100*2)
	LDI  R31,HIGH(_tbl10_G100*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(5)
	RJMP _0x200003C
_0x200003B:
	CPI  R30,LOW(0x58)
	BRNE _0x200003E
	ORI  R16,LOW(8)
	RJMP _0x200003F
_0x200003E:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0x2000070
_0x200003F:
	LDI  R30,LOW(_tbl16_G100*2)
	LDI  R31,HIGH(_tbl16_G100*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(4)
_0x200003C:
	SBRS R16,2
	RJMP _0x2000041
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDD  R26,Y+11
	TST  R26
	BRPL _0x2000042
	CALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R20,LOW(45)
_0x2000042:
	CPI  R20,0
	BREQ _0x2000043
	SUBI R17,-LOW(1)
	RJMP _0x2000044
_0x2000043:
	ANDI R16,LOW(251)
_0x2000044:
	RJMP _0x2000045
_0x2000041:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
_0x2000045:
_0x2000035:
	SBRC R16,0
	RJMP _0x2000046
_0x2000047:
	CP   R17,R21
	BRSH _0x2000049
	SBRS R16,7
	RJMP _0x200004A
	SBRS R16,2
	RJMP _0x200004B
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x200004C
_0x200004B:
	LDI  R18,LOW(48)
_0x200004C:
	RJMP _0x200004D
_0x200004A:
	LDI  R18,LOW(32)
_0x200004D:
	ST   -Y,R18
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	RCALL __put_G100
	SUBI R21,LOW(1)
	RJMP _0x2000047
_0x2000049:
_0x2000046:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x200004E
_0x200004F:
	CPI  R19,0
	BREQ _0x2000051
	SBRS R16,3
	RJMP _0x2000052
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,1
	LPM  R30,Z
	RJMP _0x20000BD
_0x2000052:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x20000BD:
	ST   -Y,R30
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	RCALL __put_G100
	CPI  R21,0
	BREQ _0x2000054
	SUBI R21,LOW(1)
_0x2000054:
	SUBI R19,LOW(1)
	RJMP _0x200004F
_0x2000051:
	RJMP _0x2000055
_0x200004E:
_0x2000057:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
_0x2000059:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x200005B
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+10,R30
	STD  Y+10+1,R31
	RJMP _0x2000059
_0x200005B:
	CPI  R18,58
	BRLO _0x200005C
	SBRS R16,3
	RJMP _0x200005D
	SUBI R18,-LOW(7)
	RJMP _0x200005E
_0x200005D:
	SUBI R18,-LOW(39)
_0x200005E:
_0x200005C:
	SBRC R16,4
	RJMP _0x2000060
	CPI  R18,49
	BRSH _0x2000062
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x2000061
_0x2000062:
	RJMP _0x20000BE
_0x2000061:
	CP   R21,R19
	BRLO _0x2000066
	SBRS R16,0
	RJMP _0x2000067
_0x2000066:
	RJMP _0x2000065
_0x2000067:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x2000068
	LDI  R18,LOW(48)
_0x20000BE:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x2000069
	ANDI R16,LOW(251)
	ST   -Y,R20
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	RCALL __put_G100
	CPI  R21,0
	BREQ _0x200006A
	SUBI R21,LOW(1)
_0x200006A:
_0x2000069:
_0x2000068:
_0x2000060:
	ST   -Y,R18
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	RCALL __put_G100
	CPI  R21,0
	BREQ _0x200006B
	SUBI R21,LOW(1)
_0x200006B:
_0x2000065:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x2000058
	RJMP _0x2000057
_0x2000058:
_0x2000055:
	SBRS R16,0
	RJMP _0x200006C
_0x200006D:
	CPI  R21,0
	BREQ _0x200006F
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	RCALL __put_G100
	RJMP _0x200006D
_0x200006F:
_0x200006C:
_0x2000070:
_0x200002F:
_0x20000BC:
	LDI  R17,LOW(0)
_0x200001A:
	RJMP _0x2000015
_0x2000017:
	CALL __LOADLOCR6
	ADIW R28,20
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,2
	ST   -Y,R17
	ST   -Y,R16
	MOVW R26,R28
	CALL __ADDW2R15
	MOVW R16,R26
	MOVW R26,R28
	ADIW R26,6
	CALL __ADDW2R15
	CALL __GETW1P
	STD  Y+2,R30
	STD  Y+2+1,R31
	MOVW R26,R28
	ADIW R26,4
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G100
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(0)
	ST   X,R30
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,4
	POP  R15
	RET

	.CSEG
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_grafinit:
	ST   -Y,R17
	ST   -Y,R16
	CBI  0x15,5
	CBI  0x15,4
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	SBI  0x15,4
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	CBI  0x15,5
	LDI  R30,LOW(33)
	ST   -Y,R30
	RCALL _spi
	LDI  R30,LOW(200)
	ST   -Y,R30
	RCALL _spi
	LDI  R30,LOW(6)
	ST   -Y,R30
	RCALL _spi
	LDI  R30,LOW(19)
	ST   -Y,R30
	RCALL _spi
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL _spi
	LDI  R30,LOW(12)
	ST   -Y,R30
	RCALL _spi
	__DELAY_USW 1500
	CBI  0x15,5
	LDI  R30,LOW(64)
	ST   -Y,R30
	RCALL _spi
	LDI  R30,LOW(128)
	ST   -Y,R30
	RCALL _spi
	SBI  0x15,5
	__GETWRN 16,17,0
_0x2040010:
	__CPWRN 16,17,909
	BRSH _0x2040011
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _spi
	__ADDWRN 16,17,1
	RJMP _0x2040010
_0x2040011:
	CBI  0x15,5
	LDI  R30,LOW(64)
	ST   -Y,R30
	RCALL _spi
	LDI  R30,LOW(128)
	ST   -Y,R30
	RCALL _spi
	SBI  0x15,5
	RJMP _0x20E0002
_lcd_refresh:
	ST   -Y,R17
	ST   -Y,R16
	CBI  0x15,5
	LDI  R30,LOW(64)
	ST   -Y,R30
	RCALL _spi
	SBI  0x15,5
	LDI  R17,LOW(0)
_0x204001B:
	CPI  R17,8
	BRSH _0x204001C
	CBI  0x15,5
	MOV  R30,R17
	SUBI R30,-LOW(64)
	ST   -Y,R30
	RCALL _spi
	LDI  R30,LOW(128)
	ST   -Y,R30
	RCALL _spi
	SBI  0x15,5
	LDI  R16,LOW(0)
_0x2040022:
	CPI  R16,96
	BRSH _0x2040023
	LDI  R26,LOW(96)
	MUL  R17,R26
	MOVW R30,R0
	SUBI R30,LOW(-_buff)
	SBCI R31,HIGH(-_buff)
	MOVW R26,R30
	CLR  R30
	ADD  R26,R16
	ADC  R27,R30
	LD   R30,X
	ST   -Y,R30
	RCALL _spi
	SUBI R16,-1
	RJMP _0x2040022
_0x2040023:
	SUBI R17,-1
	RJMP _0x204001B
_0x204001C:
	RJMP _0x20E0002
_lcd_pixel:
	ST   -Y,R17
	ST   -Y,R16
	LDD  R30,Y+3
	LSR  R30
	LSR  R30
	LSR  R30
	MOV  R17,R30
	LDD  R30,Y+3
	ANDI R30,LOW(0x7)
	MOV  R16,R30
	LDD  R30,Y+2
	CPI  R30,0
	BREQ _0x2040024
	LDI  R26,LOW(96)
	MUL  R17,R26
	MOVW R30,R0
	SUBI R30,LOW(-_buff)
	SBCI R31,HIGH(-_buff)
	MOVW R26,R30
	LDD  R30,Y+4
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	LDI  R26,LOW(96)
	MUL  R17,R26
	MOVW R30,R0
	SUBI R30,LOW(-_buff)
	SBCI R31,HIGH(-_buff)
	MOVW R26,R30
	LDD  R30,Y+4
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	LD   R1,X
	MOV  R30,R16
	LDI  R26,LOW(1)
	CALL __LSLB12
	OR   R30,R1
	RJMP _0x2040067
_0x2040024:
	LDI  R26,LOW(96)
	MUL  R17,R26
	MOVW R30,R0
	SUBI R30,LOW(-_buff)
	SBCI R31,HIGH(-_buff)
	MOVW R26,R30
	LDD  R30,Y+4
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	LDI  R26,LOW(96)
	MUL  R17,R26
	MOVW R30,R0
	SUBI R30,LOW(-_buff)
	SBCI R31,HIGH(-_buff)
	MOVW R26,R30
	LDD  R30,Y+4
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	LD   R1,X
	MOV  R30,R16
	LDI  R26,LOW(1)
	CALL __LSLB12
	COM  R30
	AND  R30,R1
_0x2040067:
	MOVW R26,R22
	ST   X,R30
	LDD  R17,Y+1
	LDD  R16,Y+0
	RJMP _0x20E0006
_lcd_line:
	SBIW R28,4
	CALL __SAVELOCR6
	LDD  R26,Y+13
	LDD  R30,Y+11
	SUB  R30,R26
	LDI  R31,0
	SBRC R30,7
	SER  R31
	MOVW R18,R30
	LDD  R26,Y+14
	LDD  R30,Y+12
	SUB  R30,R26
	LDI  R31,0
	SBRC R30,7
	SER  R31
	MOVW R16,R30
	TST  R19
	BRPL _0x2040026
	MOVW R30,R18
	CALL __ANEGW1
	MOVW R18,R30
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x2040068
_0x2040026:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
_0x2040068:
	STD  Y+8,R30
	STD  Y+8+1,R31
	TST  R17
	BRPL _0x2040028
	MOVW R30,R16
	CALL __ANEGW1
	MOVW R16,R30
	__GETWRN 20,21,65535
	RJMP _0x2040029
_0x2040028:
	__GETWRN 20,21,1
_0x2040029:
	LSL  R16
	ROL  R17
	LSL  R18
	ROL  R19
	LDD  R30,Y+14
	ST   -Y,R30
	LDD  R30,Y+14
	ST   -Y,R30
	LDD  R30,Y+12
	ST   -Y,R30
	RCALL _lcd_pixel
	__CPWRR 18,19,16,17
	BRGE _0x204002A
	MOVW R30,R16
	ASR  R31
	ROR  R30
	MOVW R26,R30
	MOVW R30,R18
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+6,R30
	STD  Y+6+1,R31
_0x204002B:
	LDD  R30,Y+12
	LDD  R26,Y+14
	CP   R30,R26
	BREQ _0x204002D
	LDD  R26,Y+7
	TST  R26
	BRMI _0x204002E
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+13
	ADD  R30,R26
	STD  Y+13,R30
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	SUB  R30,R16
	SBC  R31,R17
	STD  Y+6,R30
	STD  Y+6+1,R31
_0x204002E:
	MOVW R30,R20
	LDD  R26,Y+14
	ADD  R30,R26
	STD  Y+14,R30
	MOVW R30,R18
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADD  R30,R26
	ADC  R31,R27
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDD  R30,Y+14
	ST   -Y,R30
	LDD  R30,Y+14
	ST   -Y,R30
	LDD  R30,Y+12
	ST   -Y,R30
	RCALL _lcd_pixel
	RJMP _0x204002B
_0x204002D:
	RJMP _0x204002F
_0x204002A:
	MOVW R30,R18
	ASR  R31
	ROR  R30
	MOVW R26,R30
	MOVW R30,R16
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+6,R30
	STD  Y+6+1,R31
_0x2040030:
	LDD  R30,Y+11
	LDD  R26,Y+13
	CP   R30,R26
	BREQ _0x2040032
	LDD  R26,Y+7
	TST  R26
	BRMI _0x2040033
	MOVW R30,R20
	LDD  R26,Y+14
	ADD  R30,R26
	STD  Y+14,R30
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	SUB  R30,R18
	SBC  R31,R19
	STD  Y+6,R30
	STD  Y+6+1,R31
_0x2040033:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+13
	ADD  R30,R26
	STD  Y+13,R30
	MOVW R30,R16
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADD  R30,R26
	ADC  R31,R27
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDD  R30,Y+14
	ST   -Y,R30
	LDD  R30,Y+14
	ST   -Y,R30
	LDD  R30,Y+12
	ST   -Y,R30
	RCALL _lcd_pixel
	RJMP _0x2040030
_0x2040032:
_0x204002F:
	CALL __LOADLOCR6
	ADIW R28,15
	RET
_lcd_dashline:
	SBIW R28,6
	CALL __SAVELOCR6
	LDD  R26,Y+14
	LDD  R30,Y+12
	SUB  R30,R26
	LDI  R31,0
	SBRC R30,7
	SER  R31
	MOVW R20,R30
	LDD  R26,Y+15
	LDD  R30,Y+13
	SUB  R30,R26
	LDI  R31,0
	SBRC R30,7
	SER  R31
	MOVW R18,R30
	LDI  R17,LOW(1)
	TST  R21
	BRPL _0x2040034
	MOVW R30,R20
	CALL __ANEGW1
	MOVW R20,R30
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x2040069
_0x2040034:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
_0x2040069:
	STD  Y+8,R30
	STD  Y+8+1,R31
	TST  R19
	BRPL _0x2040036
	MOVW R30,R18
	CALL __ANEGW1
	MOVW R18,R30
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x204006A
_0x2040036:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
_0x204006A:
	STD  Y+10,R30
	STD  Y+10+1,R31
	LSL  R18
	ROL  R19
	LSL  R20
	ROL  R21
	LDD  R30,Y+15
	ST   -Y,R30
	LDD  R30,Y+15
	ST   -Y,R30
	ST   -Y,R17
	RCALL _lcd_pixel
	__CPWRR 20,21,18,19
	BRGE _0x2040038
	MOVW R30,R18
	ASR  R31
	ROR  R30
	MOVW R26,R30
	MOVW R30,R20
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+6,R30
	STD  Y+6+1,R31
_0x2040039:
	LDD  R30,Y+13
	LDD  R26,Y+15
	CP   R30,R26
	BREQ _0x204003B
	LDD  R26,Y+7
	TST  R26
	BRMI _0x204003C
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+14
	ADD  R30,R26
	STD  Y+14,R30
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	SUB  R30,R18
	SBC  R31,R19
	STD  Y+6,R30
	STD  Y+6+1,R31
_0x204003C:
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	LDD  R26,Y+15
	ADD  R30,R26
	STD  Y+15,R30
	MOVW R30,R20
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADD  R30,R26
	ADC  R31,R27
	STD  Y+6,R30
	STD  Y+6+1,R31
	CPI  R17,0
	BREQ _0x204003D
	LDI  R17,LOW(0)
	RJMP _0x204003E
_0x204003D:
	LDI  R17,LOW(1)
_0x204003E:
	LDD  R30,Y+15
	ST   -Y,R30
	LDD  R30,Y+15
	ST   -Y,R30
	ST   -Y,R17
	RCALL _lcd_pixel
	RJMP _0x2040039
_0x204003B:
	RJMP _0x204003F
_0x2040038:
	MOVW R30,R20
	ASR  R31
	ROR  R30
	MOVW R26,R30
	MOVW R30,R18
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+6,R30
	STD  Y+6+1,R31
_0x2040040:
	LDD  R30,Y+12
	LDD  R26,Y+14
	CP   R30,R26
	BREQ _0x2040042
	LDD  R26,Y+7
	TST  R26
	BRMI _0x2040043
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	LDD  R26,Y+15
	ADD  R30,R26
	STD  Y+15,R30
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	SUB  R30,R20
	SBC  R31,R21
	STD  Y+6,R30
	STD  Y+6+1,R31
_0x2040043:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+14
	ADD  R30,R26
	STD  Y+14,R30
	MOVW R30,R18
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADD  R30,R26
	ADC  R31,R27
	STD  Y+6,R30
	STD  Y+6+1,R31
	CPI  R17,0
	BREQ _0x2040044
	LDI  R17,LOW(0)
	RJMP _0x2040045
_0x2040044:
	LDI  R17,LOW(1)
_0x2040045:
	LDD  R30,Y+15
	ST   -Y,R30
	LDD  R30,Y+15
	ST   -Y,R30
	ST   -Y,R17
	RCALL _lcd_pixel
	RJMP _0x2040040
_0x2040042:
_0x204003F:
	CALL __LOADLOCR6
	ADIW R28,16
	RET
_lcd_rectangle:
	LDD  R30,Y+4
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	LDD  R30,Y+6
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	RCALL _lcd_line
	LDD  R30,Y+4
	ST   -Y,R30
	LDD  R30,Y+2
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	RCALL _lcd_line
	LDD  R30,Y+2
	ST   -Y,R30
	LDD  R30,Y+2
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	LDD  R30,Y+6
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	RCALL _lcd_line
	LDD  R30,Y+4
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	LDD  R30,Y+6
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	RCALL _lcd_line
_0x20E0006:
	ADIW R28,5
	RET
_lcd_fillrect:
	ST   -Y,R17
	LDD  R17,Y+4
_0x2040047:
	LDD  R30,Y+2
	MOV  R26,R17
	LDI  R27,0
	LDI  R31,0
	SBRC R30,7
	SER  R31
	CP   R30,R26
	CPC  R31,R27
	BRLT _0x2040048
	LDD  R30,Y+5
	ST   -Y,R30
	ST   -Y,R17
	LDD  R30,Y+5
	ST   -Y,R30
	ST   -Y,R17
	LDD  R30,Y+5
	ST   -Y,R30
	RCALL _lcd_line
	SUBI R17,-1
	RJMP _0x2040047
_0x2040048:
	LDD  R17,Y+0
	RJMP _0x20E0005
_lcd_setxy:
	LDD  R30,Y+1
	STS  _posx,R30
	LD   R30,Y
	STS  _posy,R30
	ADIW R28,2
	RET
_lcd_deg12x16:
	CALL __SAVELOCR4
	LDI  R17,LOW(0)
_0x204004A:
	CPI  R17,12
	BRGE _0x204004B
	LDD  R30,Y+5
	LDI  R26,LOW(24)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_deg12x16*2)
	SBCI R31,HIGH(-_deg12x16*2)
	MOVW R26,R30
	MOV  R30,R17
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	LPM  R19,Z
	LDI  R16,LOW(0)
_0x204004D:
	CPI  R16,8
	BRGE _0x204004E
	LDS  R30,_posx
	ST   -Y,R30
	MOV  R30,R16
	LDS  R26,_posy
	ADD  R30,R26
	ST   -Y,R30
	LDD  R30,Y+6
	EOR  R30,R19
	COM  R30
	ANDI R30,LOW(0x1)
	ST   -Y,R30
	RCALL _lcd_pixel
	LSR  R19
	SUBI R16,-1
	RJMP _0x204004D
_0x204004E:
	LDS  R30,_posx
	SUBI R30,-LOW(1)
	STS  _posx,R30
	SUBI R17,-1
	RJMP _0x204004A
_0x204004B:
	LDS  R30,_posy
	SUBI R30,-LOW(8)
	STS  _posy,R30
	LDS  R30,_posx
	SUBI R30,LOW(12)
	STS  _posx,R30
	LDI  R17,LOW(12)
_0x2040050:
	CPI  R17,24
	BRGE _0x2040051
	LDD  R30,Y+5
	LDI  R26,LOW(24)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_deg12x16*2)
	SBCI R31,HIGH(-_deg12x16*2)
	MOVW R26,R30
	MOV  R30,R17
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	LPM  R19,Z
	LDI  R16,LOW(0)
_0x2040053:
	CPI  R16,8
	BRGE _0x2040054
	LDS  R30,_posx
	ST   -Y,R30
	MOV  R30,R16
	LDS  R26,_posy
	ADD  R30,R26
	ST   -Y,R30
	LDD  R30,Y+6
	EOR  R30,R19
	COM  R30
	ANDI R30,LOW(0x1)
	ST   -Y,R30
	RCALL _lcd_pixel
	LSR  R19
	SUBI R16,-1
	RJMP _0x2040053
_0x2040054:
	LDS  R30,_posx
	SUBI R30,-LOW(1)
	STS  _posx,R30
	SUBI R17,-1
	RJMP _0x2040050
_0x2040051:
	RJMP _0x20E0004
_lcd_char:
	CALL __SAVELOCR4
	LDD  R30,Y+5
	SUBI R30,LOW(32)
	STD  Y+5,R30
	LDI  R17,LOW(0)
_0x2040056:
	CPI  R17,8
	BRGE _0x2040057
	LDD  R30,Y+5
	LDI  R31,0
	CALL __LSLW3
	SUBI R30,LOW(-_font8x8*2)
	SBCI R31,HIGH(-_font8x8*2)
	MOVW R26,R30
	MOV  R30,R17
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	LPM  R19,Z
	LDI  R16,LOW(0)
_0x2040059:
	CPI  R16,8
	BRGE _0x204005A
	LDS  R30,_posx
	ST   -Y,R30
	MOV  R30,R16
	LDS  R26,_posy
	ADD  R30,R26
	ST   -Y,R30
	LDD  R30,Y+6
	EOR  R30,R19
	COM  R30
	ANDI R30,LOW(0x1)
	ST   -Y,R30
	RCALL _lcd_pixel
	LSR  R19
	SUBI R16,-1
	RJMP _0x2040059
_0x204005A:
	LDS  R30,_posx
	SUBI R30,-LOW(1)
	STS  _posx,R30
	SUBI R17,-1
	RJMP _0x2040056
_0x2040057:
_0x20E0004:
	CALL __LOADLOCR4
_0x20E0005:
	ADIW R28,6
	RET
_lcd_wrs:
_0x204005B:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X
	CPI  R30,0
	BREQ _0x204005D
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	ST   -Y,R30
	LDD  R30,Y+1
	ST   -Y,R30
	RCALL _lcd_char
	RJMP _0x204005B
_0x204005D:
	RJMP _0x20E0003
_lcd_wrsf:
_0x204005E:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	LPM  R30,Z
	CPI  R30,0
	BREQ _0x2040060
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ADIW R30,1
	STD  Y+1,R30
	STD  Y+1+1,R31
	SBIW R30,1
	LPM  R30,Z
	ST   -Y,R30
	LDD  R30,Y+1
	ST   -Y,R30
	RCALL _lcd_char
	RJMP _0x204005E
_0x2040060:
_0x20E0003:
	ADIW R28,3
	RET
_lcd_clear:
	ST   -Y,R17
	ST   -Y,R16
	LDI  R17,LOW(0)
_0x2040062:
	CPI  R17,8
	BRSH _0x2040063
	LDI  R16,LOW(0)
_0x2040065:
	CPI  R16,96
	BRSH _0x2040066
	LDI  R26,LOW(96)
	MUL  R17,R26
	MOVW R30,R0
	SUBI R30,LOW(-_buff)
	SBCI R31,HIGH(-_buff)
	MOVW R26,R30
	CLR  R30
	ADD  R26,R16
	ADC  R27,R30
	ST   X,R30
	SUBI R16,-1
	RJMP _0x2040065
_0x2040066:
	SUBI R17,-1
	RJMP _0x2040062
_0x2040063:
_0x20E0002:
	LD   R16,Y+
	LD   R17,Y+
	RET
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_spi:
	LD   R30,Y
	OUT  0xF,R30
_0x2060003:
	SBIS 0xE,7
	RJMP _0x2060003
	IN   R30,0xF
_0x20E0001:
	ADIW R28,1
	RET

	.CSEG

	.CSEG
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
    lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret

	.CSEG

	.DSEG

	.CSEG

	.DSEG
_input:
	.BYTE 0x14
_out_cur:
	.BYTE 0x14
_output:
	.BYTE 0x14
_AD:
	.BYTE 0xA
_ADmin:
	.BYTE 0xA
_ADmax:
	.BYTE 0xA
_ADmid:
	.BYTE 0xA
_buf:
	.BYTE 0xC
_Kmin:
	.BYTE 0x14
_Kmax:
	.BYTE 0x14
_S_trim:
	.BYTE 0x4
_counter:
	.BYTE 0x1
_precounter:
	.BYTE 0x1
_sound:
	.BYTE 0x1
_cur_model_num:
	.BYTE 0x1
_deep:
	.BYTE 0x1
_en:
	.BYTE 0x1
_pen:
	.BYTE 0x1
_pos:
	.BYTE 0x4
_edit:
	.BYTE 0x1
_curve_ed_enable:
	.BYTE 0x1
_edit_cur:
	.BYTE 0x1
_T:
	.BYTE 0x2
_trim_sound_en:
	.BYTE 0x1
_Clip:
	.BYTE 0x1
_PreClip:
	.BYTE 0x1
_screen_name:
	.BYTE 0x9
_contr:
	.BYTE 0x208
_chans:
	.BYTE 0x318
_curmodel:
	.BYTE 0x21

	.ESEG
_reverse:
	.BYTE 0xA0
_maxRates:
	.BYTE 0xA0
_minRates:
	.BYTE 0xA0
_maxDRates:
	.BYTE 0xA0
_minDRates:
	.BYTE 0xA0
_from:
	.BYTE 0xA0
_nodes:
	.BYTE 0x460
_CH:
	.BYTE 0x630
_name:
	.BYTE 0x20
_type:
	.BYTE 0x4
_modulation:
	.BYTE 0x4
_trimmer:
	.BYTE 0x40
_EEPRsound:
	.BYTE 0x1
_timer:
	.BYTE 0x8
_timer_mode:
	.BYTE 0x4
_start_model:
	.BYTE 0x1
_EEPR_ADmid:
	.BYTE 0xA
_EEPR_Kmin:
	.BYTE 0x5
_EEPR_Kmax:
	.BYTE 0x5
_num_ch:
	.BYTE 0x4
_FirstON:
	.BYTE 0x1

	.DSEG
_i:
	.BYTE 0x1
_modeNames:
	.BYTE 0xC
_modulNames:
	.BYTE 0x6
_menuT0:
	.BYTE 0xA
_menuT1:
	.BYTE 0x10
_menuT2:
	.BYTE 0x16
_menuT3:
	.BYTE 0x6
_menuT4:
	.BYTE 0x8
_menuT5:
	.BYTE 0x10
_menuT6:
	.BYTE 0x4
_Timer_modes1:
	.BYTE 0x4
_Timer_modes2:
	.BYTE 0x4
_nb:
	.BYTE 0x2
_del:
	.BYTE 0x2
_buff:
	.BYTE 0x300
_posx:
	.BYTE 0x1
_posy:
	.BYTE 0x1
_p_S1050024:
	.BYTE 0x2
__seed_G106:
	.BYTE 0x4

	.CSEG

	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xBB8
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ADDD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	ADC  R23,R25
	RET

__SUBD12:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	SBC  R23,R25
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LSLB12:
	TST  R30
	MOV  R0,R30
	MOV  R30,R26
	BREQ __LSLB12R
__LSLB12L:
	LSL  R30
	DEC  R0
	BRNE __LSLB12L
__LSLB12R:
	RET

__LSLW4:
	LSL  R30
	ROL  R31
__LSLW3:
	LSL  R30
	ROL  R31
__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__ASRW8:
	MOV  R30,R31
	CLR  R31
	SBRC R30,7
	SER  R31
	RET

__CBD1:
	MOV  R31,R30
	ADD  R31,R31
	SBC  R31,R31
	MOV  R22,R31
	MOV  R23,R31
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__CWD2:
	MOV  R24,R27
	ADD  R24,R24
	SBC  R24,R24
	MOV  R25,R24
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULD12U:
	MUL  R23,R26
	MOV  R23,R0
	MUL  R22,R27
	ADD  R23,R0
	MUL  R31,R24
	ADD  R23,R0
	MUL  R30,R25
	ADD  R23,R0
	MUL  R22,R26
	MOV  R22,R0
	ADD  R23,R1
	MUL  R31,R27
	ADD  R22,R0
	ADC  R23,R1
	MUL  R30,R24
	ADD  R22,R0
	ADC  R23,R1
	CLR  R24
	MUL  R31,R26
	MOV  R31,R0
	ADD  R22,R1
	ADC  R23,R24
	MUL  R30,R27
	ADD  R31,R0
	ADC  R22,R1
	ADC  R23,R24
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	ADC  R22,R24
	ADC  R23,R24
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__MULD12:
	RCALL __CHKSIGND
	RCALL __MULD12U
	BRTC __MULD121
	RCALL __ANEGD1
__MULD121:
	RET

__DIVB21U:
	CLR  R0
	LDI  R25,8
__DIVB21U1:
	LSL  R26
	ROL  R0
	SUB  R0,R30
	BRCC __DIVB21U2
	ADD  R0,R30
	RJMP __DIVB21U3
__DIVB21U2:
	SBR  R26,1
__DIVB21U3:
	DEC  R25
	BRNE __DIVB21U1
	MOV  R30,R26
	MOV  R26,R0
	RET

__DIVB21:
	RCALL __CHKSIGNB
	RCALL __DIVB21U
	BRTC __DIVB211
	NEG  R30
__DIVB211:
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__DIVD21:
	RCALL __CHKSIGND
	RCALL __DIVD21U
	BRTC __DIVD211
	RCALL __ANEGD1
__DIVD211:
	RET

__MODB21:
	CLT
	SBRS R26,7
	RJMP __MODB211
	NEG  R26
	SET
__MODB211:
	SBRC R30,7
	NEG  R30
	RCALL __DIVB21U
	MOV  R30,R26
	BRTC __MODB212
	NEG  R30
__MODB212:
	RET

__MODW21:
	CLT
	SBRS R27,7
	RJMP __MODW211
	COM  R26
	COM  R27
	ADIW R26,1
	SET
__MODW211:
	SBRC R31,7
	RCALL __ANEGW1
	RCALL __DIVW21U
	MOVW R30,R26
	BRTC __MODW212
	RCALL __ANEGW1
__MODW212:
	RET

__CHKSIGNB:
	CLT
	SBRS R30,7
	RJMP __CHKSB1
	NEG  R30
	SET
__CHKSB1:
	SBRS R26,7
	RJMP __CHKSB2
	NEG  R26
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSB2:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__CHKSIGND:
	CLT
	SBRS R23,7
	RJMP __CHKSD1
	RCALL __ANEGD1
	SET
__CHKSD1:
	SBRS R25,7
	RJMP __CHKSD2
	CLR  R0
	COM  R26
	COM  R27
	COM  R24
	COM  R25
	ADIW R26,1
	ADC  R24,R0
	ADC  R25,R0
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSD2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__PUTDP1:
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__EEPROMRDW:
	ADIW R26,1
	RCALL __EEPROMRDB
	MOV  R31,R30
	SBIW R26,1

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRW:
	RCALL __EEPROMWRB
	ADIW R26,1
	PUSH R30
	MOV  R30,R31
	RCALL __EEPROMWRB
	POP  R30
	SBIW R26,1
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__CPW02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
